// CalendarInfo.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "CalendarInfo.h"
#include "messagesToChildren.h"
#include "lctypemsg.h"
#include "msg.h"
#include "Query.h"
#include "GetCaption.h"
#include "LogWnd.h"
#include "ErrorString.h"
#include "MultiSz.h"
#include "EnablePair.h"
#include "IsEditControl.h"
#include "RTLMap.h"
#include "AllChildren.h"
#include "BiFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//****************************
// Messages received from parent
//****************************
DECLARE_MESSAGE(UWM_SELECT_LCTYPE)
//****************************
// Messages sent to parent
//****************************

IMPLEMENT_DYNCREATE(CCalendarInfo, CFunction)

/////////////////////////////////////////////////////////////////////////////
// CCalendarInfo dialog


CCalendarInfo::CCalendarInfo(CWnd* pParent /*=NULL*/)
        : CFunction(CCalendarInfo::IDD, pParent)
{
        //{{AFX_DATA_INIT(CCalendarInfo)
        //}}AFX_DATA_INIT
    ItemSelection = 0;
    CalidSelection = 0;
    EnumCalid = 0;
}


void CCalendarInfo::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CCalendarInfo)
        DDX_Control(pDX, IDC_RADIO3, c_SpareRadio);
        DDX_Control(pDX, IDC_CAL_TAIWAN, c_CAL_TAIWAN);
        DDX_Control(pDX, IDC_CAL_KOREA, c_CAL_KOREA);
        DDX_Control(pDX, IDC_CAL_JAPAN, c_CAL_JAPAN);
        DDX_Control(pDX, IDC_CAL_HIJRI, c_CAL_HIJRI);
        DDX_Control(pDX, IDC_CAL_GREGORIAN_US, c_CAL_GREGORIAN_US);
        DDX_Control(pDX, IDC_CAL_GREGORIAN, c_CAL_GREGORIAN);
        DDX_Control(pDX, IDC_CAL_THAI, c_CAL_THAI);
        DDX_Control(pDX, IDC_CAL_HEBREW, c_CAL_HEBREW);
        DDX_Control(pDX, IDC_CAL_GREGORIAN_XLIT_FRENCH, c_CAL_GREGORIAN_XLIT_FRENCH);
        DDX_Control(pDX, IDC_CAL_GREGORIAN_XLIT_ENGLISH, c_CAL_GREGORIAN_XLIT_ENGLISH);
        DDX_Control(pDX, IDC_CAL_GREGORIAN_ME_FRENCH, c_CAL_GREGORIAN_ME_FRENCH);
        DDX_Control(pDX, IDC_CAL_GREGORIAN_ARABIC, c_CAL_GREGORIAN_ARABIC);
        DDX_Control(pDX, IDC_ENUM_ALL_CALENDARS, c_EnumAllCalendars);
        DDX_Control(pDX, IDC_GET_CALENDAR_INFO, c_GetCalendarInfo);
        DDX_Control(pDX, IDC_CALLBACK_NAME_CAPTION, x_CallbackName);
        DDX_Control(pDX, IDC_CALTYPE_CAPTION, c_CALTYPE);
        DDX_Control(pDX, CAL_SYEARMONTH, c_CAL_SYEARMONTH);
        DDX_Control(pDX, CAL_SSHORTDATE, c_CAL_SSHORTDATE);
        DDX_Control(pDX, CAL_SMONTHNAME9, c_CAL_SMONTHNAME9);
        DDX_Control(pDX, CAL_SMONTHNAME8, c_CAL_SMONTHNAME8);
        DDX_Control(pDX, CAL_SMONTHNAME7, c_CAL_SMONTHNAME7);
        DDX_Control(pDX, CAL_SMONTHNAME6, c_CAL_SMONTHNAME6);
        DDX_Control(pDX, CAL_SMONTHNAME5, c_CAL_SMONTHNAME5);
        DDX_Control(pDX, CAL_SMONTHNAME4, c_CAL_SMONTHNAME4);
        DDX_Control(pDX, CAL_SMONTHNAME3, c_CAL_SMONTHNAME3);
        DDX_Control(pDX, CAL_SMONTHNAME2, c_CAL_SMONTHNAME2);
        DDX_Control(pDX, CAL_SMONTHNAME13, c_CAL_SMONTHNAME13);
        DDX_Control(pDX, CAL_SMONTHNAME12, c_CAL_SMONTHNAME12);
        DDX_Control(pDX, CAL_SMONTHNAME11, c_CAL_SMONTHNAME11);
        DDX_Control(pDX, CAL_SMONTHNAME10, c_CAL_SMONTHNAME10);
        DDX_Control(pDX, CAL_SMONTHNAME1, c_CAL_SMONTHNAME1);
        DDX_Control(pDX, CAL_SLONGDATE, c_CAL_SLONGDATE);
        DDX_Control(pDX, CAL_SERASTRING, c_CAL_SERASTRING);
        DDX_Control(pDX, CAL_SDAYNAME7, c_CAL_SDAYNAME7);
        DDX_Control(pDX, CAL_SDAYNAME6, c_CAL_SDAYNAME6);
        DDX_Control(pDX, CAL_SDAYNAME5, c_CAL_SDAYNAME5);
        DDX_Control(pDX, CAL_SDAYNAME4, c_CAL_SDAYNAME4);
        DDX_Control(pDX, CAL_SDAYNAME3, c_CAL_SDAYNAME3);
        DDX_Control(pDX, CAL_SDAYNAME2, c_CAL_SDAYNAME2);
        DDX_Control(pDX, CAL_SDAYNAME1, c_CAL_SDAYNAME1);
        DDX_Control(pDX, CAL_SCALNAME, c_CAL_SCALENAME);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME9, c_CAL_SABBREVMONTHNAME9);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME8, c_CAL_SABBREVMONTHNAME8);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME7, c_CAL_SABBREVMONTHNAME7);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME6, c_CAL_SABBREVMONTHNAME6);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME5, c_CAL_SABBREVMONTHNAME5);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME4, c_CAL_SABBREVMONTHNAME4);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME3, c_CAL_SABBREVMONTHNAME3);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME2, c_CAL_SABBREVMONTHNAME2);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME13, c_CAL_SABBREVMONTHNAME13);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME12, c_CAL_SABBREVMONTHNAME12);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME11, c_CAL_SABBREVMONTHNAME11);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME10, c_CAL_SABBREVMONTHNAME10);
        DDX_Control(pDX, CAL_SABBREVMONTHNAME1, c_CAL_SABBREVMONTHNAME1);
        DDX_Control(pDX, CAL_SABBREVDAYNAME7, c_CAL_SABBREVDAYNAME7);
        DDX_Control(pDX, CAL_SABBREVDAYNAME6, c_CAL_SABBREVDAYNAME6);
        DDX_Control(pDX, CAL_SABBREVDAYNAME5, c_CAL_SABBREVDAYNAME5);
        DDX_Control(pDX, CAL_SABBREVDAYNAME4, c_CAL_SABBREVDAYNAME4);
        DDX_Control(pDX, CAL_SABBREVDAYNAME3, c_CAL_SABBREVDAYNAME3);
        DDX_Control(pDX, CAL_SABBREVDAYNAME2, c_CAL_SABBREVDAYNAME2);
        DDX_Control(pDX, CAL_SABBREVDAYNAME1, c_CAL_SABBREVDAYNAME1);
        DDX_Control(pDX, CAL_IYEAROFFSETRANGE, c_CAL_IYEAROFFSETRANGE);
        DDX_Control(pDX, CAL_ITWODIGITYEARMAX, c_CAL_TWODIGITYEARMAX);
        DDX_Control(pDX, CAL_ICALINTVALUE, c_CAL_ICALINTVALUE);
        DDX_Control(pDX, IDC_CALLBACK_NAME, c_CallbackName);
        DDX_Control(pDX, IDC_OUTPUT, c_Output);
        DDX_Control(pDX, IDC_ENUM_CALENDAR_EX, c_EnumCalendarEx);
        DDX_Control(pDX, IDC_ENUM_CALENDAR, c_EnumCalendar);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCalendarInfo, CFunction)
        ON_REGISTERED_MESSAGE(UWM_SELECT_LCTYPE, OnSelectLCType)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_ENUM_ALL_CALENDARS, IDC_CAL_GREGORIAN_XLIT_FRENCH, OnCal)
        //{{AFX_MSG_MAP(CCalendarInfo)
        ON_BN_CLICKED(IDC_ENUM_CALENDAR, OnEnumCalendarInfo)
        ON_BN_CLICKED(IDC_ENUM_CALENDAR_EX, OnEnumCalendarInfoEx)
        ON_BN_CLICKED(IDC_GET_CALENDAR_INFO, OnGetCalendarInfo)
        ON_WM_SIZE()
        ON_EN_CHANGE(IDC_CALLBACK_NAME, OnChangeCallbackName)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalendarInfo message handlers

BOOL CCalendarInfo::OnInitDialog() 
{
        CFunction::OnInitDialog();

        CalidSelection = IDC_ENUM_ALL_CALENDARS;
        CheckRadioButton(IDC_ENUM_ALL_CALENDARS, IDC_CAL_GREGORIAN_XLIT_FRENCH, CalidSelection);

        CheckRadioButton(IDC_ENUM_CALENDAR, IDC_ENUM_CALENDAR_EX, IDC_ENUM_CALENDAR);
   
        c_Output.InsertColumnEx(0, _T("LPTSTR lpCalendarInfoString"), LVCFMT_LEFT, 0);
        c_Output.InsertColumnEx(1, _T("CALID Calendar"), LVCFMT_LEFT, -1);
        CalWidth = c_Output.GetColumnWidth(1);

        updateControls();

        Refresh();
     
        return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

/****************************************************************************
*                            CCalendarInfo::OnCal
* Inputs:
*       UINT id: ID code
* Result: void
*       
* Effect: 
*       Generates the example
****************************************************************************/

void CCalendarInfo::OnCal(UINT id) 
   {
    CalidSelection = id;
    EnumCalid = 0; // cancel any existing return value
    Refresh();
   }


/****************************************************************************
*                        CCalendarInfo::OnSelectLCType
* Inputs:
*       WPARAM:
*       LPARAM lParam: (LPARAM)(GetDlgCtrlID)
* Result: LRESULT
*       
* Effect: 
*       Indicates a locale item has been selected
****************************************************************************/

LRESULT CCalendarInfo::OnSelectLCType(WPARAM, LPARAM lParam)
    {
     ItemSelection = lParam;

     switch(ItemSelection)
        { /* ItemSelection */
         case CAL_ICALINTVALUE:
         case CAL_IYEAROFFSETRANGE:
         case CAL_ITWODIGITYEARMAX:
            EnableQuery(QUERY_DWORD, TRUE);
            break;
         default:
            EnableQuery(QUERY_DWORD, FALSE);
            break;
        } /* ItemSelection */
     CString caption;
     caption = GetCaption(lParam);
     CString variable = caption;
     variable.Replace(_T("CAL_"), _T(""));
     variable.MakeLower();
     variable += _T("_data");
     SetVariable(variable);
     
     UpdateCode();
     return 0;
    } // CCalendarInfo::OnSelectLCType

/****************************************************************************
*                        CCalendarInfo::SetFontToControls
* Result: void
*       
* Effect: 
*       Virtual method that loads all the controls with the selected font
****************************************************************************/

void CCalendarInfo::SetFontToControls()
    {
#ifdef _UNICODE        
     c_Output.SetFont(&UnicodeFont);
     for(ALL_CHILDREN(wnd))
        { /* scan windows */
         if(IsDisplay(wnd) && IsEditControl(wnd))
            wnd->SetFont(&UnicodeFont);
        } /* scan windows */
#endif
    } // CCalendarInfo::SetFontToControls

/****************************************************************************
*                       CCalendarInfo::ShowCalendarInfo
* Result: void
*       
* Effect: 
*       Fills in all the edit controls according to the selected CALTYPE
****************************************************************************/

void CCalendarInfo::ShowCalendarInfo()
    {
     if(!initialized)
         return;

     EnableQuery(QUERY_USE_CP_ACP, TRUE);
     EnableQuery(QUERY_NOUSEROVERRIDE, TRUE);
     EnableQuery(QUERY_DWORD, TRUE);

     
     for(ALL_CHILDREN(wnd))
        { /* scan windows */
         CString text;
         if(!IsDisplay(wnd))
            continue;
         if(!::IsEditControl(wnd))
            continue;
         //****************
         // LCID
         //****************
         LCID lcid = QueryLocale();
         //****************
         // CALID
         //****************
         CALID calid = ControlIDtoCALID(CalidSelection);
         if(calid == ENUM_ALL_CALENDARS)
            calid = CAL_GREGORIAN;
         //****************
         // CALTYPE
         //****************
         CALTYPE caltype = wnd->GetDlgCtrlID(); // get CALTYPE
         if(QueryFlag(QUERY_NOUSEROVERRIDE))
            caltype |= LOCALE_NOUSEROVERRIDE;
         if(QueryFlag(QUERY_USE_CP_ACP))
            caltype |= LOCALE_USE_CP_ACP;
         int result = GetCalendarInfo(lcid, calid, caltype, NULL, 0, NULL);
         if(result == 0)
            { /* failed */
             DWORD err = ::GetLastError();
             CString msg;
             if(err == ERROR_INVALID_PARAMETER)
                msg.LoadString(IDS_ERROR_VALUE);
             else
                msg = ErrorString(err);
             ::EnablePair(wnd, FALSE);
             text = msg;
            } /* failed */
         else
            { /* got length */
             CString s;
             LPTSTR p = s.GetBuffer(result);
             if(!GetCalendarInfo(lcid, calid, caltype, p, result, NULL))
                { /* failed actual */
                 DWORD err = ::GetLastError();
                 CString msg;
                 if(err == ERROR_INVALID_PARAMETER)
                    msg.LoadString(IDS_ERROR_VALUE);
                 else
                    msg = ErrorString(err);
                 ::EnablePair(wnd, FALSE);
                 text = msg;
                 s.ReleaseBuffer();
                } /* failed actual */
             else
                { /* succeeded */
                 s.ReleaseBuffer();
                 text = s;
                 ::EnablePair(wnd, TRUE);
                } /* succeeded */
            } /* got length */
         RTLMap(text, lcid);
         wnd->SetWindowText(text);
        } /* scan windows */
    } // CCalendarInfo::ShowCalendarInfo

/****************************************************************************
*                         CCalendarInfo::Refresh
* Result: void
*       
* Effect: 
*       Shows the data for the selected locale
****************************************************************************/

void CCalendarInfo::Refresh()
    {
     ShowCalendarInfo();
     UpdateCode();
    } // CCalendarInfo::Refresh

/****************************************************************************
*                      CCalendarInfo::EnumCalendInfoProcEx
* Inputs:
*       LPTSTR info:
*       CALID calendar:
* Result: BOOL
*       TRUE, always
* Effect: 
*       Logs the information
* Notes:
*       This shows the typical irresponsible design of most enumerators,
*       which do not take an extra parameter, thus necessitating the use
*       of a global variable. This makes it nearly impossible to use these
*       in multithreaded environments. It is amazing that this bizarre
*       deficiency persists! Even new calls have this defect!
****************************************************************************/
CCalendarInfo * CCalendarInfo::LogWnd = NULL;

/* static */BOOL CALLBACK CCalendarInfo::EnumCalendarInfoProcEx(LPTSTR info, CALID calendar)
    {
     if(LogWnd == NULL)
        return TRUE;
     CString calendarname = LogWnd->GetCaption(IDC_ENUM_ALL_CALENDARS + (UINT)calendar);
     LCID lcid = (LCID)LogWnd->TabParent->SendMessage(UWM_QUERY, (WPARAM)QUERY_LOCALE);
     
     // Handle the special cases
     switch(LogWnd->ItemSelection)
        { /* ItemSelection */
         case CAL_IYEAROFFSETRANGE:
         case CAL_SERASTRING:
            { /* Special MultiSz case */
             CString multi = ExtractMultiSz(info);
            } /* Special MultiSz case */
            break;
         default:
            { /* normal string */
             CString s = info;
             RTLMap(s, lcid);
             int n = LogWnd->c_Output.GetItemCount();
             n = LogWnd->c_Output.InsertItem(n, s);
             LogWnd->c_Output.SetItemText(n, 1, calendarname);
             LogWnd->c_Output.SetItemData(n, lcid);
            } /* normal string */
        } /* ItemSelection */
     return TRUE;
    } // CCalendarInfo::EnumCalendInfoProcEx

/****************************************************************************
*                      CCalendarInfo::EnumCalendarInfoProc
* Inputs:
*       LPTSTR info: Calendar info
* Result: BOOL
*       TRUE, always
* Effect: 
*       Displays the text
* Notes:
*       This shows the typical irresponsible design of most enumerators,
*       which do not take an extra parameter, thus necessitating the use
*       of a global variable. This makes it nearly impossible to use these
*       in multithreaded environments. It is amazing that this bizarre
*       deficiency persists! Even new calls have this defect!
****************************************************************************/


/*static */ BOOL CALLBACK CCalendarInfo::EnumCalendarInfoProc(LPTSTR info)
   {
    if(LogWnd == NULL)
       return TRUE;
    CString s = info;
    LCID lcid = (LCID)LogWnd->TabParent->SendMessage(UWM_QUERY, (WPARAM)QUERY_LOCALE);
    CALID calid = 0; // not applicable
    RTLMap(s, lcid);
     int n = LogWnd->c_Output.GetItemCount();
     LogWnd->c_Output.InsertItem(n, s);
     LogWnd->c_Output.SetItemData(n, lcid);
    return TRUE;
   } // CCalendarInfo::EnumCalendarInfoProc

/****************************************************************************
*                          CCalendarInfo::UpdateCode
* Result: void
*       
* Effect: 
*       Updates the code
****************************************************************************/

void CCalendarInfo::UpdateCode()
    {
     if(!initialized)
         return;
     EnableQuery(QUERY_NOUSEROVERRIDE, TRUE);
     EnableQuery(QUERY_USE_CP_ACP, TRUE);
     EnableQuery(QUERY_DWORD, c_GetCalendarInfo.GetCheck() == BST_CHECKED && CanBeDWord(ItemSelection));

     CString or = QueryTemplate(_T("[OR]"));


     if(ItemSelection == 0)
        { /* no item */
         CString s;
         s.LoadString(IDS_SELECT_CALTYPE);
         SetCode(s, FALSE);
         QueryTemplate(_T(""));
         return;
        } /* no item */

     BOOL dw = QueryDWORD();
     CString fmt;
     CString defaultCallback;
     if(c_EnumCalendar.GetCheck() == BST_CHECKED)
        { /* EnumCalendar */
         fmt = QueryTemplate(_T("[EnumCalendarInfo]"));
         defaultCallback = _T("EnumCalendarInfoProc");
        } /* Enumcalendar */
     else
     if(c_EnumCalendarEx.GetCheck() == BST_CHECKED)
        { /* EnumCalendarEx */
         fmt = QueryTemplate(_T("[EnumCalendarInfoEx]"));
         defaultCallback = _T("EnumCalendarInfoProcEx");
        } /* EnumCalendarEx */
     else
     if(c_GetCalendarInfo.GetCheck() == BST_CHECKED)
        { /* GetCalendarInfo */
         if(CanBeDWord(ItemSelection) && dw)
            fmt = QueryTemplate(_T("[GetCalendarInfo:DWORD]"));
         else
            fmt = QueryTemplate(_T("[GetCalendarInfo:VARIABLE]"));
        } /* GetCalendarInfo */

     DWORD dword_flag = 0;
     if(dw)
        dword_flag |= CAL_RETURN_NUMBER;
     

     // %1:    the LCID as symbolic or hex
     // %2:    the CALTYPE name
     // %3:    the CALTYPE options (see below)
     // %4:    the fixed length (as a character string) (not applicable to EnumCalendar(Ex)
     // %5:    the variable name
     // %6:    The CALTYPE value, with flags, as a decimal integer (for languages like VB)
     // %7:    The bitwise OR operator
     // %8:    The LCID as a decimal integer
     // %9:    The CALID value as a string
     //%10:    The CALID value as a decimal integer
     //%11:    The callback function name

     //-----------------------------------------------------------------------------
     // %1: The locale ID
     //-----------------------------------------------------------------------------
     CString localeName = GetLocaleName();

     //-----------------------------------------------------------------------------
     // %2: The CALTYPE value as a string
     //-----------------------------------------------------------------------------
     CString caltype = GetCaption(ItemSelection); // CALID

     //-----------------------------------------------------------------------------     
     // %3: Option flags
     //-----------------------------------------------------------------------------

     CString options;   // %3
     if(dw)
        options = _T("CAL_RETURN_NUMBER");
     DWORD flags = ItemSelection;
     GetOptionFlags(options, flags, or);
     if(!options.IsEmpty())
        { /* append */
         options += _T(" ") + or + _T(" ");
        } /* append */
     options += caltype;

     //-----------------------------------------------------------------------------
     // %4: Length
     //-----------------------------------------------------------------------------

     CString length; // empty string, not used

     //-----------------------------------------------------------------------------
     // %5: The variable name
     //-----------------------------------------------------------------------------
     CString variable;  // %5
     variable = GetVariable();
     
     //-----------------------------------------------------------------------------     
     // %6: The CALTYPE as a decimal integer
     //-----------------------------------------------------------------------------
     CString caltypeDecimal;
     caltypeDecimal.Format(_T("%d"), flags | dword_flag);

     //-----------------------------------------------------------------------------
     // %7: The OR operator for bitwise operations
     //-----------------------------------------------------------------------------
     // This was set when the choice was made between C, CPP, MFC, STL or USER

     //-----------------------------------------------------------------------------
     // %8: The locale ID as a decimal integer
     //-----------------------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //-----------------------------------------------------------------------------
     // %9: The CALID value as a string
     //-----------------------------------------------------------------------------

     CString calid = GetCaption(CalidSelection);
     
     //-----------------------------------------------------------------------------
     // %10: The CALID string as a decimal number
     //-----------------------------------------------------------------------------

     CALID id = ControlIDtoCALID(CalidSelection);
     CString calidDecimal;
     calidDecimal.Format(_T("%d"), id);

     //-----------------------------------------------------------------------------
     // %11: The callback function name
     //-----------------------------------------------------------------------------
     CString callbackname;
     c_CallbackName.GetWindowText(callbackname);
     callbackname.TrimLeft();
     callbackname.TrimRight();
     if(callbackname.IsEmpty())
        callbackname = defaultCallback;

     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1           %2       %3       %4       %5           %6        %7     %8            %9      %10           %11
     text.FormatMessage(fmt, localeName,  caltype, options, length, variable, caltypeDecimal, or, localeDecimal, calid, calidDecimal, callbackname);

     //-----------------------------------------------------------------------------------------------
     SetCode(text, !variable.IsEmpty());

     c_Output.DeleteAllItems();
     LogWnd = this;
     
     if(c_EnumCalendar.GetCheck() == BST_CHECKED)
        { /* EnumCalendar */
         if(!EnumCalendarInfo(EnumCalendarInfoProc, lcid, id, flags))
            { /* failed */
             DWORD err = ::GetLastError();
             int n = LogWnd->c_Output.GetItemCount();
             LogWnd->c_Output.InsertItem(n, _T("----------"));
             LogWnd->c_Output.SetItemText(n, 1, ErrorString(err));
             LogWnd->c_Output.SetItemData(n, lcid);
             EnableDisplay(FALSE);
            } /* failed */
         else
            { /* OK string */
             EnableDisplay(TRUE);
            } /* OK string */
        } /* Enumcalendar */
     else
     if(c_EnumCalendarEx.GetCheck() == BST_CHECKED)
        { /* EnumCalendarEx */
         if(!EnumCalendarInfoEx(EnumCalendarInfoProcEx, lcid, id, flags))
            { /* failedex */
             DWORD err = ::GetLastError();
             int n = LogWnd->c_Output.GetItemCount();
             LogWnd->c_Output.InsertItem(n, _T("----------"));
             LogWnd->c_Output.SetItemText(n, 1, ErrorString(err));
             LogWnd->c_Output.SetItemData(n, lcid);
             EnableDisplay(FALSE);
            } /* failedex */
         else
            { /* OK stringex */
             EnableDisplay(TRUE);
            } /* OK stringex */
        } /* EnumCalendarEx */
    } // CCalendarInfo::UpdateCode

/****************************************************************************
*                       CCalendarInfo::ControlIDtoCALID
* Inputs:
*       UINT ctlid: Control ID
* Result: CALID
*       Calendar ID based on control ID
****************************************************************************/

CALID CCalendarInfo::ControlIDtoCALID(UINT ctlid)
    {
#define case_cal(n) case IDC_##n: return n;
     switch(ctlid)
        { /* ctlid */
         case_cal(ENUM_ALL_CALENDARS);
         case_cal(CAL_GREGORIAN);
         case_cal(CAL_GREGORIAN_US);
         case_cal(CAL_JAPAN);
         case_cal(CAL_TAIWAN);
         case_cal(CAL_KOREA);
         case_cal(CAL_HIJRI);
         case_cal(CAL_THAI);
         case_cal(CAL_HEBREW);
         case_cal(CAL_GREGORIAN_ME_FRENCH);
         case_cal(CAL_GREGORIAN_ARABIC);
         case_cal(CAL_GREGORIAN_XLIT_ENGLISH);
         case_cal(CAL_GREGORIAN_XLIT_FRENCH);
         default:
            return ENUM_ALL_CALENDARS;
        } /* ctlid */
    } // CCalendarInfo::ControlIDtoCALID

/****************************************************************************
*                      CCalendarInfo::OnEnumCalendarInfo
* Result: void
*       
* Effect: 
*       Updates the locale
****************************************************************************/

void CCalendarInfo::OnEnumCalendarInfo()
    {
     // In case we had moved from EnumAll, set up to return to it
     if(EnumCalid != 0)
        { /* reset it */
         CheckRadioButton(IDC_ENUM_ALL_CALENDARS, IDC_CAL_GREGORIAN_XLIT_FRENCH, EnumCalid);
         EnumCalid = 0;
        } /* reset it */
     Refresh();
     updateControls();
    } // CCalendarInfo::OnEnumCalendarInfo

/****************************************************************************
*                     CCalendarInfo::OnEnumCalendarInfoEx
* Result: void
*       
* Effect: 
*       Updates the locale
****************************************************************************/

void CCalendarInfo::OnEnumCalendarInfoEx()
    {
     // In case we had moved from EnumAll, set up to return to it
     if(EnumCalid != 0)
        { /* reset it */
         CheckRadioButton(IDC_ENUM_ALL_CALENDARS, IDC_CAL_GREGORIAN_XLIT_FRENCH, EnumCalid);
         EnumCalid = 0;
        } /* reset it */
     Refresh();
     updateControls();
    } // CCalendarInfo::OnEnumCalendarInfoEx

/****************************************************************************
*                      CCalendarInfo::OnGetCalendarInfo
* Result: void
*       
* Effect: 
*       Updates the locale
****************************************************************************/

void CCalendarInfo::OnGetCalendarInfo()
    {
     EnumCalid = CalidSelection; // save for when we go back
     Refresh();
     updateControls();
    } // CCalendarInfo::OnGetCalendarInfo

/****************************************************************************
*                          CCalendarInfo::CanBeDWord
* Inputs:
*       UINT item: Selection to consider
* Result: BOOl
*       TRUE if the item could be binary
*       FALSE if the item can be only a string
****************************************************************************/

BOOL CCalendarInfo::CanBeDWord(UINT item)
    {
     switch(item)
        { /* item */
         case CAL_ICALINTVALUE:
         case CAL_ITWODIGITYEARMAX:
         case CAL_IYEAROFFSETRANGE:
            return TRUE;
         default:
            return FALSE;
        } /* item */
    } // CCalendarInfo::CanBeDWord

/****************************************************************************
*                        CCalendarInfo::EnableDisplay
* Inputs:
*       BOOL mode: Desired mode
* Result: void
*       
* Effect: 
*       Enables all the display windows
****************************************************************************/

void CCalendarInfo::EnableDisplay(BOOL mode)
    {
     // Find all the output displays and enable them
     for(ALL_CHILDREN(wnd))
        { /* scan all */
         if(!IsDisplay(wnd))
            continue;
         if(::IsEditControl(wnd))
             ::EnablePair(wnd, mode);
        } /* scan all */
    } // CCalendarInfo::EnableDisplay

/****************************************************************************
*                        CCalendarInfo::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CCalendarInfo::updateControls()
    {
     //----------------------------------------------------------------
     // Callback Function Name
     // Callback Function Name caption
     //----------------------------------------------------------------
     BOOL enable = TRUE;
     if(c_GetCalendarInfo.GetCheck() == BST_CHECKED)
        enable = FALSE;

     c_CallbackName.EnableWindow(enable);
     x_CallbackName.EnableWindow(enable);

     if(c_EnumAllCalendars.GetCheck() == BST_CHECKED && !enable)
        { /* switch it */
         // Note the assumption here that +1 will give the next control. This is the expected
         // behavior and the order of the buttons really does matter!
         CheckRadioButton(IDC_ENUM_ALL_CALENDARS, IDC_CAL_GREGORIAN_XLIT_FRENCH, IDC_ENUM_ALL_CALENDARS + 1);
        } /* switch it */
     c_EnumAllCalendars.EnableWindow(enable);

     if(c_EnumCalendarEx.GetCheck() == BST_CHECKED)
        { /* ex form */
         c_Output.SetColumnWidth(1, CalWidth);
        } /* ex form */
     else
        { /* anything else */
         c_Output.SetColumnWidth(1, 0);
        } /* anything else */
    } // CCalendarInfo::updateControls

/****************************************************************************
*                          CCalendarInfo::IsDisplay
* Inputs:
*       CWnd * wnd: Window to test
* Result: BOOL
*       TRUE if window is inside the "display" area
*       FALSE otherwise
****************************************************************************/

BOOL CCalendarInfo::IsDisplay(CWnd * wnd)
    {
     CRect r;
     c_CALTYPE.GetWindowRect(&r);
     CRect w;
     wnd->GetWindowRect(&w);
     CRect t;
     return t.IntersectRect(&r, &w);
    } // CCalendarInfo::IsDisplay

/****************************************************************************
*                            CCalendarInfo::OnSize
* Inputs:
*       UINT nType:
*       int cx: new width
*       int cy: new height
* Result: void
*       
* Effect: 
*       Resizes the output window
****************************************************************************/

void CCalendarInfo::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);

    ExpandBottom(c_Output);
    ExtendColumn(c_Output);
   }

/****************************************************************************
*                         CCalendarInfo::OnSetActive
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CCalendarInfo::OnSetActive()
   {
    updateControls();
   } // CCalendarInfo::OnSetActive


/****************************************************************************
*                            CCalendarInfo::IndexOK
* Inputs:
*       CWnd * wnd: Window to check
* Result: BOOL
*       TRUE to allow the window to be indexed
*       FALSE to skip it
****************************************************************************/

BOOL CCalendarInfo::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_SpareRadio)
        return FALSE;
     return TRUE;
    } // CCalendarInfo::IndexOK

void CCalendarInfo::OnChangeCallbackName() 
    {
     UpdateCode();
    }

/****************************************************************************
*                          CCalendarInfo::QuerySave
* Result: BOOL
*       TRUE, always
****************************************************************************/

BOOL CCalendarInfo::QuerySave()
    {
     return TRUE;
    } // CCalendarInfo::QuerySave

/****************************************************************************
*                             CCalendarInfo::Save
* Inputs:
*       const CString & filename: File name
*       UINT mode: Save mode: 0 (default), 8 (UTF-8), 16 (UTF-16)
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Saves the information
****************************************************************************/

BOOL CCalendarInfo::Save(const CString & filename, UINT mode)
    {
     CBiFile f;

     if(!f.Open(filename, CFile::modeWrite | CFile::modeCreate, mode))
        { /* failed */
         return FALSE;
        } /* failed */

     CString lcname = GetLocaleName();

     try
        { /* try */
         f.WriteBOM();
         f.WriteString(GetOutputHeader());
         f.WriteString(lcname);
         f.WriteString(_T("  "));
         for(int i = IDC_ENUM_ALL_CALENDARS; i <= IDC_CAL_GREGORIAN_XLIT_FRENCH; i++)
            { /* scan controls */
             CButton * b = (CButton *)GetDlgItem(i);
             if(b->GetCheck() == BST_CHECKED)
                { /* got it */
                 CString s;
                 b->GetWindowText(s);
                 s.Replace(_T("&"), _T(""));
                 f.WriteString(s);
                 break;
                } /* got it */
            } /* scan controls */
         f.WriteString(_T("\n\n"));
        } /* try */
     catch (CFileException * e)
        { /* failed */
         e->Delete();
         f.Close();
         return FALSE;
        } /* failed */

     BOOL result = WriteChildren(f);
     f.Close();
     return result;
    } // CCalendarInfo::Save
