#include "stdafx.h"
#include "CharSets.h"

#define CHARSET(x) {_T(#x), x }

static const struct {
   LPCTSTR name;
   UINT id; } Charsets[] = {
      CHARSET(ANSI_CHARSET),
      CHARSET(DEFAULT_CHARSET),
      CHARSET(SYMBOL_CHARSET),
      CHARSET(SHIFTJIS_CHARSET),
      CHARSET(HANGUL_CHARSET),
      CHARSET(GB2312_CHARSET),
      CHARSET(CHINESEBIG5_CHARSET),
      CHARSET(OEM_CHARSET),
      CHARSET(JOHAB_CHARSET),
      CHARSET(HEBREW_CHARSET),
      CHARSET(ARABIC_CHARSET),
      CHARSET(GREEK_CHARSET),
      CHARSET(TURKISH_CHARSET),
      CHARSET(VIETNAMESE_CHARSET),
      CHARSET(THAI_CHARSET),
      CHARSET(EASTEUROPE_CHARSET),
      CHARSET(RUSSIAN_CHARSET),
      CHARSET(MAC_CHARSET),
      CHARSET(BALTIC_CHARSET),
            { NULL, 0}
   };


/****************************************************************************
*                               GetCharsetName
* Inputs:
*       UINT charset: Charset ID
* Result: CString
*       Printable name (might be decimal integer
****************************************************************************/

CString GetCharsetName(UINT charset)
    {
     for(int i = 0; Charsets[i].name != NULL; i++)
        { /* scan table */
         if(Charsets[i].id == charset)
            return CString(Charsets[i].name);
        } /* scan table */
     CString s;
     s.Format(_T("%d"), charset);
     return s;
    } // GetCharsetName
   
