// CodePageCombo.cpp : implementation file
//

#include "stdafx.h"
#include "CodePageCombo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCodePageCombo

CCodePageCombo::CCodePageCombo()
{
}

CCodePageCombo::~CCodePageCombo()
{
}


BEGIN_MESSAGE_MAP(CCodePageCombo, CIDCombo)
        //{{AFX_MSG_MAP(CCodePageCombo)
                // NOTE - the ClassWizard will add and remove mapping macros here.
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodePageCombo message handlers

int CCodePageCombo::CompareItem(LPCOMPAREITEMSTRUCT cis) 
   {
    // TODO: Add your code to determine the sorting order of the specified items
    // return -1 = item 1 sorts before item 2
    // return 0 = item 1 and item 2 sort the same
    // return 1 = item 1 sorts after item 2

    Info * info1 = (Info *)cis->itemData1;
    Info * info2 = (Info *)cis->itemData2;
        
    return (int)info1->codepage - (int)info2->codepage;
   }

void CCodePageCombo::DrawItem(LPDRAWITEMSTRUCT dis) 
   {
    CDC * dc = CDC::FromHandle(dis->hDC);
    CRect r = dis->rcItem;

    COLORREF txcolor;
    COLORREF bkcolor;

    if(dis->itemState & ODS_SELECTED)
       { /* selected */
        bkcolor = GetSysColor(COLOR_HIGHLIGHT);
        txcolor = GetSysColor(COLOR_HIGHLIGHTTEXT);
       } /* selected */
    else
       { /* unselected */
        if(dis->itemState & (ODS_DISABLED | ODS_GRAYED))
           txcolor = GetSysColor(COLOR_GRAYTEXT);
        else
           txcolor = GetSysColor(COLOR_WINDOWTEXT);

        bkcolor = GetSysColor(COLOR_WINDOW);
       } /* unselected */

    Info * info = (Info *)dis->itemData;

    dc->SetBkColor(bkcolor);
    dc->SetTextColor(txcolor);

    CBrush br;
    CBrush * oldbrush;

    br.CreateSolidBrush(bkcolor);
    oldbrush = dc->SelectObject(&br);

    dc->PatBlt(r.left, r.top, r.Width(), r.Height(), PATCOPY);

    dc->SelectObject(oldbrush);
    br.DeleteObject();

    if(dis->itemID != (UINT)-1 
       && (dis->itemState & (ODS_DISABLED | ODS_GRAYED)) == 0)
       { /* has item */
        dc->TextOut(r.left, r.top, info->text);
       } /* has item */

    if(dis->itemState & ODS_FOCUS && dis->itemAction != ODA_SELECT)
       dc->DrawFocusRect(&r);
   }

void CCodePageCombo::DeleteItem(LPDELETEITEMSTRUCT dis) 
   {
    Info * info = (Info *)dis->itemData;
    delete info;
        
    CIDCombo::DeleteItem(dis);
   }

/****************************************************************************
*                          CCodePageCombo::AddString
* Inputs:
*       LPCTSTR name:
*       UINT id:
* Result: int
*       
* Effect: 
*       Adds the string
****************************************************************************/

int CCodePageCombo::AddString(LPCTSTR name, UINT id)
    {
     int n = CComboBox::AddString((LPCTSTR)new Info(name, id));
     return n;
    } // CCodePageCombo::AddString

/****************************************************************************
*                       CCodePageCombo::SupersedeString
* Inputs:
*       LPCTSTR s: String
*       UINT id:
* Result: int
*       Place where it was inserted
* Effect: 
*       Inserts the string. If a value of id already exists, it is replaced
****************************************************************************/

int CCodePageCombo::SupersedeString(LPCTSTR s, UINT id)
    {
     for(int i = 0; i < GetCount(); i++)
        { /* scan for existence */
         Info * info = (Info *)CIDCombo::GetItemDataPtr(i);
         if(info->codepage == id)
            { /* found duplicate */
             CIDCombo::DeleteString(i);
             break;
            } /* found duplicate */
        } /* scan for existence */
     return AddString(s, id);
    } // CCodePageCombo::SupersedeString

/****************************************************************************
*                           CCodePageCombo::Select
* Inputs:
*       UINT cp: Code page ID
* Result: int
*       Entry for codepage, or CB_ERR if not found
****************************************************************************/

int CCodePageCombo::Select(UINT cp)
    {
     for(int i = 0; i < GetCount(); i++)
        { /* scan for value */
         if(GetCodePage(i) == cp)
            { /* found it */
             SetCurSel(i);
             return i;
            } /* found it */
        } /* scan for value */
     return CB_ERR;
    } // CCodePageCombo::Select
