// CodePageInfo.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "CodePageInfo.h"
#include "Query.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CCodePageInfo, CFunction)

/////////////////////////////////////////////////////////////////////////////
// CCodePageInfo dialog


CCodePageInfo::CCodePageInfo(CWnd* pParent /*=NULL*/)
        : CFunction(CCodePageInfo::IDD, pParent)
{
        //{{AFX_DATA_INIT(CCodePageInfo)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CCodePageInfo::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CCodePageInfo)
        DDX_Control(pDX, IDC_CP_THREAD_ACP, c_CP_THREAD_ACP);
        DDX_Control(pDX, IDC_CP_OEMCP, c_CP_OEMCP);
        DDX_Control(pDX, IDC_CP_MACCP, c_CP_MACCP);
        DDX_Control(pDX, IDC_CP_ACP, c_CP_ACP);
        DDX_Control(pDX, IDC_RESULT, c_Result);
        DDX_Control(pDX, IDC_MAXCHARSIZE_CAPTION, x_MaxCharSize);
        DDX_Control(pDX, IDC_DEFAULTCHAR_CAPTION, x_DefaultChar);
        DDX_Control(pDX, IDC_GETOEMCP, c_GetOEMCP);
        DDX_Control(pDX, IDC_CP_SUPPORTED, c_CP_SUPPORTED);
        DDX_Control(pDX, IDC_CP_INSTALLED, c_CP_INSTALLED);
        DDX_Control(pDX, IDC_SOURCE_CODEPAGE, c_SourceCodePage);
        DDX_Control(pDX, IDC_GETACP, c_GetACP);
        DDX_Control(pDX, IDC_UNICODEDEFAULTCHARCAPTION, x_UnicodeDefaultChar);
        DDX_Control(pDX, IDC_UNICODEDEFAULTCHAR, c_UnicodeDefaultChar);
        DDX_Control(pDX, IDC_LEADBYTE_CAPTION, x_LeadByte);
        DDX_Control(pDX, IDC_DEFAULTCHAR, c_DefaultChar);
        DDX_Control(pDX, IDC_MAXCHARSIZE, c_MaxCharSize);
        DDX_Control(pDX, IDC_LEADBYTE, c_LeadByte);
        DDX_Control(pDX, IDC_CODEPAGENAME_CAPTION, x_CodePageName);
        DDX_Control(pDX, IDC_CODEPAGENAME, c_CodePageName);
        DDX_Control(pDX, IDC_CODEPAGE_CAPTION, x_CodePage);
        DDX_Control(pDX, IDC_CODEPAGE, c_CodePage);
        DDX_Control(pDX, IDC_API, c_API);
        DDX_Control(pDX, IDC_GETCPINFOEX, c_GetCPInfoEx);
        DDX_Control(pDX, IDC_GETCPINFO, c_GetCPInfo);
        DDX_Control(pDX, IDC_CODEPAGES, c_CodePages);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCodePageInfo, CFunction)
        //{{AFX_MSG_MAP(CCodePageInfo)
        ON_BN_CLICKED(IDC_GETCPINFO, OnGetcpinfo)
        ON_BN_CLICKED(IDC_GETCPINFOEX, OnGetcpinfoex)
        ON_WM_SIZE()
        ON_BN_CLICKED(IDC_GETACP, OnGetacp)
        ON_BN_CLICKED(IDC_SOURCE_CODEPAGE, OnSourceCodepage)
        ON_BN_CLICKED(IDC_CP_INSTALLED, OnCpInstalled)
        ON_BN_CLICKED(IDC_CP_SUPPORTED, OnCpSupported)
        ON_NOTIFY(LVN_ODSTATECHANGED, IDC_CODEPAGES, OnOdstatechangedCodepages)
        ON_NOTIFY(NM_CLICK, IDC_CODEPAGES, OnClickCodepages)
        ON_BN_CLICKED(IDC_GETOEMCP, OnGetoemcp)
        ON_BN_CLICKED(IDC_CP_THREAD_ACP, OnCpThreadAcp)
        ON_BN_CLICKED(IDC_CP_OEMCP, OnCpOemcp)
        ON_BN_CLICKED(IDC_CP_MACCP, OnCpMaccp)
        ON_BN_CLICKED(IDC_CP_ACP, OnCpAcp)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodePageInfo message handlers

BOOL CCodePageInfo::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    // TODO: Add extra initialization here
    CheckRadioButton(IDC_GETCPINFO, IDC_GETCPINFOEX, IDC_GETCPINFO);

    variable = _T("info");

    CheckRadioButton(IDC_GETACP, IDC_SOURCE_CODEPAGE, IDC_GETACP);
    CheckRadioButton(IDC_CP_INSTALLED, IDC_CP_SUPPORTED, IDC_CP_INSTALLED);
    UpdateCodePageList();
    updateControls();
        
    return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                            CCodePageInfo::OnSize
* Inputs:
*       UINT nType:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Extends the code page list
****************************************************************************/

void CCodePageInfo::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);
        
    ExpandBottom(c_CodePages);

    ExtendColumn(c_CodePages);
   }

/****************************************************************************
*                        CCodePageInfo::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CCodePageInfo::updateControls()
    {
     if(!initialized)
        return;

     BOOL ExEnable = FALSE;
     CString caption;

     if(c_GetCPInfo.GetCheck() == BST_CHECKED)
        { /* GetCPInfo */
         caption = _T("CPINFO");
         ExEnable = FALSE;
        } /* GetCPInfo */         
     else
     if(c_GetCPInfoEx.GetCheck() == BST_CHECKED)
        { /* GetCPInfoEx */
         caption = _T("CPINFOEX");
         ExEnable = TRUE;
        } /* GetCPInfoEx */
     else
        ASSERT(FALSE);

     c_API.SetWindowText(caption);

     x_UnicodeDefaultChar.EnableWindow(ExEnable);
     c_UnicodeDefaultChar.EnableWindow(ExEnable);

     x_CodePage.EnableWindow(ExEnable);
     c_CodePage.EnableWindow(ExEnable);

     x_CodePageName.EnableWindow(ExEnable);
     c_CodePageName.EnableWindow(ExEnable);

     UINT show = ExEnable ? SW_SHOW : SW_HIDE;

     x_UnicodeDefaultChar.ShowWindow(show);
     c_UnicodeDefaultChar.ShowWindow(show);

     x_CodePage.ShowWindow(show);
     c_CodePage.ShowWindow(show);

     x_CodePageName.ShowWindow(show);
     c_CodePageName.ShowWindow(show);
     
     if(c_CodePages.GetSelectedCount() == 1)
        { /* has selection */
         POSITION pos = c_CodePages.GetFirstSelectedItemPosition();
         int sel = c_CodePages.GetNextSelectedItem(pos);
         // Remember that a negative ItemData means there was an error
         // in getting the description
         int cp  = (int)c_CodePages.GetItemData(sel);
         CString s;
         s = c_CodePages.GetItemText(sel, 1);
         if(s.IsEmpty() || cp < 0)
            s = c_CodePages.GetItemText(sel, 0);
         c_SourceCodePage.SetWindowText(s);
         c_SourceCodePage.SetUserData(cp);
        } /* has selection */
     else
        { /* no selection */
         CString s;
         s.LoadString(IDS_NO_SELECTION);
         c_SourceCodePage.SetWindowText(s);
         c_SourceCodePage.SetUserData(0);
        } /* no selection */
    } // CCodePageInfo::updateControls

void CCodePageInfo::OnGetcpinfo() 
   {
    updateControls();
    Refresh();
   }

void CCodePageInfo::OnGetcpinfoex() 
   {
    updateControls();
    Refresh();
   }

/****************************************************************************
*                     CCodePageInfo::EnableOutputDisplay
* Inputs:
*       BOOL result: Desired result
* Result: void
*       
* Effect: 
*       Enables/disables the output display
****************************************************************************/

void CCodePageInfo::EnableOutputDisplay(BOOL result)
    {
     c_MaxCharSize.EnableWindow(result);
     x_MaxCharSize.EnableWindow(result);

     c_DefaultChar.EnableWindow(result);
     x_DefaultChar.EnableWindow(result);

     c_LeadByte.EnableWindow(result);
     x_LeadByte.EnableWindow(result);

     c_UnicodeDefaultChar.EnableWindow(result);
     x_UnicodeDefaultChar.EnableWindow(result);

     c_CodePage.EnableWindow(result);   
     x_CodePage.EnableWindow(result);

     c_CodePageName.EnableWindow(result);
     x_CodePageName.EnableWindow(result);
    } // CCodePageInfo::EnableOutputDisplay


/****************************************************************************
*                           CCodePageInfo::Refresh
* Result: void
*       
* Effect: 
*       Updates the code sample
****************************************************************************/

void CCodePageInfo::Refresh()
    {
     if(!initialized)
        return;

     BOOL hasformat = TRUE;

     updateControls();
     
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;

     if(c_GetCPInfo.GetCheck() == BST_CHECKED)
        { /* GetCPIno */
         fmt = QueryTemplate(_T("[GetCPInfo:VARIABLE]"));
        } /* GetCPIno */
     else
     if(c_GetCPInfoEx.GetCheck() == BST_CHECKED)
        { /* GetCPInfoEx */
         fmt = QueryTemplate(_T("[GetCPInfoEx:VARIABLE]"));
        } /* GetCPInfoEx */
     else
        ASSERT(FALSE);
     
     int sel = c_CodePages.GetSelectedCount();
     if(c_SourceCodePage.GetCheck() == BST_CHECKED && sel != 1)
        { /* no selection */
         fmt.LoadString(IDS_NO_SELECTION);
         hasformat = FALSE;
        } /* no selection */

     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2: The CodePage as a string
     //----------------------------------------------------------------
     CString CodePage;
     CString CodePageName;
     c_SourceCodePage.GetWindowText(CodePage);
     CodePageName = CodePage;
     UINT cp = c_SourceCodePage.GetUserData();

     switch(cp)
        { /* cp */
         case CP_ACP:
         case CP_MACCP:
         case CP_OEMCP:
         case CP_THREAD_ACP:
            break;
         default:
            CodePage.Format(_T("%u"), cp);
            break;
        } /* cp */

     if(c_GetACP.GetCheck() == BST_CHECKED)
        { /* use ACP */
         CodePage = _T("GetACP()");
         CodePageName = CodePage;
         cp = ::GetACP();
        } /* use ACP */
     else
     if(c_GetOEMCP.GetCheck() == BST_CHECKED)
        { /* use OEM */
         CodePage = _T("GetOEMCP()");
         CodePageName = CodePage;
         cp = ::GetOEMCP();
        } /* use OEM */
     else
     if(c_CP_ACP.GetCheck() == BST_CHECKED)
        { /* CP_ACP */
         CodePage = _T("CP_ACP");
         CodePageName = CodePage;
         cp = CP_ACP;
        } /* CP_ACP */
     else
     if(c_CP_MACCP.GetCheck() == BST_CHECKED)
        { /* CP_MACCP */
         CodePage = _T("CP_MACCP");
         CodePageName = CodePage;
         cp = CP_MACCP;
        } /* CP_MACCP */
     else
     if(c_CP_THREAD_ACP.GetCheck() == BST_CHECKED)
        { /* CP_THREAD_ACP */
         CodePage = _T("CP_THREAD_ACP");
         CodePageName = CodePage;
         cp = CP_THREAD_ACP;
        } /* CP_THREAD_ACP */
     else
     if(c_CP_OEMCP.GetCheck() == BST_CHECKED)
        { /* CP_ACP */
         CodePage = _T("CP_OEMCP");
         CodePageName = CodePage;
         cp = CP_OEMCP;
        } /* CP_OEMCP */
     else
     if(c_SourceCodePage.GetCheck() == BST_CHECKED)
         { /* user-defined */
         } /* user-defined */
     else
        ASSERT(FALSE);

     //----------------------------------------------------------------
     // %3: not used
     //----------------------------------------------------------------
     CString options;

     //----------------------------------------------------------------
     // %4: Length: not used
     //----------------------------------------------------------------
     CString length;

     //----------------------------------------------------------------
     // %5: The variable name
     //----------------------------------------------------------------
     CString variable;
     variable = GetVariable();
     
     //----------------------------------------------------------------
     // %6: Codepage as a decimal number
     //----------------------------------------------------------------
     CString dwFlagsDecimal;
     dwFlagsDecimal.Format(_T("%d"), 0); // todo
     if(c_GetACP.GetCheck() == BST_CHECKED)
        { /* use ACP */
         dwFlagsDecimal = _T("GetACP()");
        } /* use ACP */
     else
     if(c_GetOEMCP.GetCheck() == BST_CHECKED)
        { /* use OEM */
         dwFlagsDecimal = _T("GetOEMCP()");
        } /* use OEM */
     else
     if(c_CP_ACP.GetCheck() == BST_CHECKED)
        { /* CP_ACP */
         dwFlagsDecimal.Format(_T("%d"), CP_ACP);
        } /* CP_ACP */
     else
     if(c_CP_OEMCP.GetCheck() == BST_CHECKED)
        { /* CP_OEMCP */
         dwFlagsDecimal.Format(_T("%d"), CP_OEMCP);
        } /* CP_OEMCP */
     else
     if(c_CP_MACCP.GetCheck() == BST_CHECKED)
        { /* CP_MACCP */
         dwFlagsDecimal.Format(_T("%d"), CP_MACCP);
        } /* CP_MACCP */
     else
     if(c_CP_THREAD_ACP.GetCheck() == BST_CHECKED)
        { /* CP_THREAD_ACP */
         dwFlagsDecimal.Format(_T("%d"), CP_THREAD_ACP);
        } /* CP_THREAD_ACP */
     else
     if(c_SourceCodePage.GetCheck() == BST_CHECKED)
        { /* user page */
         UINT cp = c_SourceCodePage.GetUserData();
         dwFlagsDecimal.Format(_T("%d"), cp);
        } /* user page */
     else
        { /* none of the above */
         ASSERT(FALSE);
         dwFlagsDecimal = _T("0");
        } /* none of the above */

     //----------------------------------------------------------------
     // %7: The OR operator for bitwise operations
     //----------------------------------------------------------------
     // This was set when the language choice was made

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal integer
     //----------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %9: Not used
     //----------------------------------------------------------------


     //----------------------------------------------------------------
     // %10: Code page name 
     //----------------------------------------------------------------
     // CodePageName was set back with %2

     //----------------------------------------------------------------
     // %11: Not used
     //----------------------------------------------------------------

     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1           %2        %3       %4       %5           %6        %7     %8      %9       %10         %11
     text.FormatMessage(fmt, localeName,  CodePage, _T(""), _T(""), variable, dwFlagsDecimal,  or, _T(""), _T(""), CodePageName, _T(""));

     //-----------------------------------------------------------------------------------------------
     SetCode(text, !variable.IsEmpty() && hasformat);

     BOOL result;
     if(sel == 1 || c_SourceCodePage.GetCheck() == BST_UNCHECKED)
        { /* can do it */
         if(c_GetCPInfo.GetCheck() == BST_CHECKED)
            { /* GetCPInfo */
             CPINFO info;
             result = GetCPInfo(cp, &info);
             if(result)
                { /* got values */
                 c_Result.SetWindowText(_T(""));

                 CString s;
                 //----------------------------------------------------------------
                 // MaxCharSize
                 //----------------------------------------------------------------
                 s.Format(_T("%u"), info.MaxCharSize);
                 c_MaxCharSize.SetWindowText(s);
                 //----------------------------------------------------------------
                 // DefaultChar
                 //----------------------------------------------------------------
                 s.Format(_T("0x%02x ('%c')"), info.DefaultChar[0], info.DefaultChar[0]);
                 c_DefaultChar.SetWindowText(s);
                 //----------------------------------------------------------------
                 // LeadByte
                 //----------------------------------------------------------------
                 s = _T("");
                 for(int i = 0; i < MAX_LEADBYTES; i++)
                    { /* leadbytes */
                     CString t;
                     t.Format(_T("%02x "), info.LeadByte[i]);
                     s += t;
                    } /* leadbytes */
                 c_LeadByte.SetWindowText(s);
                } /* got values */
             else
                { /* error */
                 DWORD err = ::GetLastError();
                 c_Result.SetWindowText(ErrorString(err));
                 c_MaxCharSize.SetWindowText(_T(""));
                 c_DefaultChar.SetWindowText(_T(""));
                 c_LeadByte.SetWindowText(_T(""));
                } /* error */
            } /* GetCPInfo */
         else
            { /* GetCPInfoEx */
             CPINFOEX info;
             result = GetCPInfoEx(cp, 0, &info);
             if(result)
                { /* success */
                 c_Result.SetWindowText(_T(""));

                 CString s;
                 //----------------------------------------------------------------
                 // MaxCharSize
                 //----------------------------------------------------------------
                 s.Format(_T("%u"), info.MaxCharSize);
                 c_MaxCharSize.SetWindowText(s);
                 //----------------------------------------------------------------
                 // DefaultChar
                 //----------------------------------------------------------------
                 s.Format(_T("0x%02x ('%c')"), info.DefaultChar[0], info.DefaultChar[0]);
                 c_DefaultChar.SetWindowText(s);
                 //----------------------------------------------------------------
                 // LeadByte
                 //----------------------------------------------------------------
                 s = _T("");
                 for(int i = 0; i < MAX_LEADBYTES; i++)
                    { /* leadbytes */
                     CString t;
                     t.Format(_T("%02x "), info.LeadByte[i]);
                     s += t;
                    } /* leadbytes */
                 c_LeadByte.SetWindowText(s);
                 //----------------------------------------------------------------
                 // UnicodeDefaultChar
                 //----------------------------------------------------------------
                 s.Format(_T("0x%04x (L'%c')"), info.UnicodeDefaultChar, info.UnicodeDefaultChar);
                 c_UnicodeDefaultChar.SetWindowText(s);
                 //----------------------------------------------------------------
                 // CodePage
                 //----------------------------------------------------------------
                 s.Format(_T("%d"), info.CodePage);
                 c_CodePage.SetWindowText(s);
                 //----------------------------------------------------------------
                 // CodePageName
                 //----------------------------------------------------------------
                 c_CodePageName.SetWindowText(info.CodePageName);
                } /* success */
             else
                { /* error */
                 DWORD err = ::GetLastError();
                 c_Result.SetWindowText(ErrorString(err));
                 c_MaxCharSize.SetWindowText(_T(""));
                 c_DefaultChar.SetWindowText(_T(""));
                 c_LeadByte.SetWindowText(_T(""));
                 c_UnicodeDefaultChar.SetWindowText(_T(""));
                 c_CodePage.SetWindowText(_T(""));
                 c_CodePageName.SetWindowText(_T(""));
                } /* error */
            } /* GetCPInfoEx */
        } /* can do it */
     else
        { /* can't do it */
         // We have c_SourceCodePage selected but there is
         // no active selection
         result = FALSE;
         CString s;
         s.LoadString(IDS_NO_SELECTION);
         c_Result.SetWindowText(s);
        } /* can't do it */
     EnableOutputDisplay(result);
    } // CCodePageInfo::Refresh

/****************************************************************************
*                      CCodePageInfo::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the fonts to the controls
****************************************************************************/

void CCodePageInfo::SetFontToControls()
    {
     
    } // CCodePageInfo::SetFontToControls

void CCodePageInfo::OnGetacp() 
   {
    Refresh();
   }

void CCodePageInfo::OnSourceCodepage() 
   {
    Refresh();
   }

void CCodePageInfo::OnGetoemcp() 
   {
    Refresh();
   }

void CCodePageInfo::OnCpThreadAcp() 
   {
    Refresh();
   }

void CCodePageInfo::OnCpOemcp() 
   {
    Refresh();
   }

void CCodePageInfo::OnCpMaccp() 
   {
    Refresh();
   }

void CCodePageInfo::OnCpAcp() 
   {
    Refresh();
   }
   

/****************************************************************************
*                         CCodePageInfo::OnSetActive
* Result: void
*       
* Effect: 
*       Updates the page
****************************************************************************/

void CCodePageInfo::OnSetActive()
    {
     updateControls();
    } // CCodePageInfo::OnSetActive


/****************************************************************************
*                        CCodePageInfo::OnCpInstalled
*                        CCodePageInfo::OnCpSupported
* Result: void
*       
* Effect: 
*       Reloads the codepage list
****************************************************************************/

void CCodePageInfo::OnCpInstalled() 
   {
    UpdateCodePageList();
   }

void CCodePageInfo::OnCpSupported() 
   {
    UpdateCodePageList();
   }

/****************************************************************************
*                      CCodePageInfo::UpdateCodePageList
* Result: void
*       
* Effect: 
*       Updates the code page list
****************************************************************************/

void CCodePageInfo::UpdateCodePageList()
    {
     DWORD flags = 0;
     if(c_CP_INSTALLED.GetCheck() == BST_CHECKED)
        { /* CP_INSTALLED */
         flags = CP_INSTALLED;
        } /* CP_INSTALLED */
     else
     if(c_CP_SUPPORTED.GetCheck() == BST_CHECKED)
        { /* CP_SUPPORTED */
         flags = CP_SUPPORTED;
        } /* CP_SUPPORTED */

     c_CodePages.Load(flags);
    } // CCodePageInfo::UpdateCodePageList

/****************************************************************************
*                  CCodePageInfo::OnOdstatechangedCodepages
* Inputs:
*       NMHDR * pNMHDR: header
*       LRESULT * pResult: 0, always
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CCodePageInfo::OnOdstatechangedCodepages(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    NMLVODSTATECHANGE* pStateChanged = (NMLVODSTATECHANGE*)pNMHDR;
    updateControls();
    Refresh();
    *pResult = 0;
   }

void CCodePageInfo::OnClickCodepages(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    updateControls();
    if(c_CodePages.GetSelectedCount() == 1)
       { /* force selection */
        CheckRadioButton(IDC_GETACP, IDC_SOURCE_CODEPAGE, IDC_SOURCE_CODEPAGE);
       } /* force selection */
    Refresh();
        
    *pResult = 0;
   }

/****************************************************************************
*                          CCodePageInfo::QuerySave
* Result: BOOL
*       TRUE to allow save
*       FALSE for no save
****************************************************************************/

BOOL CCodePageInfo::QuerySave()
    {
     return c_CodePages.GetItemCount() > 0;
    } // CCodePageInfo::QuerySave


/****************************************************************************
*                             CCodePageInfo::Save
* Inputs:
*       const CString & filename: File name to use
*       UINT mode: Desired save mode: 0 (default), 8 (UTF-8) or 16 (UTF-16)
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Saves the list of pages
****************************************************************************/

BOOL CCodePageInfo::Save(const CString & filename, UINT mode)
    {
     return c_CodePages.Save(filename, mode);
    } // CCodePageInfo::Save
