// CompareString.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "CompareString.h"
#include "Query.h"
#include "ErrorString.h"
#include "RegVars.h"
#include "lcids.h"
#include "AddFlag.h"
#include "OpenFileEx.h"
#include "strsafe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CCompareString, CFunction)

#define ASCII_RANGE (((DWORD)_T('~') - (DWORD)_T(' ')) + (DWORD)(0xFF - 0xA1))

/////////////////////////////////////////////////////////////////////////////
// CCompareString dialog


CCompareString::CCompareString(CWnd* pParent /*=NULL*/)
        : CFunction(CCompareString::IDD, pParent)
   {
        //{{AFX_DATA_INIT(CCompareString)
        //}}AFX_DATA_INIT
    lastLCID = (LCID)-1;
   }


void CCompareString::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CCompareString)
        DDX_Control(pDX, IDC_COMPARISON_BOX, x_Comparison);
        DDX_Control(pDX, IDC_USE_UNICODE, c_UseUnicode);
        DDX_Control(pDX, IDC_USE_ASCII, c_UseASCII);
        DDX_Control(pDX, IDC_CLEAR, c_Clear);
        DDX_Control(pDX, IDC_NORM_IGNORENONSPACE, c_NORM_IGNORENONSPACE);
        DDX_Control(pDX, IDC_PROGRESS, c_Progress);
        DDX_Control(pDX, IDC_DATA_SOURCE_CAPTION, x_DataSource);
        DDX_Control(pDX, IDC_SORTID_CAPTION, x_SortID);
        DDX_Control(pDX, IDC_CMPFLAGS_CAPTION, x_dwCmpFlags);
        DDX_Control(pDX, IDC_LSTRCMPI, c_lstrcmpi);
        DDX_Control(pDX, IDC_LSTRCMP, c_lstrcmp);
        DDX_Control(pDX, IDC_RELOAD, c_Reload);
        DDX_Control(pDX, IDC_TCSICMP, c_UseTcsiCmp);
        DDX_Control(pDX, IDC_TCSCMP, c_UseTcsCmp);
        DDX_Control(pDX, IDC_COMPARESTRING, c_UseCompareString);
        DDX_Control(pDX, IDC_UNICODE_RANGES_CAPTION, x_UnicodeRanges);
        DDX_Control(pDX, IDC_UNICODE_RANGES, c_UnicodeRanges);
        DDX_Control(pDX, IDC_ERRORMESSAGE, c_ErrorMessage);
        DDX_Control(pDX, IDC_SORTID, c_SortID);
        DDX_Control(pDX, IDC_LCID_DISPLAY, c_LCIDDisplay);
        DDX_Control(pDX, IDC_USERDATA, c_UserData);
        DDX_Control(pDX, IDC_TWOSTRINGS, c_TwoStrings);
        DDX_Control(pDX, IDC_RANDOMSTRINGS, c_AllStrings);
        DDX_Control(pDX, IDC_SORT_STRINGSORT, c_SORT_STRINGSORT);
        DDX_Control(pDX, IDC_NORM_IGNOREWIDTH, c_NORM_IGNOREWIDTH);
        DDX_Control(pDX, IDC_STRING2_CAPTION, x_String2);
        DDX_Control(pDX, IDC_STRING2, c_String2);
        DDX_Control(pDX, IDC_STRING1_CAPTION, x_String1);
        DDX_Control(pDX, IDC_STRING1, c_String1);
        DDX_Control(pDX, IDC_SAMPLES, c_Output);
        DDX_Control(pDX, IDC_NORM_IGNORESYMBOLS, c_NORM_IGNORESYMBOLS);
        DDX_Control(pDX, IDC_NORM_IGNOREKANATYPE, c_NORM_IGNOREKANATYPE);
        DDX_Control(pDX, IDC_NORM_IGNORECASE, c_NORM_IGNORECASE);
        DDX_Control(pDX, IDC_FILENAME_CAPTION, x_Filename);
        DDX_Control(pDX, IDC_FILENAME, c_Filename);
        DDX_Control(pDX, IDC_BROWSE, c_Browse);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCompareString, CFunction)
        //{{AFX_MSG_MAP(CCompareString)
        ON_WM_SIZE()
        ON_EN_CHANGE(IDC_FILENAME, OnChangeFilename)
        ON_BN_CLICKED(IDC_NORM_IGNORECASE, OnNormIgnorecase)
        ON_BN_CLICKED(IDC_NORM_IGNOREKANATYPE, OnNormIgnorekanatype)
        ON_BN_CLICKED(IDC_NORM_IGNORESYMBOLS, OnNormIgnoresymbols)
        ON_BN_CLICKED(IDC_NORM_IGNORENONSPACE, OnNormIgnorenonspace)
        ON_BN_CLICKED(IDC_NORM_IGNOREWIDTH, OnNormIgnorewidth)
        ON_BN_CLICKED(IDC_SORT_STRINGSORT, OnSortStringsort)
        ON_BN_CLICKED(IDC_RANDOMSTRINGS, OnAllStrings)
        ON_EN_CHANGE(IDC_STRING1, OnChangeString1)
        ON_EN_CHANGE(IDC_STRING2, OnChangeString2)
        ON_BN_CLICKED(IDC_TWOSTRINGS, OnTwostrings)
        ON_BN_CLICKED(IDC_USERDATA, OnUserdata)
        ON_NOTIFY(LVN_DELETEITEM, IDC_SAMPLES, OnDeleteitemSamples)
        ON_CBN_SELENDOK(IDC_SORTID, OnSelendokSortid)
        ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
        ON_BN_CLICKED(IDC_COMPARESTRING, OnComparestring)
        ON_BN_CLICKED(IDC_TCSCMP, OnTcscmp)
        ON_BN_CLICKED(IDC_TCSICMP, OnTcsicmp)
        ON_BN_CLICKED(IDC_RELOAD, OnReload)
        ON_BN_CLICKED(IDC_LSTRCMP, OnLstrcmp)
        ON_BN_CLICKED(IDC_LSTRCMPI, OnLstrcmpi)
        ON_BN_CLICKED(IDC_CLEAR, OnClear)
        ON_BN_CLICKED(IDC_USE_UNICODE, OnUseUnicode)
        ON_BN_CLICKED(IDC_USE_ASCII, OnUseAscii)
        ON_NOTIFY(LVN_ITEMCHANGED, IDC_SAMPLES, OnItemchangedSamples)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompareString message handlers

BOOL CCompareString::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    // TODO: Add extra initialization here
    CheckRadioButton(IDC_TWOSTRINGS, IDC_USERDATA, IDC_TWOSTRINGS);
    CheckRadioButton(IDC_COMPARESTRING, IDC_TCSICMP, IDC_COMPARESTRING);

    RegistryString string1(IDS_REGISTRY_COMPARESTRING_STRING1);
    string1.load();
    c_String1.SetWindowText(string1.value);

    RegistryString string2(IDS_REGISTRY_COMPARESTRING_STRING2);
    string2.load();
    c_String2.SetWindowText(string2.value);

    c_Output.InsertColumnEx(COL_DESC, IDS_DESCRIPTION_CAPTION, LVCFMT_LEFT);
    c_Output.InsertColumnEx(COL_COMPARE, _T(" ? "), LVCFMT_CENTER,_T("__?__"));
    c_Output.InsertColumnEx(COL_TEXT, IDS_STRING_CAPTION, LVCFMT_LEFT, -1);

#ifndef _UNICODE
    x_UnicodeRanges.ShowWindow(SW_HIDE);
    c_UnicodeRanges.ShowWindow(SW_HIDE);
#endif
    RegistryString userfile(IDS_REGISTRY_USER_SAMPLE);
    userfile.load();
    c_Filename.SetWindowText(userfile.value);

    CheckRadioButton(IDC_USE_UNICODE, IDC_USE_ASCII, IDC_USE_ASCII);

    CFont * font = GetFont();
    if(font != NULL)
       { /* set display font */
        LOGFONT lf;
        font->GetLogFont(&lf);
        StringCchCopy(lf.lfFaceName, LF_FACESIZE, _T("Courier New"));
        CFont courier;
        if(courier.CreateFontIndirect(&lf))
           { /* got font */
            c_UnicodeRanges.SetFont(&courier);
            courier.Detach(); // keep it from going away when local is destroyed
           } /* got font */
       } /* set display font */

    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

void CCompareString::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);
        
    // TODO: Add your message handler code here
    ExpandBottom(c_Output);
   }

void CCompareString::OnChangeFilename() 
   {
    updateControls();
   }

void CCompareString::OnNormIgnorecase() 
   {
    Refresh();
   }

void CCompareString::OnNormIgnorekanatype() 
   {
    Refresh();
   }

void CCompareString::OnNormIgnorenonspace() 
   {
    Refresh();
   }

void CCompareString::OnNormIgnoresymbols() 
   {
    Refresh();
   }

void CCompareString::OnNormIgnorewidth() 
   {
    Refresh();
   }

void CCompareString::OnSortStringsort() 
   {
    Refresh();
   }

void CCompareString::OnAllStrings() 
   {
    InstallData();
    Refresh();
   }

void CCompareString::OnSelendokSortid() 
   {
    Refresh();
   }


void CCompareString::OnComparestring() 
   {
    updateControls();
    Refresh();
   }

void CCompareString::OnTcscmp() 
   {
    updateControls();
    Refresh();
   }

void CCompareString::OnTcsicmp() 
   {
    updateControls();
    Refresh();
   }
   
void CCompareString::OnLstrcmp() 
   {
    updateControls();
    Refresh();
   }

void CCompareString::OnLstrcmpi() 
   {
    updateControls();
    Refresh();
   }

void CCompareString::OnChangeString1() 
   {
    RegistryString string1(IDS_REGISTRY_COMPARESTRING_STRING1);
    c_String1.GetWindowText(string1.value);
    string1.store();
    InstallData();
    Refresh();
   }

void CCompareString::OnChangeString2() 
   {
    RegistryString string2(IDS_REGISTRY_COMPARESTRING_STRING2);
    c_String2.GetWindowText(string2.value);
    string2.store();
    InstallData();
    Refresh();
   }

void CCompareString::OnTwostrings() 
   {
    InstallData();
    Refresh();
   }

void CCompareString::OnUserdata() 
   {
    InstallData();
    Refresh();
   }

/****************************************************************************
*                           CCompareString::compare
* Inputs:
*       LPARAM lParam1: (LPARAM)(SortData *)
*       LPARAM lParam2: (LPARAM)(SortData *)
*       LPARAM data: (LPARAM)(CompareInfo *)
* Result: int
*       < 0 if lParam1 < lParam2
*       == 0 if lParam1 == lParam2
*       > 0 if lParam1 > lParam2;
* Notes:
*       It is assumed that prior to calling any function which performs
*       a sort the appropriate locale has been set using ::SetThreadLocale
****************************************************************************/

/* static */ int CALLBACK CCompareString::compare(LPARAM lParam1, LPARAM lParam2, LPARAM data)
    {
     CompareInfo * info = (CompareInfo *)data;
     // CCompareString * self = (CCompareString *)data;
     SortData * p1 = (SortData *)lParam1;
     SortData * p2 = (SortData *)lParam2;

     p1->compare = p2->compare = 0;
     p1->error = p2->error = ERROR_SUCCESS;
     
     //****************************************************************
     // _tcscmp
     //****************************************************************
     if(info->comparison == CompareInfo::Use_tcscmp)
        { /* tcscmp */
         return normalize(_tcscmp(p1->data, p2->data));
        } /* tcscmp */
     //****************************************************************
     // _tcsicmp
     //****************************************************************
     if(info->comparison == CompareInfo::Use_tcsicmp)
        { /* tcsicmp */
         return normalize(_tcsicmp(p1->data, p2->data));
        } /* tcsicmp */
     //****************************************************************
     // lstrcmp
     //****************************************************************
     if(info->comparison == CompareInfo::Use_lstrcmp)
        { /* lstrcmp */
         return normalize(lstrcmp(p1->data, p2->data));
        } /* lstrcmp */
     //****************************************************************
     // lstrcmpi
     //****************************************************************
     if(info->comparison == CompareInfo::Use_lstrcmpi)
        { /* lstrcmpi */
         return normalize(lstrcmpi(p1->data, p2->data));
        } /* lstrcmpi */
     
     //****************************************************************
     // CompareString
     //****************************************************************
     if(info->comparison == CompareInfo::Use_CompareString)
        { /* CompareString */
         switch(CompareString(info->lcid, info->flags, p1->data, -1, p2->data, -1))
            { /* return value */
             case CSTR_LESS_THAN:
                return -1;
             case CSTR_EQUAL:
                return 0;
             case CSTR_GREATER_THAN:
                return 1;
             case 0:
                return -2;  // special error indicator
             default:
                ASSERT(FALSE);
                return -2; // special error indicator
            } /* return value */
        } /* CompareString */

     ASSERT(FALSE); // unknown comparison
     return -2;
    } // CCompareString::compare

/****************************************************************************
*                          CCompareString::GetFlags
* Inputs:
*       CString & options: Printable string of options
*       DWORD & flags: Flags to set
* Result: void
*       
* Effect: 
*       Sets the flags
****************************************************************************/

void CCompareString::GetFlags(CString & options, DWORD & flags, const CString & or)
    {
     ADDFLAG(NORM_IGNORECASE);
     ADDFLAG(NORM_IGNOREKANATYPE);
     ADDFLAG(NORM_IGNORENONSPACE);
     ADDFLAG(NORM_IGNORESYMBOLS);
     ADDFLAG(NORM_IGNOREWIDTH);
     ADDFLAG(SORT_STRINGSORT);
    } // CCompareString::GetFlags

/****************************************************************************
*                           CCompareString::GetLCID
* Inputs:
*       CString & localeName: Place to put printable locale name
*       LCID & lcid: Place to put LCID
* Result: void
*       
* Effect: 
*       Gets the LCID; sets up subsort IDs
****************************************************************************/

void CCompareString::GetLCID(CString & localeName, LCID & lcid)
    {
     lcid = QueryLocale();

     if(lcid != lastLCID)
        { /* lcid changed */
         AddSortIDs(c_SortID, lcid);
         lastLCID = lcid;
        } /* lcid changed */

     UINT sortindex = c_SortID.GetCurSel();
     UINT sort;
     if(sortindex == CB_ERR)
        sort = SORT_DEFAULT;
     else
        sort = c_SortID.GetItemData(sortindex);

     lcid = MAKELCID(LANGIDFROMLCID(lcid), sort);
     CString slcid;
     slcid.Format(_T("0x%08x"), lcid);
     c_LCIDDisplay.SetWindowText(slcid);

     localeName = GetLCIDString(lcid);
    } // CCompareString::GetLCID

/****************************************************************************
*                       CCompareString::SetCompareState
* Result: void
*       
* Effect: 
*       Sets the compare state to indicate the relation of each string
*       to its following string
****************************************************************************/

void CCompareString::SetCompareState(CompareInfo * info)
    {
     int limit = c_Output.GetItemCount();
     c_Progress.SetRange(0, limit);
     c_Progress.SetPos(0);
     c_Progress.ShowWindow(SW_SHOW);

     //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     // Before doing anything that invokes the "compare" function,
     // the thread locale must be esablished so tnat any code which is
     // locale-sensitive will now become locale-aware
     //****************************************************************
     LCID oldlcid = ::GetThreadLocale();
     ::SetThreadLocale(info->lcid);

     for(int i = 0; i < limit - 1; i++)
        { /* set compare state */
         LPARAM p1 = c_Output.GetItemData(i);
         LPARAM p2 = c_Output.GetItemData(i+1);
         c_Progress.StepIt();
         SortData * s1 = (SortData *)p1;
         int compared = compare(p1, p2, (DWORD_PTR)info);
         if(compared == -2) // error indicator
            { /* failed */
             DWORD err = ::GetLastError();
             c_Output.SetItemText(i, COL_COMPARE, _T("?"));
             s1->error = err;
            } /* failed */
         else
         if(compared < 0)
            { /* < */
             c_Output.SetItemText(i, COL_COMPARE, _T("<"));
             s1->compare = -1;
            } /* < */
         else
         if(compared > 0)
            { /* > */
             c_Output.SetItemText(i, COL_COMPARE, _T(">"));
             s1->compare = 1;
            } /* > */
         else
            { /* == */
             c_Output.SetItemText(i, COL_COMPARE, _T("="));
             s1->compare = 0;
            } /* == */
        } /* set compare state */

     if(limit > 0)
        c_Output.SetItemText(limit - 1, COL_COMPARE, _T(" "));

     ::SetThreadLocale(oldlcid);
     c_Progress.ShowWindow(SW_HIDE);
    } // CCompareString::SetCompareState

/****************************************************************************
*                           CCompareString::Refresh
* Result: void
*       
* Effect: 
*       Refreshes display
****************************************************************************/

void CCompareString::Refresh()
    {
     if(!initialized)
        return;

     CWaitCursor wait;
     
     updateControls();

     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);
     CString or = QueryTemplate(_T("[OR]"));
     
     CString fmt;
     fmt = QueryTemplate(_T("[CompareString]"));

     //----------------------------------------------------------------
     // %1: LCID
     //----------------------------------------------------------------
     CString localeName;
     LCID lcid;
     GetLCID(localeName, lcid);
     
     //----------------------------------------------------------------
     // %2:
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %3: flags
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;

     GetFlags(options, flags, or);

     if(options.IsEmpty())
        options = _T("0");
     
     //----------------------------------------------------------------
     // %4: unused
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %5: variable
     //----------------------------------------------------------------
     CString variable = QueryVariable();

     BOOL enable = TRUE;
     variable = GetVariable();

     //----------------------------------------------------------------
     // %6: options as a decimal number
     //----------------------------------------------------------------
     CString flagsDecimal;
     flagsDecimal.Format(_T("%d"), flags);

     //----------------------------------------------------------------
     // %7: or
     //----------------------------------------------------------------
     // This was already set

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal number
     //----------------------------------------------------------------
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);
     
     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1            %2      %3       %4      %5         %6         %7        %8          %9     %10     %11
     text.FormatMessage(fmt, localeName,  _T(""), options, _T(""), variable, flagsDecimal,  or, localeDecimal, _T(""), _T(""), _T(""));

     //-----------------------------------------------------------------------------------------------
     SetCode(text, enable);

     //----------------------------------------------------------------

     enable = TRUE;
     DWORD err = ERROR_SUCCESS;
     CString ErrorMessage;
     switch(CompareString(lcid, flags, _T(""), -1, _T(""), -1))
        { /* return value */
         case CSTR_LESS_THAN:
         case CSTR_EQUAL:
         case CSTR_GREATER_THAN:
            break;
         case 0:
            enable = FALSE;
            err = ::GetLastError();
            if(err == ERROR_SUCCESS)
               ErrorMessage.LoadString(IDS_INTERNAL_COMPARESTRING_ERROR);
            else
               ErrorMessage = ErrorString(err);
            break;
        } /* return value */

     c_ErrorMessage.SetWindowText(ErrorMessage);
     
     if(ErrorMessage.IsEmpty())
        { /* can do */
         c_Output.EnableWindow(TRUE);
         c_Progress.ShowWindow(SW_SHOW);
         c_Progress.SetPos(0);
         c_Progress.SetStep(1);
         // Sort the data

         CompareInfo info;

         if(c_UseTcsCmp.GetCheck() == BST_CHECKED)
            info.comparison = CompareInfo::Use_tcscmp;
         else
         if(c_UseTcsiCmp.GetCheck() == BST_CHECKED)
            info.comparison = CompareInfo::Use_tcsicmp;
         else
         if(c_lstrcmp.GetCheck() == BST_CHECKED)
            info.comparison = CompareInfo::Use_lstrcmp;
         else
         if(c_lstrcmpi.GetCheck() == BST_CHECKED)
            info.comparison = CompareInfo::Use_lstrcmpi;
         else
         if(c_UseCompareString.GetCheck() == BST_CHECKED)
            info.comparison = CompareInfo::Use_CompareString;
         else
            { /* unknown */
             ASSERT(FALSE);
             info.comparison = CompareInfo::Use_CompareString;
            } /* unknown */

         info.lcid = lcid;
         info.flags = flags;
         c_Output.SortItems(compare, (DWORD_PTR)&info);

         // Now indicate how the comparisons matched
         SetCompareState(&info);
        } /* can do */
     else
        { /* can't do */
         c_Output.EnableWindow(FALSE);
        } /* can't do */
    } // CCompareString::Refresh

/****************************************************************************
*                       CCompareString::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CCompareString::updateControls()
    {
     BOOL enable;
     enable = c_TwoStrings.GetCheck() == BST_CHECKED;
     c_String1.EnableWindow(enable);
     x_String1.EnableWindow(enable);
     c_String2.EnableWindow(enable);
     x_String2.EnableWindow(enable);

     enable = c_UserData.GetCheck() == BST_CHECKED;
     c_Filename.EnableWindow(enable);
     c_Browse.EnableWindow(enable);
     CString s;
     c_Filename.GetWindowText(s);
     s.TrimLeft();
     s.TrimRight();
     c_Reload.EnableWindow(enable && !s.IsEmpty());

     enable = c_AllStrings.GetCheck() == BST_CHECKED && c_UseUnicode.GetCheck() == BST_CHECKED;
     c_UnicodeRanges.EnableWindow(enable);
     x_UnicodeRanges.EnableWindow(enable);

     enable = c_UseCompareString.GetCheck() == BST_CHECKED;
     x_dwCmpFlags.EnableWindow(enable);
     c_NORM_IGNORECASE.EnableWindow(enable);
     c_NORM_IGNOREKANATYPE.EnableWindow(enable);
     c_NORM_IGNORESYMBOLS.EnableWindow(enable);
     c_NORM_IGNORENONSPACE.EnableWindow(enable);
     c_NORM_IGNOREWIDTH.EnableWindow(enable);
     c_SORT_STRINGSORT.EnableWindow(enable);

     x_SortID.EnableWindow(enable);
     c_LCIDDisplay.EnableWindow(enable);
     c_SortID.EnableWindow(enable && c_SortID.GetCount() > 1);
    } // CCompareString::updateControls

/****************************************************************************
*                      CCompareString::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font
****************************************************************************/

void CCompareString::SetFontToControls()
    {
#ifdef _UNICODE
     c_Output.SetFont(&UnicodeFont);
     c_String1.SetFont(&UnicodeFont);
     c_String2.SetFont(&UnicodeFont);
#endif
    } // CCompareString::SetFontToControls

/****************************************************************************
*                         CCompareString::Initialize
* Result: void
*       
* Effect: 
*       Initializes the display
****************************************************************************/

void CCompareString::Initialize()
    {
     variable = _T("stringval");
     InstallData();
     Refresh();
    } // CCompareString::Initialize

/****************************************************************************
*                     CCompareString::OnDeleteItemSamples
* Inputs:
*       NMHDR * pNMHDR:
*       LPRESULT * pResult: 0, always
* Result: void
*       
* Effect: 
*       Handles deletion of an item
****************************************************************************/

void CCompareString::OnDeleteitemSamples(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
    // TODO: Add your control notification handler code here
    SortData * sd = (SortData *)pNMListView->lParam;
    delete sd;
    *pResult = 0;
   }

/****************************************************************************
*                          CCompareString::BaseASCII
* Result: void
*       
* Effect: 
*       Loads the basic ASCII strings, either for ANSI mode or for
*       a case of GetFontUnicodeRanges failing
****************************************************************************/

void CCompareString::BaseASCII()
    {
     c_Progress.SetRange(0, ASCII_RANGE); 

     for(TCHAR i = _T(' '); i <= _T('~'); i++)
        { /* add one */
         AddOneChar(i);
         c_Progress.StepIt();
        } /* add one */

     for(i = (TCHAR)0xA1; i <= 0xFF; i++)
        { /* add high chars */
         AddOneChar(i);
         c_Progress.StepIt();
        } /* add high chars */
    } // CCompareString::BaseASCII

/****************************************************************************
*                         CCompareString::InstallData
* Result: void
*       
* Effect: 
*       Installs data in the list
****************************************************************************/

void CCompareString::InstallData()
    {
     CWaitCursor wait;
     c_Output.DeleteAllItems();
     if(c_TwoStrings.GetCheck() == BST_CHECKED)
        { /* two strings */
         CString caption;
         CString data;
         int n;

         n = c_Output.GetItemCount();
         x_String1.GetWindowText(caption);
         caption.Replace(_T("&"), _T(""));
         c_Output.InsertItem(n, caption);
         c_String1.GetWindowText(data);
         c_Output.SetItemText(n, COL_TEXT, data);
         c_Output.SetItemData(n, (LPARAM)new SortData(data));

         n = c_Output.GetItemCount();
         x_String2.GetWindowText(caption);
         caption.Replace(_T("&"), _T(""));
         c_Output.InsertItem(n, caption);
         c_String2.GetWindowText(data);
         c_Output.SetItemText(n, COL_TEXT, data);
         c_Output.SetItemData(n, (LPARAM)new SortData(data));
        } /* two strings */

     if(c_AllStrings.GetCheck() == BST_CHECKED)
        { /* random strings */
         if(c_UseUnicode.GetCheck() == BST_CHECKED)
            { /* Unicode option */
             c_Progress.SetPos(0);
             c_Progress.ShowWindow(SW_SHOW);
             c_Progress.SetStep(1);
#ifdef _UNICODE
             CClientDC dc(&c_Output);
             dc.SelectObject(&UnicodeFont);
             DWORD count = ::GetFontUnicodeRanges((HDC)dc, NULL);
             c_Progress.SetRange(0, ASCII_RANGE);
             if(count == 0)
                { /* failed */
                 BaseASCII();
                } /* failed */
             else
                { /* success */
                 LPGLYPHSET glyphs = (LPGLYPHSET)new BYTE[count];
                 glyphs->cbThis = count;
                 ::GetFontUnicodeRanges((HDC)dc, glyphs);
                 c_UnicodeRanges.ResetContent();
                 c_Progress.SetPos(0);
                 c_Progress.SetRange(0, (short)glyphs->cRanges);
                 for(DWORD g = 0; g < glyphs->cRanges; g++)
                    { /* scan ranges */
                     c_Progress.StepIt();
                     WCHAR low = glyphs->ranges[g].wcLow;
                     WCHAR high = glyphs->ranges[g].wcLow + glyphs->ranges[g].cGlyphs;

                     CString s;
                     s.Format(_T("0x%04x - 0x%04x"), low, high);
                     c_UnicodeRanges.AddString(s);

                     for(WCHAR i = low; i <= high; i++)
                        { /* character range */
                         AddOneChar(i);
                        } /* character range */
                    } /* scan ranges */
                 delete glyphs;
                } /* success */
#else
             BaseASCII();
#endif
            } /* Unicode option */
         else
            { /* ASCII-only */
             BaseASCII();
            } /* ASCII-only */

         c_Progress.ShowWindow(SW_HIDE);
        } /* random strings */
    } // CCompareString::InstallData

/****************************************************************************
*                         CCompareString::AddOneChar
* Inputs:
*       TCHAR i: Character to add
* Result: void
*       
* Effect: 
*       Adds one character
****************************************************************************/

void CCompareString::AddOneChar(TCHAR i)
    {
     CString s;
#ifdef _UNICODE
     s.Format(_T("0x%04x"), i);
#else
     s.Format(_T("0x%02x"), i);
#endif
     int n = c_Output.GetItemCount();
     c_Output.InsertItem(n, s);
#define NCHARS 5
     CString  p((TCHAR)i, NCHARS); 
     c_Output.SetItemText(n, COL_TEXT, p);
     c_Output.SetItemData(n, (LPARAM)new SortData(p));
    } // CCompareString::AddOneChar


/****************************************************************************
*                          CCompareString::OnBrowse
* Result: void
*       
* Effect: 
*       Finds a file
****************************************************************************/

void CCompareString::OnBrowse() 
   {

    RegistryString userfile(IDS_REGISTRY_USER_SAMPLE);
    userfile.load();

    CString name;
    name = userfile.value; // set default value

    UINT width = 8; // assume UTF-8
    if(!OpenFileEx(FALSE, name, _T(".txt"), width, IDS_USER_SAMPLE_FILTER, MAKEINTRESOURCE(IDS_LOAD_TEMPLATE_TITLE)))
       return; // failed

    //c_UserFile.SetWindowText(name);

    userfile.value = name;
    VERIFY(userfile.store());
    c_Filename.SetWindowText(name);
    OnReload();
    Refresh();
   }

/****************************************************************************
*                          CCompareString::OnReload
* Result: void
*       
* Effect: 
*       Reloads the contents of the specified file
****************************************************************************/

void CCompareString::OnReload() 
   {
    c_Output.DeleteAllItems();

    CStdioFile f;
    CString filename;
    c_Filename.GetWindowText(filename);
    if(!f.Open(filename, CFile::modeRead))
       { /* open failed */
        DWORD err = ::GetLastError();
        c_ErrorMessage.SetWindowText(ErrorString(err));
        return;
       } /* open failed */

    CString line;
    int count = 1;
    while(f.ReadString(line))
       { /* has line */
        CString lineNumber;
        lineNumber.Format(_T("%d"), count);
        count++;
        
        int n = c_Output.GetItemCount();
        c_Output.InsertItem(n, lineNumber);
        
        c_Output.SetItemText(n, COL_TEXT, line);

        c_Output.SetItemData(n, (LPARAM)new SortData(line));
       } /* has line */
    
    f.Close();
    Refresh();
   }


/****************************************************************************
*                           CCompareString::IndexOK
* Inputs:
*       CWnd * wnd: Window to index 
* Result: BOOL
*       TRUE if OK to index
*       FALSE if should not be indexed
****************************************************************************/
static UINT ValidControls[] = {
   // From the dwCmpFlags box:
   IDC_NORM_IGNORECASE, IDC_NORM_IGNOREKANATYPE, IDC_NORM_IGNORESYMBOLS, IDC_NORM_IGNORENONSPACE, IDC_NORM_IGNOREWIDTH,
   // From the DataSource box:
   IDC_DATA_SOURCE_CAPTION,
   IDC_TWOSTRINGS,
      IDC_STRING1_CAPTION, IDC_STRING1,
      IDC_STRING2_CAPTION, IDC_STRING2,
   IDC_RANDOMSTRINGS,
   IDC_USERDATA,                IDC_RELOAD,
      IDC_FILENAME_CAPTION, IDC_FILENAME,
   // From the SortID box
   IDC_SORTID_CAPTION,
      IDC_SORTID,
   // From the comparison box
      IDC_COMPARESTRING,
      IDC_TCSCMP,
      IDC_TCSICMP,
      IDC_LSTRCMP,
      IDC_LSTRCMPI,
   // From the Unicode Ranges box
   IDC_UNICODE_RANGES,
   // From the output box
   IDC_SAMPLES,
   
   0 // EOT
};

BOOL CCompareString::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_ErrorMessage)
        return FALSE;
     if(wnd == &c_LCIDDisplay)
        return FALSE;
     if(wnd == &c_Browse)
        return FALSE;

     // This is REALLY tacky, but there is no good
     // way around this problem, unfortunately
     UINT id = wnd->GetDlgCtrlID();
     for(int i = 0; ValidControls[i] != 0; i++)
        { /* eliminate subclass-only controls */
         if(ValidControls[i] == id)
            return TRUE;
        } /* eliminate subclass-only controls */

     return FALSE;
    } // CCompareString::IndexOK

/****************************************************************************
*                           CCompareString::OnClear
* Result: void
*       
* Effect: 
*       Clears all the flags
****************************************************************************/

void CCompareString::OnClear() 
   {
    Clear();
   }

/****************************************************************************
*                            CCompareString::Clear
* Result: void
*       
* Effect: 
*       Clears the flags
****************************************************************************/

void CCompareString::Clear()
    {
     c_NORM_IGNORECASE.SetCheck(BST_UNCHECKED);
     c_NORM_IGNOREKANATYPE.SetCheck(BST_UNCHECKED);
     c_NORM_IGNORENONSPACE.SetCheck(BST_UNCHECKED);
     c_NORM_IGNORESYMBOLS.SetCheck(BST_UNCHECKED);
     c_NORM_IGNORENONSPACE.SetCheck(BST_UNCHECKED);
     c_NORM_IGNORESYMBOLS.SetCheck(BST_UNCHECKED);
     c_NORM_IGNOREWIDTH.SetCheck(BST_UNCHECKED);
     c_SORT_STRINGSORT.SetCheck(BST_UNCHECKED);
    } // CCompareString::Clear

/****************************************************************************
*                        CCompareString::OnUseUnicode
*                         CCompareString::OnUseAscii
* Result: void
*       
* Effect: 
*       Loads either full UNICODE or just the ASCII subset
****************************************************************************/

void CCompareString::OnUseUnicode() 
   {
    InstallData();
    Refresh();
   }

void CCompareString::OnUseAscii() 
   {
    InstallData();
    Refresh();
   }

/****************************************************************************
*                          CCompareString::QuerySave
* Result: BOOL
*       TRUE if save is possible
*       FALSE if save is not possible
****************************************************************************/

BOOL CCompareString::QuerySave()
    {
     return c_Output.GetItemCount() > 0;
    } // CCompareString::QuerySave

/****************************************************************************
*                            CCompareString::Save
* Inputs:
*       const CString & filename: File name to save
*       UINT mode: save mode: 0 (default), 8 (UTF-8), 16 (UNICODE)
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Saves the file
****************************************************************************/

BOOL CCompareString::Save(const CString & filename, UINT mode)
    {
     return c_Output.Save(filename, mode);
    } // CCompareString::Save

/****************************************************************************
*                    CCompareString::OnItemchangedSamples
* Inputs:
*       NMHDR * pNMHDR: header
*       LRESULT * pResult: set to 0, always
* Result: void
*       
* Effect: 
*       If the item has an error status, display the error status
****************************************************************************/

void CCompareString::OnItemchangedSamples(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    NM_LISTVIEW* plv = (NM_LISTVIEW*)pNMHDR;
    
    *pResult = 0;

    if( (plv->uChanged & LVIF_STATE) == 0)
       return; // state was not what changed

    if( (plv->uNewState & LVIS_SELECTED) == 0)
       return; // not selected state

    // The item in question is a selected item
    if(plv->iItem == -1)
       return; // no valid value
    SortData * p = (SortData *)c_Output.GetItemData(plv->iItem);
    if(p == NULL)
       return; // missing pointer
    if(p->error == ERROR_SUCCESS)
       { /* kill message */
        c_ErrorMessage.SetWindowText(_T(""));
       } /* kill message */
    else
       { /* show message */
        c_ErrorMessage.SetWindowText(ErrorString(p->error));
       } /* show message */
   }
