#if !defined(AFX_COMPARESTRING_H__793225B1_CDD5_4C91_BC4F_9AB806637F9A__INCLUDED_)
#define AFX_COMPARESTRING_H__793225B1_CDD5_4C91_BC4F_9AB806637F9A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CompareString.h : header file
//
#include "Function.h"
#include "WhatIsItButton.h"
#include "WhatIsThisEdit.h"
#include "WhatIsItGroupBox.h"
#include "ListCtrlEx.h"
#include "IDCombo.h"
#include "StringDisplay.h"

/////////////////////////////////////////////////////////////////////////////
// CCompareString dialog

class CCompareString : public CFunction
{
 DECLARE_DYNCREATE(CCompareString)
    protected:
     class CompareInfo;
// Construction
public:
        CCompareString(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CCompareString)
        enum { IDD = IDD_COMPARESTRING };
        CButton x_Comparison;
        CWhatIsItButton c_UseUnicode;
        CWhatIsItButton c_UseASCII;
        CWhatIsItButton c_Clear;
        CWhatIsItButton c_NORM_IGNORENONSPACE;
        CProgressCtrl   c_Progress;
        CWhatIsItGroupBox       x_DataSource;
        CWhatIsItGroupBox x_SortID;
        CWhatIsItGroupBox x_dwCmpFlags;
        CWhatIsItButton c_lstrcmpi;
        CWhatIsItButton c_lstrcmp;
        CWhatIsItButton c_Reload;
        CWhatIsItButton c_UseTcsiCmp;
        CWhatIsItButton c_UseTcsCmp;
        CWhatIsItButton c_UseCompareString;
        CWhatIsItGroupBox x_UnicodeRanges;
        CListBox        c_UnicodeRanges;
        CStatic c_ErrorMessage;
        CIDCombo        c_SortID;
        CStatic c_LCIDDisplay;
        CWhatIsItButton c_UserData;
        CWhatIsItButton c_TwoStrings;
        CWhatIsItButton c_AllStrings;
        CWhatIsItButton c_SORT_STRINGSORT;
        CWhatIsItButton c_NORM_IGNOREWIDTH;
        CStatic x_String2;
        CWhatIsThisEdit c_String2;
        CStatic x_String1;
        CWhatIsThisEdit c_String1;
        CStringDisplay       c_Output;
        CWhatIsItButton c_NORM_IGNORESYMBOLS;
        CWhatIsItButton c_NORM_IGNOREKANATYPE;
        CWhatIsItButton c_NORM_IGNORECASE;
        CStatic x_Filename;
        CWhatIsThisEdit c_Filename;
        CWhatIsItButton c_Browse;
        //}}AFX_DATA

// Columns of the c_Output window
#define COL_DESC    0
#define COL_COMPARE 1
#define COL_TEXT    2
#define COL_LAST    2

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CCompareString)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        virtual void SetFontToControls();
        virtual void Refresh();
        virtual void Initialize();
        virtual BOOL IndexOK(CWnd * wnd);
        virtual BOOL QuerySave();
        virtual BOOL Save(const CString & name, UINT mode);
protected: // methods
        void updateControls();
        void InstallData();
        static int CALLBACK compare(LPARAM p1, LPARAM p2, LPARAM data);
        void AddOneChar(TCHAR i);
        void BaseASCII();
        void GetFlags(CString & options, DWORD & flags, const CString & or);
        void Clear();
        void GetLCID(CString & localeName, LCID & lcid);
        void SetCompareState(CompareInfo * info);
protected:
        /****************************************************************************
        *                          CCompareString::normalize
        * Inputs:
        *       int n: Integer value
        * Result: int
        *       n < 0 returns -1
        *       n > 0 returns 1
        *       n == 0 returns 0
        * Notes:
        *       This is required to handle the case where we are trying to return
        *       a value from CCompareString::compare, and it must be in a
        *       canonical format, from the set {-2, -1, 0, 1}, where -2 is a
        *       special error code.  But _tcscmp, _tcsicmp, etc. can return any
        *       value, which means they don't meet the criterion for comparison
        ****************************************************************************/
        __inline static int CCompareString::normalize(int n)
           {
            if(n < 0)
               return -1;
            if(n > 0)
               return 1;
            return 0;
           } // CCompareString::normalize

protected: // classes
        class SortData {
            public:
               SortData(const CString & s) { data = s; compare = 0; error = ERROR_SUCCESS; }
               CString data;
               int compare;
               DWORD error;
        };
               
        class CompareInfo {
            public:
               typedef enum { Use_tcscmp, Use_tcsicmp, Use_lstrcmp, Use_lstrcmpi, Use_CompareString } CompareType;
               CompareType comparison;
               LCID lcid;
               DWORD flags;
        };
        
protected: // data
        LCID lastLCID;
        
        
        // Generated message map functions
        //{{AFX_MSG(CCompareString)
        virtual BOOL OnInitDialog();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnChangeFilename();
        afx_msg void OnNormIgnorecase();
        afx_msg void OnNormIgnorekanatype();
        afx_msg void OnNormIgnoresymbols();
        afx_msg void OnNormIgnorenonspace();
        afx_msg void OnNormIgnorewidth();
        afx_msg void OnSortStringsort();
        afx_msg void OnAllStrings();
        afx_msg void OnChangeString1();
        afx_msg void OnChangeString2();
        afx_msg void OnTwostrings();
        afx_msg void OnUserdata();
        afx_msg void OnDeleteitemSamples(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnSelendokSortid();
        afx_msg void OnBrowse();
        afx_msg void OnComparestring();
        afx_msg void OnTcscmp();
        afx_msg void OnTcsicmp();
        afx_msg void OnReload();
        afx_msg void OnLstrcmp();
        afx_msg void OnLstrcmpi();
        afx_msg void OnClear();
        afx_msg void OnUseUnicode();
        afx_msg void OnUseAscii();
        afx_msg void OnItemchangedSamples(NMHDR* pNMHDR, LRESULT* pResult);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMPARESTRING_H__793225B1_CDD5_4C91_BC4F_9AB806637F9A__INCLUDED_)
