// DateFormats.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "DateFormats.h"
#include "Query.h"
#include "msg.h"
#include "RTLMap.h"
#include "GetCaption.h"
#include "LogWnd.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDateFormats dialog

IMPLEMENT_DYNCREATE(CDateFormats, CFunction)

CDateFormats::CDateFormats(CWnd* pParent /*=NULL*/)
        : CFunction(CDateFormats::IDD, pParent)
{
        //{{AFX_DATA_INIT(CDateFormats)
        //}}AFX_DATA_INIT
}


void CDateFormats::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CDateFormats)
        DDX_Control(pDX, IDC_IGNORE_CAPTION, c_IgnoreCaption);
        DDX_Control(pDX, IDC_ENUMDATEFORMATSEX, c_EnumDateFormatsEx);
        DDX_Control(pDX, IDC_ENUMDATEFORMATS, c_EnumDateFormats);
        DDX_Control(pDX, IDC_DATE_YEARMONTH, c_DATE_YEARMONTH);
        DDX_Control(pDX, IDC_DATE_LONGDATE, c_DATE_LONGDATE);
        DDX_Control(pDX, IDC_DATE_SHORTDATE, c_DATE_SHORTDATE);
        DDX_Control(pDX, IDC_CALLBACK_NAME, c_CallbackName);
        DDX_Control(pDX, IDC_OUTPUT, c_Output);
        DDX_Control(pDX, IDC_RADIO3, c_SpareRadio);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDateFormats, CFunction)
        //{{AFX_MSG_MAP(CDateFormats)
        ON_BN_CLICKED(IDC_ENUMDATEFORMATS, OnEnumdateformats)
        ON_BN_CLICKED(IDC_ENUMDATEFORMATSEX, OnEnumdateformatsex)
        ON_BN_CLICKED(IDC_DATE_LONGDATE, OnDateLongdate)
        ON_BN_CLICKED(IDC_DATE_SHORTDATE, OnDateShortdate)
        ON_BN_CLICKED(IDC_DATE_YEARMONTH, OnDateYearmonth)
        ON_EN_CHANGE(IDC_CALLBACK_NAME, OnChangeCallbackName)
        ON_WM_SIZE()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDateFormats message handlers

void CDateFormats::OnEnumdateformats() 
   {
    Refresh();
    updateControls();
   }

void CDateFormats::OnEnumdateformatsex() 
   {
    Refresh();
    updateControls();
   }

void CDateFormats::OnDateLongdate() 
   {
    Refresh();
   }

void CDateFormats::OnDateShortdate() 
   {
    Refresh();
   }

void CDateFormats::OnDateYearmonth() 
   {
    Refresh();
   }

BOOL CDateFormats::OnInitDialog() 
{
        CFunction::OnInitDialog();
        
        // TODO: Add extra initialization here
        
        CheckRadioButton(IDC_DATE_SHORTDATE, IDC_DATE_YEARMONTH, IDC_DATE_SHORTDATE);
        CheckRadioButton(IDC_ENUMDATEFORMATS, IDC_ENUMDATEFORMATSEX, IDC_ENUMDATEFORMATS);

        c_Output.InsertColumnEx(0, _T("LPTSTR lpDateFormatString"), LVCFMT_LEFT, 0);
        c_Output.InsertColumnEx(1, _T("CALID CalendarID"), LVCFMT_LEFT, -1);
        DateWidth = c_Output.GetColumnWidth(1);
        updateControls();
        return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

/****************************************************************************
*                       CDateFormats::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font in the relevant controls
****************************************************************************/

void CDateFormats::SetFontToControls()
    {
#ifdef _UNICODE
     c_Output.SetFont(&UnicodeFont);
#endif
    } // CDateFormats::SetFontToControls

/****************************************************************************
*                          CDateFormats::Refresh
* Result: void
*       
* Effect: 
*       Shows the data for the selected locale
****************************************************************************/

void CDateFormats::Refresh()
    {
     ShowDateFormats();
     UpdateCode();
    } // CDateFormats::Refresh

/****************************************************************************
*                        CDateFormats::ShowDateFormats
* Result: void
*       
* Effect: 
*       Shows the date information
****************************************************************************/

void CDateFormats::ShowDateFormats()
    {
     
    } // CDateFormats::ShowDateFormats

/****************************************************************************
*                       CDateFormats::EnumDateFormatsProc
* Inputs:
*       LPTSTR info: Calendar info
* Result: BOOL
*       TRUE, always
* Effect: 
*       Displays the text
****************************************************************************/
CDateFormats * CDateFormats::LogWnd = NULL;

/* static */ BOOL CALLBACK CDateFormats::EnumDateFormatsProc(LPTSTR info)
    {
     if(LogWnd == NULL)
        return TRUE;
     CString s = info;
     LCID lcid = (LCID)LogWnd->TabParent->SendMessage(UWM_QUERY, (WPARAM)QUERY_LOCALE);
     RTLMap(s, lcid);
     int n = LogWnd->c_Output.GetItemCount();
     LogWnd->c_Output.InsertItem(n, s);
     LogWnd->c_Output.SetItemData(n, lcid); // for sorting
     return TRUE;
    } // 

/****************************************************************************
*                       CDateFormats::EnumDateFormatsProcEx
* Inputs:
*       LPTSTR info: Calendar info
* Result: BOOL
*       TRUE, always
* Effect: 
*       Displays the text
****************************************************************************/

/* static */ BOOL CALLBACK CDateFormats::EnumDateFormatsProcEx(LPTSTR info, CALID calid)
   {
    if(LogWnd == NULL)
       return TRUE;
    CString s = info;
    LCID lcid = (LCID)LogWnd->TabParent->SendMessage(UWM_QUERY, (WPARAM)QUERY_LOCALE);
    CString calendarname = LogWnd->GetCaption(IDC_ENUM_ALL_CALENDARS + (UINT)calid);

    RTLMap(s, lcid);
     int n = LogWnd->c_Output.GetItemCount();
     LogWnd->c_Output.InsertItem(n, s);
     LogWnd->c_Output.SetItemText(n, 1, calendarname);
     LogWnd->c_Output.SetItemData(n, lcid);
    return TRUE;
   } // 

/****************************************************************************
*                          CDateFormats::UpdateCode
* Result: void
*       
* Effect: 
*       Updates the code example
****************************************************************************/

void CDateFormats::UpdateCode()
    {
     if(!initialized)
        return;

     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, TRUE);
     EnableQuery(QUERY_DWORD, FALSE);

     CString defaultCallback;

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;
     if(c_EnumDateFormats.GetCheck() == BST_CHECKED)
        { /* EnumDateFormats */
         fmt = QueryTemplate(_T("[EnumDateFormats:VARIABLE]"));
         defaultCallback = _T("EnumDateFormatsProc");
        } /* EnumDateFormats */
     else
     if(c_EnumDateFormatsEx.GetCheck() == BST_CHECKED)
        { /* EnumDateFormatsEx */
         fmt = QueryTemplate(_T("[EnumDateFormatsEx:VARIABLE]"));
         defaultCallback = _T("EnumDateFormatsProcEx");
        } /* EnumDateFormatsEx */

     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2: The DWORD as a string
     //----------------------------------------------------------------
     CString dwordparameter = _T(""); // todo

     //----------------------------------------------------------------
     // %3: The option flags
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;
     GetOptionFlags(options, flags, or);

     if(c_DATE_SHORTDATE.GetCheck() == BST_CHECKED)
        { /* DATE_SHORTDATE */
         options = _T("DATE_SHORTDATE ") + options;
         flags |= DATE_SHORTDATE;
        } /* DATE_SHORTDATE */
     else
     if(c_DATE_LONGDATE.GetCheck() == BST_CHECKED)
        { /* DATE_LONGDATE */
         options = _T("DATE_LONGDATE ") + options;
         flags |= DATE_LONGDATE;
        } /* DATE_LONGDATE */
     else
     if(c_DATE_YEARMONTH.GetCheck() == BST_CHECKED)
        { /* DATE_YEARMONTH */
         options = _T("DATE_YEARMONTH ") + options;
         flags |= DATE_YEARMONTH;
        } /* DATE_YEARMONTH */
     //----------------------------------------------------------------
     // %4: Length: not used
     //----------------------------------------------------------------
     CString length;

     //----------------------------------------------------------------
     // %5: The variable name (unused)
     //----------------------------------------------------------------
     variable = _T("");
     
     //----------------------------------------------------------------
     // %6: dwFlags as a decimal number
     //----------------------------------------------------------------
     CString dwFlagsDecimal;
     dwFlagsDecimal.Format(_T("%d"), flags);
     
     //----------------------------------------------------------------
     // %7: The OR operator for bitwise operations
     //----------------------------------------------------------------
     // This was set when the language choice was made

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal integer
     //----------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);
     
     //----------------------------------------------------------------
     // %9: Not used
     //----------------------------------------------------------------


     //----------------------------------------------------------------
     // %10: Not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %11: The callback function name
     //----------------------------------------------------------------
     CString callbackname;
     c_CallbackName.GetWindowText(callbackname);
     callbackname.TrimLeft();
     callbackname.TrimRight();
     if(callbackname.IsEmpty())
        callbackname = defaultCallback;
     
     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1           %2               %3       %4       %5           %6        %7     %8      %9     %10       %11
     text.FormatMessage(fmt, localeName,  dwordparameter, options, length, variable, dwFlagsDecimal,  or, _T(""), _T(""), _T(""), callbackname);

     //-----------------------------------------------------------------------------------------------
     SetCode(text, TRUE);

     c_Output.DeleteAllItems();
     LogWnd = this;

     if(c_EnumDateFormats.GetCheck() == BST_CHECKED)
        { /* EnumDateFormats */
         if(!::EnumDateFormats(EnumDateFormatsProc, lcid, flags))
            { /* failed */
             DWORD err = ::GetLastError();
             int n = c_Output.GetItemCount();
             c_Output.InsertItem(n, ErrorString(err));
            } /* failed */
         else
            { /* success */
            } /* success */
        } /* EnumDateFormats */
     else
     if(c_EnumDateFormatsEx.GetCheck() == BST_CHECKED)
        { /* EnumDateFormatsEx */
         if(!::EnumDateFormatsEx(EnumDateFormatsProcEx, lcid, flags))
            { /* failedex */
             DWORD err = ::GetLastError();
             int n = c_Output.GetItemCount();
             c_Output.InsertItem(n, ErrorString(err));
            } /* failedex */
         else
            { /* successex */
            } /* successex */
        } /* EnumDateFormatsEx */
     
    } // CDateFormats::UpdateCode

/****************************************************************************
*                     CDateFormats::OnChangeCallbackName
* Result: void
*       
* Effect: 
*       Updates the code display
****************************************************************************/

void CDateFormats::OnChangeCallbackName() 
   {
    Refresh();
   }

/****************************************************************************
*                            CDateFormats::OnSize
* Inputs:
*       UINT nType:
*       int cx: New client width
*       int cy: New client height
* Result: void
*       
* Effect: 
*       Resizes the output window
****************************************************************************/

void CDateFormats::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);
        
    ExpandBottom(c_Output);
   }

/****************************************************************************
*                        CDateFormats::updateControls
* Result: void
*       
* Effect: 
*       Hides/shows/enables/disables controls
****************************************************************************/

void CDateFormats::updateControls()
    {
     if(c_EnumDateFormats.GetCheck() == BST_CHECKED)
        { /* hide ex */
         c_Output.SetColumnWidth(1, 0);
        } /* hide ex */
     else
        { /* shoe ex */
         c_Output.SetColumnWidth(1, DateWidth);
        } /* shoe ex */
    } // CDateFormats::updateControls

/****************************************************************************
*                            CDateFormats::IndexOK
* Inputs:
*       CWnd * wnd: Window to check
* Result: BOOL
*       TRUE to allow the window to be indexed
*       FALSE to skip it
****************************************************************************/

BOOL CDateFormats::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_SpareRadio)
        return FALSE;
     if(wnd == &c_IgnoreCaption)
        return FALSE;
     return TRUE;
    } // CDateFormats::IndexOK
