// Defaults.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Defaults.h"
#include "Query.h"
#include "ErrorString.h"
#include "GetGeoInfoData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CDefaults, CFunction)

/////////////////////////////////////////////////////////////////////////////
// CDefaults dialog

CDefaults::CDefaults(CWnd* pParent /*=NULL*/)
        : CFunction(CDefaults::IDD, pParent)
{
        //{{AFX_DATA_INIT(CDefaults)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CDefaults::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CDefaults)
        DDX_Control(pDX, IDC_GETUSERGEOID_STATUS, c_GetUserGeoIDStatus);
        DDX_Control(pDX, IDC_GETUSERDEFAULTUILANGUAGE_STATUS, c_GetUserDefaultUILanguageStatus);
        DDX_Control(pDX, IDC_GETUSERDEFAULTLCID_STATUS, c_GetUserDefaultLCIDStatus);
        DDX_Control(pDX, IDC_GETUSERDEFAULTLANGID_STATUS, c_GetUserDefaultLangIDStatus);
        DDX_Control(pDX, IDC_GETSYSTEMDEFAULTLANGID_STATUS, c_GetSystemDefaultLangIDStatus);
        DDX_Control(pDX, IDC_GETUSERGEOID_RESULT, c_GetUserGeoIDResult);
        DDX_Control(pDX, IDC_GETUSERGEOID, c_GetUserGeoID);
        DDX_Control(pDX, IDC_GETUSERDEFAULTUILANGUAGE_RESULT, c_GetUserDefaultUILanguageResult);
        DDX_Control(pDX, IDC_GETUSERDEFAULTUILANGUAGE, c_GetUserDefaultUILanguage);
        DDX_Control(pDX, IDC_GETUSERDEFAULTLANGID, c_GetUserDefaultLangID);
        DDX_Control(pDX, IDC_GETSYSTEMDEFAULTLANGID, c_GetSystemDefaultLangID);
        DDX_Control(pDX, IDC_GETUSERDEFAULTLCID_RESULT, c_GetUserDefaultLCIDResult);
        DDX_Control(pDX, IDC_GETUSERDEFAULTLCID, c_GetUserDefaultLCID);
        DDX_Control(pDX, IDC_GETUSERDEFAULTLANGID_RESULT, c_GetUserDefaultLangIDResult);
        DDX_Control(pDX, IDC_GETSYSTEMDEFAULTLANGID_RESULT, c_GetSystemDefaultLangIDResult);
        DDX_Control(pDX, IDC_CONVERTDEFAULTLOCALE, c_ConvertDefaultLocale);
        DDX_Control(pDX, IDC_CONVERTDEFAULTLOCALE_RESULT, c_ConvertDefaultLocaleResult);
        DDX_Control(pDX, IDC_CONVERTDEFAULTLOCALE_STATUS, c_ConvertDefaultLocaleStatus);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDefaults, CFunction)
        //{{AFX_MSG_MAP(CDefaults)
        ON_BN_CLICKED(IDC_CONVERTDEFAULTLOCALE, OnConvertdefaultlocale)
        ON_BN_CLICKED(IDC_GETSYSTEMDEFAULTLANGID, OnGetsystemdefaultlangid)
        ON_BN_CLICKED(IDC_GETUSERDEFAULTLANGID, OnGetuserdefaultlangid)
        ON_BN_CLICKED(IDC_GETUSERDEFAULTLCID, OnGetuserdefaultlcid)
        ON_BN_CLICKED(IDC_GETUSERDEFAULTUILANGUAGE, OnGetuserdefaultuilanguage)
        ON_BN_CLICKED(IDC_GETUSERGEOID, OnGetusergeoid)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDefaults message handlers

/****************************************************************************
*                          CDefaults::SetCountryInfo
* Inputs:
*       UINT id: LANGID or LCID
*       CStatic & status: Status control
* Result: void
*       
* Effect: 
*       Converts to a country name and stores it in the control
****************************************************************************/

void CDefaults::SetCountryInfo(UINT id, CStatic & status)
    {
     CString scountry_data;
     { /* get LOCALE_SCOUNTRY */
      int length = GetLocaleInfo(id, LOCALE_SLANGUAGE, NULL, 0);
      LPTSTR p = scountry_data.GetBuffer(length);
      if(!::GetLocaleInfo(id, LOCALE_SLANGUAGE, p, length))
         { /* failed */
          DWORD err = ::GetLastError();
          status.SetWindowText(ErrorString(err));           
         } /* failed */
      else
         { /* success */
          scountry_data.ReleaseBuffer();
          status.SetWindowText(scountry_data);
         } /* success */
     } /* get LOCALE_SCOUNTRY */
    } // CDefaults::SetCountryInfo

/****************************************************************************
*                             CDefaults::Refresh
* Result: void
*       
* Effect: 
*       Shows the values and the code
****************************************************************************/

void CDefaults::Refresh()
    {
     if(!initialized)
        return;
     EnableQuery(QUERY_DWORD, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     
     LCID lcid = QueryLocale();

     CString fmt;

     CString or = QueryTemplate(_T("[OR]"));

     QueryTemplate(_T(""));
     //----------------------------------------------------------------
     // ConvertDefaultLocale
     //----------------------------------------------------------------
     LCID neutralID = MAKELCID(MAKELANGID(PRIMARYLANGID(lcid), SUBLANG_NEUTRAL), SORT_DEFAULT);
     LCID ConvertDefaultLocaleResult = ::ConvertDefaultLocale(neutralID);
     if(ConvertDefaultLocaleResult == lcid)
        { /* failed */
         DWORD err = ::GetLastError();
         if(err == ERROR_SUCCESS)
            { /* no conversion */
             CString s;
             s.LoadString(IDS_NO_CONVERSION);
             c_ConvertDefaultLocaleStatus.SetWindowText(s);
            } /* no conversion */
         else
            c_ConvertDefaultLocaleStatus.SetWindowText(ErrorString(err));
        } /* failed */
     else
        { /* success */
         SetCountryInfo((UINT)ConvertDefaultLocaleResult, c_ConvertDefaultLocaleStatus);
        } /* success */
     
     CString ConvertDefaultLocaleResultString;
     ConvertDefaultLocaleResultString.Format(_T("0x%04x"), ConvertDefaultLocaleResult);
     c_ConvertDefaultLocaleResult.SetWindowText(ConvertDefaultLocaleResultString);

     if(c_ConvertDefaultLocale.GetCheck() == BST_CHECKED)
        { /* ConvertDefaultLocale */
         fmt = QueryTemplate(_T("[ConvertDefaultLocale]"));
         SetVariable(_T("DefaultLocale"));
        } /* ConvertDefaultLocale */

     //----------------------------------------------------------------
     // GetSystemDefaultLangID
     //----------------------------------------------------------------
     LANGID GetSystemDefaultLangIDResult = ::GetSystemDefaultLangID();
     CString GetSystemDefaultLangIDString;
     GetSystemDefaultLangIDString.Format(_T("0x%04x"), GetSystemDefaultLangIDResult);
     c_GetSystemDefaultLangIDResult.SetWindowText(GetSystemDefaultLangIDString);
     if(c_GetSystemDefaultLangID.GetCheck() == BST_CHECKED)
        { /* GetSystemDefaultLangID */
         fmt = QueryTemplate(_T("[GetSystemDefaultLangID]"));
         SetVariable(_T("DefaultSystemLangID"));
        } /* GetSystemDefaultLangID */

     SetCountryInfo((UINT)GetSystemDefaultLangIDResult, c_GetSystemDefaultLangIDStatus);

     //----------------------------------------------------------------
     // GetUserDefaultLangID
     //----------------------------------------------------------------
     LANGID GetUserDefaultLangIDResult = ::GetUserDefaultLangID();
     CString GetUserDefaultLangIDString;
     GetUserDefaultLangIDString.Format(_T("0x%04x"), GetUserDefaultLangIDResult);
     c_GetUserDefaultLangIDResult.SetWindowText(GetUserDefaultLangIDString);
     if(c_GetUserDefaultLangID.GetCheck() == BST_CHECKED)
        { /* GetUserDefaultLangID */
         fmt = QueryTemplate(_T("[GetUserDefaultLangID]"));
         SetVariable(_T("DefaultUserLangID"));
        } /* GetUserDefaultLangID */
     
     SetCountryInfo((UINT)GetUserDefaultLangIDResult, c_GetUserDefaultLangIDStatus);

     //----------------------------------------------------------------
     // GetUserDefaultLCID
     //----------------------------------------------------------------
     LCID GetUserDefaultLCIDResult = ::GetUserDefaultLCID();
     CString GetUserDefaultLCIDString;
     GetUserDefaultLCIDString.Format(_T("0x%04x"), GetUserDefaultLCIDResult);
     c_GetUserDefaultLCIDResult.SetWindowText(GetUserDefaultLCIDString);
     if(c_GetUserDefaultLCID.GetCheck() == BST_CHECKED)
        { /* GetUserDefaultLCID */
         fmt = QueryTemplate(_T("[GetUserDefaultLCID]"));
         SetVariable(_T("UserDefaultLCID"));
        } /* GetUserDefaultLCID */

     SetCountryInfo((UINT)GetUserDefaultLCIDResult, c_GetUserDefaultLCIDStatus);

     //----------------------------------------------------------------
     // GetUserDefaultUILanguage
     //----------------------------------------------------------------
     LANGID GetUserDefaultUILanguageResult = ::GetUserDefaultUILanguage();
     CString GetUserDefaultUILanguageString;
     GetUserDefaultUILanguageString.Format(_T("0x%04x"), GetUserDefaultUILanguageResult);
     c_GetUserDefaultUILanguageResult.SetWindowText(GetUserDefaultUILanguageString);
     if(c_GetUserDefaultUILanguage.GetCheck() == BST_CHECKED)
        { /* GetUserDefaultUILanguage */
         fmt = QueryTemplate(_T("[GetUserDefaultUILanguage]"));
         SetVariable(_T("UserDefaultUILanguage"));
        } /* GetUserDefaultUILanguage */

     SetCountryInfo((UINT)GetUserDefaultUILanguageResult, c_GetUserDefaultUILanguageStatus);

     //----------------------------------------------------------------
     // GetUserGeoID
     //----------------------------------------------------------------
     GEOID GetUserGeoIDResult = ::GetUserGeoID(GEOCLASS_NATION);
     CString GetUserGeoIDString;
     GetUserGeoIDString.Format(_T("%d"), GetUserGeoIDResult);
     c_GetUserGeoIDResult.SetWindowText(GetUserGeoIDString);
     if(c_GetUserGeoID.GetCheck() == BST_CHECKED)
        { /* GetUserGeoID */
         fmt = QueryTemplate(_T("[GetUserGeoID]"));
         SetVariable(_T("UserGeoID"));
        } /* GetUserGeoID */

     CString friendlyname_data = Get_GEO_FRIENDLYNAME(GetUserGeoIDResult, GetUserDefaultLangIDResult);
     c_GetUserGeoIDStatus.SetWindowText(friendlyname_data);

     //----------------------------------------------------------------
     // %1: Locale name
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %5: Variable name
     //----------------------------------------------------------------

     CString variable = GetVariable();
     
     //----------------------------------------------------------------
     // Format it
     //----------------------------------------------------------------

     
     BOOL enable = TRUE;
     CString text;
     if(fmt.IsEmpty())
        { /* nothing to do */
         enable = FALSE;
         fmt.LoadString(IDS_NO_PATTERN_SELECTED);
        } /* nothing to do */
     text.FormatMessage(fmt, localeName, _T(""), _T(""), _T(""), variable, _T(""), or, _T(""), _T(""), _T(""), _T(""));

     SetCode(text, enable);
    } // CDefaults::Refresh

/****************************************************************************
*                        CDefaults::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font to the controls
****************************************************************************/

void CDefaults::SetFontToControls()
    {
#ifdef _UNICODE
     c_ConvertDefaultLocaleStatus.SetFont(&UnicodeFont);
     c_GetUserGeoIDStatus.SetFont(&UnicodeFont);
     c_GetUserDefaultUILanguageStatus.SetFont(&UnicodeFont);
     c_GetUserDefaultLCIDStatus.SetFont(&UnicodeFont);
     c_GetUserDefaultLangIDStatus.SetFont(&UnicodeFont);
     c_GetSystemDefaultLangIDStatus.SetFont(&UnicodeFont);
#endif
    } // CDefaults::SetFontToControls

void CDefaults::OnConvertdefaultlocale() 
   {
    Refresh();
   }

void CDefaults::OnGetsystemdefaultlangid() 
   {
    Refresh();
   }

void CDefaults::OnGetuserdefaultlangid() 
   {
    Refresh();
   }

void CDefaults::OnGetuserdefaultlcid() 
   {
    Refresh();
   }

void CDefaults::OnGetuserdefaultuilanguage() 
   {
    Refresh();
   }

void CDefaults::OnGetusergeoid() 
   {
    Refresh();
   }

/****************************************************************************
*                             CDefaults::IndexOK
* Inputs:
*       CWnd * wnd: Window reference
* Result: BOOL
*       TRUE if indexing is OK
*       FALSE if should not index
****************************************************************************/

BOOL CDefaults::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_GetUserGeoIDStatus)
        return FALSE;
     if(wnd == &c_GetUserDefaultUILanguageStatus)
        return FALSE;
     if(wnd == &c_GetUserDefaultLCIDStatus)
        return FALSE;
     if(wnd == &c_GetUserDefaultLangIDStatus)
        return FALSE;
     if(wnd == &c_GetSystemDefaultLangIDStatus)
        return FALSE;
     if(wnd == &c_ConvertDefaultLocaleStatus)
        return FALSE;
     return TRUE;
    } // CDefaults::IndexOK
