#include "stdafx.h"
#include "EnablePair.h"
#include "IsEditControl.h"

/****************************************************************************
*                                 EnablePair
* Inputs:
*       CWnd * w: Desired window
*       BOOL enable: Enable flag
* Result: void
*       
* Effect: 
*       Enables/disables a window and its caption
****************************************************************************/

void EnablePair(CWnd * w, BOOL enable)
    {
     if(w != NULL)
        w->EnableWindow(enable);

     if(IsEditControl(w) && !enable)
        w->SetWindowText(_T(""));

     CWnd * caption = NULL;
     HWND prev = (HWND)::GetWindowLongPtr(w->m_hWnd, GWLP_USERDATA);
     if(prev != NULL)
        caption = CWnd::FromHandle(prev);
     else
        caption = w->GetWindow(GW_HWNDPREV);

     caption->EnableWindow(enable);
    } // EnablePair
