// EnumLanguageGroupLocales.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "EnumLanguageGroupLocales.h"
#include "Query.h"
#include "ErrorString.h"
#include "LCIDs.h"

#include "msg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CEnumLanguageGroupLocales, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CEnumLanguageGroupLocales dialog


CEnumLanguageGroupLocales::CEnumLanguageGroupLocales(CWnd* pParent /*=NULL*/)
        : CFunction(CEnumLanguageGroupLocales::IDD, pParent)
{
        //{{AFX_DATA_INIT(CEnumLanguageGroupLocales)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CEnumLanguageGroupLocales::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CEnumLanguageGroupLocales)
        DDX_Control(pDX, IDC_LGRPID_VIETNAMESE, c_LGRPID_VIETNAMESE);
        DDX_Control(pDX, IDC_LGRPID_TURKISH, c_LGRPID_TURKISH);
        DDX_Control(pDX, IDC_LGRPID_TRADITIONAL_CHINESE, c_LGRPID_TRADITIONAL_CHINESE);
        DDX_Control(pDX, IDC_LGRPID_THAI, c_LGRPID_THAI);
        DDX_Control(pDX, IDC_LGRPID_SIMPLIFIED_CHINESE, c_LGRPID_SIMPLIFIED_CHINESE);
        DDX_Control(pDX, IDC_LGRPID_KOREAN, c_LGRPID_KOREAN);
        DDX_Control(pDX, IDC_LGRPID_JAPANESE, c_LGRPID_JAPANESE);
        DDX_Control(pDX, IDC_LGRPID_INDIC, c_LGRPID_INDIC);
        DDX_Control(pDX, IDC_LGRPID_HEBREW, c_LGRPID_HEBREW);
        DDX_Control(pDX, IDC_LGRPID_GREEK, c_LGRPID_GREEK);
        DDX_Control(pDX, IDC_LGRPID_GEORGIAN, c_LGRPID_GEORGIAN);
        DDX_Control(pDX, IDC_LGRPID_CYRILLIC, c_LGRPID_CYRILLIC);
        DDX_Control(pDX, IDC_LGRPID_CENTRAL_EUROPE, c_LGRPID_CENTRAL_EUROPE);
        DDX_Control(pDX, IDC_LGRPID_BALTIC, c_LGRPID_BALTIC);
        DDX_Control(pDX, IDC_LGRPID_ARMENIAN, c_LGRPID_ARMENIAN);
        DDX_Control(pDX, IDC_LGRPID_ARABIC, c_LGRPID_ARABIC);
        DDX_Control(pDX, IDC_LGRPID_WESTERN_EUROPE, c_LPGRPIP_WESTERN_EUROPE);
        DDX_Control(pDX, IDC_OUTPUT2, c_Output2);
        DDX_Control(pDX, IDC_CALLBACK_NAME, c_CallbackName);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnumLanguageGroupLocales, CFunction)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_LGRPID_WESTERN_EUROPE, IDC_LGRPID_VIETNAMESE, OnGroupLocale)   
        //{{AFX_MSG_MAP(CEnumLanguageGroupLocales)
        ON_EN_CHANGE(IDC_CALLBACK_NAME, OnChangeCallbackName)
        ON_WM_SIZE()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnumLanguageGroupLocales message handlers

/****************************************************************************
*                    CEnumLanguageGroupLocales::Initialize
* Result: void
*       
* Effect: 
*       Initializes
****************************************************************************/

void CEnumLanguageGroupLocales::Initialize()
    {
     variable = _T("typename");
    } // CEnumLanguageGroupLocales::Initialize

/****************************************************************************
*                  CEnumLanguageGroupLocales::OnGroupLocale
* Inputs:
*       UINT id: ID that triggered event
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CEnumLanguageGroupLocales::OnGroupLocale(UINT id)
    {
     lgrpidSelection = id;
     Refresh();
    } // CEnumLanguageGroupLocales::OnGroupLocale

/****************************************************************************
*               CEnumLanguageGroupLocales::OnChangeCallbackName
* Result: void
*       
* Effect: 
*       Updates the code
****************************************************************************/

void CEnumLanguageGroupLocales::OnChangeCallbackName() 
   {
    UpdateCode();
   }

/****************************************************************************
*                   CEnumLanguageGroupLocales::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initailizes teh dialog
****************************************************************************/

BOOL CEnumLanguageGroupLocales::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    // TODO: Add extra initialization here
    lgrpidSelection = IDC_LGRPID_WESTERN_EUROPE;
    CheckRadioButton(IDC_LGRPID_WESTERN_EUROPE, IDC_LGRPID_VIETNAMESE, lgrpidSelection);

    // LGRPID LanguageGroup   LCID Locale    LPTSTR lpLocaleString          LONG_PTR lParam
    
    c_Output2.InsertColumnEx(0, _T("LGRPID LanguageGroup"),  LVCFMT_RIGHT);
    c_Output2.InsertColumnEx(1, _T("LCID Locale"),           LVCFMT_RIGHT);
    c_Output2.InsertColumnEx(2, _T("LPTSTR lpLocaleString"), LVCFMT_LEFT);
    c_Output2.InsertColumnEx(3, _T("LONG_PTR lParam"),       LVCFMT_RIGHT);
    c_Output2.InsertColumnEx(4, _T("(LCID)"),                LVCFMT_LEFT, -1);

    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                 CEnumLanguageGroupLocales::ControlToLGRPID
* Inputs:
*       UINT ctlid: Control ID
* Result: LGRPID
*       Group id
****************************************************************************/

LGRPID CEnumLanguageGroupLocales::ControlToLGRPID(UINT ctlid)
    {
#define case_grpid(x) case IDC_##x: return x;
     switch(ctlid)
        { /* ctlid */
         case_grpid(LGRPID_WESTERN_EUROPE);
         case_grpid(LGRPID_CENTRAL_EUROPE);
         case_grpid(LGRPID_ARABIC);
         case_grpid(LGRPID_ARMENIAN);
         case_grpid(LGRPID_BALTIC);
         case_grpid(LGRPID_CYRILLIC);
         case_grpid(LGRPID_GEORGIAN);
         case_grpid(LGRPID_GREEK);
         case_grpid(LGRPID_HEBREW);
         case_grpid(LGRPID_INDIC);
         case_grpid(LGRPID_JAPANESE);
         case_grpid(LGRPID_KOREAN);
         case_grpid(LGRPID_SIMPLIFIED_CHINESE);
         case_grpid(LGRPID_TRADITIONAL_CHINESE);
         case_grpid(LGRPID_THAI);
         case_grpid(LGRPID_TURKISH);
         case_grpid(LGRPID_VIETNAMESE);
         default: return 0;
        } /* ctlid */
    } // CEnumLanguageGroupLocales::ControlToLGRPID

/****************************************************************************
*           CEnumLanguageGroupLocales::EnumLanguageGroupLocalesProc
* Inputs:
*       LGRPID group: Group ID
*       LCID lcid:
*       LPTSTR locale:
*       LONG_PTR lParam: (LPARAM)(CEnumLanguageGroupLocales *)
* Result: BOOL
*       TRUE, always
* Effect: 
*       Logs the information
****************************************************************************/

BOOL CALLBACK CEnumLanguageGroupLocales::EnumLanguageGroupLocalesProc(LGRPID group, LCID lcid, LPTSTR locale, LONG_PTR lParam)
    {
     CEnumLanguageGroupLocales * self = (CEnumLanguageGroupLocales *)lParam;
     int n = self->c_Output2.GetItemCount();
     LVITEM item;
     CString s;
     s.Format(_T("%d"), group);
     ::ZeroMemory(&item, sizeof(item));
     item.mask = LVIF_TEXT;
     item.iItem = n;
     item.iSubItem = 0;
     item.pszText = (LPTSTR)(LPCTSTR)s;
     self->c_Output2.InsertItem(&item);

     s.Format(_T("0x%04x"), lcid);
     self->c_Output2.SetItemText(n, 1, s);

     self->c_Output2.SetItemText(n, 2, locale);

     self->c_Output2.SetItemText(n, 3, _T("lParam"));

     s = _T("(") + LCIDString(lcid) + _T(")");
     self->c_Output2.SetItemText(n, 4, s);
     return TRUE;
    } // CEnumLanguageGroupLocales::EnumLanguageGroupLocalesProc

/****************************************************************************
*                                 UpdateCode
* Result: void
*       
* Effect: 
*       Updates the code display
****************************************************************************/

void CEnumLanguageGroupLocales::UpdateCode()
    {
     if(!initialized)
        return;

     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);

     CString defaultCallback;

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;
     fmt = QueryTemplate(_T("[EnumLanguageGroupLocales:VARIABLE]"));
     defaultCallback = _T("EnumSystemGroupLocalesProc");

     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName(); // not actually needed

     //----------------------------------------------------------------
     // %2: The LGRPID as a string
     //----------------------------------------------------------------
     CString lgrpidString;
     lgrpidString = GetCaption(lgrpidSelection);
    
     //----------------------------------------------------------------
     // %3: The option flags (not used)
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;

     //----------------------------------------------------------------
     // %4: Length: not used
     //----------------------------------------------------------------
     CString length;

     //----------------------------------------------------------------
     // %5: The variable name
     //----------------------------------------------------------------
     CString variable;

     variable = GetVariable();

     //----------------------------------------------------------------
     // %6: dwFlags as a decimal number
     //----------------------------------------------------------------
     CString dwFlagsDecimal;
     dwFlagsDecimal.Format(_T("%d"), flags);

     //----------------------------------------------------------------
     // %7: The OR operator for bitwise operations
     //----------------------------------------------------------------
     // This was set when the language choice was made

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal integer
     //----------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %9: The LGRPID as a decimal integer
     //----------------------------------------------------------------
     CString lgrpidDecimal;
     lgrpidDecimal.Format(_T("%d"), ControlToLGRPID(lgrpidSelection));

     //----------------------------------------------------------------
     // %10: Not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %11: The callback function name
     //----------------------------------------------------------------
     CString callbackname;
     c_CallbackName.GetWindowText(callbackname);
     callbackname.TrimLeft();
     callbackname.TrimRight();
     if(callbackname.IsEmpty())
        callbackname = defaultCallback;

     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1           %2            %3      %4       %5            %6         %7        %8            %9          %10       %11
     text.FormatMessage(fmt, localeName,  lgrpidString, options, length, variable, dwFlagsDecimal,  or, localeDecimal, lgrpidDecimal, _T(""), callbackname);

     //-----------------------------------------------------------------------------------------------
     SetCode(text, !variable.IsEmpty());

     c_Output2.DeleteAllItems();

     if(!EnumLanguageGroupLocales(EnumLanguageGroupLocalesProc, ControlToLGRPID(lgrpidSelection), flags, (LONG_PTR)this))
        { /* failed */
         DWORD err = ::GetLastError();
         c_Output2.InsertItem(c_Output2.GetItemCount(), ErrorString(err));
        } /* failed */
     else
        { /* success */
        } /* success */

    } // CEnumLanguageGroupLocales::UpdateCode

/****************************************************************************
*                     CEnumLanguageGroupLocales::Refresh
* Result: void
*       
* Effect: 
*       Updates the data
****************************************************************************/

void CEnumLanguageGroupLocales::Refresh()
    {
     UpdateCode();
    } // CEnumLanguageGroupLocales::Refresh

/****************************************************************************
*                      CEnumLanguageGroupLocales::OnSize
* Inputs:
*       UINT nType: Type
*       int cx: new width
*       int cy: new height
* Result: void
*       
* Effect: 
*       Handles window resizing
****************************************************************************/

void CEnumLanguageGroupLocales::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);
        
    ExpandBottom(c_Output2);
   }

/****************************************************************************
*                    CEnumLanguageGroupLocales::QuerySave
* Result: BOOL
*       TRUE if save is possible
*       FALSE if save is not possible
****************************************************************************/

BOOL CEnumLanguageGroupLocales::QuerySave()
    {
     return c_Output2.GetItemCount() > 0;
    } // CEnumLanguageGroupLocales::QuerySave

/****************************************************************************
*                       CEnumLanguageGroupLocales::Save
* Inputs:
*       const CString & filename: File name
*       UINT mode: Mode
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Saves the values
****************************************************************************/

BOOL CEnumLanguageGroupLocales::Save(const CString & filename, UINT mode)
    {
     return c_Output2.Save(filename, mode);
    } // CEnumLanguageGroupLocales::Save
