// EnumSystemGeoID.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "EnumSystemGeoID.h"
#include "Query.h"
#include "msg.h"
#include "ErrorString.h"
#include "LogWnd.h"
#include "RTLMap.h"
#include "GetGeoInfoData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CEnumSystemGeoID, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CEnumSystemGeoID dialog


CEnumSystemGeoID::CEnumSystemGeoID(CWnd* pParent /*=NULL*/)
        : CFunction(CEnumSystemGeoID::IDD, pParent)
{
        //{{AFX_DATA_INIT(CEnumSystemGeoID)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CEnumSystemGeoID::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CEnumSystemGeoID)
        DDX_Control(pDX, IDC_PROGRESS, c_Progress);
        DDX_Control(pDX, IDC_OUTPUT2, c_Output2);
        DDX_Control(pDX, IDC_GEOCLASS_NATION, c_GEOCLASS_NATION);
        DDX_Control(pDX, IDC_CALLBACK_NAME, c_CallbackName);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnumSystemGeoID, CFunction)
        //{{AFX_MSG_MAP(CEnumSystemGeoID)
        ON_EN_CHANGE(IDC_CALLBACK_NAME, OnChangeCallbackName)
        ON_BN_CLICKED(IDC_GEOCLASS_NATION, OnGeoclassNation)
        ON_WM_SIZE()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnumSystemGeoID message handlers

/****************************************************************************
*                       CEnumSystemGeoID::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the dialog
****************************************************************************/

BOOL CEnumSystemGeoID::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    CheckRadioButton(IDC_GEOCLASS_NATION, IDC_GEOCLASS_NATION, IDC_GEOCLASS_NATION);
        
    int width;
    CClientDC dc(&c_Output2);
    int total = 0;

    CString caption;

    caption = _T("GEOID");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(0, caption, LVCFMT_RIGHT, width);

#define COL_GEO_NATION 1
    caption = _T("GEO_NATION");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_NATION, caption, LVCFMT_LEFT, width);

#define COL_GEO_LATITUDE 2
    caption = _T("GEO_LATITUDE");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_LATITUDE, caption, LVCFMT_RIGHT, width);

#define COL_GEO_LONGITUDE 3
    caption = _T("GEO_LONGITUDE");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_LONGITUDE, caption, LVCFMT_RIGHT, width);
    
#define COL_GEO_ISO2 4
    caption = _T("GEO_ISO2");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_ISO2, caption, LVCFMT_RIGHT, width);

#define COL_GEO_ISO3 5
    caption = _T("GEO_ISO3");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_ISO3, caption, LVCFMT_RIGHT, width);

#define COL_GEO_RFC1766 6
    caption = _T("GEO_RFC1766");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_RFC1766, caption, LVCFMT_LEFT, width);

#define COL_GEO_LCID 7
    caption = _T("GEO_LCID");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_LCID, caption, LVCFMT_LEFT, width);

#define COL_GEO_FRIENDLYNAME 8
    caption = _T("GEO_FRIENDLYNAME");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_FRIENDLYNAME, caption, LVCFMT_LEFT, width);

#define COL_GEO_OFFICIALNAME 9
    caption = _T("GEO_OFFICIALNAME");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_OFFICIALNAME, caption, LVCFMT_LEFT, width);
    
#define COL_GEO_TIMEZONES 10
    caption = _T("GEO_TIMEZONES");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_TIMEZONES, caption, LVCFMT_LEFT, width);

#define COL_GEO_OFFICIALLANGUAGES 11
    caption = _T("GEO_OFFICIALLANGUAGES");
    width = dc.GetTextExtent(caption).cx;
    c_Output2.InsertColumnEx(COL_GEO_OFFICIALLANGUAGES, caption, LVCFMT_LEFT, width);

    Refresh();
    
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

void CEnumSystemGeoID::OnChangeCallbackName() 
   {
    Refresh();
   }

void CEnumSystemGeoID::OnGeoclassNation() 
   {
    Refresh();
   }

/****************************************************************************
*                      CEnumSystemGeoID::EnumGeoInfoProc
* Inputs:
*       GEOID geoid: ID value
* Result: BOOL
*       TRUE, always
****************************************************************************/
CEnumSystemGeoID * CEnumSystemGeoID::LogWnd = NULL;

/* static */ BOOL CALLBACK CEnumSystemGeoID::EnumGeoInfoProc(GEOID geoid)
    {
     if(LogWnd == NULL)
        return TRUE;

     LogWnd->c_Progress.StepIt();
     LogWnd->c_Progress.UpdateWindow();
     
     LCID lcid = (LCID)LogWnd->TabParent->SendMessage(UWM_QUERY, (WPARAM)QUERY_LOCALE);
     LANGID langid = LANGIDFROMLCID(lcid);

     CString info;
     info.Format(_T("%d"), geoid);
     int n = LogWnd->c_Output2.GetItemCount();
     LogWnd->c_Output2.InsertItem(n, info);

     LogWnd->c_Output2.SetItemText(n, COL_GEO_NATION,            Get_GEO_NATION(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_LATITUDE,          Get_GEO_LATITUDE(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_LONGITUDE,         Get_GEO_LONGITUDE(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_ISO2,              Get_GEO_ISO2(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_ISO3,              Get_GEO_ISO3(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_RFC1766,           Get_GEO_RFC1766(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_LCID,              Get_GEO_LCID(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_FRIENDLYNAME,      Get_GEO_FRIENDLYNAME(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_OFFICIALNAME,      Get_GEO_OFFICIALNAME(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_TIMEZONES,         Get_GEO_TIMEZONES(geoid, langid));
     LogWnd->c_Output2.SetItemText(n, COL_GEO_OFFICIALLANGUAGES, Get_GEO_OFFICIALLANGUAGES(geoid, langid));

     return TRUE;
    } // CEnumSystemGeoID::EnumGeoInfoProc

/****************************************************************************
*                      CEnumSystemGeoID::EnumGeoCountProc
* Inputs:
*       GEOID: ignored
* Result: BOOL
*       TRUE, always
* Effect: 
*       Increments the item count
****************************************************************************/

BOOL CALLBACK CEnumSystemGeoID::EnumGeoCountProc(GEOID)
    {
     LogWnd->count++;
     return TRUE;
    } // CEnumSystemGeoID::EnumGeoCountProc

/****************************************************************************
*                          CEnumSystemGeoID::Refresh
* Result: void
*       
* Effect: 
*       Updates the code
****************************************************************************/

void CEnumSystemGeoID::Refresh()
    {
     if(!initialized)
        return;

     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);

     CString defaultCallback;

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;
     fmt = QueryTemplate(_T("[EnumSystemGeoID:VARIABLE]"));
     defaultCallback = _T("EnumGeoInfoProc");

     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2: The DWORD as a string
     //----------------------------------------------------------------
     CString dwordparameter = _T(""); // todo

     //----------------------------------------------------------------
     // %3: The option flags
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;
     GetOptionFlags(options, flags, or);

     if(c_GEOCLASS_NATION.GetCheck() == BST_CHECKED)
        { /* GEOCLASS_NATION */
         options = _T("GEOCLASS_NATION ") + options;
         flags |= GEOCLASS_NATION;
        } /* CP_INSTALLED */

     //----------------------------------------------------------------
     // %4: Length: not used
     //----------------------------------------------------------------
     CString length;

     //----------------------------------------------------------------
     // %5: The variable name
     //----------------------------------------------------------------
     CString variable;

     variable = GetVariable();

     //----------------------------------------------------------------
     // %6: dwFlags as a decimal number
     //----------------------------------------------------------------
     CString dwFlagsDecimal;
     dwFlagsDecimal.Format(_T("%d"), flags);

     //----------------------------------------------------------------
     // %7: The OR operator for bitwise operations
     //----------------------------------------------------------------
     // This was set when the language choice was made

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal integer
     //----------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %9: Not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %10: Not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %11: The callback function name
     //----------------------------------------------------------------
     CString callbackname;
     c_CallbackName.GetWindowText(callbackname);
     callbackname.TrimLeft();
     callbackname.TrimRight();
     if(callbackname.IsEmpty())
        callbackname = defaultCallback;

     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1           %2               %3       %4       %5           %6        %7     %8      %9     %10       %11
     text.FormatMessage(fmt, localeName,  dwordparameter, options, length, variable, dwFlagsDecimal,  or, _T(""), _T(""), _T(""), callbackname);

     //-----------------------------------------------------------------------------------------------
     SetCode(text, !variable.IsEmpty());

     LogWnd = this;
     //----------------------------------------------------------------
     // We first compute the range of the scrollbar
     //----------------------------------------------------------------
     count = 0;
     if(!EnumSystemGeoID(flags, 0, EnumGeoCountProc))
        { /* failed */
        } /* failed */
     else
        { /* success */
         c_Progress.SetRange(0, count);
         c_Progress.SetPos(0);
         c_Progress.SetStep(1);
         c_Progress.ShowWindow(SW_SHOW);
         c_Progress.UpdateWindow();
        } /* success */

     c_Output2.DeleteAllItems();

     if(!EnumSystemGeoID(flags, 0, EnumGeoInfoProc))
        { /* failed */
         DWORD err = ::GetLastError();
         //c_Output.AddString(ErrorString(err));
        } /* failed */
     else
        { /* success */
        } /* success */

     c_Progress.ShowWindow(SW_HIDE);
     
    } // CEnumSystemGeoID::Refresh

/****************************************************************************
*                          CEnumSystemGeoID::OnSize
* Inputs:
*       UINT nType: Type
*       int cx: new client width
*       int cy: new client height
* Result: void
*       
* Effect: 
*       Resizes the list control
****************************************************************************/

void CEnumSystemGeoID::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);
        
    ExpandBottom(c_Output2);

    if(c_Progress.GetSafeHwnd() != NULL)
       { /* has progress */
        CRect w;
        c_Progress.GetWindowRect(&w);
        ScreenToClient(&w);
        c_Progress.SetWindowPos(NULL, 0, 0,
                                cx,
                                w.Height(),
                                SWP_NOMOVE | SWP_NOZORDER);
       } /* has progress */
   }

/****************************************************************************
*                         CEnumSystemGeoID::QuerySave
* Result: BOOL
*       TRUE if save can be done
*       FALSE if no save can be done
****************************************************************************/

BOOL CEnumSystemGeoID::QuerySave()
    {
     return c_Output2.GetItemCount() > 0;
    } // CEnumSystemGeoID::QuerySave

/****************************************************************************
*                           CEnumSystemGeoID::Save
* Inputs:
*       const CString & filename: Filename to save
*       UINT mode: Mode of save: 0 (default), 8 (UTF-8), 16 (UTF-16)
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Saves the information
****************************************************************************/

BOOL CEnumSystemGeoID::Save(const CString & filename, UINT mode)
    {
     return c_Output2.Save(filename, mode);
    } // CEnumSystemGeoID::Save
