// EnumUILanguages.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "EnumUILanguages.h"
#include "Query.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CEnumUILanguages, CFunction)

/////////////////////////////////////////////////////////////////////////////
// CEnumUILanguages dialog


CEnumUILanguages::CEnumUILanguages(CWnd* pParent /*=NULL*/)
        : CFunction(CEnumUILanguages::IDD, pParent)
{
        //{{AFX_DATA_INIT(CEnumUILanguages)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CEnumUILanguages::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CEnumUILanguages)
        DDX_Control(pDX, IDC_OUTPUT, c_Output);
        DDX_Control(pDX, IDC_CALLBACK_NAME, c_CallbackName);
        DDX_Control(pDX, IDC_0, c_0);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnumUILanguages, CFunction)
        //{{AFX_MSG_MAP(CEnumUILanguages)
        ON_WM_SIZE()
        ON_BN_CLICKED(IDC_0, On0)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnumUILanguages message handlers

BOOL CEnumUILanguages::OnInitDialog() 
{
        CFunction::OnInitDialog();
        
        // TODO: Add extra initialization here
        c_Output.InsertColumnEx(0, _T("LCID"), LVCFMT_RIGHT, _T("00000000"));
        c_Output.InsertColumnEx(1, _T("LOCALE_SLANGUAGE"), LVCFMT_LEFT, -1);
        CheckRadioButton(IDC_0, IDC_0, IDC_0);

        return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

/****************************************************************************
*                   CEnumUILanguages::CEnumUILanguagesProc
* Inputs:
*       LPTSTR UILanguageString
*       LONG_PTR lParam: Whatever (LONG_PTR)(CEnumUILanguages *)
* Result: BOOL
*       TRUE, always
* Effect: 
*       Handles the enumeration
****************************************************************************/

/* static */ BOOL CALLBACK CEnumUILanguages::EnumUILanguagesProc(LPTSTR UILanguageString, LONG_PTR lParam)
    {
     CEnumUILanguages * me = (CEnumUILanguages *)lParam;
     
     int n = me->c_Output.GetItemCount();
     me->c_Output.InsertItem(n, UILanguageString);

     LCID lcid = _tcstoul(UILanguageString, NULL, 16);
     
     // LOCALE_SLANGUAGE
     CString slanguage_data;
     { /* get LOCALE_SLANGUAGE */
      int length = GetLocaleInfo(lcid, LOCALE_SLANGUAGE, NULL, 0);
      LPTSTR p = slanguage_data.GetBuffer(length);
      VERIFY(::GetLocaleInfo(lcid, LOCALE_SLANGUAGE, p, length));
     } /* get LOCALE_SLANGUAGE */
     slanguage_data.ReleaseBuffer();
     // ... use slanguage_data here

     me->c_Output.SetItemText(n, 1, slanguage_data);

     return TRUE; // continue enumeration
    } // CEnumUILanguages::CEnumUILanguagesProc

/****************************************************************************
*                          CEnumUILanguages::Refresh
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CEnumUILanguages::Refresh()
    {
     if(!initialized)
        return;
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt = QueryTemplate(_T("[EnumUILanguages]"));
     
     CString defaultCallback = _T("EnumUILanguagesProc");

     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName(); // not actually needed

     //----------------------------------------------------------------
     // %2: not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %3: The option flags (not used)
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;
     options = _T("0");

     //----------------------------------------------------------------
     // %4: Length: not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %5: The variable name
     //----------------------------------------------------------------
     CString variable;
     variable = GetVariable();

     //----------------------------------------------------------------
     // %6: dwFlags as a decimal number
     //----------------------------------------------------------------
     CString dwFlagsDecimal;
     dwFlagsDecimal.Format(_T("%d"), flags);

     //----------------------------------------------------------------
     // %7: The OR operator for bitwise operations
     //----------------------------------------------------------------
     // already set

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal integer
     //----------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %9: Not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %10: Not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %11: The callback function name
     //----------------------------------------------------------------
     CString callbackname;
     c_CallbackName.GetWindowText(callbackname);
     callbackname.TrimLeft();
     callbackname.TrimRight();
     if(callbackname.IsEmpty())
        callbackname = defaultCallback;

     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1           %2       %3       %4      %5            %6        %7        %8          %9     %10       %11
     text.FormatMessage(fmt, localeName,  _T(""), options, _T(""), variable, dwFlagsDecimal,  or, localeDecimal, _T(""), _T(""), callbackname);

     //-----------------------------------------------------------------------------------------------
     SetCode(text, !variable.IsEmpty());

     c_Output.DeleteAllItems();
     if(!::EnumUILanguages(EnumUILanguagesProc, 0, (LONG_PTR)this))
        { /* failed */
         DWORD err = ::GetLastError();
         ASSERT(FALSE);
        } /* failed */
    } // CEnumUILanguages::Refresh

/****************************************************************************
*                        CEnumUILanguages::Initialize
* Result: void
*       
* Effect: 
*       Refreshes
****************************************************************************/

void CEnumUILanguages::Initialize()
    {
     Refresh();
    } // CEnumUILanguages::Initialize

/****************************************************************************
*                     CEnumUILanguages::SetFontToControls
* Result: void
*       
* Effect: 
*       
****************************************************************************/

void CEnumUILanguages::SetFontToControls()
    {
#ifdef _DEBUG
#endif
    } // CEnumUILanguages::SetFontToControls

void CEnumUILanguages::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);
        
    ExpandBottom(c_Output);
   }

void CEnumUILanguages::On0() 
   {
    Refresh();  
   }
