
/****************************************************************************
*                              FindHelpResource
* Inputs:
*       CString helpname: The name of the help, expressed as
*               "HELP_name"
*               "#ddddd"  for ddddd the resource ID in decimal
* Result: HRSRC
*       Resource handle to help resource
* Effect: 
*       Finds the help resource
****************************************************************************/

HRSRC FindHelpResource(CString helpname)
    {
     if(m_HelpName.Left(1) == _T("#"))
        { /* decimal ID */
         UINT id = _ttoi(m_HelpName.Mid(1));
         resource = ::FindResource(AfxGetInstanceHandle(), MAKEINTRESOURCE(id), _T("RTF"));
        } /* decimal ID */
     else
        { /* string name */
         resource = ::FindResource(AfxGetInstanceHandle(), MakeHelpName(m_HelpName), _T("RTF"));
        } /* string name */
    } // FindHelpResource
