// GEOID.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "GEOID.h"
#include "_tstof.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGEOID

CGEOID::CGEOID()
{
}

CGEOID::~CGEOID()
{
}


BEGIN_MESSAGE_MAP(CGEOID, CListCtrl)
        //{{AFX_MSG_MAP(CGEOID)
        ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnclick)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGEOID message handlers

/****************************************************************************
*                               CGEOID::compare
* Inputs:
*       LPARAM lParam1: First item
*       LPARAM lParam2: Second item
*       LPARAM: unused
* Result: int
*       < 0 if lParam1 < lParam2
*       = 0 if lParam1 == lParam2
*       > 0 if lParam1 > lParam2
****************************************************************************/

/* static */ int CALLBACK CGEOID::compare(LPARAM lParam1, LPARAM lParam2, LPARAM)
    {
     LPTSTR s1 = (LPTSTR)lParam1;
     LPTSTR s2 = (LPTSTR)lParam2;
     return lstrcmpi(s1, s2);
    } // CGEOID::compare


/****************************************************************************
*                             CGEOID::OnColumnClick
* Inputs:
*       NMHDR * pNMHDR: (NM_LISTVIEW *)(NMHDR *)
*       LRESULT * pResult: Always set to 0
* Result: void
*       
* Effect: 
*       Sorts according to the clicked column
****************************************************************************/

void CGEOID::OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
    *pResult = 0;

    int column = pNMListView->iSubItem;

    LVCOLUMN item;
    CString text;

    BOOL floating = FALSE;
    BOOL numeric = TRUE;

    item.mask = LVCF_TEXT;
    item.pszText = text.GetBuffer(MAX_PATH);
    item.cchTextMax = MAX_PATH;
    GetColumn(column, &item);

    text.ReleaseBuffer();
    if(text == _T("GEO_LATITUDE") ||
       text == _T("GEO_LONGITUDE"))
       floating = TRUE;
    else
       { /* might be numeric */
        // See if sort is numeric or textual value
        for(int i = 0; i < GetItemCount(); i++)
           { /* scan column */
            CString s = GetItemText(i, column);
            CString t = s.SpanIncluding(_T("0123456789"));
            if(s != t)
               numeric = FALSE;
           } /* scan column */
       } /* might be numeric */

    for(int i = 0; i < GetItemCount(); i++)
       { /* prepare for sorting */
        LPVOID p = (LPVOID)GetItemData(i);
        delete p;
        SetItemData(i, NULL);
       } /* prepare for sorting */

    for(i = 0; i < GetItemCount(); i++)
       { /* set column data */
        CString s = GetItemText(i, column);
        if(floating)
           { /* floating point */
            double d = _tstof(s);
            d += 180.0;                         // bias by 180
            s.Format(_T("%08.3f"), d);
           } /* floating point */
        else
        if(numeric)
           { /* convert to canonical */
            CString t;
            t.Format(_T("%09d"), _ttoi(s));
            s = t;
           } /* convert to canonical */
        LPTSTR p = new TCHAR[s.GetLength() + 1];
        if(p != NULL)
           { /* can store it */
            lstrcpy(p, s); // safe because we know new buffer is long enough
            SetItemData(i, (LPARAM)p);
           } /* can store it */
        else
           ASSERT(FALSE); // allocation failure
       } /* set column data */

    SortItems(compare, NULL);
    TRACE0("====================================\n");
    for(i = 0; i < GetItemCount(); i++)
       { /* prepare for sorting */
        LPTSTR p = (LPTSTR)GetItemData(i);
        TRACE2("%d: %s\n", i, p);
        delete p;
        SetItemData(i, NULL);
       } /* prepare for sorting */
    
   }
