// GetNLSVersion.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "GetNLSVersion.h"
#include "Query.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CGetNLSVersion, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CGetNLSVersion dialog


CGetNLSVersion::CGetNLSVersion(CWnd* pParent /*=NULL*/)
        : CFunction(CGetNLSVersion::IDD, pParent)
{
        //{{AFX_DATA_INIT(CGetNLSVersion)
        //}}AFX_DATA_INIT
}


void CGetNLSVersion::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CGetNLSVersion)
        DDX_Control(pDX, IDC_COMPATIBLE, c_Compatible);
        DDX_Control(pDX, IDC_STATUS, c_Status);
        DDX_Control(pDX, IDC_NLSVERSIONINFOSIZE_CAPTION, x_NLSVersionInfoSize);
        DDX_Control(pDX, IDC_NLSVERSIONINFOSIZE, c_NLSVersionInfoSize);
        DDX_Control(pDX, IDC_NLSVERSIONINFO, c_NLSVERSIONINFO);
        DDX_Control(pDX, IDC_NLSVERSION_CAPTION, x_NLSVersion);
        DDX_Control(pDX, IDC_NLSVERSION, c_NLSVersion);
        DDX_Control(pDX, IDC_DEFINEDVERSION_CAPTION, x_DefinedVersion);
        DDX_Control(pDX, IDC_DEFINEDVERSION, c_DefinedVersion);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGetNLSVersion, CFunction)
        //{{AFX_MSG_MAP(CGetNLSVersion)
        ON_BN_CLICKED(IDC_COMPARE_STRING, OnCompareString)
        ON_BN_CLICKED(IDC_COMPATIBLE, OnCompatible)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetNLSVersion message handlers


BOOL CGetNLSVersion::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    // TODO: Add extra initialization here
        
    variable = _T("info");
    CheckRadioButton(IDC_COMPARE_STRING, IDC_COMPARE_STRING, IDC_COMPARE_STRING);
        
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                           CGetNLSVersion::Refresh
* Result: void
*       
* Effect: 
*       Updates the data
****************************************************************************/

void CGetNLSVersion::Refresh()
    {
     EnableQuery(QUERY_DWORD, FALSE);
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;
     if(c_Compatible.GetCheck() == BST_CHECKED)
        fmt = QueryTemplate(_T("[GetNLSVersion:Compatible]"));
     else
        fmt = QueryTemplate(_T("[GetNLSVersion:2003]"));
     

     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2: The NLS_FUNCTION
     //----------------------------------------------------------------
     CString NLSFunction = _T("COMPARE_STRING"); // currently this is all that is supported
                                                 // If more radio buttons are added, ennance this

     //----------------------------------------------------------------
     // %3 unused
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %4: sizeof(NLSVERSIONFINO)
     //----------------------------------------------------------------
     CString length;
     length.Format(_T("%d"), sizeof(NLSVERSIONINFO));

     //----------------------------------------------------------------
     // %5: variable
     //----------------------------------------------------------------

     //CString variable = QueryVariable();
     CString variable = GetVariable();

     //----------------------------------------------------------------
     // %6: NLS_FUNCTION as a number
     //----------------------------------------------------------------
     NLS_FUNCTION function = COMPARE_STRING;  // If more options are supported, add
                                              // code to deal with them
     CString NLSFunctionDecimal;
     NLSFunctionDecimal.Format(_T("%d"), function);


     //----------------------------------------------------------------
     // %7: OR
     //----------------------------------------------------------------
     // Already obtained, above

     //----------------------------------------------------------------
     // %8: LCID decimal
     //----------------------------------------------------------------
     CString localeDecimal;
     LCID lcid = QueryLocale();
     localeDecimal.Format(_T("%d"), lcid);

     //-----------------------------------------------------------------------------
     CString text;
     //                          %1          %2          %3     %4       %5           %6            %7       %8           %9     %10     %11
     text.FormatMessage(fmt, localeName, NLSFunction, _T(""), length, variable, NLSFunctionDecimal, or, localeDecimal, _T(""), _T(""), _T(""));

     SetCode(text, TRUE);

     NLSVERSIONINFO info = {sizeof(NLSVERSIONINFO) };
     BOOL enable = TRUE;
     typedef BOOL (WINAPI * GetNLSVersionProc)(NLS_FUNCTION function, LCID locale, LPNLSVERSIONINFO info);
     GetNLSVersionProc GetNLSVersion1;

     HMODULE kernel32 = ::GetModuleHandle(_T("KERNEL32"));
     GetNLSVersion1 = (GetNLSVersionProc)::GetProcAddress(kernel32, "GetNLSVersion"); // note 8-bit name, not _T()!
     if(GetNLSVersion1 == NULL || !GetNLSVersion1(function, lcid, &info))
        { /* failed */
         DWORD err = ::GetLastError();
         enable = FALSE;
         c_Status.SetWindowText(ErrorString(err));
         c_NLSVersion.SetWindowText(_T(""));
         c_DefinedVersion.SetWindowText(_T(""));
        } /* failed */
     else
        { /* success */
         c_Status.SetWindowText(_T(""));
         CString s;
         s.Format(_T("%d"), info.dwNLSVersion);
         c_NLSVersion.SetWindowText(s);
         s.Format(_T("%d"), info.dwDefinedVersion);
         c_DefinedVersion.SetWindowText(s);
        } /* success */         


     c_NLSVERSIONINFO.EnableWindow(enable);

     c_NLSVersionInfoSize.SetWindowText(_T("sizeof(NLSVERSIONINFO)"));
     x_NLSVersionInfoSize.EnableWindow(enable);
     c_NLSVersionInfoSize.EnableWindow(enable);

     x_NLSVersion.EnableWindow(enable);
     c_NLSVersion.EnableWindow(enable);
     
     x_DefinedVersion.EnableWindow(enable);
     c_DefinedVersion.EnableWindow(enable);
    } // CGetNLSVersion::Refresh


/****************************************************************************
*                        CGetNLSVersion::OnCompatible
*                       CGetNLSVersion::OnCompareString
* Result: void
*       
* Effect: 
*       Redraws the code
****************************************************************************/

void CGetNLSVersion::OnCompatible() 
   {
    Refresh();
   }

void CGetNLSVersion::OnCompareString() 
   {
    Refresh();
   }
