// GetNumberFormat.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "GetNumberFormat.h"
#include "Query.h"
#include "ErrorString.h"
#include "TranslateDigits.h"
#include "Registry.h"
#include "MessagesToChildren.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CGetNumberFormat, CFunction)

DECLARE_MESSAGE(UWM_REFRESH)
/////////////////////////////////////////////////////////////////////////////
// CGetNumberFormat dialog


CGetNumberFormat::CGetNumberFormat(CWnd* pParent /*=NULL*/)
        : CFunction(CGetNumberFormat::IDD, pParent)
{
        //{{AFX_DATA_INIT(CGetNumberFormat)
        //}}AFX_DATA_INIT
}


void CGetNumberFormat::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CGetNumberFormat)
        DDX_Control(pDX, IDC_INDIC_GROUPING, c_IndicGrouping);
        DDX_Control(pDX, IDC_TRANSLATED, c_Translated);
        DDX_Control(pDX, IDC_SHOW_DIGIT_TRANSLATION, c_ShowDigitTranslation);
        DDX_Control(pDX, IDC_LOCALIZED_DIGITS, c_LocalizedDigits);
        DDX_Control(pDX, IDC_VALUE_NAME, c_ValueName);
        DDX_Control(pDX, IDC_NUMBERFMT_NAME, c_NUMBERFMTName);
        DDX_Control(pDX, IDC_LEADINGZERO_CAPTION, x_LeadingZero);
        DDX_Control(pDX, IDC_NEGATIVEORDER_CAPTION, x_NegativeOrder);
        DDX_Control(pDX, IDC_THOUSANDSEP_CAPTION, x_ThousandSep);
        DDX_Control(pDX, IDC_DECIMALSEP_CAPTION, x_DecimalSep);
        DDX_Control(pDX, IDC_CUSTOM_NEGATIVEORDER, c_CustomNegativeOrder);
        DDX_Control(pDX, IDC_CUSTOM_THOUSANDSEP, c_CustomThousandSep);
        DDX_Control(pDX, IDC_CUSTOM_DECIMALSEP, c_CustomDecimalSep);
        DDX_Control(pDX, IDC_GROUPING_CAPTION, x_Grouping);
        DDX_Control(pDX, IDC_CUSTOM_LEADINGZERO, c_CustomLeadingZero);
        DDX_Control(pDX, IDC_CUSTOM_NUMDIGITS, c_CustomNumDigits);
        DDX_Control(pDX, IDC_NUMBER_FORMAT_NULL, c_DefaultToLocale);
        DDX_Control(pDX, IDC_NUMDIGITS_CAPTION, x_NumDigits);
        DDX_Control(pDX, IDC_CUSTOM_FMT, c_UseFormat);
        DDX_Control(pDX, IDC_NUMBERFMT, c_NUMBERFMT);
        DDX_Control(pDX, IDC_SPININEGNUMBER, c_SpinNegativeOrder);
        DDX_Control(pDX, IDC_SPINNUMDIGITS, c_SpinNumDigits);
        DDX_Control(pDX, IDC_RESULT, c_Result);
        DDX_Control(pDX, IDC_NUMDIGITS, c_NumDigits);
        DDX_Control(pDX, IDC_LPDECIMALSEP, c_DecimalSep);
        DDX_Control(pDX, IDC_LPTHOUSANDSEP, c_ThousandSep);
        DDX_Control(pDX, IDC_NEGATIVEORDER, c_NegativeOrder);
        DDX_Control(pDX, IDC_GROUPING, c_Grouping);
        DDX_Control(pDX, IDC_LEADINGZERO, c_LeadingZero);
        DDX_Control(pDX, IDC_LOCALE_IDIGITS, c_LOCALE_IDIGITS);
        DDX_Control(pDX, IDC_LOCALE_ILZERO, c_LOCALE_ILZERO);
        DDX_Control(pDX, IDC_LOCALE_INEGNUMBER, c_LOCALE_INEGNUMBER);
        DDX_Control(pDX, IDC_ADD, c_Add);
        DDX_Control(pDX, IDC_SHOW_NEGATIVEORDER, c_ShowNegativeOrder);
        DDX_Control(pDX, IDC_SPINGROUPING, c_SpinGrouping);
        DDX_Control(pDX, IDC_SAMPLES, c_Samples);
        DDX_Control(pDX, IDC_REMOVE, c_Remove);
        DDX_Control(pDX, IDC_LOCALE_STHOUSAND, c_LOCALE_STHOUSAND);
        DDX_Control(pDX, IDC_LOCALE_SDECIMAL, c_LOCALE_SDECIMAL);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGetNumberFormat, CFunction)
        //{{AFX_MSG_MAP(CGetNumberFormat)
        ON_BN_CLICKED(IDC_ADD, OnAdd)
        ON_BN_CLICKED(IDC_REMOVE, OnRemove)
        ON_BN_CLICKED(IDC_NUMBER_FORMAT_NULL, OnNumberFormatNull)
        ON_BN_CLICKED(IDC_CUSTOM_FMT, OnCustomFmt)
        ON_CBN_EDITCHANGE(IDC_SAMPLES, OnEditchangeSamples)
        ON_CBN_SELCHANGE(IDC_SAMPLES, OnSelchangeSamples)
        ON_WM_VSCROLL()
        ON_BN_CLICKED(IDC_LOCALE_IDIGITS, OnLocaleIdigits)
        ON_BN_CLICKED(IDC_LOCALE_ILZERO, OnLocaleIlzero)
        ON_BN_CLICKED(IDC_LEADINGZERO, OnLeadingzero)
        ON_EN_CHANGE(IDC_GROUPING, OnChangeGrouping)
        ON_BN_CLICKED(IDC_CUSTOM_NUMDIGITS, OnCustomNumdigits)
        ON_BN_CLICKED(IDC_CUSTOM_LEADINGZERO, OnCustomLeadingzero)
        ON_BN_CLICKED(IDC_CUSTOM_NEGATIVEORDER, OnCustomNegativeorder)
        ON_BN_CLICKED(IDC_CUSTOM_THOUSANDSEP, OnCustomThousandsep)
        ON_BN_CLICKED(IDC_LOCALE_INEGNUMBER, OnLocaleInegNumber)
        ON_BN_CLICKED(IDC_LOCALE_SDECIMAL, OnLocaleSdecimal)
        ON_BN_CLICKED(IDC_LOCALE_STHOUSAND, OnLocaleSthousand)
        ON_EN_CHANGE(IDC_LPDECIMALSEP, OnChangeLpdecimalsep)
        ON_EN_CHANGE(IDC_LPTHOUSANDSEP, OnChangeLpthousandsep)
        ON_EN_CHANGE(IDC_NEGATIVEORDER, OnChangeNegativeorder)
        ON_EN_CHANGE(IDC_NUMDIGITS, OnChangeNumdigits)
        ON_BN_CLICKED(IDC_CUSTOM_DECIMALSEP, OnCustomDecimalsep)
        ON_EN_CHANGE(IDC_NUMBERFMT_NAME, OnChangeNumberfmtName)
        ON_EN_CHANGE(IDC_VALUE_NAME, OnChangeValueName)
        ON_BN_CLICKED(IDC_SHOW_DIGIT_TRANSLATION, OnShowDigitTranslation)
        ON_CBN_SELENDOK(IDC_SAMPLES, OnSelendokSamples)
        ON_BN_CLICKED(IDC_INDIC_GROUPING, OnIndicGrouping)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetNumberFormat message handlers

/****************************************************************************
*                      CGetNumberFormat::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the dialog
****************************************************************************/

BOOL CGetNumberFormat::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    // TODO: Add extra initialization here
    c_SpinNegativeOrder.SetRange32(0, 4);
    c_SpinNumDigits.SetRange32(0, 10);
    c_SpinGrouping.SetRange32(0, 9);

    CheckRadioButton(IDC_NUMBER_FORMAT_NULL, IDC_CUSTOM_FMT, IDC_NUMBER_FORMAT_NULL);

    CheckRadioButton(IDC_LOCALE_IDIGITS, IDC_CUSTOM_NUMDIGITS, IDC_LOCALE_IDIGITS);

    CheckRadioButton(IDC_LOCALE_ILZERO, IDC_CUSTOM_LEADINGZERO, IDC_LOCALE_ILZERO);

    CheckRadioButton(IDC_LOCALE_SDECIMAL, IDC_CUSTOM_DECIMALSEP, IDC_LOCALE_SDECIMAL);

    CheckRadioButton(IDC_LOCALE_STHOUSAND, IDC_CUSTOM_THOUSANDSEP, IDC_LOCALE_STHOUSAND);

    CheckRadioButton(IDC_LOCALE_INEGNUMBER, IDC_CUSTOM_NEGATIVEORDER, IDC_LOCALE_INEGNUMBER);
    
    updateControls();
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                         CGetNumberFormat::Refresh
* Result: void
*       
* Effect: 
*       Updates the data and the code sample
****************************************************************************/

void CGetNumberFormat::Refresh()
    {
     updateControls();
    } // CGetNumberFormat::Refresh

/****************************************************************************
*                    CGetNumberFormat::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font to the controls
****************************************************************************/

void CGetNumberFormat::SetFontToControls()
    {
#ifdef _UNICODE
     c_ShowNegativeOrder.SetFont(&UnicodeFont);
     c_DecimalSep.SetFont(&UnicodeFont);
     c_ThousandSep.SetFont(&UnicodeFont);
     c_Result.SetFont(&UnicodeFont);
     c_Translated.SetFont(&UnicodeFont);
     c_LocalizedDigits.SetFont(&UnicodeFont);
#endif
    } // CGetNumberFormat::SetFontToControls

/****************************************************************************
*                          CGetNumberFormat::OnAdd
* Result: void
*       
* Effect: 
*       Adds the current text to the control
* Notes:
*       This button will not be enabled if the sample already exists
****************************************************************************/

void CGetNumberFormat::OnAdd() 
   {
    CString s;
    c_Samples.GetWindowText(s);
    c_Samples.AddString(s);
    CStringArray arr;
    for(int i = 0; i < c_Samples.GetCount(); i++)
       { /* retrieve each */
        CString s;
        c_Samples.GetLBText(i, s);
        arr.Add(s);
       } /* retrieve each */
    SetRegistryValues(HKEY_CURRENT_USER, IDS_REGISTRY_GETNUMBERFORMAT_SAMPLES, arr);
   }

/****************************************************************************
*                        CGetNumberFormat::OnRemove
* Result: void
*       
* Effect: 
*       Removes the current selection
* Notes:
*       Although there is a test for GetCurSel() == CB_ERR, this should
*       never occur because the button should not be enabled if there is
*       no selection
****************************************************************************/

void CGetNumberFormat::OnRemove() 
   {
    int sel = c_Samples.GetCurSel();
    if(sel == CB_ERR)
       return;
    c_Samples.DeleteString(sel);
   }

void CGetNumberFormat::OnNumberFormatNull() 
   {
    updateControls();
   }

void CGetNumberFormat::OnCustomFmt() 
   {
    updateControls();
   }

/****************************************************************************
*                     CGetNumberFormat::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CGetNumberFormat::updateControls()
    {
     NUMBERFMT NumberFormat;

     if(!initialized)
         return;
     BOOL enable;

     EnableQuery(QUERY_DWORD, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);

     CString or = QueryTemplate(_T("[OR]"));

     LCID lcid = QueryLocale();
     //----------------------------------------------------------------
     // Add button
     //----------------------------------------------------------------
     enable = TRUE;
     CString s;
     c_Samples.GetWindowText(s);
     s.TrimLeft();
     s.TrimRight();
     if(s.IsEmpty())
        enable = FALSE;

     int sel = c_Samples.FindStringExact(-1, s);
     if(sel != CB_ERR)
        enable = FALSE;

     c_Add.EnableWindow(enable);

     //----------------------------------------------------------------
     // Remove button
     //----------------------------------------------------------------
     enable = TRUE;
     sel = c_Samples.GetCurSel();
     if(sel == CB_ERR)
        enable = FALSE;

     c_Remove.EnableWindow(enable);

     //----------------------------------------------------------------
     // Number Format
     //----------------------------------------------------------------
     BOOL UseFormat = c_UseFormat.GetCheck() == BST_CHECKED;
     
     c_NUMBERFMT.EnableWindow(UseFormat);

     EnableQuery(QUERY_NOUSEROVERRIDE, !UseFormat);
     
     BOOL readonly;
     //----------------------------------------------------------------
     // NumDigits
     //----------------------------------------------------------------
     readonly = FALSE;
     if(c_LOCALE_IDIGITS.GetCheck() == BST_CHECKED)
        readonly = TRUE;

     c_SpinNumDigits.EnableWindow(!readonly && UseFormat);
     c_NumDigits.EnableWindow(UseFormat);
     c_NumDigits.SetReadOnly(readonly);
     x_NumDigits.EnableWindow(UseFormat);
     c_LOCALE_IDIGITS.EnableWindow(UseFormat);
     c_CustomNumDigits.EnableWindow(UseFormat);
     
     if(c_LOCALE_IDIGITS.GetCheck() == BST_CHECKED)
        { /* use locale */
         // LOCALE_IDIGITS
         DWORD idigits_data;
         if(!::GetLocaleInfo(lcid, LOCALE_IDIGITS | LOCALE_RETURN_NUMBER, (LPTSTR)&idigits_data, sizeof(DWORD)))
            { /* failed */
             idigits_data = 0;
            } /* failed */
         BOOL notify = c_NumDigits.SetNotify(FALSE);
         c_SpinNumDigits.SetPos32(idigits_data);
         c_NumDigits.SetNotify(notify);
        } /* use locale */

     NumberFormat.NumDigits = c_SpinNumDigits.GetPos32();

     //----------------------------------------------------------------
     // LeadingZero [x]
     //----------------------------------------------------------------
     enable = TRUE;
     if(c_LOCALE_ILZERO.GetCheck() == BST_CHECKED)
        enable = FALSE;
     x_LeadingZero.EnableWindow(UseFormat);
     c_LeadingZero.EnableWindow(UseFormat && enable);
     c_LOCALE_ILZERO.EnableWindow(UseFormat);
     c_CustomLeadingZero.EnableWindow(UseFormat);

     if(c_LOCALE_ILZERO.GetCheck() == BST_CHECKED)
        { /* use locale */
         // LOCALE_ILZERO
         DWORD ilzero_data;
         if(!::GetLocaleInfo(lcid, LOCALE_ILZERO | LOCALE_RETURN_NUMBER, (LPTSTR)&ilzero_data, sizeof(DWORD)))
            { /* failed */
             ilzero_data = FALSE;
            } /* failed */
         c_LeadingZero.SetCheck(ilzero_data ? BST_CHECKED : BST_UNCHECKED);
        } /* use locale */

     NumberFormat.LeadingZero = c_LeadingZero.GetCheck();

     //----------------------------------------------------------------
     // Grouping
     //----------------------------------------------------------------
     BOOL indic = c_IndicGrouping.GetCheck() == BST_CHECKED;
     c_Grouping.EnableWindow(UseFormat && !indic);
     x_Grouping.EnableWindow(UseFormat && !indic);
     c_SpinGrouping.EnableWindow(UseFormat && !indic);
     NumberFormat.Grouping = indic ? 32 : c_SpinGrouping.GetPos32();
     c_IndicGrouping.EnableWindow(UseFormat);
     
     //----------------------------------------------------------------
     // lpDecimalSep
     //----------------------------------------------------------------
     readonly = FALSE;
     if(c_LOCALE_SDECIMAL.GetCheck() == BST_CHECKED)
        readonly = TRUE;
     c_DecimalSep.SetReadOnly(readonly);
     c_DecimalSep.EnableWindow(UseFormat);
     c_LOCALE_SDECIMAL.EnableWindow(UseFormat);
     c_CustomDecimalSep.EnableWindow(UseFormat);
     x_DecimalSep.EnableWindow(UseFormat);

     // LOCALE_SDECIMAL
     CString sdecimal_data;
     if(c_LOCALE_SDECIMAL.GetCheck() == BST_CHECKED)
        { /* get LOCALE_SDECIMAL */
         LPTSTR p = sdecimal_data.GetBuffer(5);
         if(::GetLocaleInfo(lcid, LOCALE_SDECIMAL, p, 5) == 0)
            { /* failed */
             sdecimal_data.ReleaseBuffer();
             sdecimal_data = _T(".");
            } /* failed */
         else
            sdecimal_data.ReleaseBuffer();
         c_DecimalSep.SetWindowTextNoNotify(sdecimal_data);
        } /* get LOCALE_SDECIMAL */
     else
        { /* use custom */
         c_DecimalSep.GetWindowText(sdecimal_data);
        } /* use custom */

     NumberFormat.lpDecimalSep = (LPTSTR)(LPCTSTR)sdecimal_data;

     //----------------------------------------------------------------
     // lpThousandSep
     //----------------------------------------------------------------
     readonly = FALSE;
     if(c_LOCALE_STHOUSAND.GetCheck() == BST_CHECKED)
        readonly = TRUE;
     c_ThousandSep.SetReadOnly(readonly);
     c_ThousandSep.EnableWindow(UseFormat);
     c_LOCALE_STHOUSAND.EnableWindow(UseFormat);
     c_CustomThousandSep.EnableWindow(UseFormat);
     x_ThousandSep.EnableWindow(UseFormat);

     // LOCALE_STHOUSAND
     CString sthousand_data;
     if(c_LOCALE_STHOUSAND.GetCheck() == BST_CHECKED)
        { /* get LOCALE_STHOSAND */
         LPTSTR p = sthousand_data.GetBuffer(5);
         if(::GetLocaleInfo(lcid, LOCALE_STHOUSAND, p, 5) == 0)
            { /* failed */
             sthousand_data.ReleaseBuffer();
             sthousand_data = _T(".");
            } /* failed */
         else
            sthousand_data.ReleaseBuffer();
         c_ThousandSep.SetWindowTextNoNotify(sthousand_data);
        } /* get LOCALE_SDECIMAL */
     else
        { /* use custom */
         c_ThousandSep.GetWindowText(sthousand_data);
        } /* use custom */

     NumberFormat.lpThousandSep = (LPTSTR)(LPCTSTR)sthousand_data;

     //----------------------------------------------------------------
     // NegativeOrder
     //----------------------------------------------------------------
     readonly = FALSE;
     if(c_LOCALE_INEGNUMBER.GetCheck() == BST_CHECKED)
        readonly = TRUE;
     c_NegativeOrder.SetReadOnly(readonly);
     c_NegativeOrder.EnableWindow(UseFormat);
     c_LOCALE_INEGNUMBER.EnableWindow(UseFormat);
     c_CustomNegativeOrder.EnableWindow(UseFormat);
     x_NegativeOrder.EnableWindow(UseFormat);
     c_SpinNegativeOrder.EnableWindow(UseFormat && !readonly);

     if(c_LOCALE_INEGNUMBER.GetCheck() == BST_CHECKED)
        { /* use locale */
         // LOCALE_INEGNUMBER
         DWORD inegnumber;
         if(!::GetLocaleInfo(lcid, LOCALE_INEGNUMBER | LOCALE_RETURN_NUMBER, (LPTSTR)&inegnumber, sizeof(DWORD)))
            { /* failed */
             inegnumber = 0;
            } /* failed */
         BOOL notify = c_NegativeOrder.SetNotify(FALSE);
         c_SpinNegativeOrder.SetPos32(inegnumber);
         c_NegativeOrder.SetNotify(notify);
        } /* use locale */

     NumberFormat.NegativeOrder = c_SpinNegativeOrder.GetPos32();

     //----------------------------------------------------------------
     // ShowNegativeOrder
     //----------------------------------------------------------------
     c_ShowNegativeOrder.ShowWindow(UseFormat ? SW_SHOW : SW_HIDE);

     //----------------------------------------------------------------
     // Show negative order
     //----------------------------------------------------------------
     int order = c_SpinNegativeOrder.GetPos32();

     CString showOrder;
     showOrder.LoadString(IDS_LOCALE_INEGNUMBER_0 + order);

     //----------------------------------------------------------------
     // String is of the form
     // $ 1.1-
     //
     // LOCALE_SNATIVEDIGITS
     FormatSample(showOrder, sdecimal_data); 
     c_ShowNegativeOrder.SetWindowText(showOrder);

     // Template
     // NUMBERFMT <<fmt>>;                           // %11
     // <<fmt>>.NumDigits = <<NumDigits>>;             // %11,%12
     // <<fmt>>.LeadingZero = <<LeadingZero>>;         // %11,%13
     // <<fmt>>.Grouping = <<Grouping>>;               // %11,%14
     // <<fmt>>.lpDecimalSep = _T("<<decimalsep>>");   // %11,%15
     // <<fmt>>.lpThousandSep = _T("<<thousandsep>>"); // %11,%16
     // <<fmt>>.NegativeOrder = <<negativeorder>>;     // %11,%17
     //
     // decltype <<variable>>;                         // %5
     // {
     //  int length = GetNumberFormat(<<lcid>>, <<options>>, <<amount>>, <<fmt|NULL>>, NULL, 0); // %1, %3, %9, %11
     //  if(length == 0)
     //     { /* failed */
     //      DWORD error = ::GetLastError();
     //      // .. handle error here
     //     } /* failed */
     //
     //  <<variable>> = string alloc;                   // %5
     //  if(GetNumberFormat(<<lcid>>, <<options>>, <<amount>>, <<fmt | NULL>>, <<variable>>, length) == 0) // %1, %3, %9, %11, %5
     //     { /* failed */
     //      DWORD error = ::GetLastError();
     //      // .. handle error here
     //     } /* failed */
     // .. use <<variable>> here                        // %5
     // free <<variable>>

     // %1: LCID
     // %2:
     // %3: Options string
     // %4:
     // %5: variable
     // %6: Options#
     // %7: OR
     // %8: LCID#
     // %9:  value name
     // %10:
     // %11: NUMBERFMT name

     //----------------------------------------------------------------
     // %1: LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();
     
     //----------------------------------------------------------------
     // %2: unused
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %3 options
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;
     GetOptionFlags(options, flags, or);
     if(options.IsEmpty())
        options = _T("0");

     //----------------------------------------------------------------
     // %4: unused
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %5: variable
     //----------------------------------------------------------------
     enable = TRUE;
     CString variable = QueryVariable();

     //     variable.TrimLeft();
     //     variable.TrimRight();
     //     if(variable.IsEmpty())
     //        { /* empty */
     //         variable = _T("?");
     //         enable = FALSE;
     //        } /* empty */
     variable = GetVariable();

     //----------------------------------------------------------------
     // %6 options #
     //----------------------------------------------------------------
     CString optionsDecimal;
     optionsDecimal.Format(_T("%d"), flags);

     //----------------------------------------------------------------
     // %7 OR
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %8 LCID#
     //----------------------------------------------------------------
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %9 value name
     //----------------------------------------------------------------
     CString valuename;
     c_ValueName.GetWindowText(valuename);

     //----------------------------------------------------------------
     // %10: unused
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %11: NUMBERFMT symbol
     //----------------------------------------------------------------
     CString NumberFormatName;
     c_NUMBERFMTName.GetWindowText(NumberFormatName);
     NumberFormatName.TrimLeft();
     NumberFormatName.TrimRight();

     if(!UseFormat)
        NumberFormatName = _T("NULL");

     //----------------------------------------------------------------
     // %12: NumDigits
     //----------------------------------------------------------------
     CString NumDigits;
     NumDigits.Format(_T("%d"), NumberFormat.NumDigits);

     //----------------------------------------------------------------
     // %13: LeadingZero
     //----------------------------------------------------------------
     CString LeadingZero;
     LeadingZero = c_LeadingZero.GetCheck() ? _T("1") : _T("0");

     //----------------------------------------------------------------
     // %14: Grouping
     //----------------------------------------------------------------
     CString Grouping;
     Grouping.Format(_T("%d"), NumberFormat.Grouping);

     //----------------------------------------------------------------
     // %15: lpDecimalSep
     //----------------------------------------------------------------
     // just use directly from NumberFormat

     //----------------------------------------------------------------
     // %16: lpThousandSep
     //----------------------------------------------------------------
     // just use directly from NumberFormat

     //----------------------------------------------------------------
     // %17: NegativeOrder
     //----------------------------------------------------------------
     CString NegativeOrder;
     NegativeOrder.Format(_T("%d"), NumberFormat.NegativeOrder);

     CString fmt;
     CString text;

     if(c_ShowDigitTranslation.GetCheck() == BST_CHECKED)
        { /* show digit translation */
         fmt = QueryTemplate(_T("[TranslateDigits]"));
         text.FormatMessage(fmt);
        } /* show digit translation */
     else
        { /* show GetNumberFormat */
         if(UseFormat)
            fmt = QueryTemplate(_T("[GetNumberFormat:VARIABLE]"));
         else
            fmt = QueryTemplate(_T("[GetNumberFormat:DEFAULT]"));
         //-----------------------------------------------------------------------------------------------
         //                        %1            %2     %3        %4      %5           %6         %7        %8          %9       %10       %11
         text.FormatMessage(fmt, localeName,  _T(""), options, _T(""), variable, optionsDecimal,  or, localeDecimal,valuename, _T(""), NumberFormatName,
                             //   %12           %13        %14                %15                            %16
                                NumDigits,  LeadingZero, Grouping, NumberFormat.lpDecimalSep, NumberFormat.lpThousandSep,
                             //   %17            %18     %19
                                NegativeOrder, _T(""), _T(""));
        } /* show GetNumberFormat */

     if(valuename.IsEmpty())
        enable = FALSE;
     if(NumberFormatName.IsEmpty())
        enable = FALSE;
     SetCode(text, enable);
     
     CString snativedigits_data;
     { /* get LOCALE_SNATIVEDIGITS */
      int length = GetLocaleInfo(lcid, LOCALE_SNATIVEDIGITS, NULL, 0);
      LPTSTR p = snativedigits_data.GetBuffer(length);
      if(!::GetLocaleInfo(lcid, LOCALE_SNATIVEDIGITS, p, length))
         { /* failed */
          DWORD err = GetLastError();
          c_LocalizedDigits.SetWindowText(ErrorString(err));
         } /* failed */
      else
         { /* success */
          snativedigits_data.ReleaseBuffer();
          c_LocalizedDigits.SetWindowText(snativedigits_data);
         } /* success */
     } /* get LOCALE_SNATIVEDIGITS */

     CString sample;
     c_Samples.GetWindowText(sample);
     if(!UseFormat)
        { /* default format */
         CString result;
         { /* GetNumberFormat */
          int length = GetNumberFormat(lcid, 0, sample, NULL, NULL, 0);
          if(length == 0)
             { /* error */
              DWORD err = GetLastError();
              c_Result.SetWindowText(ErrorString(err));
              c_Translated.SetWindowText(_T(""));
             } /* error */
          else
             { /* valid length */
              LPTSTR p = result.GetBuffer(length);
              if(GetNumberFormat(lcid, 0, sample, NULL, p, length) == 0)
                 { /* failed */
                  DWORD err = GetLastError();
                  result.ReleaseBuffer();
                  c_Result.SetWindowText(ErrorString(err));
                  c_Translated.SetWindowText(_T(""));
                 } /* failed */
              else
                 { /* success */
                  result.ReleaseBuffer();
                  c_Result.SetWindowText(result);
                  if(!TranslateDigits(lcid, result, QueryDigitInfo()))
                     { /* translate digits failed */
                      DWORD err = ::GetLastError();
                      if(err == ERROR_SUCCESS)
                         { /* no translation */
                          c_Translated.SetWindowText(result);
                         } /* no translation */
                      else
                         { /* error */
                          c_Translated.SetWindowText(ErrorString(err));
                         } /* error */
                     } /* translate digits failed */
                  else
                     { /* success */
                      c_Translated.SetWindowText(result);
                     } /* success */
                 } /* success */
             } /* valid length */
         } /* GetNumberFormat */
        } /* default format */
     else
        { /* explicit format */
         CString result;
         { /* GetNumberFormat */
          int length = GetNumberFormat(lcid, 0, sample, &NumberFormat, NULL, 0);
          if(length == 0)
             { /* error */
              DWORD err = GetLastError();
              c_Result.SetWindowText(ErrorString(err));
              c_Translated.SetWindowText(_T(""));
             } /* error */
          else
             { /* valid length */
              LPTSTR p = result.GetBuffer(length);
              if(GetNumberFormat(lcid, 0, sample, &NumberFormat, p, length) == 0)
                 { /* failed */
                  DWORD err = GetLastError();
                  result.ReleaseBuffer();
                  c_Translated.SetWindowText(_T(""));
                  c_Result.SetWindowText(ErrorString(err));
                 } /* failed */
              else
                 { /* success */
                  result.ReleaseBuffer();
                  c_Result.SetWindowText(result);
                  if(!TranslateDigits(lcid, result, QueryDigitInfo()))
                     { /* translate digits failed */
                      DWORD err = ::GetLastError();
                      if(err == ERROR_SUCCESS)
                         { /* no translation */
                          c_Translated.SetWindowText(result);
                         } /* no translation */
                      else
                         { /* error */
                          c_Translated.SetWindowText(ErrorString(err));
                         } /* error */
                     } /* translate digits failed */
                  else
                     { /* success */
                      c_Translated.SetWindowText(result);
                     } /* success */
                 } /* success */
             } /* valid length */
         } /* GetNumberFormat */
        } /* explicit format */
    } // CGetNumberFormat::updateControls

/****************************************************************************
*                   CGetNumberFormat::OnEditchangeSamples
*                    CGetNumberFormat::OnSelchangeSamples
*                    CGetNumberFormat::OnSelendokSamples
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CGetNumberFormat::OnEditchangeSamples() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnSelchangeSamples() 
   {
    PostMessage(UWM_REFRESH);
    //updateControls();      
   }

void CGetNumberFormat::OnSelendokSamples() 
   {
    updateControls();
   }

/****************************************************************************
*                        CGetNumberFormat::OnVScroll
* Inputs:
*       UINT nSBCode:
*       UINT nPos:
*       CScrollBar * pScrollBar: Scroll bar reference (NULL for built-in
*               scrollbar)
* Result: vboid
*       
* Effect: 
*       If an internal scrollbar, does nothing
****************************************************************************/

void CGetNumberFormat::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
   {
    if(pScrollBar != NULL)
       { /* internal spin control */
        updateControls();
        return; // do nothing else
       } /* internal spin control */
        
    CFunction::OnVScroll(nSBCode, nPos, pScrollBar); // built-in scrollbar
   }

void CGetNumberFormat::OnLocaleIdigits() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnLocaleIlzero() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnLeadingzero() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnChangeGrouping() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnCustomNumdigits() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnCustomLeadingzero() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnCustomNegativeorder() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnCustomThousandsep() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnLocaleInegNumber() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnLocaleSdecimal() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnLocaleSthousand() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnChangeLpdecimalsep() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnChangeLpthousandsep() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnChangeNegativeorder() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnChangeNumdigits() 
   {
    updateControls();      
   }

void CGetNumberFormat::OnChangeNumberfmtName() 
   {
    updateControls();
   }

void CGetNumberFormat::OnChangeValueName() 
   {
    updateControls();
   }

void CGetNumberFormat::OnShowDigitTranslation() 
   {
    updateControls();
   }

void CGetNumberFormat::OnCustomNumbersymbol() 
   {
    updateControls();
   }

void CGetNumberFormat::OnCustomDecimalsep() 
   {
    updateControls();
   }

void CGetNumberFormat::OnIndicGrouping() 
   {
    updateControls();   
   }


/****************************************************************************
*                       CGetNumberFormat::Initialize
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CGetNumberFormat::Initialize()
    {
     InitializeVariableNames();
     CStringArray arr;
     GetRegistryValues(HKEY_CURRENT_USER, IDS_REGISTRY_GETNUMBERFORMAT_SAMPLES, arr);
     for(int i = 0; i < arr.GetSize(); i++)
        c_Samples.AddString(arr[i]);
     updateControls();
    } // CGetNumberFormat::Initialize

/****************************************************************************
*                      CGetNumberFormat::FormatSample
* Inputs:
*       CString & showOrder: String to convert
*       CString sdecimaldata: Decimal point
* Result: void
*       
* Effect: 
*       Replaces the contents of the string with the localized data
****************************************************************************/

void CGetNumberFormat::FormatSample(CString & showOrder, CString sdecimal_data)
    {
     LCID lcid = QueryLocale();

     TranslateDigits(lcid, showOrder, QueryDigitInfo());
     
     sdecimal_data.TrimLeft();
     sdecimal_data.TrimRight();
     if(!sdecimal_data.IsEmpty())
        showOrder.Replace(_T("."), sdecimal_data);
    } // CGetNumberFormat::FormatSample

/****************************************************************************
*                       CGetNumberFormat::OnSetActive
* Result: void
*       
* Effect: 
*       Handles page activation
****************************************************************************/

void CGetNumberFormat::OnSetActive()
    {
     if(!initialized)
        return;
     InitializeVariableNames();
    } // CGetNumberFormat::OnSetActive

/****************************************************************************
*                 CGetNumberFormat::InitializeVariableNames
* Result: void
*       
* Effect: 
*       Initializes the variable names
****************************************************************************/

void CGetNumberFormat::InitializeVariableNames()
    {
     CString s;
     s = QueryVariable();
     if(s.IsEmpty())
        SetVariable(_T("Number"));

     c_ValueName.GetWindowText(s);
     s.TrimLeft();
     s.TrimRight();
     if(s.IsEmpty())
        c_ValueName.SetWindowText(_T("value"));

     c_NUMBERFMTName.GetWindowText(s);
     s.TrimLeft();
     s.TrimRight();
     if(s.IsEmpty())
        c_NUMBERFMTName.SetWindowText(_T("NumberFormat"));
    } // CGetNumberFormat::InitializeVariableNames

/****************************************************************************
*                          CGetNumberFormat::IndexOK
* Inputs:
*       CWnd * wnd:
* Result: BOOL
*       TRUE to include the window
*       FALSE to exclude the window
****************************************************************************/

BOOL CGetNumberFormat::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_ShowNegativeOrder)
        return FALSE;
     return TRUE;
    } // CGetNumberFormat::IndexOK

