// GetStringTypeEx.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "GetStringTypeEx.h"
#include "winnls.h"
#include "Query.h"
#include "Escapes.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CGetStringTypeEx, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CGetStringTypeEx dialog


CGetStringTypeEx::CGetStringTypeEx(CWnd* pParent /*=NULL*/)
        : CFunction(CGetStringTypeEx::IDD, pParent)
{
        //{{AFX_DATA_INIT(CGetStringTypeEx)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CGetStringTypeEx::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CGetStringTypeEx)
        DDX_Control(pDX, IDC_REFRESH, c_Refresh);
        DDX_Control(pDX, IDC_CT_CTYPE3, c_CT_CTYPE3);
        DDX_Control(pDX, IDC_CT_CTYPE2, c_CT_CTYPE2);
        DDX_Control(pDX, IDC_CT_CTYPE1, c_CT_CTYPE1);
        DDX_Control(pDX, IDC_CHARCODE, c_Unicode);
        DDX_Control(pDX, IDC_STRING, c_String);
        DDX_Control(pDX, IDC_OUTPUT, c_Output);
        DDX_Control(pDX, IDC_UNICODE_START, c_UnicodeStart);
        DDX_Control(pDX, IDC_UNICODE_END, c_UnicodeEnd);
        DDX_Control(pDX, IDC_TO, c_To);
        DDX_Control(pDX, IDC_TEXT, c_Text);
        DDX_Control(pDX, IDC_SPINSTARTLO, c_SpinStartLO);
        DDX_Control(pDX, IDC_SPINSTARTHO, c_SpinStartHO);
        DDX_Control(pDX, IDC_SPINENDLO, c_SpinEndLO);
        DDX_Control(pDX, IDC_SPINENDHO, c_SpinEndHO);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGetStringTypeEx, CFunction)
        //{{AFX_MSG_MAP(CGetStringTypeEx)
        ON_WM_VSCROLL()
        ON_BN_CLICKED(IDC_CHARCODE, OnUnicode)
        ON_BN_CLICKED(IDC_STRING, OnString)
        ON_EN_CHANGE(IDC_TEXT, OnChangeText)
        ON_BN_CLICKED(IDC_TO, OnTo)
        ON_EN_CHANGE(IDC_UNICODE_START, OnChangeUnicodeStart)
        ON_EN_CHANGE(IDC_UNICODE_END, OnChangeUnicodeEnd)
        ON_WM_SIZE()
        ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
        ON_BN_CLICKED(IDC_CT_CTYPE1, OnCtCtype1)
        ON_BN_CLICKED(IDC_CT_CTYPE2, OnCtCtype2)
        ON_BN_CLICKED(IDC_CT_CTYPE3, OnCtCtype3)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetStringTypeEx message handlers

BOOL CGetStringTypeEx::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    CheckRadioButton(IDC_STRING, IDC_CHARCODE, IDC_STRING);
    c_SpinStartLO.SetRange(0, 0xFF);
    c_SpinStartHO.SetRange(0, 0xFF);
    c_SpinEndLO.SetRange(0, 0xFF);
    c_SpinEndHO.SetRange(0, 0xFF);
#ifdef _UNICODE
    c_UnicodeStart.SetLimitText(4);
    c_UnicodeEnd.SetLimitText(4);
#else
    c_UnicodeStart.SetLimitText(2);
    c_UnicodeEnd.SetLimitText(2);
#endif
    CheckRadioButton(IDC_CT_CTYPE1, IDC_CT_CTYPE3, IDC_CT_CTYPE1);

    updateControls();
    Refresh();
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                         CGetStringTypeEx::OnVScroll
* Inputs:
*       UINT nSBCode:
*       UINT nPos:
*       CScrollBar * pScrollBar: NULL for builtin scrollbars, non-NULL for spin controls
* Result: void
*       
* Effect: 
*       Handles the scrolling operation
****************************************************************************/

void CGetStringTypeEx::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
   {
    if(pScrollBar == NULL)
       { /* pass up */        
        CFunction::OnVScroll(nSBCode, nPos, pScrollBar);
        return;
       } /* pass up */

    if(((CWnd *)pScrollBar == (CWnd *)&c_SpinStartLO) ||
       ((CWnd *)pScrollBar == (CWnd *)&c_SpinStartHO))
        { /* spin start */
         SpinValue(c_UnicodeStart, c_SpinStartLO, c_SpinStartHO);
        } /* spin start */
    if(((CWnd *)pScrollBar == (CWnd *)&c_SpinEndLO) ||
       ((CWnd *)pScrollBar == (CWnd *)&c_SpinEndHO))
       { /* spin start */
        SpinValue(c_UnicodeEnd, c_SpinEndLO, c_SpinEndHO);
       } /* spin start */
   }

/****************************************************************************
*                        CGetStringTypeEx::SpinValue
* Inputs:
*       CHexEdit & edit: Edit control
*       CSpinButtonCtrl & low: Spin button for low order byte
*       CSpinButtonCtgrl & high: Spin button for high order byte
* Result: void
*       
* Effect: 
*       Handles spinning the low order byte of start
****************************************************************************/

void CGetStringTypeEx::SpinValue(CHexEdit & edit, CSpinButtonCtrl & low, CSpinButtonCtrl & high)
    {
     BYTE lo = (BYTE)LOWORD(low.GetPos());
     BYTE hi = (BYTE)LOWORD(high.GetPos());
     UINT val = MAKEWORD(lo, hi);
     edit.SetWindowTextNoNotify(val);
    } // CGetStringTypeEx::SpinStartLO


/****************************************************************************
*                          CGetStringTypeEx::IndexOK
* Inputs:
*       CWnd * wnd: Window reference
* Result: BOOL
*       TRUE if it should be indexed
*       FALSE to not index
****************************************************************************/

BOOL CGetStringTypeEx::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_UnicodeStart)
        return FALSE;
     if(wnd == &c_UnicodeEnd)
        return FALSE;
     if(wnd == &c_String)
        return FALSE;
     if(wnd == &c_Unicode)
        return FALSE;
     return TRUE;
    } // CGetStringTypeEx::IndexOK

void CGetStringTypeEx::OnUnicode() 
   {
    updateControls();
    Refresh();
   }

void CGetStringTypeEx::OnString() 
   {
    updateControls();
    Refresh();
   }

void CGetStringTypeEx::OnChangeText() 
   {
    Refresh();
   }

/****************************************************************************
*                        CGetStringTypeEx::Initialize
* Result: void
*       
* Effect: 
*       Initializes the page
****************************************************************************/

void CGetStringTypeEx::Initialize()
    {
     variable = _T("info");
    } // CGetStringTypeEx::Initialize

/****************************************************************************
*                        CGetStringTypeEx::AddElement
* Inputs:
*       TCHAR ch: Character to add
* Result: void
*       
* Effect: 
*       Addes the element to the tree control
* Notes:
*       [-]--L'c'  0xnnnn
*        |    |
*        |   [-]-- CT_CTYPE1
*        |    |    |
*        |    |    +-- C1_UPPER
*        |    |    +-- C1_LOWER
*        |    |    +-- C1_DIGIT
*        |    |    +-- C1_SPACE
*        |    |    +-- C1_PUNCT
*        |    |    +-- C1_CNTRL
*        |    |    +-- C1_BLANK
*        |    |    +-- C1_XDIGIT
*        |    |    +-- C1_ALPHA
*        |    |    +-- C1_DEFINED
*        |   [-]-- CT_CTYPE2
*        |    |    |
*        |    |   [-]-- Strong
*        |    |    |    |
*        |    |    |    +-- C2_LEFTTORIGHT
*        |    |    |    +-- C2_RIGHTTOLEFT
*        |    |    |
*        |    |   [-]-- Weak
*        |    |    |    |
*        |    |    |    +-- C2_EUROPENUMBER
*        |    |    |    +-- C2_EUROPESEPARATOR
*        |    |    |    +-- C2_EUROPETERMINATOR
*        |    |    |    +-- C2_ARABICNUMBER
*        |    |    |    +-- C2_COMMONSEPARATOR
*        |    |   [-]-- Neutral
*        |    |    |    |
*        |    |    |    +-- C2_BLOCKSEPARATOR
*        |    |    |    +-- C2_SEGMENTSEPARATOR
*        |    |    |    +-- C2_WHITESPACE
*        |    |    |    +-- C2_OTHERNEUTRAL
*        |    |   [-]-- Other
*        |    |         |
*        |    |         +-- C2_NOTAPPLICABLE
*        |    |
*        |   [-]-- CT_CTYPE3
*        |         |
*        |         +--C3_NONSPACING
*        |         +--C3_DIACRITIC
*        |         +--C3_VOWELMARK
*        |         +--C3_SYMBOL
*        |         +--C3_KATAKANA
*        |         +--C3_HIRAGANA
*        |         +--C3_HALFWIDTH
*        |         +--C3_FULLWIDTH
*        |         +--C3_IDEOGRAPH
*        |         +--C3_KASHIDA
*        |         +--C3_LEXICAL
*        |         +--C3_ALPHA
*        |         +--C3_NOTAPPLICABLE
*        |
*       [-]-- L'c' 0xdddd
****************************************************************************/

void CGetStringTypeEx::AddElement(TCHAR ch)
    {
     CString chardesc;
     CString charrep = ch;
     LCID lcid = QueryLocale();
     //EnEscape(charrep, TRUE);
#ifdef _UNICODE
     chardesc.Format(_T("L'%s' 0x%04x"), charrep, ch);
#else
     chardesc.Format(_T("'%s' 0x%02x"), charrep, ch);
#endif     
     HTREEITEM root = c_Output.InsertItem(chardesc);
     WORD type;
     
#define ADDBIT(x, node) \
                        if(type & x) \
                        c_Output.InsertItem(_T(#x), node)
     //----------------------------------------------------------------
     // CT_CTYPE1
     // These types are a bit vector
     //----------------------------------------------------------------
     HTREEITEM ctype1 = c_Output.InsertItem(_T("CT_CTYPE1"), root);
     if(GetStringTypeEx(lcid, CT_CTYPE1, &ch, 1, &type))
        { /* success */
         if(type != 0)
            { /* has ctype1 */
             ADDBIT(C1_UPPER,   ctype1);
             ADDBIT(C1_LOWER,   ctype1);
             ADDBIT(C1_DIGIT,   ctype1);
             ADDBIT(C1_SPACE,   ctype1);
             ADDBIT(C1_PUNCT,   ctype1);
             ADDBIT(C1_CNTRL,   ctype1);
             ADDBIT(C1_BLANK,   ctype1);
             ADDBIT(C1_XDIGIT,  ctype1);
             ADDBIT(C1_ALPHA,   ctype1);
             ADDBIT(C1_DEFINED, ctype1);
            } /* has ctype1 */
         else
            { /* no ctype1 */
             c_Output.DeleteItem(ctype1);
            } /* no ctype1 */
        } /* success */
     else
        { /* failure */
         DWORD err = ::GetLastError();
         CString s = ErrorString(err);
         c_Output.InsertItem(s, ctype1);
        } /* failure */

     //----------------------------------------------------------------
     // CT_CTYPE2
     // These types are mutually exclusive
     //----------------------------------------------------------------
#define ADDELEMENT(x, node) if(type == x) c_Output.InsertItem(_T(#x), node);
     HTREEITEM ctype2 = c_Output.InsertItem(_T("CT_CTYPE2"), root);
     if(GetStringTypeEx(lcid, CT_CTYPE2, &ch, 1, &type))
        { /* success */
         if(type != 0)
            { /* has C2 */
             
             ADDELEMENT(C2_LEFTTORIGHT,     ctype2);
             ADDELEMENT(C2_RIGHTTOLEFT,     ctype2);
             ADDELEMENT(C2_EUROPENUMBER,    ctype2);
             ADDELEMENT(C2_EUROPESEPARATOR, ctype2);
             ADDELEMENT(C2_ARABICNUMBER,    ctype2);
             ADDELEMENT(C2_COMMONSEPARATOR, ctype2);
             ADDELEMENT(C2_BLOCKSEPARATOR,  ctype2);
             ADDELEMENT(C2_SEGMENTSEPARATOR,ctype2);
             ADDELEMENT(C2_WHITESPACE,      ctype2);
             ADDELEMENT(C2_OTHERNEUTRAL,    ctype2);
             ADDELEMENT(C2_NOTAPPLICABLE,   ctype2);
            } /* has C2 */
         else
            { /* no c2 */
             c_Output.DeleteItem(ctype2);
            } /* no c2 */
        } /* success */
     else
        { /* failure */
         DWORD err = ::GetLastError();
         CString s = ErrorString(err);
         c_Output.InsertItem(s, ctype2);
        } /* failure */

     //----------------------------------------------------------------
     // CT_CTYPE3
     // This is a bit vector
     //----------------------------------------------------------------
     HTREEITEM ctype3 = c_Output.InsertItem(_T("CT_CTYPE3"), root);
     if(GetStringTypeEx(lcid, CT_CTYPE3, &ch, 1, &type))
        { /* success */
         if(type != 0)
            { /* has C3 data */
             ADDBIT(C3_NONSPACING,      ctype3);
             ADDBIT(C3_DIACRITIC,       ctype3);
             ADDBIT(C3_VOWELMARK,       ctype3);
             ADDBIT(C3_SYMBOL,          ctype3);
             ADDBIT(C3_KATAKANA,        ctype3);
             ADDBIT(C3_HIRAGANA,        ctype3);
             ADDBIT(C3_HALFWIDTH,       ctype3);
             ADDBIT(C3_FULLWIDTH,       ctype3);
             ADDBIT(C3_IDEOGRAPH,       ctype3);
             ADDBIT(C3_KASHIDA,         ctype3);
             ADDBIT(C3_LEXICAL,         ctype3);
             ADDBIT(C3_ALPHA,           ctype3);
             ADDBIT(C3_NOTAPPLICABLE,   ctype2);
            } /* has C3 data */
         else
            { /* remove it */
             c_Output.DeleteItem(ctype3);
            } /* remove it */
        } /* success */
     else
        { /* failure */
         DWORD err = ::GetLastError();
         CString s = ErrorString(err);
         c_Output.InsertItem(s, ctype2);
        } /* failure */

    } // CGetStringTypeEx::AddElement

/****************************************************************************
*                          CGetStringTypeEx::Refresh
* Result: void
*       
* Effect: 
*       Refreshes the display
****************************************************************************/

void CGetStringTypeEx::Refresh()
    {
     if(!initialized)
         return;

     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);
     
     CString str;
     
     CString or = QueryTemplate(_T("[OR]"));

     CString fmt = QueryTemplate(_T("[GetStringTypeEx]"));

     c_Output.DeleteAllItems();

     //****************************************************************
     // String value
     //****************************************************************

     if(c_String.GetCheck() == BST_CHECKED)
        { /* string values */
         c_Text.GetWindowText(str);
         UnEscape(str);
         if(str.IsEmpty())
            { /* no text */
             // .. nothing to do
             CString msg;
             msg.LoadString(IDS_NO_TEXT);
             c_Output.InsertItem(msg);
             SetCode(msg, FALSE);
             QueryTemplate(_T("")); // in case we exit
             return;
            } /* no text */
        } /* string values */

     //****************************************************************
     // Unicode range
     //****************************************************************

     if(c_Unicode.GetCheck() == BST_CHECKED)
        { /* Unicode range */
         UINT lo = MAKEWORD((BYTE)LOWORD(c_SpinStartLO.GetPos()), (BYTE)LOWORD(c_SpinStartHO.GetPos()));
         UINT hi = MAKEWORD((byte)LOWORD(c_SpinEndLO.GetPos()), (BYTE)LOWORD(c_SpinEndHO.GetPos()));
         if(c_To.GetCheck() == BST_UNCHECKED)
            hi = lo;
         if(lo > hi)
            { /* illegal range */
             CString fmt;
#ifdef _UNICODE
             fmt.LoadString(IDS_ILLEGAL_UNICODE_RANGE);
#else
             fmt.LoadString(IDS_ILLEGAL_ANSI_RANGE);
#endif
             CString msg;
             msg.Format(fmt, lo, hi);
             c_Output.InsertItem(msg);
             SetCode(msg, FALSE);
            } /* illegal range */
         else
            { /* legal range */
             LPTSTR p = str.GetBuffer(hi - lo + 2); // 1 for range, 1 for NUL
                                                    // Note that this may be slightly too large if start == 0
             int count = 0;
             for(UINT i = lo; i <= hi; i++)
                { /* fill array */
                 if(i == 0)
                    continue;
                 p[count] = (TCHAR)i;
                 count++;
                } /* fill array */
             p[count] = _T('\0');
             str.ReleaseBuffer(count);
            } /* legal range */
        } /* Unicode range */

     for(int i = 0; i < str.GetLength(); i++)
        { /* scan string */
         AddElement(str[i]);
        } /* scan string */
     
     fmt = QueryTemplate(_T("[GetStringTypeEx]"));

     //----------------------------------------------------------------
     // %1: LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2: dwInfoType
     //----------------------------------------------------------------
     CString InfoType;
     DWORD type;
#define GetType(x) if(c_##x.GetCheck() == BST_CHECKED) \
                      { /* match  */                   \
                       type = x;                       \
                       InfoType = _T(#x);              \
                      } /* match */

     GetType(CT_CTYPE1);
     GetType(CT_CTYPE2);
     GetType(CT_CTYPE3);
     
     //----------------------------------------------------------------
     // %5: Variable
     //----------------------------------------------------------------
     CString variable = GetVariable();

     //----------------------------------------------------------------
     // %6: dwInfoType decimal
     //----------------------------------------------------------------
     // Computed as type variable, see %2, above
     CString InfoTypeDecimal;
     InfoTypeDecimal.Format(_T("%d"), type);

     //----------------------------------------------------------------
     // %7: or
     //----------------------------------------------------------------
     // Already computed, see above

     //----------------------------------------------------------------
     // %8: LCID decimal
     //----------------------------------------------------------------
     LCID lcid = (LCID)QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %9: string
     //----------------------------------------------------------------
     CString strval;
     if(c_String.GetCheck() == BST_CHECKED)
        { /* use string */
         strval = str;
         EnEscape(strval, TRUE);
        } /* use string */
     else
     if(c_Unicode.GetCheck() == BST_CHECKED)
        { /* use selected char */
         UINT lo = MAKEWORD((BYTE)LOWORD(c_SpinStartLO.GetPos()), (BYTE)LOWORD(c_SpinStartHO.GetPos()));
         if(c_To.GetCheck() == BST_CHECKED)
            { /* range selected */
             strval = CString((TCHAR)lo);  // Rework this to use selected character after we redo the control to be a CListCtrl not a CTreeCtrl
            } /* range selected */
         else
            { /* one selected */
             strval = CString((TCHAR)lo);
            } /* use selected char */
         EnEscape(strval, TRUE);
        } /* use selected char */

     CString text;
     //-----------------------------------------------------------------------------------------------
     //                        %1           %2        %3       %4      %5           %6         %7       %8          %9      %10     %11
     text.FormatMessage(fmt, localeName, InfoType, _T(""),  _T(""), variable, InfoTypeDecimal, or, localeDecimal, strval, _T(""), _T(""));
     //-----------------------------------------------------------------------------------------------
     SetCode(text, !variable.IsEmpty());     
    } // CGetStringTypeEx::Refresh

/****************************************************************************
*                     CGetStringTypeEx::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font to the various controls
****************************************************************************/

void CGetStringTypeEx::SetFontToControls()
    {
#ifdef _UNICODE
     c_Output.SetFont(&UnicodeFont);
     c_Text.SetFont(&UnicodeFont);
#endif
    } // CGetStringTypeEx::SetFontToControls

/****************************************************************************
*                      CGetStringTypeEx::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CGetStringTypeEx::updateControls()
    {
     c_Text.EnableWindow(c_String.GetCheck() == BST_CHECKED);

     c_UnicodeStart.EnableWindow(c_Unicode.GetCheck() == BST_CHECKED);
     c_SpinStartLO.EnableWindow(c_Unicode.GetCheck() == BST_CHECKED);
     c_SpinStartHO.EnableWindow(c_Unicode.GetCheck() == BST_CHECKED);
     c_UnicodeEnd.EnableWindow(c_Unicode.GetCheck() == BST_CHECKED && c_To.GetCheck() == BST_CHECKED);
     c_SpinEndLO.EnableWindow(c_Unicode.GetCheck() == BST_CHECKED && c_To.GetCheck() == BST_CHECKED);
     c_SpinEndHO.EnableWindow(c_Unicode.GetCheck() == BST_CHECKED && c_To.GetCheck() == BST_CHECKED);
     c_To.EnableWindow(c_Unicode.GetCheck() == BST_CHECKED);
#ifndef _UNICODE
     c_SpinStartHO.EnableWindow(FALSE);
     c_SpinStartHO.SetPos(0);
     c_SpinEndHO.EnableWindow(FALSE);
     c_SpinEndHO.SetPos(0);
#endif
     c_Refresh.EnableWindow(c_Unicode.GetCheck() == BST_CHECKED);
    } // CGetStringTypeEx::updateControls

/****************************************************************************
*                           CGetStringTypeEx::OnTo
* Result: void
*       
* Effect: 
*       Allows a range
****************************************************************************/

void CGetStringTypeEx::OnTo() 
   {
    UINT from;
    UINT to;
    c_UnicodeStart.GetWindowText(from);
    c_UnicodeEnd.GetWindowText(to);
    if(to < from)
       c_UnicodeEnd.SetWindowText(from);
    updateControls();
   }

/****************************************************************************
*                   CGetStringTypeEx::OnChangeUnicodeStart
* Result: void
*       
* Effect: 
*       Handles change in the Unicode Start value
****************************************************************************/

void CGetStringTypeEx::OnChangeUnicodeStart() 
   {
    UINT n;
    c_UnicodeStart.GetWindowText(n);
    BYTE hi = HIBYTE((WORD)n);
    BYTE lo = LOBYTE((WORD)n);
    c_SpinStartLO.SetPos(lo);
    c_SpinStartHO.SetPos(hi);
    c_Output.DeleteAllItems();
   }

/****************************************************************************
*                    CGetStringTypeEx::OnChangeUnicodeEnd
* Result: void
*       
* Effect: 
*       Handles a change in the Unicode-end state
****************************************************************************/

void CGetStringTypeEx::OnChangeUnicodeEnd() 
   {
    UINT n;
    c_UnicodeEnd.GetWindowText(n);
    BYTE hi = HIBYTE((WORD)n);
    BYTE lo = LOBYTE((WORD)n);
    c_SpinEndLO.SetPos(lo);
    c_SpinEndHO.SetPos(hi);
    c_Output.DeleteAllItems();
   }

/****************************************************************************
*                          CGetStringTypeEx::OnSize
* Inputs:
*       UINT nType:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Expands the bottom display
****************************************************************************/

void CGetStringTypeEx::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);
        
    ExpandBottom(c_Output);
   }

/****************************************************************************
*                         CGetStringTypeEx::OnRefresh
* Result: void
*       
* Effect: 
*       Forces a refresh
****************************************************************************/

void CGetStringTypeEx::OnRefresh() 
   {
    Refresh();
   }

void CGetStringTypeEx::OnCtCtype1() 
   {
    Refresh();
   }

void CGetStringTypeEx::OnCtCtype2() 
   {
    Refresh();
   }

void CGetStringTypeEx::OnCtCtype3() 
   {
    Refresh();
   }
