// HTMLLink.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "HTMLLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHTMLLink

CHTMLLink::CHTMLLink()
{
 classname = AfxRegisterWndClass(0, ::LoadCursor(NULL, IDC_HAND));
}

CHTMLLink::~CHTMLLink()
{
}


BEGIN_MESSAGE_MAP(CHTMLLink, CStatic)
        //{{AFX_MSG_MAP(CHTMLLink)
        ON_WM_SETCURSOR()
        ON_WM_CTLCOLOR_REFLECT()
        ON_WM_LBUTTONDOWN()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHTMLLink message handlers

/****************************************************************************
*                              CHTMLLink::Create
* Inputs:
*       LPCTSTR text:
*       const CRect & r: Position in parent window coordinates
*       CWnd * parent: Parent window
*       UINT id: ID
* Result: BOOL
*       TRUE if successful create
*       FALSE if error
* Effect: 
*       Creates the window
****************************************************************************/


BOOL CHTMLLink::Create(LPCTSTR text, const CRect & r, CWnd * parent, UINT id)
    {
     if(!CreateEx(0,                    // extended styles
                  classname,            // class name
                  text,                 // contents
                  WS_CHILD | WS_VISIBLE,// styles
                  r,                    // placement
                  parent,               // parent
                  id))                  // id
        return FALSE;

     return TRUE;
    } // CHTMLLink::Create
        

/****************************************************************************
*                           CHTMLLink::OnSetCursor
* Inputs:
*       CWnd * pWnd: ignored
*       UINT nHitTest: ignored
*       UINT message: ignored
* Result: BOOL
*       TRUE, always (stops routing of message)
* Effect: 
*       Sets the hyperlink cursor
* Notes:
*       Does not call the superclass, which would set the class cursor
****************************************************************************/

BOOL CHTMLLink::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
   {
    //HCURSOR cursor = AfxGetApp()->LoadStandardCursor(IDC_HAND);
    HCURSOR cursor = ::LoadCursor(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDC_HAND1));
    SetCursor(cursor);
    return TRUE;
    // return CStatic::OnSetCursor(pWnd, nHitTest, message);
   }

/****************************************************************************
*                             CHTMLLink::CtlColor
* Inputs:
*       CDC * pDC: DC used for drawing
*       UINT nCtlColor: ignored
* Result: HBRUSH
*       Desired brush, uses default brush
* Effect: 
*       Sets the text color
****************************************************************************/

HBRUSH CHTMLLink::CtlColor(CDC* pDC, UINT nCtlColor) 
   {
    COLORREF c = ::GetSysColor(COLOR_HOTLIGHT);
        
    c=RGB(0,0,255);
    pDC->SetTextColor(c);
    
    return (HBRUSH)::GetStockObject(COLOR_3DFACE);
   }

/****************************************************************************
*                          CHTMLLink::OnLButtonDown
* Inputs:
*       UINT nFlags: ignored
*       CPoint point: ignored
* Result: void
*       
* Effect: 
*       Launches a browser shell on the contents of the link
****************************************************************************/

void CHTMLLink::OnLButtonDown(UINT nFlags, CPoint point) 
   {
    CString s;
    GetWindowText(s);
    ShellExecute(m_hWnd, _T("open"), s, NULL, NULL, SW_NORMAL);
        
    CStatic::OnLButtonDown(nFlags, point);
   }

/****************************************************************************
*                        CHTMLLink::PreSubclassWindow
* Result: void
*       
* Effect: 
*       Sets the font to have an underline
****************************************************************************/

void CHTMLLink::PreSubclassWindow() 
   {
    ASSERT(GetStyle() & SS_NOTIFY); // Notify style missing
    LOGFONT lf;
    CFont * f = GetFont();
    f->GetLogFont(&lf);
    lf.lfUnderline = TRUE;
    font.CreateFontIndirect(&lf);
    SetFont(&font);
        
    CStatic::PreSubclassWindow();
   }
