#if !defined(AFX_HEXEDITCTRL_H__935E5C47_8E43_43E6_B050_1337D3A1EF47__INCLUDED_)
#define AFX_HEXEDITCTRL_H__935E5C47_8E43_43E6_B050_1337D3A1EF47__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// HexEditCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CHexEditCtrl window
#include "RichEditCtrlEx.h"

class CHexEditCtrl : public CRichEditCtrlEx
{
// Construction
public:
        CHexEditCtrl();

// Attributes
public:
        void SetTextColor(int i, COLORREF color);
        void SetUnderline(int i, BOOL extend, BOOL on = TRUE);
// Operations
public:
        void SetWindowText(const CString & s, long low, long high, BOOL Notify = FALSE);
        void SetWindowTextNoNotify(const CString & s, long low, long high);
        void SetSel(long low, long high);
        void SetSelNoNotify(long low, long high);
        void GetWindowText(CString & s); 
        void SetModeA();
        void SetModeW();
        void SetRawSel(long low, long high);
        void GetRawSel(long & low, long & high);
        void GetSel(long & low, long & high);
        
// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CHexEditCtrl)
        protected:
        virtual void PreSubclassWindow();
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CHexEditCtrl();

        // Generated message map functions
protected:
        BOOL OVR;
        BOOL OnChange();
        BOOL Sending;
        BOOL Changing;
        void SendInsert();
        CFont font;
        int width;
        static const int default_widthA;
        static const int default_widthW;

        CString text;
        long selstart;
        long selend;
        
        afx_msg BOOL OnProtected(NMHDR * pNMHDR, LRESULT * pResult);
        afx_msg BOOL OnSetfocus();
        afx_msg BOOL OnKillfocus();

        afx_msg LRESULT OnPaste(WPARAM, LPARAM);
        afx_msg LRESULT OnClear(WPARAM, LPARAM);
        afx_msg LRESULT OnCut(WPARAM, LPARAM);
        afx_msg LRESULT OnCopy(WPARAM, LPARAM);
        afx_msg void OnWhatIsThis();
        afx_msg void OnEditSelectAll();
        afx_msg void OnEditCopy();
        //{{AFX_MSG(CHexEditCtrl)
        afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
        afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
        afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
        afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HEXEDITCTRL_H__935E5C47_8E43_43E6_B050_1337D3A1EF47__INCLUDED_)
