// History.cpp : implementation file
//

#include "stdafx.h"
#include "History.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHistory

CHistory::CHistory()
{
}

CHistory::~CHistory()
{
}


BEGIN_MESSAGE_MAP(CHistory, CSmartDropdown)
        //{{AFX_MSG_MAP(CHistory)
        ON_CONTROL_REFLECT(CBN_DROPDOWN, OnDropdown)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHistory message handlers

void CHistory::DeleteItem(LPDELETEITEMSTRUCT dis) 
   {
    History * h = (History *)dis->itemData;
    delete h;
   }

void CHistory::DrawItem(LPDRAWITEMSTRUCT dis) 
   {
    CDC * dc = CDC::FromHandle(dis->hDC);
    CRect r = dis->rcItem;

    COLORREF txcolor;
    COLORREF bkcolor;

    if(dis->itemState & ODS_SELECTED)
       { /* selected */
        bkcolor = GetSysColor(COLOR_HIGHLIGHT);
        txcolor = GetSysColor(COLOR_HIGHLIGHTTEXT);
       } /* selected */
    else
       { /* unselected */
        if(dis->itemState & (ODS_DISABLED | ODS_GRAYED))
           txcolor = GetSysColor(COLOR_GRAYTEXT);
        else
           txcolor = GetSysColor(COLOR_WINDOWTEXT);

        bkcolor = GetSysColor(COLOR_WINDOW);
       } /* unselected */

    History * h = (History *)dis->itemData;
    if(dis->itemID == -1)
       { /* nothing in list */
        dc->DrawFocusRect(&dis->rcItem);
        return;
       } /* nothing in list */

    dc->SetBkColor(bkcolor);
    dc->SetTextColor(txcolor);

    CBrush br;
    CBrush * oldbrush;

    br.CreateSolidBrush(bkcolor);
    oldbrush = dc->SelectObject(&br);

    dc->PatBlt(r.left, r.top, r.Width(), r.Height(), PATCOPY);

    dc->SelectObject(oldbrush);
    br.DeleteObject();

    if(dis->itemID != (UINT)-1 
       && (dis->itemState & (ODS_DISABLED | ODS_GRAYED)) == 0)
       { /* has item */
        dc->TextOut(dis->rcItem.left, dis->rcItem.top, h->GetText());
       } /* has item */

    if(dis->itemState & ODS_FOCUS && dis->itemAction != ODA_SELECT)
       dc->DrawFocusRect(&r);
   }

void CHistory::OnDropdown() 
   {
    CSmartDropdown::OnDropdown();

    CRect w;
    GetParent()->GetWindowRect(&w);

    CRect r;
    GetWindowRect(&r);

    SetDroppedWidth(w.right - r.left);
   }

void CHistory::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
        // TODO: Add your code to determine the size of specified item
        
}

/****************************************************************************
*                             CHistory::IsPresent
* Inputs:
*       LPCTSTR s: String to check for
* Result: int
*       Index of element that matches or CB_ERR if no match
* Notes:
*       Case-sensitive search
****************************************************************************/

int CHistory::IsPresent(History * h)
    {
     ASSERT(h != NULL);
     for(int i = 0; i < GetCount(); i++)
        { /* search */
         History * t = GetItemData(i);
         ASSERT(t != NULL);
         if(t == NULL)
            continue;
         if(t->GetText() == h->GetText())
            return i;
        } /* search */

     return CB_ERR;
    } // CHistory::IsPresent

/****************************************************************************
*                        CHistory::InsertConditionally
* Inputs:
*       int n: place to insert
*       History * h: Object to add
* Result: int
*       Place of insertion
*       CB_ERR if item already exists
* Effect: 
*       Inserts item. If the item already exists, the History object is deleted
****************************************************************************/

int CHistory::InsertConditionally(int n, History * h)
    {
     if(IsPresent(h) != CB_ERR)
        { /* already there */
         delete h;
         return CB_ERR;
        } /* already there */
     return InsertString(n, h);
    } // CHistory::InsertConditionally
