#if !defined(AFX_INDEX_H__F47B7154_A173_4C0F_9557_9547810C0625__INCLUDED_)
#define AFX_INDEX_H__F47B7154_A173_4C0F_9557_9547810C0625__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Index.h : header file
//
#include "Function.h"

/////////////////////////////////////////////////////////////////////////////
// CIndex dialog
#include "IndexText.h"
#include "IndexInfo.h"
#include "TimeStamp.h"

#include "LinkItem.h"

class FastIndexItem : public LinkItem {
    public:
       FastIndexItem(CHARRANGE & c1, CHARRANGE & c2) : LinkItem(c1, c2.cpMin) { } //{ chrg = c1; selection = c2;  }
       FastIndexItem() : LinkItem() { }
};       

class FastIndexTable : public CArray<FastIndexItem, FastIndexItem&> {
    public:
    protected:
};

class CIndex : public CFunction
{
    DECLARE_DYNCREATE(CIndex)
// Construction
public:
        CIndex(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CIndex)
        enum { IDD = IDD_INDEX };
        CIndexText c_Index;
        CIndexText c_FastIndex;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CIndex)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void SetFontToControls();
        virtual void Refresh();
        virtual BOOL QuerySave();
        virtual BOOL Save(const CString & name, UINT mode);
protected:
        ReferenceTable hyperlinks;
        FastIndexTable fastlinks;

        BOOL GetExeTimeStamp(TimeStamp & t);
        BOOL CanLoadFromCache();
        BOOL RetrieveFromCache();
        void SaveToCache();
        void MarkLink(CRichEditCtrlEx & ctl, CHARRANGE & range);
        void ResetAllContent();
        BOOL GetCacheFile(CString & name);
        static DWORD CALLBACK StreamOutCallback(DWORD_PTR, LPBYTE, LONG, LONG *);
        static DWORD CALLBACK StreamInCallback(DWORD_PTR, LPBYTE, LONG, LONG *);
        class StreamInCookie {
            public:
               CFile * file;
               DWORD_PTR remaining;
               DWORD err;
        };
        
        class StreamOutCookie {
            public:
               CFile * file;
               DWORD_PTR LengthOffset;
               DWORD err;
        };
        // Generated message map functions
        afx_msg LRESULT OnIndex(WPARAM, LPARAM);
        //{{AFX_MSG(CIndex)
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnLinkIndex(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnLinkFastIndex(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnDestroy();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_INDEX_H__F47B7154_A173_4C0F_9557_9547810C0625__INCLUDED_)
