#include "msg.h"

#include "LinkItem.h"
#pragma once

class CFunction;
class CTabView;


class Reference : public LinkItem {
    public:
       Reference(CString s, CFunction * p, CWnd * w);
       Reference(CString s, CString s_as, CFunction * p, CWnd * w); 
       Reference() : LinkItem() { }
       static void Canonicalize(CString & s);
    public:
       //================================================================+
       // These are used to construct the index, but are not needed      |
       // after construction, so they do not need to be saved in the     |
       // cache                                                          |
       //================================================================+
       CFunction * page;                                              // |
       CWnd * wnd;                                                    // |
       CString text;                                                  // |
       CString textAs;                                                // |
       //================================================================+
    protected:
       void Set(const CString & s, const CString & as, CFunction * p, CWnd * w);
};

class ReferenceTable : public CArray<Reference *, Reference *> {
    public:
       void Sort();
       static int compare(const void * e1, const void * e2);

}; 


/****************************************************************************
*                                UWM_REFERENCE
* Inputs:
*       WPARAM: (WPARAM)(Reference *) Reference object
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Notifies the parent of an index entry
****************************************************************************/

#define UWM_REFERENCE_MSG _T("UWM_REFERENCE-{18DCB5A2-BA43-4fa5-8D86-555B45FE2BDF}")

DECLARE_MESSAGE(UWM_REFERENCE)


/****************************************************************************
*                                  UWM_INDEX_MSG
* Inputs:
*       WPARAM: (WPARAM)(ReferenceTable *): Pointer to reference table
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       The receiving page will index this table
****************************************************************************/

#define UWM_INDEX_MSG _T("UWM_INDEX-{18DCB5A2-BA43-4fa5-8D86-555B45FE2BDF}")

DECLARE_MESSAGE(UWM_INDEX)
