// IndexText.cpp : implementation file
//

#include "stdafx.h"
#include "IndexText.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIndexText

CIndexText::CIndexText()
{
}

CIndexText::~CIndexText()
{
}


BEGIN_MESSAGE_MAP(CIndexText, CRichEditCtrlEx)
        //{{AFX_MSG_MAP(CIndexText)
        ON_WM_CONTEXTMENU()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIndexText message handlers

/****************************************************************************
*                             CIndexText::Append
* Inputs:
*       LPCTSTR text: String to append
* Result: CHARRANGE
*       Range where it was placed
* Effect: 
*       Appends the text
****************************************************************************/

CHARRANGE CIndexText::Append(LPCTSTR text)
    {
     CHARRANGE old;
     GetSel(old);
     SetRedraw(FALSE);

     int length = GetTextLength();
     //TRACE3("Append(\"%s\"), SetSel(%d, %d)", text, length, length);
     SetSel(length, length);
     ReplaceSel(text);
     int newlength = GetTextLength();
     //TRACE1(" newlength = %d\n", newlength);
     CHARRANGE result = {length, newlength };
     SetSel(old);
     SetRedraw(TRUE);
     return result;
    } // CIndexText::Append

/****************************************************************************
*                          CIndexText::OnContextMenu
* Inputs:
*       CWnd * pWnd:
*       CPoint point:
* Result: void
*       
* Effect: 
*       Help popup
****************************************************************************/

void CIndexText::OnContextMenu(CWnd* pWnd, CPoint point) 
   {
#ifdef _DEBUG //----------------------------------------------------------------+
    CString s;                                                               // |
#if 0                                                                        // |
    s.Format(_T("Text length %d"), GetTextLength());                         // |
    AfxMessageBox(s);                                                        // |
    GetWindowText(s);                                                        // |
    AfxMessageBox(s);                                                        // |
#endif                                                                       // |
#if 0                                                                        // |
    CHARRANGE r;                                                             // |
    GetSel(r);                                                               // |
    CString text = GetSelText();                                             // |
    s.Format(_T("Selection %d..%d \"%s\""), r.cpMin, r.cpMax, text);         // |
    AfxMessageBox(s);                                                        // |
#endif                                                                       // |
#endif //-----------------------------------------------------------------------+
   }

/****************************************************************************
*                          CIndexText::PreSubclassWIndow
* Result: void
*       
* Effect: 
*       Enables the event flags
****************************************************************************/

void CIndexText::PreSubclassWindow()
    {
     SetEventMask(ENM_LINK);
    } // CIndexText::PreSubclassWIndow
