// IsNLSDefinedString.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "IsNLSDefinedString.h"
#include "Query.h"
#include "ErrorString.h"
#ifndef _UNICODE
#include "atlconv.h"
#endif

#include "WideHelper.h"
#include "mbtrace.h"
#include "escapes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CIsNLSDefinedString, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CIsNLSDefinedString dialog


CIsNLSDefinedString::CIsNLSDefinedString(CWnd* pParent /*=NULL*/)
        : CFunction(CIsNLSDefinedString::IDD, pParent)
{
        //{{AFX_DATA_INIT(CIsNLSDefinedString)
        //}}AFX_DATA_INIT
}


void CIsNLSDefinedString::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CIsNLSDefinedString)
        DDX_Control(pDX, IDC_EXPLICIT_LENGTH, c_ExplicitLength);
        DDX_Control(pDX, IDC_NULL, c_NULL);
        DDX_Control(pDX, IDC_NLSVERSIONINFOSIZE_CAPTION, x_NLSVersionInfoSize);
        DDX_Control(pDX, IDC_COMPARE_STRING, c_COMPARE_STRING);
        DDX_Control(pDX, IDC_NLSVERSIONINFOSIZE, c_NLSVersionInfoSize);
        DDX_Control(pDX, IDC_NLSVERSIONINFO, c_NLSVERSIONINFO);
        DDX_Control(pDX, IDC_NLSVERSION_CAPTION, x_NLSVersion);
        DDX_Control(pDX, IDC_NLSVERSION, c_NLSVersion);
        DDX_Control(pDX, IDC_LENGTH, c_Length);
        DDX_Control(pDX, IDC_SPINLENGTH, c_SpinLength);
        DDX_Control(pDX, IDC_STATUS, c_Status);
        DDX_Control(pDX, IDC_WIDE, c_Wide);
        DDX_Control(pDX, IDC_WIDEHEX, c_WideHex);
        DDX_Control(pDX, IDC_DEFINEDVERSION_CAPTION, x_DefinedVersion);
        DDX_Control(pDX, IDC_DEFINEDVERSION, c_DefinedVersion);
        DDX_Control(pDX, IDC_DEFAULTLENGTH, c_DefaultLength);
        DDX_Control(pDX, IDC_COMPATIBLE, c_Compatible);
        DDX_Control(pDX, IDC_GETNLSVERSION, c_GetNLSVersion);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIsNLSDefinedString, CFunction)
        //{{AFX_MSG_MAP(CIsNLSDefinedString)
        ON_BN_CLICKED(IDC_COMPATIBLE, OnCompatible)
        ON_BN_CLICKED(IDC_DEFAULTLENGTH, OnDefaultlength)
        ON_BN_CLICKED(IDC_EXPLICIT_LENGTH, OnExplicitLength)
        ON_EN_CHANGE(IDC_WIDEHEX, OnChangeWidehex)
        ON_BN_CLICKED(IDC_GETNLSVERSION, OnGetnlsversion)
        ON_EN_CHANGE(IDC_LENGTH, OnChangeLength)
        ON_BN_CLICKED(IDC_NULL, OnNull)
        ON_EN_CHANGE(IDC_WIDE, OnChangeWide)
        ON_BN_CLICKED(IDC_COMPARE_STRING, OnCompareString)
        ON_NOTIFY(EN_SELCHANGE, IDC_WIDEHEX, OnSelchangeWidehex)
        ON_NOTIFY(EN_SELCHANGE, IDC_WIDE, OnSelchangeWide)
        ON_WM_VSCROLL()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIsNLSDefinedString message handlers

BOOL CIsNLSDefinedString::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    // TODO: Add extra initialization here
        
    variable = _T("info");
    CheckRadioButton(IDC_COMPARE_STRING, IDC_COMPARE_STRING, IDC_COMPARE_STRING);
    CheckRadioButton(IDC_GETNLSVERSION, IDC_NULL, IDC_GETNLSVERSION);
    CheckRadioButton(IDC_DEFAULTLENGTH, IDC_EXPLICIT_LENGTH, IDC_DEFAULTLENGTH);

    c_SpinLength.SetRange32(-1, 1000);

    c_Wide.SetEventMask(ENM_CHANGE | ENM_SELCHANGE | c_Wide.GetEventMask());
    c_WideHex.SetEventMask(ENM_CHANGE | ENM_SELCHANGE | ENM_PROTECTED | c_WideHex.GetEventMask());

    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

void CIsNLSDefinedString::OnCompatible() 
   {
    Refresh();
   }

void CIsNLSDefinedString::OnDefaultlength() 
   {
    Refresh();
   }

void CIsNLSDefinedString::OnExplicitLength() 
   {
    Refresh();
   }

void CIsNLSDefinedString::OnGetnlsversion() 
   {
    Refresh();
   }

void CIsNLSDefinedString::OnChangeLength() 
   {
    Refresh();
   }

void CIsNLSDefinedString::OnNull() 
   {
    Refresh();
   }

/****************************************************************************
*                     CIsNLSDefinedString::OnChangeWide
* Result: void
*       
* Effect: 
*       Recomputes the spin control if necessary
****************************************************************************/

void CIsNLSDefinedString::OnChangeWide() 
   {
    WideHelper::OnChangeWide(c_Wide, c_WideHex);

    int len = c_Wide.GetWindowTextLength();
    int pos = c_SpinLength.GetPos32();

    c_SpinLength.SetRange32(-1, len);

    if(pos > len)
       c_SpinLength.SetPos32(len);
    Refresh();
   }

/****************************************************************************
*                        CIsNLSDefinedString::Refresh
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CIsNLSDefinedString::Refresh()
    {
#ifndef _UNICODE
    USES_CONVERSION;
#endif
     if(!initialized)
         return;

     EnableQuery(QUERY_DWORD, FALSE);
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;
     if(c_NULL.GetCheck() == BST_CHECKED)
        { /* NULL */
         if(c_Compatible.GetCheck() == BST_CHECKED)
            fmt = QueryTemplate(_T("[IsNLSDefinedString:Compatible:FIXED]"));
         else
            fmt = QueryTemplate(_T("[IsNLSDefinedString:2003:FIXED]"));
        } /* NULL */
     else
        { /* defined */
         if(c_Compatible.GetCheck() == BST_CHECKED)
            fmt = QueryTemplate(_T("[IsNLSDefinedString:Compatible:VARIABLE]"));
         else
            fmt = QueryTemplate(_T("[IsNLSDefinedString:2003:VARIABLE]"));
        } /* defined */

     BOOL enable = c_ExplicitLength.GetCheck() == BST_CHECKED;
     c_SpinLength.EnableWindow(enable);
     c_Length.EnableWindow(enable);
        

     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2: The NLS_FUNCTION
     //----------------------------------------------------------------
     CString NLSFunction = _T("COMPARE_STRING"); // currently this is all that is supported
                                                 // If more radio buttons are added, ennance this

     //----------------------------------------------------------------
     // %3 structure size
     //----------------------------------------------------------------
     CString size;
     size.Format(_T("%d"), sizeof(NLSVERSIONINFO));

     //----------------------------------------------------------------
     // %4: sizeof(NLSVERSIONFINO)
     //----------------------------------------------------------------
     CString lengthDecimal;
     int length = c_DefaultLength.GetCheck() == BST_CHECKED ? -1 : c_SpinLength.GetPos32();
     lengthDecimal.Format(_T("%d"), length);
     
     //----------------------------------------------------------------
     // %5: variable
     //----------------------------------------------------------------
     //CString variable = QueryVariable();
     CString variable = GetVariable();

     //----------------------------------------------------------------
     // %6: NLS_FUNCTION as a number
     //----------------------------------------------------------------
     NLS_FUNCTION function = COMPARE_STRING;  // If more options are supported, add
                                              // code to deal with them
     CString NLSFunctionDecimal;
     NLSFunctionDecimal.Format(_T("%d"), function);


     //----------------------------------------------------------------
     // %7: OR
     //----------------------------------------------------------------
     // Alrleady obtained, above

     //----------------------------------------------------------------
     // %8: LCID decimal
     //----------------------------------------------------------------
     CString localeDecimal;
     LCID lcid = QueryLocale();
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %9: String
     //----------------------------------------------------------------
     CString str;
     c_Wide.GetWindowText(str);
     EnEscape(str, TRUE);

     //-----------------------------------------------------------------------------
     CString text;
#ifdef _DEBUG //----------------------------------------------------------------+
     int n = fmt.GetLength();                                                // |
#endif //-----------------------------------------------------------------------+
     try {
          //                          %1          %2        %3     %4              %5           %6            %7       %8         %9    %10     %11
          text.FormatMessage(fmt, localeName, NLSFunction, size, lengthDecimal, variable, NLSFunctionDecimal, or, localeDecimal, str, _T(""), _T(""));
         }
     catch(CMemoryException * e)
        { /* report error */
         DWORD err = ::GetLastError();
         c_Status.SetWindowText(ErrorString(err));
         e->Delete();
         text.LoadString(IDS_FORMATTING_ERROR);
        } /* report error */

     str.ReleaseBuffer();

     SetCode(text, TRUE);

     NLSVERSIONINFO info = {sizeof(NLSVERSIONINFO) };
     LPNLSVERSIONINFO pinfo = NULL;

     enable = TRUE;
     typedef BOOL (WINAPI * GetNLSVersionProc)(NLS_FUNCTION function, LCID locale, LPNLSVERSIONINFO info);
     // Note that in the name below I have to use the prefix 'p' because the
     // compiler will always find the global name first (which seems to make
     // no sense, since it should find the local scope first! Note there is no
     // :: on the name, but if I don't use a 'p' prefix to make the name unique,
     // it really does try to compile the actual API call
     GetNLSVersionProc pGetNLSVersion;

     HMODULE kernel32 = ::GetModuleHandle(_T("KERNEL32"));
     if(c_GetNLSVersion.GetCheck() == BST_CHECKED)
        { /* use GetNLSVersion */
         pGetNLSVersion = (GetNLSVersionProc)::GetProcAddress(kernel32, "GetNLSVersion"); // note 8-bit name, not _T()!
         if(pGetNLSVersion == NULL || !pGetNLSVersion(function, lcid, &info))
            { /* failed */
             DWORD err = ::GetLastError();
             enable = FALSE;
             c_Status.SetWindowText(ErrorString(err));
             c_NLSVersion.SetWindowText(_T(""));
             c_DefinedVersion.SetWindowText(_T(""));
            } /* failed */
         else
            { /* success */
             c_Status.SetWindowText(_T(""));
             CString s;
             s.Format(_T("%d"), info.dwNLSVersion);
             c_NLSVersion.SetWindowText(s);
             s.Format(_T("%d"), info.dwDefinedVersion);
             c_DefinedVersion.SetWindowText(s);
             pinfo = &info;
            } /* success */
        } /* use GetNLSVersion */
     else
        { /* use NULL */
         enable = FALSE;
         c_Status.SetWindowText(_T(""));
         c_NLSVersion.SetWindowText(_T(""));
         c_DefinedVersion.SetWindowText(_T(""));
        } /* use NULL */


     LPWSTR sample;
     CString sp;
     c_Wide.GetWindowText(sp);
#ifdef _UNICODE
     sample = sp.GetBuffer(0);
#else
     sample = A2W((LPCTSTR)sp);
#endif
     typedef BOOL (WINAPI * IsNLSDefinedStringProc)(NLS_FUNCTION, DWORD, LPNLSVERSIONINFO, LPCWSTR, int);
     IsNLSDefinedStringProc pIsNLSDefinedString = (IsNLSDefinedStringProc)::GetProcAddress(kernel32, "IsNLSDefinedString"); // note 8-bit name, not _T()!
     
     if(pIsNLSDefinedString == NULL || !pIsNLSDefinedString(function, 0, pinfo, sample, length))
        { /* IsNLSDefinedString failed */
         DWORD err = ::GetLastError();
         if(err == ERROR_SUCCESS)
            { /* invalid characters */
             CString s;
             s.LoadString(IDS_INVALID_CHARACTERS);
             c_Status.SetWindowText(s);
            } /* invalid characters */
         else
            { /* other error */
             c_Status.SetWindowText(ErrorString(err));
            } /* other error */
        } /* IsNLSDefinedString failed */
     else
        { /* success */
         CString s;
         s.LoadString(IDS_TRUE);
         c_Status.SetWindowText(s);
        } /* success */
#ifdef _UNICODE
     sp.ReleaseBuffer();
#else
     // Nothing to do
#endif

     c_NLSVERSIONINFO.EnableWindow(enable);

     c_NLSVersionInfoSize.SetWindowText(_T("sizeof(NLSVERSIONINFO)"));
     x_NLSVersionInfoSize.EnableWindow(enable);
     c_NLSVersionInfoSize.EnableWindow(enable);

     x_NLSVersion.EnableWindow(enable);
     c_NLSVersion.EnableWindow(enable);

     x_DefinedVersion.EnableWindow(enable);
     c_DefinedVersion.EnableWindow(enable);
     
    } // CIsNLSDefinedString::Refresh

void CIsNLSDefinedString::OnCompareString() 
{
        // TODO: Add your control notification handler code here
        
}

/****************************************************************************
*                       CIsNLSDefinedString::OnVScroll
* Inputs:
*       UINT nSBCode:
*       UINT nPos:
*       CScrollBar * pScrollBar
* Result: void
*       
* Effect: 
*       Handles scrolling
* Notes:
*       If the pScrollBar is non-NULL, it is from a spin control inside and
*       we ignore it
****************************************************************************/

void CIsNLSDefinedString::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
   {
    if(pScrollBar != NULL)
       return; // spin control internally
        
    CFunction::OnVScroll(nSBCode, nPos, pScrollBar);
   }

/****************************************************************************
*                       CIsNLSDefinedString::Initialize
* Result: void
*       
* Effect: 
*       Performs initialization
****************************************************************************/

void CIsNLSDefinedString::Initialize()
    {
     Refresh();
    } // CIsNLSDefinedString::Initialize

/****************************************************************************
*                   CIsNLSDefinedString::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the selected Unicode font in the control 
****************************************************************************/

void CIsNLSDefinedString::SetFontToControls()
    {
#ifdef _DEBUG //----------------------------------------------------------------+
         LOGFONT lf;                                                         // |
         UnicodeFont.GetLogFont(&lf); // this is just for debugging          // |
#endif //-----------------------------------------------------------------------+
#ifdef _UNICODE
     c_Wide.SetFont(&UnicodeFont);
#endif
    } // CIsNLSDefinedString::SetFontToControls

/****************************************************************************
*                         CIsNLSDefinedString::OnChangeWideHex
* Result: void
*       
* Effect: 
*       A change was made in the hex window. Replace the characters in
*       the input window
****************************************************************************/

void CIsNLSDefinedString::OnChangeWidehex() 
   {
        WideHelper::OnChangeWideHex(c_Wide, c_WideHex);
    Refresh();
   }

/****************************************************************************
*                         CIsNLSDefinedString::OnSelchangeWide
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Causes concurrent selection to appear in hex control
****************************************************************************/

void CIsNLSDefinedString::OnSelchangeWide(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    SELCHANGE *pSelChange = reinterpret_cast<SELCHANGE *>(pNMHDR);
    // TODO: The control will not send this notification unless you override the
    // CFunction::OnInitDialog() function to send the EM_SETEVENTMASK message
    // to the control with the ENM_SELCHANGE flag ORed into the lParam mask.
        
        WideHelper::OnSelChangeWide(c_Wide, c_WideHex);
    *pResult = 0;
   }

/****************************************************************************
*                       CIsNLSDefinedString::OnSelchangeWidehex
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Refelcts the change to the c_Wide control
****************************************************************************/

void CIsNLSDefinedString::OnSelchangeWidehex(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    SELCHANGE *pSelChange = reinterpret_cast<SELCHANGE *>(pNMHDR);
    // TODO: The control will not send this notification unless you override the
    // CFunction::OnInitDialog() function to send the EM_SETEVENTMASK message
    // to the control with the ENM_SELCHANGE flag ORed into the lParam mask.
        WideHelper::OnSelChangeWideHex(c_Wide, c_WideHex);
    *pResult = 0;
   }
