// IsTextUnicode.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "IsTextUnicode.h"
#include "WideHelper.h"
#include "Query.h"
#include "Escapes.h"
#include "lcids.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CIsTextUnicode, CFunction)

/////////////////////////////////////////////////////////////////////////////
// CIsTextUnicode dialog

#define ITU(flag) FlagMap.Add(FlagMapEntry((DWORD)flag, &c_##flag, &c_OUT_##flag)); 

class FlagMapEntry {
    public:
       FlagMapEntry(DWORD f, CWhatIsItButton * b, CButton * o) { flag = f; button = b; output = o; }
       FlagMapEntry() { flag = 0; button = NULL; output = NULL; }
    public:
       DWORD flag;
       CWhatIsItButton * button;
       CButton * output;
};

class FlagMapArray : public CArray<FlagMapEntry, FlagMapEntry  &> {
    public:
       CString GetFlagValue(DWORD flag) {
          for(int i = 0; i < GetSize(); i++)
             {
              if( (GetAt(i).flag & flag) == flag)
                 {
                  CString s;
                  GetAt(i).button->GetWindowText(s);
                  return s;
                 }
             }
          return _T("");
       }
       void SetOutputValue(DWORD flag, BOOL mode) {
          for(int i = 0; i < GetSize(); i++)
             { /* scan structure */
              if( (GetAt(i).flag & flag) == flag)
                 { /* set it */
                  GetAt(i).output->SetCheck(mode ? BST_CHECKED : BST_UNCHECKED);
                 } /* set it */
             } /* scan structure */
       }
};

FlagMapArray FlagMap;

CIsTextUnicode::CIsTextUnicode(CWnd* pParent /*=NULL*/)
        : CFunction(CIsTextUnicode::IDD, pParent)
{
        //{{AFX_DATA_INIT(CIsTextUnicode)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CIsTextUnicode::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CIsTextUnicode)
        DDX_Control(pDX, IDC_WIDE, c_Wide);
        DDX_Control(pDX, IDC_WIDEHEX, c_WideHex);
        DDX_Control(pDX, IDC_RESULT, c_Result);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_ODD_LENGTH, c_IS_TEXT_UNICODE_ODD_LENGTH);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_ILLEGAL_CHARS, c_IS_TEXT_UNICODE_ILLEGAL_CHARS);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_UNICODE_MASK, c_IS_TEXT_UNICODE_UNICODE_MASK);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_STATISTICS, c_IS_TEXT_UNICODE_STATISTICS);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_SIGNATURE, c_IS_TEXT_UNICODE_SIGNATURE);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_REVERSE_STATISTICS, c_IS_TEXT_UNICODE_REVERSE_STATISTICS);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_REVERSE_SIGNATURE, c_IS_TEXT_UNICODE_REVERSE_SIGNATURE);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_REVERSE_MASK, c_IS_TEXT_UNICODE_REVERSE_MASK);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_REVERSE_CONTROLS, c_IS_TEXT_UNICODE_REVERSE_CONTROLS);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_REVERSE_ASCII16, c_IS_TEXT_UNICODE_REVERSE_ASCII16);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_NULL_BYTES, c_IS_TEXT_UNICODE_NULL_BYTES);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_NOT_UNICODE_MASK, c_IS_TEXT_UNICODE_NOT_UNICODE_MASK);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_NOT_ASCII_MASK, c_IS_TEXT_UNICODE_NOT_ASCII_MASK);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_DBCS_LEADBYTE, c_IS_TEXT_UNICODE_DBCS_LEADBYTE);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_CONTROLS, c_IS_TEXT_UNICODE_CONTROLS);
        DDX_Control(pDX, IDC_IS_TEXT_UNICODE_ASCII16, c_IS_TEXT_UNICODE_ASCII16);
        DDX_Control(pDX, IDC_0X8000, c_0X8000);
        DDX_Control(pDX, IDC_0X4000, c_0X4000);
        DDX_Control(pDX, IDC_0X2000, c_0X2000);
        DDX_Control(pDX, IDC_0X0800, c_0X0800);
        DDX_Control(pDX, IDC_VS7, c_VS7);
        DDX_Control(pDX, IDC_VS6, c_VS6);

        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_ODD_LENGTH, c_OUT_IS_TEXT_UNICODE_ODD_LENGTH);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_ILLEGAL_CHARS, c_OUT_IS_TEXT_UNICODE_ILLEGAL_CHARS);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_STATISTICS, c_OUT_IS_TEXT_UNICODE_STATISTICS);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_SIGNATURE, c_OUT_IS_TEXT_UNICODE_SIGNATURE);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_REVERSE_STATISTICS, c_OUT_IS_TEXT_UNICODE_REVERSE_STATISTICS);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_REVERSE_SIGNATURE, c_OUT_IS_TEXT_UNICODE_REVERSE_SIGNATURE);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_REVERSE_CONTROLS, c_OUT_IS_TEXT_UNICODE_REVERSE_CONTROLS);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_REVERSE_ASCII16, c_OUT_IS_TEXT_UNICODE_REVERSE_ASCII16);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_NULL_BYTES, c_OUT_IS_TEXT_UNICODE_NULL_BYTES);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_DBCS_LEADBYTE, c_OUT_IS_TEXT_UNICODE_DBCS_LEADBYTE);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_CONTROLS, c_OUT_IS_TEXT_UNICODE_CONTROLS);
        DDX_Control(pDX, IDC_OUT_IS_TEXT_UNICODE_ASCII16, c_OUT_IS_TEXT_UNICODE_ASCII16);
        DDX_Control(pDX, IDC_OUT_0X8000, c_OUT_0X8000);
        DDX_Control(pDX, IDC_OUT_0X4000, c_OUT_0X4000);
        DDX_Control(pDX, IDC_OUT_0X2000, c_OUT_0X2000);
        DDX_Control(pDX, IDC_OUT_0X0800, c_OUT_0X0800);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIsTextUnicode, CFunction)
        //{{AFX_MSG_MAP(CIsTextUnicode)
        ON_BN_CLICKED(IDC_VS6, OnVs6)
        ON_BN_CLICKED(IDC_VS7, OnVs7)
        ON_BN_CLICKED(IDC_0X0800, On0x0800)
        ON_BN_CLICKED(IDC_0X2000, On0x2000)
        ON_BN_CLICKED(IDC_0X4000, On0x4000)
        ON_BN_CLICKED(IDC_0X8000, On0x8000)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_ASCII16, OnIsTextUnicodeAscii16)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_CONTROLS, OnIsTextUnicodeControls)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_DBCS_LEADBYTE, OnIsTextUnicodeDbcsLeadbyte)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_NOT_ASCII_MASK, OnIsTextUnicodeNotAsciiMask)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_NOT_UNICODE_MASK, OnIsTextUnicodeNotUnicodeMask)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_NULL_BYTES, OnIsTextUnicodeNullBytes)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_REVERSE_ASCII16, OnIsTextUnicodeReverseAscii16)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_REVERSE_CONTROLS, OnIsTextUnicodeReverseControls)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_REVERSE_MASK, OnIsTextUnicodeReverseMask)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_REVERSE_SIGNATURE, OnIsTextUnicodeReverseSignature)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_REVERSE_STATISTICS, OnIsTextUnicodeReverseStatistics)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_SIGNATURE, OnIsTextUnicodeSignature)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_STATISTICS, OnIsTextUnicodeStatistics)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_UNICODE_MASK, OnIsTextUnicodeUnicodeMask)
        ON_NOTIFY(EN_SELCHANGE, IDC_WIDE, OnSelchangeWide)
        ON_NOTIFY(EN_SELCHANGE, IDC_WIDEHEX, OnSelchangeWidehex)
        ON_EN_CHANGE(IDC_WIDE, OnChangeWide)
        ON_EN_CHANGE(IDC_WIDEHEX, OnChangeWidehex)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_ILLEGAL_CHARS, OnIsTextUnicodeIllegalChars)
        ON_BN_CLICKED(IDC_IS_TEXT_UNICODE_ODD_LENGTH, OnIsTextUnicodeOddLength)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIsTextUnicode message handlers

/****************************************************************************
*                         CIsTextUnicode::Initialize
* Result: void
*       
* Effect: 
*       Initializes the page
****************************************************************************/

void CIsTextUnicode::Initialize()
    {
     variable = _T("buffer");
    } // CIsTextUnicode::Initialize

/****************************************************************************
*                          CIsTextUnicode::On0x8000
*                                     0x8000
* Result: void
*       
* Effect: 
*       Handes 0x8000
****************************************************************************/

void CIsTextUnicode::On0x8000() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                          CIsTextUnicode::On0x4000
*                                     0x4000
* Result: void
*       
* Effect: 
*       Handles 0x4000
****************************************************************************/

void CIsTextUnicode::On0x4000() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                          CIsTextUnicode::On0x2000
*                                     0x2000
* Result: void
*       
* Effect: 
*       Enables F000
****************************************************************************/

void CIsTextUnicode::On0x2000() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                  CIsTextUnicode::OnIsTextUnicodeNullBytes
*                                     0x1000
* Result: void
*       
* Effect: 
*       Handles 0xF000
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeNullBytes() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                          CIsTextUnicode::On0x0800
*                                     0x800
* Result: void
*       
* Effect: 
*       Handles 0X0F00
****************************************************************************/

void CIsTextUnicode::On0x0800() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                 CIsTextUnicode::OnIsTextUnicodeDbcsLeadbyte
*                                     0x0400
* Result: void
*       
* Effect: 
*       Handles 0x0F00
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeDbcsLeadbyte() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                  CIsTextUnicode::OnIsTextUnicodeOddLength
*                                     0x0200
* Result: void
*       
* Effect: 
*       Hndles 0x0F00
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeOddLength() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                 CIsTextUnicode::OnIsTextUnicodeIllegalChars
*                                     0x0100
* Result: void
*       
* Effect: 
*       Handles 0x0F00
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeIllegalChars() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*               CIsTextUnicode::OnIsTextUncodeReverseSignature
*                                     0x0080
* Result: void
*       
* Effect: 
*       Handles 0x00F0
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeReverseSignature() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*               CIsTextUnicode::OnIsTextUnicodeReverseControls
*                                     0x0040
* Result: void
*       
* Effect: 
*       Handles 0x00F0
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeReverseControls() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*              CIsTextUnicode::OnIsTextUnicodeReverseStatistics
*                                     0x0020
* Result: void
*       
* Effect: 
*       Handes 0x00F0
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeReverseStatistics() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                CIsTextUnicode::OnIsTextUnicodeReverseAscii16
*                                     0x0010
* Result: void
*       
* Effect: 
*       Handles 0x00F0
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeReverseAscii16() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                  CIsTextUnicode::OnIsTextUnicodeSignature
*                                     0x0008
* Result: void
*       
* Effect: 
*       Handes 0x000F
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeSignature() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                   CIsTextUnicode::OnIsTextUnicodeControls
                                     0x0004
* Result: void
*       
* Effect: 
*       Handles 0x000F
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeControls() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                  CIsTextUnicode::OnIsTextUnicodeStatistics
                                     0x0002
* Result: void
*       
* Effect: 
*       Handles 0x000F
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeStatistics() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                   CIsTextUnicode::OnIsTextUnicodeAscii16
*                                     0x0001
* Result: void
*       
* Effect: 
*       Handles 0x000F
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeAscii16() 
   {
    EnableMasks();
    Refresh();
   }

/****************************************************************************
*                 CIsTextUnicode::OnIsTextUnicodeNotAciiMask
*                                     0xF000
* Result: void
*       
* Effect: 
*       Handles 0xF000
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeNotAsciiMask() 
   {
    UINT check = c_IS_TEXT_UNICODE_NOT_ASCII_MASK.GetCheck();
    c_0X8000.SetCheck(check);                           // 0x8000
    c_0X4000.SetCheck(check);                           // 0x4000
    c_0X2000.SetCheck(check);                           // 0x2000
    c_IS_TEXT_UNICODE_NULL_BYTES.SetCheck(check);       // 0x1000
    Refresh();
   }

/****************************************************************************
*                CIsTextUnicode::OnIsTextUnicodeNotUnicodeMask
*                                     0x0F00
* Result: void
*       
* Effect: 
*       Handes 0x0F00
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeNotUnicodeMask() 
   {
    UINT check = c_IS_TEXT_UNICODE_NOT_UNICODE_MASK.GetCheck();
    c_0X0800.SetCheck(check);                           // 0x0800
    c_IS_TEXT_UNICODE_DBCS_LEADBYTE.SetCheck(check);    // 0x0400
    c_IS_TEXT_UNICODE_ODD_LENGTH.SetCheck(check);       // 0x0200
    c_IS_TEXT_UNICODE_ILLEGAL_CHARS.SetCheck(check);    // 0x0100
    Refresh();
   }

/****************************************************************************
*                 CIsTextUnicode::OnIsTextUnicodeReverseMask
*                                     0x00F0
* Result: void
*       
* Effect: 
*       Handles 0x00F0
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeReverseMask() 
   {
    UINT checked = c_IS_TEXT_UNICODE_REVERSE_MASK.GetCheck();
    c_IS_TEXT_UNICODE_REVERSE_SIGNATURE.SetCheck(checked);      // 0x0080
    c_IS_TEXT_UNICODE_REVERSE_CONTROLS.SetCheck(checked);       // 0x0040
    c_IS_TEXT_UNICODE_REVERSE_STATISTICS.SetCheck(checked);     // 0x0020
    c_IS_TEXT_UNICODE_REVERSE_ASCII16.SetCheck(checked);        // 0x0010

    Refresh();
   }

/****************************************************************************
*                 CIsTextUnicode::OnIsTextUnicodeUnicodeMask
*                                     0x000F
* Result: void
*       
* Effect: 
*       Hanles 0x000F
****************************************************************************/

void CIsTextUnicode::OnIsTextUnicodeUnicodeMask() 
   {
    UINT checked = c_IS_TEXT_UNICODE_UNICODE_MASK.GetCheck();
    c_IS_TEXT_UNICODE_SIGNATURE.SetCheck(checked);              // 0x0008
    c_IS_TEXT_UNICODE_CONTROLS.SetCheck(checked);               // 0x0004
    c_IS_TEXT_UNICODE_STATISTICS.SetCheck(checked);             // 0x0002
    c_IS_TEXT_UNICODE_ASCII16.SetCheck(checked);                // 0x0001
    Refresh();
   }

/****************************************************************************
*                         CIsTextUnicode::EnableMasks
* Result: void
*       
* Effect: 
*       If F000 is valid, sets that flag
****************************************************************************/

void CIsTextUnicode::EnableMasks()
    {
     UINT flags = ControlsToFlags();

#define ENABLE_MASK(x) c_##x.SetCheck( ((flags & x) == x) ? BST_CHECKED : BST_UNCHECKED)

     ENABLE_MASK(IS_TEXT_UNICODE_NOT_ASCII_MASK);
     ENABLE_MASK(IS_TEXT_UNICODE_NOT_UNICODE_MASK);
     ENABLE_MASK(IS_TEXT_UNICODE_REVERSE_MASK);
     ENABLE_MASK(IS_TEXT_UNICODE_UNICODE_MASK);
    } // CIsTextUnicode::EnableMasks

/****************************************************************************
*                       CIsTextUnicode::ControlsToFlags
* Inputs:
*       
* Result: UINT
*       THe flags
* Effect: 
*       
****************************************************************************/

UINT CIsTextUnicode::ControlsToFlags()
    {
     DWORD flags = 0;

#if 0
#define SETFLAG(x) flags |= c_##x.GetCheck() == BST_CHECKED ? x : 0
     SETFLAG(0X8000);
     SETFLAG(0X4000);
     SETFLAG(0X2000);
     SETFLAG(IS_TEXT_UNICODE_NULL_BYTES);

     SETFLAG(0X0800);
     SETFLAG(IS_TEXT_UNICODE_DBCS_LEADBYTE);
     SETFLAG(IS_TEXT_UNICODE_ODD_LENGTH);
     SETFLAG(IS_TEXT_UNICODE_ILLEGAL_CHARS);

     SETFLAG(IS_TEXT_UNICODE_REVERSE_SIGNATURE);
     SETFLAG(IS_TEXT_UNICODE_REVERSE_CONTROLS);
     SETFLAG(IS_TEXT_UNICODE_REVERSE_STATISTICS);
     SETFLAG(IS_TEXT_UNICODE_REVERSE_ASCII16);

     SETFLAG(IS_TEXT_UNICODE_SIGNATURE);
     SETFLAG(IS_TEXT_UNICODE_CONTROLS);
     SETFLAG(IS_TEXT_UNICODE_STATISTICS);
     SETFLAG(IS_TEXT_UNICODE_ASCII16);
#else
     for(int i = 0; i < FlagMap.GetSize(); i++)
        flags |= FlagMap[i].button->GetCheck() == BST_CHECKED ? FlagMap[i].flag : 0;
#endif

     return flags;
    } // CIsTextUnicode::ControlsToFlags

/****************************************************************************
*                           CIsTextUnicode::Refresh
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CIsTextUnicode::Refresh()
    {
     if(!initialized)
        return;
     
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;
     if(c_VS6.GetCheck() == BST_CHECKED)
        fmt = QueryTemplate(_T("[IsTextUnicode:6]"));
     else
        fmt = QueryTemplate(_T("[IsTextUnicode:7]"));

     //----------------------------------------------------------------
     // %1: LCID
     //----------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2:
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %3: options
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;

     GetFlags(options, flags, or);

     if(options.IsEmpty())
        options = _T("0");

     //----------------------------------------------------------------
     // %4: unused
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %5: variable
     //----------------------------------------------------------------
     BOOL enable = TRUE;
     CString variable;

     variable = GetVariable();

     //----------------------------------------------------------------
     // %6: options as a decimal number
     //----------------------------------------------------------------
     CString flagsDecimal;
     flagsDecimal.Format(_T("%d"), flags);

     //----------------------------------------------------------------
     // %7: or
     //----------------------------------------------------------------
     // This was already set

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal number
     //----------------------------------------------------------------
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal number
     //----------------------------------------------------------------
     CString sample;
     c_Wide.GetWindowText(sample);
     EnEscape(sample, TRUE);

     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1            %2      %3       %4      %5         %6         %7        %8         %9      %10     %11
     text.FormatMessage(fmt, localeName,  _T(""), options, _T(""), variable, flagsDecimal,  or, localeDecimal, sample, _T(""), _T(""));

     //-----------------------------------------------------------------------------------------------

     enable = TRUE;
     SetCode(text, enable);

     int pi = flags;
     BOOL result = ::IsTextUnicode(sample, wcslen(sample) * sizeof(WCHAR), &pi);
     CString t;
     t.LoadString(result ? IDS_TRUE : IDS_FALSE);
     c_Result.SetWindowText(t);

     for(int i = 0; i < FlagMap.GetSize(); i++)
        { /* scan result */
         FlagMap[i].output->SetCheck( ( (pi & FlagMap[i].flag) != 0) ? BST_CHECKED : BST_UNCHECKED);
        } /* scan result */

    } // CIsTextUnicode::Refresh

/****************************************************************************
*                      CIsTextUnicode::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the unicode font to the controls
****************************************************************************/

void CIsTextUnicode::SetFontToControls()
    {
     c_Wide.SetFont(&UnicodeFont);
    } // CIsTextUnicode::SetFontToControls

/****************************************************************************
*                         CIsTextUnicode::OnSelchangeWide
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Causes concurrent selection to appear in hex control
****************************************************************************/

void CIsTextUnicode::OnSelchangeWide(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    SELCHANGE *pSelChange = reinterpret_cast<SELCHANGE *>(pNMHDR);
    // TODO: The control will not send this notification unless you override the
    // CFunction::OnInitDialog() function to send the EM_SETEVENTMASK message
    // to the control with the ENM_SELCHANGE flag ORed into the lParam mask.

    WideHelper::OnSelChangeWide(c_Wide, c_WideHex);
        
    *pResult = 0;
   }

/****************************************************************************
*                       CIsTextUnicode::OnSelchangeWidehex
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Refelcts the change to the c_Wide control
****************************************************************************/

void CIsTextUnicode::OnSelchangeWidehex(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    SELCHANGE *pSelChange = reinterpret_cast<SELCHANGE *>(pNMHDR);
    // TODO: The control will not send this notification unless you override the
    // CFunction::OnInitDialog() function to send the EM_SETEVENTMASK message
    // to the control with the ENM_SELCHANGE flag ORed into the lParam mask.
    WideHelper::OnSelChangeWideHex(c_Wide, c_WideHex);
    *pResult = 0;
   }

/****************************************************************************
*                          CIsTextUnicode::OnChangeWide
* Result: void
*       
* Effect: 
*       A character has been changed in the input control. Reflect
*       it in the hex display
****************************************************************************/

void CIsTextUnicode::OnChangeWide() 
   {
    WideHelper::OnChangeWide(c_Wide, c_WideHex);

    Refresh();
   }

/****************************************************************************
*                         CIsTextUnicode::OnChangeWideHex
* Result: void
*       
* Effect: 
*       A change was made in the hex window. Replace the characters in
*       the input window
****************************************************************************/

void CIsTextUnicode::OnChangeWidehex() 
   {
    WideHelper::OnChangeWideHex(c_Wide, c_WideHex);
    Refresh();
   }

BOOL CIsTextUnicode::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    ITU( 0X8000 );                              // 0x8000
    ITU( 0X4000 );                              // 0x4000
    ITU( 0X2000 );                              // 0x2000
    ITU( IS_TEXT_UNICODE_NULL_BYTES );          // 0x1000

    ITU( 0X0800 );                              // 0x0800
    ITU( IS_TEXT_UNICODE_DBCS_LEADBYTE );       // 0x0400
    ITU( IS_TEXT_UNICODE_ODD_LENGTH );          // 0x0200
    ITU( IS_TEXT_UNICODE_ILLEGAL_CHARS );       // 0x0100

    ITU( IS_TEXT_UNICODE_REVERSE_SIGNATURE );   // 0x0080
    ITU( IS_TEXT_UNICODE_REVERSE_CONTROLS );    // 0x0040
    ITU( IS_TEXT_UNICODE_REVERSE_STATISTICS );  // 0x0020
    ITU( IS_TEXT_UNICODE_REVERSE_ASCII16 );     // 0x0010
    
    ITU( IS_TEXT_UNICODE_SIGNATURE );           // 0x0008
    ITU( IS_TEXT_UNICODE_CONTROLS );            // 0x0004
    ITU( IS_TEXT_UNICODE_STATISTICS );          // 0x0002
    ITU( IS_TEXT_UNICODE_ASCII16 );             // 0x0001

    CheckRadioButton(IDC_VS6, IDC_VS7, IDC_VS6);
    c_Wide.SetEventMask(ENM_CHANGE | ENM_SELCHANGE | c_Wide.GetEventMask());
    c_WideHex.SetEventMask(ENM_CHANGE | ENM_SELCHANGE | ENM_PROTECTED | c_WideHex.GetEventMask());

    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                          CIsTextUnicode::GetFlags
* Inputs:
*       CString & options: Options string to set
*       DWORD & flags: Flags value to set
*       const CString & or: OR operator
* Result: void
*       
* Effect: 
*       Sets the flags and options
****************************************************************************/

void CIsTextUnicode::GetFlags(CString & options, DWORD & flags, const CString & or)
    {
     for(int i = 0; i < FlagMap.GetSize(); i++)
        { /* scan flags */
         if(FlagMap[i].button->GetCheck() == BST_CHECKED)
            { /* flag set */
             flags |= FlagMap[i].flag;
             CString name;
             FlagMap[i].button->GetWindowText(name);
             AppendFlags(options, name, or);
            } /* flag set */
        } /* scan flags */
    } // CIsTextUnicode::GetFlags

/****************************************************************************
*                            CIsTextUnicode::OnVs6
* Result: void
*       
* Effect: 
*       Uses VS6 template
****************************************************************************/

void CIsTextUnicode::OnVs6()
    {
     Refresh();
    } // CIsTextUnicode::OnVs6

/****************************************************************************
*                            CIsTextUnicode::OnVs7
* Result: void
*       
* Effect: 
*       Handles VS.NET
****************************************************************************/

void CIsTextUnicode::OnVs7()
    {
     Refresh();
    } // CIsTextUnicode::OnVs7
