// IsValidCodePage.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "IsValidCodePage.h"
#include "Query.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CIsValidCodePage, CFunction)

/////////////////////////////////////////////////////////////////////////////
// CIsValidCodePage dialog


CIsValidCodePage::CIsValidCodePage(CWnd* pParent /*=NULL*/)
        : CFunction(CIsValidCodePage::IDD, pParent)
{
        //{{AFX_DATA_INIT(CIsValidCodePage)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CIsValidCodePage::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CIsValidCodePage)
        DDX_Control(pDX, IDC_GETOEMCP, c_GetOEMCP);
        DDX_Control(pDX, IDC_CP_THREAD_ACP, c_CP_THREAD_ACP);
        DDX_Control(pDX, IDC_CP_OEMCP, c_CP_OEMCP);
        DDX_Control(pDX, IDC_CP_MACCP, c_CP_MACCP);
        DDX_Control(pDX, IDC_CP_ACP, c_CP_ACP);
        DDX_Control(pDX, IDC_GETACP, c_GetACP);
        DDX_Control(pDX, IDC_CPNAME, c_CodePageName);
        DDX_Control(pDX, IDC_CP_SUPPORTED, c_CP_SUPPORTED);
        DDX_Control(pDX, IDC_CP_INSTALLED, c_CP_INSTALLED);
        DDX_Control(pDX, IDC_SPECIFIC, c_Specific);
        DDX_Control(pDX, IDC_SELECTION, c_Selection);
        DDX_Control(pDX, IDC_SPINCODEPAGE, c_SpinCodePage);
        DDX_Control(pDX, IDC_RESULT, c_Result);
        DDX_Control(pDX, IDC_OUTPUT, c_CodePages);
        DDX_Control(pDX, IDC_DWFLAGS, x_dwFlags);
        DDX_Control(pDX, IDC_CODEPAGE, c_CodePage);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIsValidCodePage, CFunction)
        //{{AFX_MSG_MAP(CIsValidCodePage)
        ON_EN_CHANGE(IDC_CODEPAGE, OnChangeCodepage)
        ON_BN_CLICKED(IDC_CP_INSTALLED, OnCpInstalled)
        ON_BN_CLICKED(IDC_CP_SUPPORTED, OnCpSupported)
        ON_BN_CLICKED(IDC_SELECTION, OnSelection)
        ON_BN_CLICKED(IDC_SPECIFIC, OnSpecific)
        ON_WM_VSCROLL()
        ON_NOTIFY(LVN_ITEMCHANGED, IDC_OUTPUT, OnItemchangedOutput)
        ON_BN_CLICKED(IDC_CP_ACP, OnCpAcp)
        ON_BN_CLICKED(IDC_CP_MACCP, OnCpMaccp)
        ON_BN_CLICKED(IDC_CP_OEMCP, OnCpOemcp)
        ON_BN_CLICKED(IDC_CP_THREAD_ACP, OnCpThreadAcp)
        ON_BN_CLICKED(IDC_GETACP, OnGetacp)
        ON_BN_CLICKED(IDC_GETOEMCP, OnGetoemcp)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIsValidCodePage message handlers

/****************************************************************************
*                       CIsValidCodePage::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes dialog
****************************************************************************/

BOOL CIsValidCodePage::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    CheckRadioButton(IDC_CP_INSTALLED, IDC_CP_SUPPORTED, IDC_CP_INSTALLED);
    CheckRadioButton(IDC_SELECTION, IDC_SPECIFIC, IDC_SELECTION);
        
    c_SpinCodePage.SetRange32(1,65535);  // randomly-chosen upper bound
    c_Result.SetWindowText(_T(""));

    updateControls();
    UpdateCodePageList();
    Refresh();
    
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                     CIsValidCodePage::OnChangeCodePage
* Result: void
*       
* Effect: 
*       Causes the value to refresh
****************************************************************************/
       
void CIsValidCodePage::OnChangeCodepage() 
   {
    Refresh();
   }

/****************************************************************************
*                       CIsValidCodePage::OnCpInstalled
* Result: void
*       
* Effect: 
*       Selects installed code pages
****************************************************************************/

void CIsValidCodePage::OnCpInstalled() 
   {
    UpdateCodePageList();
    Refresh();
   }

/****************************************************************************
*                       CIsValidCodePage::OnCpSupported
* Result: void
*       
* Effect: 
*       Selects supported code pages
****************************************************************************/

void CIsValidCodePage::OnCpSupported() 
   {
    UpdateCodePageList();
    Refresh();
   }

/****************************************************************************
*                        CIsValidCodePage::OnSelection
*                        CIsValidCodePage::OnSpecific
*                         CIsValidCodePage::OnCpAcp() 
*                        CIsValidCodePage::OnCpMaccp() 
*                        CIsValidCodePage::OnCpOemcp() 
*                      CIsValidCodePage::OnCpThreadAcp() 
*                         CIsValidCodePage::OnGetacp()
*                        CIsValidCodePage::OnGetoemcp()
* Result: void
*       
* Effect: 
*       Uses the specific code page selected
****************************************************************************/

void CIsValidCodePage::OnSelection() 
   {
    Refresh();
   }

void CIsValidCodePage::OnSpecific() 
   {
    Refresh();
   }

void CIsValidCodePage::OnCpAcp() 
   {
    Refresh();
   }

void CIsValidCodePage::OnCpMaccp() 
   {
    Refresh();
   }

void CIsValidCodePage::OnCpOemcp() 
   {
    Refresh();
   }

void CIsValidCodePage::OnCpThreadAcp() 
   {
    Refresh();
   }

void CIsValidCodePage::OnGetacp() 
   {
    Refresh();
   }

void CIsValidCodePage::OnGetoemcp() 
   {
    Refresh();
   }

/****************************************************************************
*                       CIsValidCodePage::UpdateCodePageList
* Result: void
*       
* Effect: 
*       
****************************************************************************/

void CIsValidCodePage::UpdateCodePageList()
    {
     DWORD flags = 0;
     if(c_CP_INSTALLED.GetCheck() == BST_CHECKED)
        { /* CP_INSTALLED */
         flags = CP_INSTALLED;
        } /* CP_INSTALLED */
     else
        if(c_CP_SUPPORTED.GetCheck() == BST_CHECKED)
           { /* CP_SUPPORTED */
            flags = CP_SUPPORTED;
           } /* CP_SUPPORTED */

     c_CodePages.Load(flags);
    } // CIsValidCodePage::UpdateCodePageList

/****************************************************************************
*                      CIsValidCodePage::SetCodePageName
* Inputs:
*       int cp: Code page designator
* Result: void
*       
* Effect: 
*       Sets the code page name
****************************************************************************/

void CIsValidCodePage::SetCodePageName(int cp)
    {
     CPINFOEX info;
     if(!::GetCPInfoEx(cp, 0, &info))  // GetACP()
        { /* failed */
         DWORD err = ::GetLastError();
         c_CodePageName.SetWindowText(_T(""));
             // ignore it
        } /* failed */
     else
        { /* success */
         c_CodePageName.SetWindowText(info.CodePageName);
        } /* success */
    } // CIsValidCodePage::SetCodePageName

/****************************************************************************
*                          CIsValidCodePage::Refresh
* Result: void
*       
* Effect: 
*       Refreshes the display
****************************************************************************/

void CIsValidCodePage::Refresh()
    {
     if(!initialized)
        return;

     updateControls();

     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);

     CString fmt = QueryTemplate(_T("[IsValidCodePage]"));

     int CodePageDecimal = 0;
     CString CodePage = _T("0");
     
     if(c_Specific.GetCheck() == BST_CHECKED)
        { /* specific codepage */
         CodePageDecimal = c_SpinCodePage.GetPos32();
         CodePage.Format(_T("%d"), CodePageDecimal);
         // If it is a recognized code page, say so
         SetCodePageName(CodePageDecimal);
        } /* specific codepage */
     else
     if(c_Selection.GetCheck() == BST_CHECKED)
        { /* selection */
         if(c_CodePages.GetSelectedCount() == 1)
            { /* has selection */
             POSITION pos = c_CodePages.GetFirstSelectedItemPosition();
             int sel = c_CodePages.GetNextSelectedItem(pos);
             // Remember that a negative ItemData means there was an error
             // in getting the description
             int cp  = (int)c_CodePages.GetItemData(sel);
             CodePage = c_CodePages.GetItemText(sel, 0);
             CodePageDecimal = _ttoi(CodePage);
             SetCodePageName(CodePageDecimal);
            } /* has selection */
         else
            { /* no selection */
             CString s;
             s.LoadString(IDS_NO_SELECTION);
             SetCode(s, FALSE);
             return;
            } /* no selection */
        } /* selection */
     else
     if(c_GetACP.GetCheck() == BST_CHECKED)
        { /* use ACP */
         CodePage = _T("GetACP()");
         CodePageDecimal = GetACP();
        } /* use ACP */
        else
        if(c_GetOEMCP.GetCheck() == BST_CHECKED)
           { /* use OEM */
            CodePage = _T("GetOEMCP()");
            CodePageDecimal = GetOEMCP();
           } /* use OEM */
        else
        if(c_CP_ACP.GetCheck() == BST_CHECKED)
           { /* CP_ACP */
            CodePage = _T("CP_ACP");
            CodePageDecimal = CP_ACP;
           } /* CP_ACP */
        else
        if(c_CP_OEMCP.GetCheck() == BST_CHECKED)
           { /* CP_OEMCP */
            CodePage = _T("CP_OEMCP");
            CodePageDecimal = CP_OEMCP;
           } /* CP_OEMCP */
        else
        if(c_CP_MACCP.GetCheck() == BST_CHECKED)
           { /* CP_MACCP */
            CodePage = _T("CP_MACCP");
            CodePageDecimal = CP_MACCP;
           } /* CP_MACCP */
        else
        if(c_CP_THREAD_ACP.GetCheck() == BST_CHECKED)
           { /* CP_THREAD_ACP */
            CodePage = _T("CP_THREAD_ACP");
            CodePageDecimal = CP_THREAD_ACP;
           } /* CP_THREAD_ACP */
        else
           { /* error */
            ASSERT(FALSE);
            SetCode(_T(""), FALSE);
            return;
           } /* error */

     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();
     
     //----------------------------------------------------------------
     // %2: The CodePage as a string
     //----------------------------------------------------------------
     // already set, above

     //----------------------------------------------------------------
     // %3: not used
     //----------------------------------------------------------------
     
     //----------------------------------------------------------------
     // %4: Length: not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %5: The variable name
     //----------------------------------------------------------------
     CString variable;
     //     variable = QueryVariable();
     //     variable.TrimLeft();
     //     variable.TrimRight();
     //     if(variable.IsEmpty())
     //        variable = _T("?");
     variable = GetVariable();
     
     //----------------------------------------------------------------
     // %6: CodePage as a decimal number
     //----------------------------------------------------------------
     // CodePageDecimal set above
     CString CodePageDecimalString;
     CodePageDecimalString.Format(_T("%d"), CodePageDecimal);
     
     //-----------------------------------------------------------------------------
     CString text;
     //                          %1         %2        %3      %4      %5            %6
     text.FormatMessage(fmt, localeName, CodePage, _T(""), _T(""), variable, CodePageDecimalString);
     SetCode(text, TRUE);
     
     //-----------------------------------------------------------------------------
     BOOL valid = IsValidCodePage(CodePageDecimal);
     if(!valid)
        { /* error */
        c_Result.SetWindowText(_T("FALSE"));
        } /* error */
     else
        { /* success */
         c_Result.SetWindowText(_T("TRUE"));
        } /* success */
    } // CIsValidCodePage::Refresh

/****************************************************************************
*                     CIsValidCodePage::SetFontToControls
* Result: void
*       
* Effect: 
*       
****************************************************************************/

void CIsValidCodePage::SetFontToControls()
    {
     
    } // CIsValidCodePage::SetFontToControls

/****************************************************************************
*                          CIsValidCodePage::IndexOK
* Inputs:
*       CWnd * wnd: Window reference
* Result: BOOL
*       TRUE if window should be included
*       FALSE if window should not be included
****************************************************************************/

BOOL CIsValidCodePage::IndexOK(CWnd * wnd)
    {
     return TRUE;
    } // CIsValidCodePage::IndexOK

/****************************************************************************
*                         CIsValidCodePage::OnVScroll
* Inputs:
*       UINT nSBCode: passed to superclass
*       UINT nPos: passed to superclass
*       CScrollBar * pScrollBar: NULL for built-in scrollbar; non-NULL for
*               others, such as spin controls
* Result: void
*       
* Effect: 
*       If the pScrollBar is non-NULL, it is an internal spin control and
*       will be ignored
****************************************************************************/

void CIsValidCodePage::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
   {
    if(pScrollBar != NULL)
       return;
        
    CFunction::OnVScroll(nSBCode, nPos, pScrollBar);
   }

/****************************************************************************
*                      CIsValidCodePage::updateControls
* Result: void
*       
* Effect: 
*       Enables/disables controls
****************************************************************************/

void CIsValidCodePage::updateControls()
    {
     BOOL enable;

     enable = c_Specific.GetCheck() == BST_CHECKED;
     c_SpinCodePage.EnableWindow(enable);
     c_CodePage.EnableWindow(enable);
     c_CodePages.EnableWindow(!enable);
     c_CP_INSTALLED.EnableWindow(!enable);
     c_CP_SUPPORTED.EnableWindow(!enable);
     x_dwFlags.EnableWindow(!enable);
    } // CIsValidCodePage::updateControls

/****************************************************************************
*                    CIsValidCodePage::OnItemchangedOutput
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult: set to 0, always
* Result: void
*       
* Effect: 
*       Causes a refresh on reselection
****************************************************************************/

void CIsValidCodePage::OnItemchangedOutput(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
    Refresh();
        
    *pResult = 0;
   }

/****************************************************************************
*                        CIsValidCodePage::Initialize
* Result: void
*       
* Effect: 
*       Sets the variable name
****************************************************************************/

void CIsValidCodePage::Initialize()
    {
     variable = _T("valid");
    } // CIsValidCodePage::Initialize


