// LCID.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "LCID.h"
#include "lcids.h"
#include "Query.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CLCID, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CLCID dialog


CLCID::CLCID(CWnd* pParent /*=NULL*/)
        : CFunction(CLCID::IDD, pParent)
{
        //{{AFX_DATA_INIT(CLCID)
        //}}AFX_DATA_INIT
}


void CLCID::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CLCID)
        DDX_Control(pDX, IDC_LCID, c_LCID);
        DDX_Control(pDX, IDC_MAKELCID, c_MakeLCID);
        DDX_Control(pDX, IDC_MAKELANGID, c_MakeLangID);
        DDX_Control(pDX, IDC_SUBLANGUAGE_VALUE, v_SubLanguage);
        DDX_Control(pDX, IDC_SUBLANGUAGE, c_SubLanguage);
        DDX_Control(pDX, IDC_SORTID_VALUE, v_SortID);
        DDX_Control(pDX, IDC_SORTID, c_SortID);
        DDX_Control(pDX, IDC_LANGUAGE_VALUE, v_Language);
        DDX_Control(pDX, IDC_LANGUAGE, c_Language);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLCID, CFunction)
        //{{AFX_MSG_MAP(CLCID)
        ON_CBN_SELENDOK(IDC_LANGUAGE, OnSelendokLanguage)
        ON_LBN_SELCHANGE(IDC_SUBLANGUAGE, OnSelchangeSublanguage)
        ON_CBN_SELENDOK(IDC_SORTID, OnSelendokSortid)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLCID message handlers

BOOL CLCID::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
        // TODO: Add extra initialization here
    c_Language.AddStrings(langs);
    c_Language.Select(LANG_NEUTRAL);
        
    return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

/****************************************************************************
*                           CLCID::GetSubLanguages
* Inputs:
*       
* Result: 
*       
* Effect: 
*       Due to terminal brain damage on the part of Microsoft, we have
*       to use static variables to pass in the additional parameters
****************************************************************************/
LCID CLCID::SubLanguageFilter;
CLCID * CLCID::LogWnd = NULL;

/* static */ BOOL CALLBACK CLCID::GetSubLanguages(LPTSTR locale)
    {
     if(LogWnd == NULL)
        return FALSE;
     
     LCID lcid = (LCID)_tcstoul(locale, NULL, 16);
     if(PRIMARYLANGID(lcid) != PRIMARYLANGID(SubLanguageFilter))
        return TRUE; // not interesting

     // LOCALE_SLANGUAGE
     CString slanguage_data;
     { /* get LOCALE_SLANGUAGE */
      int length = GetLocaleInfo(lcid, LOCALE_SLANGUAGE, NULL, 0);
      LPTSTR p = slanguage_data.GetBuffer(length);
      if(!::GetLocaleInfo(lcid, LOCALE_SLANGUAGE, p, length))
         return TRUE; // not interesting
     } /* get LOCALE_SLANGUAGE */
     slanguage_data.ReleaseBuffer();
     // ... use slanguage_data here

     // The string is in the form  something (sublanguage)
     int start = slanguage_data.Find(_T("("));
     if(start < 0)
        return TRUE; // not interesting
     int end = slanguage_data.Find(_T(")"));
     if(end < 0)
        return TRUE; // not interesting

     // something (sublanguage)
     //           ^           ^
     //           |           |
     //           start       end
     //           10          22
     CString sub = slanguage_data.Mid(start + 1, end - start - 1);
     int n = LogWnd->c_SubLanguage.AddString(sub);
     LogWnd->c_SubLanguage.SetItemData(n, SUBLANGID(lcid));
     return TRUE; // continue enumeration
    } // CLCID::GetSubLanguages

/****************************************************************************
*                               CLCID::Refresh
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CLCID::Refresh()
    {
     if(!initialized)
        return;

     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);

     QueryTemplate(_T(""));  // erase template information

     int lang = 0;
     int sublang = 0;
     int sort = 0;

     LCID lcid;
     
     int n = c_Language.GetCurSel();

     if(n == CB_ERR)
        { /* bad */
         v_Language.SetWindowText(_T(""));
        } /* bad */
     else
        { /* OK */
         lang = c_Language.GetItemData(n);
         CString s;
         s.Format(_T("0x%02x"), lang);
         v_Language.SetWindowText(s);
        } /* OK */

     int sub = c_SubLanguage.GetCurSel();
     if(n == CB_ERR)
        { /* no sub */
         v_SubLanguage.SetWindowText(_T(""));
        } /* no sub */
     else
        { /* OK sub */
         sublang = c_SubLanguage.GetItemData(sub);
         CString s;
         s.Format(_T("0x%02x"), sublang);
         v_SubLanguage.SetWindowText(s);
        } /* OK sub */

     CString makelangid = GetLANGIDString(MAKELANGID(lang, sublang));
     c_MakeLangID.SetWindowText(makelangid);

     CString code;
     code = makelangid;

     int sortindex = c_SortID.GetCurSel();
     if(sortindex == CB_ERR)
        { /* no sort */
         sort = SORT_DEFAULT;
        } /* no sort */
     else
        { /* has sort */
         CString s;
         sort = c_SortID.GetItemData(sortindex);
         s.Format(_T("0x%02x"), sort);
         v_SortID.SetWindowText(s);
        } /* has sort */
     
     lcid = MAKELCID(MAKELANGID(lang, sublang), sort);

     //----------------------------------------------------------------
     // MAKELCID
     //----------------------------------------------------------------
     CString makelcid = GetLCIDString(lcid);
     c_MakeLCID.SetWindowText(makelcid);
     code += _T("\r\n");
     code += makelcid;

     CString lcidstr;
     lcidstr.Format(_T("0x%08x"), lcid);
     c_LCID.SetWindowText(lcidstr);

     SetCode(code, TRUE);
    } // CLCID::Refresh

/****************************************************************************
*                          CLCID::OnSelendokLanguage
* Result: void
*       
* Effect: 
*       Handles change in the language
****************************************************************************/

void CLCID::OnSelendokLanguage() 
   {
    UpdateLanguage();
   }

/****************************************************************************
*                            CLCID::UpdateLanguage
* Result: void
*       
* Effect: 
*       Updates the language information
****************************************************************************/

void CLCID::UpdateLanguage()
    {
     int n = c_Language.GetCurSel();
     if(n == CB_ERR)
        return;
     int lang = c_Language.GetItemData(n);

    //----------------------------------------------------------------
    // Sublanguage
    //----------------------------------------------------------------
     c_SubLanguage.ResetContent();
     LogWnd = this;
     SubLanguageFilter = lang;

     if(!::EnumSystemLocales(GetSubLanguages, LCID_SUPPORTED))
        {
         DWORD err = GetLastError();
        }     
     CString subname;
     subname.LoadString(IDS_SUBLANG_NEUTRAL);
     int sub = c_SubLanguage.InsertString(0, subname);
     c_SubLanguage.SetItemData(sub, SUBLANG_NEUTRAL);

     subname.LoadString(IDS_SUBLANG_DEFAULT);
     sub = c_SubLanguage.InsertString(1, subname);
     c_SubLanguage.SetItemData(sub, SUBLANG_DEFAULT);

     subname.LoadString(IDS_SUBLANG_SYS_DEFAULT);
     sub = c_SubLanguage.InsertString(2, subname);
     c_SubLanguage.SetItemData(sub, SUBLANG_SYS_DEFAULT);

     c_SubLanguage.SetCurSel(0);

    //----------------------------------------------------------------
    // Sort ID
    //----------------------------------------------------------------
     c_SortID.ResetContent();

     AddSortIDs(c_SortID, lang);

     Refresh();
    } // CLCID::UpdateLanguage

/****************************************************************************
*                        CLCID::OnSelchangeSublanguage
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CLCID::OnSelchangeSublanguage() 
   {
    Refresh();
   }

void CLCID::OnSelendokSortid() 
   {
    Refresh();
   }

/****************************************************************************
*                                 CLCID::Initialize
* Result: void
*       
* Effect: 
*       Initializes the controls
****************************************************************************/

void CLCID::Initialize()
    {
     UpdateLanguage();
     Refresh();
    } // CLCID::Initialize

/****************************************************************************
*                               CLCID::IndexOK
* Inputs:
*       CWnd * wnd: Window to check
* Result: BOOL
*       TRUE if window should be indexed
*       FALSE if window should not be indexed
****************************************************************************/

BOOL CLCID::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_LCID)
        return FALSE;
     if(wnd == &v_SubLanguage)
        return FALSE;
     if(wnd == &v_SortID)
        return FALSE;
     if(wnd == &v_Language)
        return FALSE;
     return TRUE;
    } // CLCID::IndexOK
