// LCMapString.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "LCMapString.h"
#include "AddFlag.h"
#include "Query.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CLCMapString, CCompareString)
/////////////////////////////////////////////////////////////////////////////
// CLCMapString dialog


CLCMapString::CLCMapString(CWnd* pParent /*=NULL*/)
        : CCompareString(pParent)
{
        //{{AFX_DATA_INIT(CLCMapString)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CLCMapString::DoDataExchange(CDataExchange* pDX)
{
        CCompareString::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CLCMapString)
        DDX_Control(pDX, IDC_DWMAPFLAGS, x_dwMapFlags);
        DDX_Control(pDX, IDC_LCMAP_BYTEREV, c_LCMAP_BYTEREV);
        DDX_Control(pDX, IDC_LCMAP_SORTKEY, c_LCMAP_SORTKEY);
        DDX_Control(pDX, IDC_LCMAP_FULLWIDTH, c_LCMAP_FULLWIDTH);
        DDX_Control(pDX, IDC_LCMAP_HALFWIDTH, c_LCMAP_HALFWIDTH);
        DDX_Control(pDX, IDC_WIDTH_NONE, c_WIDTH_NONE);
        DDX_Control(pDX, IDC_LCMAP_HIRAGANA, c_LCMAP_HIRAGANA);
        DDX_Control(pDX, IDC_LCMAP_KATAKANA, c_LCMAP_KATAKANA);
        DDX_Control(pDX, IDC_KANA_NONE, c_KANA_NONE);
        DDX_Control(pDX, IDC_LCMAP_SIMPLIFIED_CHINESE, c_LCMAP_SIMPLIFIED_CHINESE);
        DDX_Control(pDX, IDC_LCMAP_TRADITIONAL_CHINESE, c_LCMAP_TRADITIONAL_CHINESE);
        DDX_Control(pDX, IDC_CHINESE_NONE, c_CHINESE_NONE);
        DDX_Control(pDX, IDC_LCMAP_LINGUISTIC_CASING, c_LCMAP_LINGUISTIC_CASING);
        DDX_Control(pDX, IDC_LCMAP_UPPERCASE, c_LCMAP_UPPERCASE);
        DDX_Control(pDX, IDC_LCMAP_LOWERCASE, c_LCMAP_LOWERCASE);
        DDX_Control(pDX, IDC_CASE_NONE, c_CASE_NONE);
        DDX_Control(pDX, IDC_WIDTH_BOX, c_WidthBox);
        DDX_Control(pDX, IDC_CASE_BOX, c_CaseBox);
        DDX_Control(pDX, IDC_KANA_BOX, c_KanaBox);
        DDX_Control(pDX, IDC_CHINESE_BOX, c_ChineseBox);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLCMapString, CCompareString)
        //{{AFX_MSG_MAP(CLCMapString)
        ON_BN_CLICKED(IDC_LCMAP_FULLWIDTH, OnLCMapFullWidth)
        ON_BN_CLICKED(IDC_LCMAP_HALFWIDTH, OnLCMapHalfWidth)
        ON_BN_CLICKED(IDC_WIDTH_NONE, OnWidthNone)
        ON_BN_CLICKED(IDC_LCMAP_HIRAGANA, OnLCMapHiragana)
        ON_BN_CLICKED(IDC_LCMAP_KATAKANA, OnLCMapKataKana)
        ON_BN_CLICKED(IDC_KANA_NONE, OnKanaNone)
        ON_BN_CLICKED(IDC_LCMAP_UPPERCASE, OnLCMapUpperCase)
        ON_BN_CLICKED(IDC_LCMAP_LOWERCASE, OnLCMapLowerCase)
        ON_BN_CLICKED(IDC_CASE_NONE, OnCaseNone)
        ON_BN_CLICKED(IDC_LCMAP_LINGUISTIC_CASING, OnLCMapLinguisticCasing)
        ON_BN_CLICKED(IDC_LCMAP_SIMPLIFIED_CHINESE, OnLCMapSimplifiedChinese)
        ON_BN_CLICKED(IDC_LCMAP_TRADITIONAL_CHINESE, OnLCMapTraditionalChinese)
        ON_BN_CLICKED(IDC_CHINESE_NONE, OnChineseNone)
        ON_BN_CLICKED(IDC_LCMAP_SORTKEY, OnLCMapSortKey)
        ON_BN_CLICKED(IDC_LCMAP_BYTEREV, OnLCMapByteRev)
        ON_BN_CLICKED(IDC_CLEAR, OnClear)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLCMapString message handlers

BOOL CLCMapString::OnInitDialog() 
   {
    CCompareString::OnInitDialog();
        
    x_dwMapFlags.ShowWindow(SW_SHOW);
    x_dwCmpFlags.SetWindowText(_T(""));
    c_LCMAP_BYTEREV.ShowWindow(SW_SHOW);
    c_LCMAP_SORTKEY.ShowWindow(SW_SHOW);

    c_LCMAP_FULLWIDTH.ShowWindow(SW_SHOW);
    c_LCMAP_HALFWIDTH.ShowWindow(SW_SHOW);
    c_WIDTH_NONE.ShowWindow(SW_SHOW);
    c_WidthBox.ShowWindow(SW_SHOW);

    c_LCMAP_HIRAGANA.ShowWindow(SW_SHOW);
    c_LCMAP_KATAKANA.ShowWindow(SW_SHOW);
    c_KANA_NONE.ShowWindow(SW_SHOW);
    c_KanaBox.ShowWindow(SW_SHOW);

    c_LCMAP_UPPERCASE.ShowWindow(SW_SHOW);
    c_LCMAP_LOWERCASE.ShowWindow(SW_SHOW);
    c_CASE_NONE.ShowWindow(SW_SHOW);
    c_LCMAP_LINGUISTIC_CASING.ShowWindow(SW_SHOW);
    c_CaseBox.ShowWindow(SW_SHOW);

    c_LCMAP_SIMPLIFIED_CHINESE.ShowWindow(SW_SHOW);
    c_LCMAP_TRADITIONAL_CHINESE.ShowWindow(SW_SHOW);
    c_CHINESE_NONE.ShowWindow(SW_SHOW);
    c_ChineseBox.ShowWindow(SW_SHOW);

    int w = c_Output.GetColumnWidth(COL_TEXT);
    c_Output.SetColumnWidth(COL_TEXT, w / 2);
    c_Output.InsertColumnEx(COL_LCMAP, IDS_LCMAP_CAPTION, LVCFMT_LEFT, -1);

    c_Output.SetSortKey(FALSE, COL_LCMAP);
    Clear();

    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
}

/****************************************************************************
*                       CLCMapString::PresubclassWindow
* Result: void
*       
* Effect: 
*       Currently does nothing; placeholder for some future changes not
*       yet installed
****************************************************************************/

void CLCMapString::PreSubclassWindow() 
   {
    // TODO: Add your specialized code here and/or call the base class
        
    CCompareString::PreSubclassWindow();
   }

/****************************************************************************
*                          CLCMapString::OnLCMapSortKey
*                          CLCMapString::OnLCMapByteRev
*                         CLCMapString::OnLCMapFullWidth
*                         CLCMapString::OnLCMapHalfWidth
*                           CLCMapString::OnWidthNone
*                         CLCMapString::OnLCMapHiragana
*                         CLCMapString::OnLCMapKataKana
*                           CLCMapString::OnKanaNone
*                        CLCMapString::OnLCMapUpperCase
*                        CLCMapString::OnLCMapLowerCase
*                           CLCMapString::OnCaseNone
*                    CLCMapString::OnLCMapLinguisticCasing
*                   CLCMapString::OnLCMapSimplifiedChinese
*                   CLCMapString::OnLCMapTraditionalChinese
*                         CLCMapString::OnChineseNone
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CLCMapString::OnLCMapSortKey()
   {
    Refresh();
   } // CLCMapString::OnLCMapSortKey

void CLCMapString::OnLCMapByteRev()
   {
    Refresh();
   } // CLCMapString::OnLCMapByteRev

void CLCMapString::OnLCMapFullWidth()
   {
    Refresh();
   } // CLCMapString::OnLCMapFullWidth

void CLCMapString::OnLCMapHalfWidth()
   {
    Refresh();
   } // CLCMapString::OnLCMapHalfWidth

void CLCMapString::OnWidthNone()
   {
    Refresh();
   } // CLCMapString::OnWidthNone

void CLCMapString::OnLCMapHiragana()
   {
    Refresh();
   } // CLCMapString::OnLCMapHiragana

void CLCMapString::OnLCMapKataKana()
   {
    Refresh();
   } // CLCMapString::OnLCMapKataKana

void CLCMapString::OnKanaNone()
   {
    Refresh();
   } // CLCMapString::OnKanaNone

void CLCMapString::OnLCMapUpperCase()
   {
    Refresh();
   } // CLCMapString::OnLCMapUpperCase

void CLCMapString::OnLCMapLowerCase()
   {
    Refresh();
   } // CLCMapString::OnLCMapLowerCase

void CLCMapString::OnCaseNone()
   {
    Refresh();
   } // CLCMapString::OnCaseNone

void CLCMapString::OnLCMapLinguisticCasing()
   {
    Refresh();
   } // CLCMapString::OnLCMapLinguisticCasing

void CLCMapString::OnLCMapSimplifiedChinese()
   {
    Refresh();
   } // CLCMapString::OnLCMapSimplifiedChinese

void CLCMapString::OnLCMapTraditionalChinese()
   {
    Refresh();
   } // CLCMapString::OnLCMapTraditionalChinese

void CLCMapString::OnChineseNone()
   {
    Refresh();
   } // CLCMapString::OnChineseNone


/****************************************************************************
*                            CLCMapString::IndexOK
* Inputs:
*       CWnd * wnd: WIndow
* Result: BOOL
*       TRUE to include the window
*       FALSE to exclude the window
****************************************************************************/

BOOL CLCMapString::IndexOK(CWnd * wnd)
    {
     BOOL ok = CCompareString::IndexOK(wnd);
     if(ok)
        return TRUE; // already eliminated

     // page-specific eliminations here...
     if(wnd == &c_ErrorMessage)
        return FALSE;
     if(wnd == &c_LCIDDisplay)
        return FALSE;
     if(wnd == &c_Browse)
        return FALSE;

     return TRUE;
    } // CLCMapString::IndexOK

/****************************************************************************
*                        CLCMapString::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CLCMapString::updateControls()
    {
     /**********************************************************************
       Here are the rules:

       LCMAP_SORTKEY disables and ignores
                   
                   c_LCMAP_FULLWIDTH
                   c_LCMAP_HALFWIDTH
                   c_WIDTH_NONE
                   c_WidthBox

                   c_LCMAP_HIRAGANA
                   c_LCMAP_KATAKANA
                   c_KANA_NONE
                   c_KanaBox

                   c_LCMAP_LOWERCASE
                   c_LCMAP_UPPERCASE
                   c_CASE_NONE
                   c_LCMAP_LINGUISTIC_CASING
                   c_CaseBox

                   c_SIMPLIFIED_CHINESE
                   c_TRADITIONAL_CHINESE
                   c_CHINESE_NONE
                   c_ChineseBox

      LCMAP_SORTKEY enables and uses
                   c_NORM_IGNORECASE
                   c_NORM_IGNOREKANATYPE
                   c_NORM_IGNORENONSPACE
                   c_NORM_IGNORESYMBOLS
                   c_NORM_IGNOREWIDTH
                   c_SORT_STRINGSORT

      LCMAP_HIRAGANA and
      LCMAP_KATAKANA disable and ignore
                   c_LCMAP_LOWERCASE
                   c_LCMAP_UPPERCASE

     **********************************************************************/

     CCompareString::updateControls();
     
     //=============================================================================
     // Start with all the controls in the enabled state
     //=============================================================================
     BOOL enable_LCMAP_FULLWIDTH           = TRUE;
     BOOL enable_LCMAP_HALFWIDTH           = TRUE;
     BOOL enable_WIDTH_NONE                = TRUE;
     BOOL enable_WidthBox                  = TRUE;

     BOOL enable_LCMAP_KATAKANA            = TRUE;
     BOOL enable_LCMAP_HIRAGANA            = TRUE;
     BOOL enable_KANA_NONE                 = TRUE;
     BOOL enable_KanaBox                   = TRUE;

     BOOL enable_LCMAP_LOWERCASE           = TRUE;
     BOOL enable_LCMAP_UPPERCASE           = TRUE;
     BOOL enable_CASE_NONE                 = TRUE;
     BOOL enable_CaseBox                   = TRUE;
     BOOL enable_LCMAP_LINGUISTIC_CASING   = TRUE;

     BOOL enable_LCMAP_SIMPLIFIED_CHINESE  = TRUE;
     BOOL enable_LCMAP_TRADITIONAL_CHINESE = TRUE;
     BOOL enable_CHINESE_NONE              = TRUE;
     BOOL enable_ChineseBox                = TRUE;

     //=============================================================================
     // Apply the rules. Note we do monotonic decrease
     //=============================================================================
     
     BOOL sortkey = c_LCMAP_SORTKEY.GetCheck() == BST_CHECKED; 
     enable_LCMAP_FULLWIDTH &= !sortkey;
     enable_LCMAP_HALFWIDTH &= !sortkey;
     enable_WIDTH_NONE      &= !sortkey;
     enable_WidthBox        &= !sortkey;

     enable_LCMAP_HIRAGANA  &= !sortkey;
     enable_LCMAP_KATAKANA  &= !sortkey;
     enable_KANA_NONE       &= !sortkey;
     enable_KanaBox         &= !sortkey;

     enable_LCMAP_LOWERCASE &= !sortkey;
     enable_LCMAP_UPPERCASE &= !sortkey;
     enable_CASE_NONE       &= !sortkey;
     enable_LCMAP_LINGUISTIC_CASING &= !sortkey;
     enable_CaseBox         &= !sortkey;

     enable_LCMAP_SIMPLIFIED_CHINESE  &= !sortkey;
     enable_LCMAP_TRADITIONAL_CHINESE &= !sortkey;
     enable_CHINESE_NONE        &= !sortkey;
     enable_ChineseBox          &= !sortkey;

     BOOL illegal = c_LCMAP_HIRAGANA.GetCheck() == BST_CHECKED;
     illegal |=     c_LCMAP_KATAKANA.GetCheck() == BST_CHECKED;
     illegal |=     c_LCMAP_FULLWIDTH.GetCheck() == BST_CHECKED;
     illegal |=     c_LCMAP_HALFWIDTH.GetCheck() == BST_CHECKED;
     enable_LCMAP_UPPERCASE &= !illegal;
     enable_LCMAP_LOWERCASE &= !illegal;
     
     //=============================================================================
     // Now commit the decisions made
     //=============================================================================
     c_LCMAP_FULLWIDTH.EnableWindow(enable_LCMAP_FULLWIDTH);
     c_LCMAP_HALFWIDTH.EnableWindow(enable_LCMAP_HALFWIDTH);
     c_WIDTH_NONE     .EnableWindow(enable_WIDTH_NONE);
     c_WidthBox       .EnableWindow(enable_WidthBox);

     c_LCMAP_KATAKANA .EnableWindow(enable_LCMAP_KATAKANA);
     c_LCMAP_HIRAGANA .EnableWindow(enable_LCMAP_HIRAGANA);
     c_KANA_NONE      .EnableWindow(enable_KANA_NONE);
     c_KanaBox        .EnableWindow(enable_KanaBox);

     c_LCMAP_LOWERCASE          .EnableWindow(enable_LCMAP_LOWERCASE);
     c_LCMAP_UPPERCASE          .EnableWindow(enable_LCMAP_UPPERCASE);
     c_CASE_NONE                .EnableWindow(enable_CASE_NONE);
     c_CaseBox                  .EnableWindow(enable_CaseBox);
     c_LCMAP_LINGUISTIC_CASING  .EnableWindow(enable_LCMAP_LINGUISTIC_CASING);

     c_LCMAP_SIMPLIFIED_CHINESE .EnableWindow(enable_LCMAP_SIMPLIFIED_CHINESE);
     c_LCMAP_TRADITIONAL_CHINESE.EnableWindow(enable_LCMAP_TRADITIONAL_CHINESE);
     c_CHINESE_NONE             .EnableWindow(enable_CHINESE_NONE);
     c_ChineseBox               .EnableWindow(enable_ChineseBox);

     c_NORM_IGNORECASE    .EnableWindow(sortkey);
     c_NORM_IGNOREKANATYPE.EnableWindow(sortkey);
     c_NORM_IGNORENONSPACE.EnableWindow(sortkey);
     c_NORM_IGNORESYMBOLS .EnableWindow(sortkey);
     c_NORM_IGNOREWIDTH   .EnableWindow(sortkey);
     c_SORT_STRINGSORT    .EnableWindow(sortkey);
     
     CString caption;
     caption.LoadString(sortkey ? IDS_LCMAP_SORTKEY : IDS_LCMAP_CAPTION);
     LVCOLUMN info = {0};
     info.mask = LVCF_TEXT;
     info.pszText = (LPTSTR)(LPCTSTR)caption;
     c_Output.SetColumn(COL_LCMAP, &info);

     CheckRadioButton(IDC_COMPARESTRING, IDC_LSTRCMPI, IDC_TCSICMP);
     c_UseCompareString.ShowWindow(SW_HIDE);
     c_UseTcsCmp.ShowWindow(SW_HIDE);
     c_UseTcsiCmp.ShowWindow(SW_HIDE);
     c_lstrcmp.ShowWindow(SW_HIDE);
     c_lstrcmpi.ShowWindow(SW_HIDE);
     x_Comparison.ShowWindow(SW_HIDE);
    } // CLCMapString::updateControls

/****************************************************************************
*                            CLCMapString::Refresh
* Result: void
*       
* Effect: 
*       Updates the display
****************************************************************************/

void CLCMapString::Refresh()
    {
     if(!initialized)
        return;

     CWaitCursor wait;
     
     updateControls();
     
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;
     fmt = QueryTemplate(_T("[LCMapString]"));

     //----------------------------------------------------------------
     // %1: LCID
     //----------------------------------------------------------------
     LCID lcid;
     CString localeName;
     CCompareString::GetLCID(localeName, lcid);

     //----------------------------------------------------------------
     // %2:
     //----------------------------------------------------------------
     
     //----------------------------------------------------------------
     // %3: options
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;

     GetFlags(options, flags, or);

     if(options.IsEmpty())
        options = _T("0");

     //----------------------------------------------------------------
     // %4: unused
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %5: variable
     //----------------------------------------------------------------
     BOOL enable = TRUE;
     CString variable;

     variable = GetVariable();

     //----------------------------------------------------------------
     // %6: options as a decimal number
     //----------------------------------------------------------------
     CString flagsDecimal;
     flagsDecimal.Format(_T("%d"), flags);

     //----------------------------------------------------------------
     // %7: or
     //----------------------------------------------------------------
     // This was already set

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal number
     //----------------------------------------------------------------
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1            %2      %3       %4      %5         %6         %7        %8          %9     %10     %11
     text.FormatMessage(fmt, localeName,  _T(""), options, _T(""), variable, flagsDecimal,  or, localeDecimal, _T(""), _T(""), _T(""));

     //-----------------------------------------------------------------------------------------------

     enable = TRUE;
     SetCode(text, enable);

     int limit = c_Output.GetItemCount();
     c_Progress.SetRange(0, limit);
     
     BOOL sortkey = c_LCMAP_SORTKEY.GetCheck() == BST_CHECKED;
     c_Output.SetSortKey(sortkey, COL_LCMAP);

     for(int i = 0; i < limit; i++)
        { /* Translate string */
         CString result;
         CString p = c_Output.GetItemText(i, COL_TEXT);
         c_Progress.StepIt();
         int n = ::LCMapString(lcid, flags, (LPCTSTR)p, _tcslen((LPCTSTR)p) + 1, NULL, 0); // Allow for NUL terminator
         if(n == 0)
            { /* failed */
             DWORD err = ::GetLastError();
             result = _T("!") + ErrorString(err);
            } /* failed */
         else
            { /* succeeded */
             CByteArray b;
             int count = n;
             if((flags & LCMAP_SORTKEY) == 0)
                count *= sizeof(TCHAR); // in case Unicode, make bigger buffer
             b.SetSize(count);
             int c = ::LCMapString(lcid, flags, (LPCTSTR)p, _tcslen((LPCTSTR)p) + 1, (LPTSTR)b.GetData(), count);
             // We have two different display representations
             // For LCMAP_SORTKEY, we show the bytes in hex
             // For all other cases, we show the character sequence
             if(c == 0)
                { /* error */
                 DWORD err = ::GetLastError();
                 result = _T("!") + ErrorString(err);
                } /* error */
             else
                { /* success */
                SortData * p = (SortData *)c_Output.GetItemData(i); // old string
                 for(int k = 0; k < count; k++)
                    { /* format each */
                     CString t;
                     t.Format(_T("%02x "), b[k]);
                     result += t;
                    } /* format each */
                 p->data = result;
                 p->data.Replace(_T(" "), _T(""));
                } /* success */
            } /* succeeded */
         c_Output.SetItemText(i, COL_LCMAP, result);
         // Now make sure the column is big enough to hold it 
         int colw = c_Output.GetColumnWidth(COL_LCMAP);
         CClientDC dc(&c_Output);
         CFont * f = c_Output.GetFont();
         dc.SelectObject(f);
         int textw = dc.GetTextExtent(result).cx;
         if(colw < textw)
            c_Output.SetColumnWidth(COL_LCMAP, textw);
        } /* Translate string */
     
     CompareInfo info;
     info.comparison = CompareInfo::Use_tcscmp;
     info.lcid = lcid;
     info.flags = flags & ~(LCMAP_FULLWIDTH | LCMAP_HALFWIDTH |
                              LCMAP_HIRAGANA | LCMAP_KATAKANA |
                              LCMAP_TRADITIONAL_CHINESE | LCMAP_SIMPLIFIED_CHINESE |
                              LCMAP_UPPERCASE | LCMAP_LOWERCASE |
                              LCMAP_LINGUISTIC_CASING |
                              LCMAP_BYTEREV |
                              LCMAP_SORTKEY);
     c_Output.SortItems(compare, (DWORD_PTR)&info);
     SetCompareState(&info);
    } // CLCMapString::Refresh

/****************************************************************************
*                       CLCMapString::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font to the controls
****************************************************************************/

void CLCMapString::SetFontToControls()
    {
     CCompareString::SetFontToControls();
    } // CLCMapString::SetFontToControls

/****************************************************************************
*                             CLCMapString::Clear
* Result: void
*       
* Effect: 
*       Clears all flags
****************************************************************************/

void CLCMapString::Clear()
    {
     CCompareString::Clear();
     c_LCMAP_LINGUISTIC_CASING.SetCheck(BST_UNCHECKED);
     c_LCMAP_SORTKEY.SetCheck(BST_UNCHECKED);
     c_LCMAP_BYTEREV.SetCheck(BST_UNCHECKED);
     CheckRadioButton(IDC_LCMAP_FULLWIDTH, IDC_WIDTH_NONE, IDC_WIDTH_NONE);
     CheckRadioButton(IDC_LCMAP_SIMPLIFIED_CHINESE, IDC_CHINESE_NONE, IDC_CHINESE_NONE);
     CheckRadioButton(IDC_LCMAP_HIRAGANA, IDC_KANA_NONE, IDC_KANA_NONE);
     CheckRadioButton(IDC_LCMAP_UPPERCASE, IDC_CASE_NONE, IDC_CASE_NONE);
     updateControls();
    } // CLCMapString::Clear

/****************************************************************************
*                           CLCMapString::GetFlags
* Inputs:
*       CString & options: Printable options string
*       DWORD & flags: Binary options flags
*       const CString & or: OR operator
* Result: void
*       
* Effect: 
*       Sets the flags and options
****************************************************************************/

void CLCMapString::GetFlags(CString & options, DWORD & flags, const CString & or)
    {
     CCompareString::GetFlags(options, flags, or);

     ADDFLAG(LCMAP_BYTEREV);
     ADDFLAG(LCMAP_SORTKEY);

     ADDFLAG(LCMAP_FULLWIDTH);
     ADDFLAG(LCMAP_HALFWIDTH);

     ADDFLAG(LCMAP_HIRAGANA);
     ADDFLAG(LCMAP_KATAKANA);

     ADDFLAG(LCMAP_UPPERCASE);
     ADDFLAG(LCMAP_LOWERCASE);
     ADDFLAG(LCMAP_LINGUISTIC_CASING);

     ADDFLAG(LCMAP_TRADITIONAL_CHINESE);
     ADDFLAG(LCMAP_SIMPLIFIED_CHINESE);
    } // CLCMapString::GetFlags

/****************************************************************************
*                            CLCMapString::OnClear
* Result: void
*       
* Effect: 
*       Resets all state
****************************************************************************/

void CLCMapString::OnClear() 
   {
    Clear();
   }
