// LatLong.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "LatLong.h"
#include "Query.h"
#include "Map1a.h"
#include "GetGeoInfoData.h"
#include "ErrorString.h"
#include "_tstof.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CLatLong, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CLatLong dialog


CLatLong::CLatLong(CWnd* pParent /*=NULL*/)
        : CFunction(CLatLong::IDD, pParent)
{
        //{{AFX_DATA_INIT(CLatLong)
        //}}AFX_DATA_INIT
}


void CLatLong::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CLatLong)
        DDX_Control(pDX, IDC_GEOID, c_GEOID);
        DDX_Control(pDX, IDC_RECT, c_Rect);
        DDX_Control(pDX, IDC_WINDOW_ORG_Y, c_WindowOrgY);
        DDX_Control(pDX, IDC_WINDOW_ORG_X, c_WindowOrgX);
        DDX_Control(pDX, IDC_WINDOW_EXT_Y, c_WindowExtY);
        DDX_Control(pDX, IDC_WINDOW_EXT_X, c_WindowExtX);
        DDX_Control(pDX, IDC_VIEWPORT_ORG_Y, c_ViewportOrgY);
        DDX_Control(pDX, IDC_VIEWPORT_ORG_X, c_ViewportOrgX);
        DDX_Control(pDX, IDC_VIEWPORT_EXT_Y, c_ViewportExtY);
        DDX_Control(pDX, IDC_VIEWPORT_EXT_X, c_ViewportExtX);
        DDX_Control(pDX, IDC_SETWINDOWORG_CAPTION, x_SetWindowOrg);
        DDX_Control(pDX, IDC_SETVIEWPORTEXT_CAPTION, x_SetViewportExt);
        DDX_Control(pDX, IDC_SETVIEWPORTORG_CAPTION, x_SetViewportOrg);
        DDX_Control(pDX, IDC_SETWINDOWEXT_CAPTION, x_SetWindowExt);
        DDX_Control(pDX, IDC_MAPLINK, c_MapLink);
        DDX_Control(pDX, IDC_LONG, c_Longitude);
        DDX_Control(pDX, IDC_LAT, c_Latitude);
        DDX_Control(pDX, IDC_GMT, c_GMT);
        DDX_Control(pDX, IDC_MAP, c_Map);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLatLong, CFunction)
        //{{AFX_MSG_MAP(CLatLong)
        ON_EN_CHANGE(IDC_LAT, OnChangeLat)
        ON_EN_CHANGE(IDC_LONG, OnChangeLong)
        ON_EN_CHANGE(IDC_VIEWPORT_EXT_X, OnChangeViewportExtX)
        ON_EN_CHANGE(IDC_VIEWPORT_EXT_Y, OnChangeViewportExtY)
        ON_EN_CHANGE(IDC_VIEWPORT_ORG_X, OnChangeViewportOrgX)
        ON_EN_CHANGE(IDC_VIEWPORT_ORG_Y, OnChangeViewportOrgY)
        ON_EN_CHANGE(IDC_WINDOW_EXT_X, OnChangeWindowExtX)
        ON_EN_CHANGE(IDC_WINDOW_EXT_Y, OnChangeWindowExtY)
        ON_EN_CHANGE(IDC_WINDOW_ORG_X, OnChangeWindowOrgX)
        ON_EN_CHANGE(IDC_WINDOW_ORG_Y, OnChangeWindowOrgY)
        ON_NOTIFY(NM_CLICK, IDC_GEOID, OnClickGeoid)
        ON_NOTIFY(LVN_ITEMCHANGED, IDC_GEOID, OnItemchangedGeoid)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLatLong message handlers

BOOL CLatLong::OnInitDialog() 
{
        CFunction::OnInitDialog();
        
        CClientDC dc(&c_GEOID);
        CString caption;

        caption = _T("GEOID");
        c_GEOID.InsertColumnEx(0, caption, LVCFMT_RIGHT);

        caption = _T("GEO_FRIENDLYNAME");
        c_GEOID.InsertColumnEx(1, caption, LVCFMT_LEFT);

#define COL_LATITUDE 2
        caption = _T("GEO_LATITUDE");
        c_GEOID.InsertColumnEx(COL_LATITUDE, caption, LVCFMT_RIGHT);
        
#define COL_LONGITUDE 3
        caption = _T("GEO_LONGITUDE");
        c_GEOID.InsertColumnEx(COL_LONGITUDE, caption, LVCFMT_RIGHT, -1);
        return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

/****************************************************************************
*                         CLatLong::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font to the controls
****************************************************************************/

void CLatLong::SetFontToControls()
    {
     
    } // CLatLong::SetFontToControls

/****************************************************************************
*                              CLatLong::Refresh
* Result: void
*       
* Effect: 
*       Handles refresh
****************************************************************************/

void CLatLong::Refresh()
    {
     if(!initialized)
        return;

     EnableQuery(QUERY_DWORD, FALSE);
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, FALSE);

     QueryTemplate(_T(""));  // erase template information

     POSITION pos = c_GEOID.GetFirstSelectedItemPosition();
     int sel = c_GEOID.GetNextSelectedItem(pos);
     CString GeoID = c_GEOID.GetItemText(sel, 0);
     
     LANGID langid = LANG_NEUTRAL;
     GEOID geoidDecimal = (GEOID)_ttoi(GeoID);
     CString result = Get_GEO_LATITUDE(geoidDecimal, langid);
     c_Latitude.SetWindowText(result);
     result = Get_GEO_LONGITUDE(geoidDecimal, langid);
     c_Longitude.SetWindowText(result);

     SetCode(_T(""), FALSE);
    } // CLatLong::Refresh

/****************************************************************************
*                            CLatLong::OnChangeLat
*                           CLatLong::OnChangeLong
* Result: void
*       
* Effect: 
*       The debug window latitude or longitude changedchanged
****************************************************************************/

void CLatLong::OnChangeLat() 
   {

    CString s;
    c_Latitude.GetWindowText(s);
    s.TrimLeft();
    s.TrimRight();
    if(s.IsEmpty())
       return;
    double d = _tstof(s);
    c_Map.SetLatitude(d);
   }

void CLatLong::OnChangeLong() 
    {
     CString s;
     c_Longitude.GetWindowText(s);
     s.TrimLeft();
     s.TrimRight();
     if(s.IsEmpty())
        return;
     double d = _tstof(s);
     c_Map.SetLongitude(d);
    }

/****************************************************************************
*                       CLatLong::OnChangedViewportExtX
*                       CLatLong::OnChangedViewportExtY
*                       CLatLong::OnChangedViewportOrgX
*                       CLatLong::OnChangedViewportOrgY
*                        CLatLong::OnChangedWindexExtX
*                        CLatLong::OnChangedWindexExtY
*                        CLatLong::OnChangedWindexOrgX
*                        CLatLong::OnChangedWindexOrgY
* Result: void
*       
* Effect: 
*       A change in the debug mapping mode windows has occurred
****************************************************************************/

void CLatLong::OnChangeViewportExtX() 
   {
    updateCoordinates();
   }

void CLatLong::OnChangeViewportExtY() 
   {
    updateCoordinates();
   }

void CLatLong::OnChangeViewportOrgX() 
   {
    updateCoordinates();
   }

void CLatLong::OnChangeViewportOrgY() 
   {
    updateCoordinates();
   }

void CLatLong::OnChangeWindowExtX() 
   {
    updateCoordinates();
   }

void CLatLong::OnChangeWindowExtY() 
   {
    updateCoordinates();
   }

void CLatLong::OnChangeWindowOrgX() 
   {
    updateCoordinates();
   }

void CLatLong::OnChangeWindowOrgY() 
   {
    updateCoordinates();
   }

/****************************************************************************
*                         CLatLong::updateCoordinates
* Result: void
*       
* Effect: 
*       Updates the coordinates
****************************************************************************/

void CLatLong::updateCoordinates()
    {
     c_Map.m_ViewportExt.cx = c_ViewportExtX.GetWindowInt();
     c_Map.m_ViewportExt.cy = c_ViewportExtY.GetWindowInt();
     c_Map.m_ViewportOrg.x  = c_ViewportOrgX.GetWindowInt();
     c_Map.m_ViewportOrg.y  = c_ViewportOrgY.GetWindowInt();
     c_Map.m_WindowExt.cx   = c_WindowExtX.GetWindowInt();
     c_Map.m_WindowExt.cy   = c_WindowExtY.GetWindowInt();
     c_Map.m_WindowOrg.x    = c_WindowOrgX.GetWindowInt();
     c_Map.m_WindowOrg.y    = c_WindowOrgY.GetWindowInt();
     c_Map.Invalidate();
    } // CLatLong::updateCoordinates

/****************************************************************************
*                            CLatLong::Initialize
* Result: void
*        
* Effect: 
*       Initializes the controls
****************************************************************************/

void CLatLong::Initialize()
   {
    LogWnd = this;
    if(!EnumSystemGeoID(GEOCLASS_NATION, 0, EnumGeoInfoProc))
       { /* failed */
       } /* failed */

    // Load the GMT logo bitmap so we can give them credit
    HBITMAP bmp = (HBITMAP)::LoadImage(AfxGetInstanceHandle(),
                                       MAKEINTRESOURCE(IDB_GMT),
                                       IMAGE_BITMAP,
                                       0,0,
                                       LR_LOADTRANSPARENT | LR_LOADMAP3DCOLORS);
    c_GMT.SetBitmap(bmp);

    // Now load the actual map image
    bmp = (HBITMAP)::LoadImage(AfxGetInstanceHandle(),
                               MAKEINTRESOURCE(IDB_MAP1A),
                               IMAGE_BITMAP,
                               0,0,
                               LR_LOADTRANSPARENT | LR_LOADMAP3DCOLORS);
    c_Map.SetBitmap(bmp);
    c_Map.SetMapRect(RECT_MAP1A); // from header file for Map1a
    c_Map.ClearCoordinates();

    // Load up the debugging windows.  These are not visible in the
    // release version
    c_WindowOrgX.SetWindowTextNoNotify(0);
    c_WindowOrgY.SetWindowTextNoNotify(0);
    c_WindowExtX.SetWindowTextNoNotify(-180);
    c_WindowExtY.SetWindowTextNoNotify(180);
    c_ViewportExtX.SetWindowTextNoNotify(-RECT_MAP1A.Width()/2);
    c_ViewportExtY.SetWindowTextNoNotify(-RECT_MAP1A.Height());
    c_ViewportOrgX.SetWindowTextNoNotify(RECT_MAP1A.Width() / 2);
    c_ViewportOrgY.SetWindowTextNoNotify(RECT_MAP1A.Height() / 2);
    CString s;
    s.Format(_T("L=%d, T=%d, R=%d, B=%d, W=%d, H=%d"),
             RECT_MAP1A.left,
             RECT_MAP1A.top,
             RECT_MAP1A.right,
             RECT_MAP1A.bottom,
             RECT_MAP1A.Width(),
             RECT_MAP1A.Height());
    c_Rect.SetWindowText(s);
#ifndef _DEBUG
    c_WindowOrgX.ShowWindow(SW_HIDE);
    c_WindowOrgY.ShowWindow(SW_HIDE);
    c_WindowExtX.ShowWindow(SW_HIDE);
    c_WindowExtY.ShowWindow(SW_HIDE);
    c_ViewportExtX.ShowWindow(SW_HIDE);
    c_ViewportExtY.ShowWindow(SW_HIDE);
    c_ViewportOrgX.ShowWindow(SW_HIDE);
    c_ViewportOrgY.ShowWindow(SW_HIDE);
    x_SetWindowOrg.ShowWindow(SW_HIDE);
    x_SetViewportOrg.ShowWindow(SW_HIDE);
    x_SetWindowExt.ShowWindow(SW_HIDE);
    x_SetViewportExt.ShowWindow(SW_HIDE);
    c_Rect.ShowWindow(SW_HIDE);
    updateCoordinates();
#endif
    Refresh();
   } // CLatLong::Initialize

/****************************************************************************
*                        CLatLong::EnumGeoInfoProc
* Inputs:
*       GEOID geoid: ID value
* Result: BOOL
*       TRUE, always
* Effect: 
*       Adds element to list of GEIODs
****************************************************************************/

CLatLong * CLatLong::LogWnd = NULL;

/* static */ BOOL CALLBACK CLatLong::EnumGeoInfoProc(GEOID geoid)
    {
     if(LogWnd == NULL)
         return TRUE;

     LCID lcid = (LCID)LogWnd->TabParent->SendMessage(UWM_QUERY, (WPARAM)QUERY_LOCALE);
     LANGID langid = LANGIDFROMLCID(lcid);

     CString gstr;
     gstr.Format(_T("%d"), geoid);

     int n = LogWnd->c_GEOID.GetItemCount();
     LogWnd->c_GEOID.InsertItem(n, gstr);

     CString friendlyname = Get_GEO_FRIENDLYNAME(geoid, langid);
     LogWnd->c_GEOID.SetItemText(n, 1, friendlyname);
     
     LogWnd->c_GEOID.SetItemText(n, COL_LONGITUDE, Get_GEO_LONGITUDE(geoid, langid));
     LogWnd->c_GEOID.SetItemText(n, COL_LATITUDE,  Get_GEO_LATITUDE(geoid, langid));

     return TRUE;
    } // CLatLong::CEnumGeoInfoProc

/****************************************************************************
*                           CLatLong::OnClickGeoid
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Updates the lat/long
****************************************************************************/

void CLatLong::OnClickGeoid(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    Refresh();
    *pResult = 0;
   }

/****************************************************************************
*                        CLatLong::OnItemChangedGeoid
* Inputs:
*       NMHDR & pNMHDR: (NUMHDR *)(NM_LISTVIEW *)
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Refreshes the display as each selection changes
****************************************************************************/

void CLatLong::OnItemchangedGeoid(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
    Refresh();
        
    *pResult = 0;
   }

/****************************************************************************
*                              CLatLong::IndexOK
* Inputs:
*       CWnd * wnd: WIndow
* Result: BOOL
*       TRUE to include the window
*       FALSE to exclude the window
****************************************************************************/

BOOL CLatLong::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_Rect)
        return FALSE;
     return TRUE;
    } // CLatLong::IndexOK

/****************************************************************************
*                             CLatLong::QuerySave
* Result: BOOL
*       TRUE to allow save
*       FALSE to inhibit it
****************************************************************************/

BOOL CLatLong::QuerySave()
    {
     return c_GEOID.GetItemCount() > 0;
    } // CLatLong::QuerySave

/****************************************************************************
*                               CLatLong::Save
* Inputs:
*       const CString & filename: file name to use
*       UINT mode: Save mode: 0 (default), 8 (UTF-8), 16 (UTF-16)
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Saves the contents of the list of locales
****************************************************************************/

BOOL CLatLong::Save(const CString & filename, UINT mode)
    {
     return c_GEOID.Save(filename, mode);
    } // CLatLong::Save
