#include "stdafx.h"
#include "LinkItem.h"

/****************************************************************************
*                              LinkItem::Write
* Inputs:
*       CFile & file: File to write to
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Writes the data to the file specified
****************************************************************************/

BOOL LinkItem::Write(CFile & file)
    {
     try {
        file.Write(&range, sizeof(range));
        file.Write(&index, sizeof(index));
     }
     catch(CFileException * e)
        { /* failed */
         e->Delete();
         return FALSE;
        } /* failed */
     return TRUE;
    } // LinkItem::Write

/****************************************************************************
*                               LinkItem::Read
* Inputs:
*       CFile & file: 
* Result: BOOL
*       TRUE if successful
*       FALSE if error or EOF, use ::GetLastError().  EOF is ERROR_HANDLE_EOF
* Effect: 
*       Reads the data
****************************************************************************/

BOOL LinkItem::Read(CFile & file)
    {
     UINT count = 0;
     try {
        count += file.Read(&range, sizeof(range));
        count += file.Read(&index, sizeof(index));
     }
     catch(CFileException * e)
        { /* failed */
         ::SetLastError(e->m_lOsError);
         e->Delete();
        } /* failed */
     if(count == 0)
        { /* EOF? */
         ::SetLastError(ERROR_HANDLE_EOF);
         return FALSE;
        } /* EOF? */
     return TRUE;
    } // LinkItem::Read
