// LocaleExplorerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "LocaleExplorerDlg.h"
#include "Help.h"
#include "lctypemsg.h"
#include "RegVars.h"
#include "errorString.h"
#include "FontMap.h"
#include "lcids.h"
#include "messagesToChildren.h"
#include "msg.h"
#include "allchildren.h"
#include "IndexInfo.h"
#include "SetMapColor.h"
#include "Initializing.h"
#include "save.h"
#include "OpenFileEx.h"
#include <afxpriv.h>
#include "DeferredMessage.h"
#include "BiFile.h"
//****************
// Pages
//****************
#include "CalendarInfo.h"
#include "CodePageInfo.h"
#include "CompareString.h"
#include "DateFormats.h"
#include "Defaults.h"
#include "EnumLanguageGroupLocales.h"
#include "EnumSystemCodePages.h"
#include "EnumSystemGeoID.h"
#include "EnumSystemLocales.h"
#include "EnumUILanguages.h"
#include "GetCurrencyFormat.h"
#include "GetDateFormat.h"
#include "GetGeoInfo.h"
#include "GetLocaleInfo.h"
#include "GetNLSVersion.h" 
#include "GetNumberFormat.h"
#include "GetStringTypeEx.h"
#include "GetTimeFormat.h"
#include "Index.h"
#include "IsNLSDefinedString.h"
#include "IsTextUnicode.h"
#include "IsValidCodePage.h"
#include "LatLong.h"
#include "LCID.h"
#include "LCMapString.h"
#include "MultiByte.h"
#include "ScriptBreak.h"
#include "ScriptGetProperties.h"
#include "TimeFormats.h"
#include "Unicode.h"

#define EXPLORERDLG
#include "Query.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//********************************
// Messages sent
//********************************
DECLARE_MESSAGE(UWM_SET_USER_FONT)
DECLARE_MESSAGE(UWM_REFRESH)
DECLARE_MESSAGE(UWM_INITIALIZE)
DECLARE_MESSAGE(UWM_QUERY_SAVE)
DECLARE_MESSAGE(UWM_SAVE)
//********************************
// Messages received
//********************************
DECLARE_MESSAGE(UWM_QUERY_GETMINMAXINFO)
//--------------------------------------------------------------------------------
// Font load table
//--------------------------------------------------------------------------------
// This indicates if a special font should be loaded to support the code
// examples: Japanes, Korean
//--------------------------------------------------------------------------------
static const struct {
   LCID id;
   LPCTSTR font;
} SpecialFonts [] = {
   { 0, NULL } // EOT
};

//-----------------------------------------------------------------------------
// RTL table
//-----------------------------------------------------------------------------
// This table indicates which language codes require reversal
// Note that this can be overridden by the FontMap entry, which is checked
// first. If it is not found explicitly in the font map, then this table is
// consulted


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        //{{AFX_DATA(CAboutDlg)
        enum { IDD = IDD_ABOUTBOX };
        CStatic c_AboutUnicode;
        //}}AFX_DATA

        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CAboutDlg)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        //{{AFX_MSG(CAboutDlg)
        virtual BOOL OnInitDialog();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
        //{{AFX_DATA_INIT(CAboutDlg)
        //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CAboutDlg)
        DDX_Control(pDX, IDC_ABOUT_UNICODE, c_AboutUnicode);
        //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
        //{{AFX_MSG_MAP(CAboutDlg)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************************
*                           CAboutDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Loads the copyright string
* Notes:
*       This is required because the resrouce compiler truncates a long
*       title string to 256 bytes, and the Unicode copyright is longer than that
****************************************************************************/

BOOL CAboutDlg::OnInitDialog() 
   {
    CDialog::OnInitDialog();
        
    CString s;
    s.LoadString(IDS_ABOUT_UNICODE);
    c_AboutUnicode.SetWindowText(s);
        
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/////////////////////////////////////////////////////////////////////////////
// CLocaleExplorerDlg dialog

CLocaleExplorerDlg::CLocaleExplorerDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CLocaleExplorerDlg::IDD, pParent)
{
        //{{AFX_DATA_INIT(CLocaleExplorerDlg)
        //}}AFX_DATA_INIT
        // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
        initialized = FALSE;
        noindex = FALSE;
}

void CLocaleExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CLocaleExplorerDlg)
        DDX_Control(pDX, IDC_TEMPLATE_NAME, c_TemplateName);
        DDX_Control(pDX, IDC_LANG_HELP, c_Lang_Help);
        DDX_Control(pDX, IDC_CHILD_CONTROLS, c_ChildControlFrame);
        DDX_Control(pDX, IDC_TABS, c_Tabs);
        DDX_Control(pDX, IDC_SUPPORTED, c_SupportedLocales);
        DDX_Control(pDX, IDC_ALL, c_AllLocales);
        DDX_Control(pDX, IDC_COPY, c_Copy);
        DDX_Control(pDX, IDC_LANG_USER, c_Lang_User);
        DDX_Control(pDX, IDC_BROWSE_USER, c_BrowseUser);
        DDX_Control(pDX, IDC_VARIABLE, c_Variable);
        DDX_Control(pDX, IDC_SAMPLE_CODE, c_SampleCode);
        DDX_Control(pDX, IDC_DWORD, c_DWORD);
        DDX_Control(pDX, IDC_LANG_STL, c_Lang_STL);
        DDX_Control(pDX, IDC_LANG_MFC, c_Lang_MFC);
        DDX_Control(pDX, IDC_LANG_CPP, c_Lang_CPP);
        DDX_Control(pDX, IDC_LANG_C, c_Lang_C);
        DDX_Control(pDX, IDC_LOCALE_NOUSEROVERRIDE, c_LOCALE_NOUSEROVERRIDE);
        DDX_Control(pDX, IDC_LOCALE_USE_CP_ACP, c_LOCALE_USE_CP_ACP);
        DDX_Control(pDX, IDC_LOCALES, c_Locales);
        //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLocaleExplorerDlg, CDialog)
        ON_REGISTERED_MESSAGE(UWM_SET_CODE, OnSetCode)
        ON_REGISTERED_MESSAGE(UWM_SET_VARIABLE, OnSetVariable)
        ON_REGISTERED_MESSAGE(UWM_QUERY, OnQuery)
        ON_REGISTERED_MESSAGE(UWM_ENABLE_QUERY, OnEnableQuery)
        ON_REGISTERED_MESSAGE(UWM_QUERY_GETMINMAXINFO, OnQueryGetMinMaxInfo)
        ON_REGISTERED_MESSAGE(UWM_REFERENCE, OnReference)
        ON_MESSAGE(WM_SETTINGCHANGE, OnSettingChange)
        ON_MESSAGE(WM_KICKIDLE, OnKickIdle)
        //{{AFX_MSG_MAP(CLocaleExplorerDlg)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        ON_WM_CLOSE()
        ON_CBN_SELENDOK(IDC_LOCALES, OnSelendokLocales)
        ON_BN_CLICKED(IDC_LOCALE_NOUSEROVERRIDE, OnLocaleNouseroverride)
        ON_BN_CLICKED(IDC_LOCALE_USE_CP_ACP, OnLocaleUseCpAcp)
        ON_BN_CLICKED(IDC_LANG_C, OnLangC)
        ON_BN_CLICKED(IDC_LANG_CPP, OnLangCpp)
        ON_BN_CLICKED(IDC_LANG_MFC, OnLangMfc)
        ON_BN_CLICKED(IDC_LANG_STL, OnLangStl)
        ON_BN_CLICKED(IDC_DWORD, OnDword)
        ON_EN_CHANGE(IDC_VARIABLE, OnChangeVariable)
        ON_BN_CLICKED(IDC_LANG_USER, OnLangUser)
        ON_BN_CLICKED(IDC_BROWSE_USER, OnBrowseUser)
        ON_BN_CLICKED(IDC_COPY, OnCopy)
        ON_WM_GETMINMAXINFO()
        ON_WM_NCHITTEST()
        ON_WM_SIZE()
        ON_BN_CLICKED(IDC_SUPPORTED, OnSupported)
        ON_BN_CLICKED(IDC_ALL, OnAll)
        ON_COMMAND(IDM_ABOUT, OnAbout)
        ON_COMMAND(IDM_EXIT, OnExit)
        ON_COMMAND(IDM_FONTMAP, OnFontmap)
        ON_COMMAND(IDM_HELP, OnHelp)
        ON_COMMAND(IDM_SHOW_PATTERNS, OnShowPatterns)
        ON_COMMAND(IDM_CODE_FONT, OnCodeFont)
        ON_BN_CLICKED(IDC_LANG_HELP, OnLangHelp)
        ON_COMMAND(IDM_MAPCOLOR, OnMapcolor)
        ON_COMMAND(IDM_BREAK, OnBreak)
        ON_COMMAND(IDM_FILE_SAVE, OnFileSave)
        ON_WM_INITMENUPOPUP()
        ON_COMMAND(IDM_DEFAULT_FONT, OnDefaultFont)
        ON_COMMAND(IDC_WRITE_TEMPLATE, OnWriteTemplate)
        ON_COMMAND(IDM_CACHE_LOCATION, OnCacheLocation)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

//        TCHAR SISO6369LANGNAME[MAX_SISO6369LANGNAME];
//        int result = GetLocaleInfo(lcid, LOCALE_SISO6369LANGNAME, SISO6369LANGNAME, sizeof(SISO6369LANGNAME)/sizeof(TCHAR));
//
//        TCHAR SENGCOUNTRY[MAX_SENGCOUNTRY];
//        result = GetLocaleInfo(lcid, LOCALE_SENGCOUNTRY, SENGCOUNTRY, sizeof(SENGCOUNTRY)/sizeof(TCHAR));

/////////////////////////////////////////////////////////////////////////////
// CLocaleExplorerDlg message handlers

CArray<LCID, LCID> locales;                
                                     
BOOL CALLBACK localefunc(LPTSTR str) 
   {                 
    LCID lcid = _tcstoul(str, NULL, 16);
    locales.Add(lcid);
    return TRUE;
   } // localefunc

BOOL CLocaleExplorerDlg::OnInitDialog()
{
        CDialog::OnInitDialog();

        // Add "About..." menu item to system menu.

        // IDM_ABOUTBOX must be in the system command range.
        ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
        ASSERT(IDM_ABOUTBOX < 0xF000);

        messagePort = ::CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0);
        ASSERT(messagePort != NULL);

        for(int i = 0; i < __argc; i++)
           { /* see if noindex */
            if(_tcsicmp(__targv[i], _T("-noindex")) ==0)
               { /* set noindex */
                noindex = TRUE;
                break;
               } /* set noindex */
           } /* see if noindex */

        CMenu* pSysMenu = GetSystemMenu(FALSE);
        if (pSysMenu != NULL)
           { /* has system menu */
            CString strAboutMenu;
            strAboutMenu.LoadString(IDS_ABOUTBOX);
            if (!strAboutMenu.IsEmpty())
               {
                pSysMenu->AppendMenu(MF_SEPARATOR);
                pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
               }
            CString helpMenu;
            helpMenu.LoadString(IDS_HELP);
            ASSERT((IDS_HELP & 0xFFF0) == IDS_HELP);
            pSysMenu->AppendMenu(MF_STRING, IDS_HELP, helpMenu);
           } /* has system menu */

        // Set the icon for this dialog.  The framework does this automatically
        //  when the application's main window is not a dialog
        SetIcon(m_hIcon, TRUE);                 // Set big icon
        SetIcon(m_hIcon, FALSE);                // Set small icon

        // TODO: Add extra initialization here

        CheckRadioButton(IDC_SUPPORTED, IDC_ALL, IDC_SUPPORTED);
        LoadLocales();

        SetUserFont();
        CheckRadioButton(IDC_LANG_C, IDC_LANG_USER, IDC_LANG_MFC);
        
        LoadTemplates(); // force initial template load
        
        RegistryString templatefile(IDS_REGISTRY_USER_TEMPLATE);
        templatefile.load();
        UserTemplateFile = templatefile.value;
        
        RegistryInt dword(IDS_REGISTRY_DWORD);
        dword.load();
        c_DWORD.SetCheck(dword.value ? BST_CHECKED : BST_UNCHECKED);

        HBITMAP bmp = (HBITMAP)::LoadImage(AfxGetInstanceHandle(),
                                           MAKEINTRESOURCE(IDB_OPEN),
                                           IMAGE_BITMAP,
                                           0,0,
                                           LR_LOADMAP3DCOLORS);
        c_BrowseUser.SetBitmap(bmp);

        bmp = (HBITMAP)::LoadImage(AfxGetInstanceHandle(),
                                   MAKEINTRESOURCE(IDB_COPY),
                                   IMAGE_BITMAP,
                                   0,0,
                                   LR_LOADMAP3DCOLORS);
        c_Copy.SetBitmap(bmp);

        GetWindowRect(&original);

        RegistryFont font(IDS_REGISTRY_CODE_FONT);
        if(font.load())
           { /* has font */
            if(CodeFont.CreateFontIndirect(&font.value))
               { /* success */
                c_SampleCode.SetFont(&CodeFont);
               } /* success */
           } /* has font */

        CRect r;
        c_Tabs.GetWindowRect(&r);
        ScreenToClient(&r);

        CRect c;
        GetClientRect(&c);

        TabHeight = c.bottom - r.bottom;
        
        InitDigitSubstitutionContext();

        initialized = TRUE;

        //SetScrollRange(SB_VERT, 0, originalClient.Height() - 1);
        
        int pageindex;
        CWnd * page;
        int pagecount = 0;
        //----------------------------------------------------------------
        // This macro depends on certain patterns. The name of the class
        // (without the C) is the name of the page
        //----------------------------------------------------------------
#define ADDPAGE(x) \
        pageindex = c_Tabs.AddPage(_T(#x), C##x::IDD, C##x::IDD, RUNTIME_CLASS(C##x)); \
        pagecount++; \
        if(pageindex >= 0) \
             { /* success */  \
              page = c_Tabs.GetPage(pageindex); \
              page->SendMessage(UWM_INITIALIZE, (WPARAM)this); \
              progress->StepIt(_T(#x)); \
              progress->UpdateWindow(); \
              References.Add(new Reference(_T(#x), (CFunction *)page, page)); \
             } /* success */ \
        else \
            ASSERT(FALSE);

#define NPAGES 29
        int pages = NPAGES;
        if(noindex)
           pages--;
        //----------------------------------------------------------------
        // Create a modeless dialog progress box
        //----------------------------------------------------------------
        CInitializing * progress = new CInitializing;
        progress->Create(IDD_INITIALIZING);
        progress->SetLimit(pages);
        progress->CenterWindow();
        progress->ShowWindow(SW_SHOW);
        
        //----------------------------------------------------------------
        // Now add all the pages in
        //----------------------------------------------------------------

        ADDPAGE(CalendarInfo);
        ADDPAGE(CodePageInfo);
        ADDPAGE(CompareString);
        ADDPAGE(DateFormats);
        ADDPAGE(Defaults);
        ADDPAGE(EnumLanguageGroupLocales);
        ADDPAGE(EnumSystemCodePages);
        ADDPAGE(EnumSystemGeoID);
        ADDPAGE(EnumSystemLocales);
        ADDPAGE(EnumUILanguages);
        ADDPAGE(GetCurrencyFormat);
        ADDPAGE(GetDateFormat);
        ADDPAGE(GetGeoInfo);
        ADDPAGE(GetLocaleInfo);
        ADDPAGE(GetNLSVersion);
        ADDPAGE(GetNumberFormat);
        ADDPAGE(GetStringTypeEx);
        ADDPAGE(GetTimeFormat);
        ADDPAGE(IsNLSDefinedString);
        ADDPAGE(IsTextUnicode);
        ADDPAGE(IsValidCodePage);
        ADDPAGE(LatLong);
        ADDPAGE(LCID);
        ADDPAGE(LCMapString);
        ADDPAGE(MultiByte);
        //ADDPAGE(ScriptBreak);
        ADDPAGE(ScriptGetProperties);
        ADDPAGE(TimeFormats);
        ADDPAGE(Unicode);
        if(!noindex)
           ADDPAGE(Index);

        ASSERT(pagecount == pages); // if this fails, update NPAGES (debugging aid)
        //----------------------------------------------------------------
        // This appears to be entirely gratuitous. However, it actually
        // fixes a bug in the CTabCtrl where the number of tab rows
        // displayed is incorrect. By forcing a resize, it is redrawn
        // correctly
        //----------------------------------------------------------------
        CRect tr;
        c_Tabs.GetWindowRect(&tr);
        ScreenToClient(&tr);
        tr.bottom++;
        c_Tabs.MoveWindow(&tr);

        //----------------------------------------------------------------
        // This handles the case where the vertical screen space is too small to hold the
        // original size
        //----------------------------------------------------------------
        CRect client;
        GetClientRect(&client);

        ResizeTabs(client.Width(), client.Height());
        
        // Request the pages to reindex themsevles
        if(!noindex)
           SendMessageToDescendants(UWM_INDEX, (WPARAM)&References, (LPARAM)progress);
        
        // Set the font
        SetUserFont();

        Refresh();

        return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLocaleExplorerDlg::OnSysCommand(UINT nID, LPARAM lParam)
   {
    switch(nID & 0xFFF0)
       { /* nID */
        case IDM_ABOUTBOX:
           {
            CAboutDlg dlgAbout;
            dlgAbout.DoModal();
           }
           break;
        case IDS_HELP:
           { /* help */
            CHelp dlg;
            dlg.m_HelpName = _T(""); // empty string means default help text
            dlg.DoModal();
           } /* help */
           break;
        default:
           CDialog::OnSysCommand(nID, lParam);
           break;
       } /* nID */
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLocaleExplorerDlg::OnPaint() 
{
        if (IsIconic())
        {
                CPaintDC dc(this); // device context for painting

                SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

                // Center icon in client rectangle
                int cxIcon = GetSystemMetrics(SM_CXICON);
                int cyIcon = GetSystemMetrics(SM_CYICON);
                CRect rect;
                GetClientRect(&rect);
                int x = (rect.Width() - cxIcon + 1) / 2;
                int y = (rect.Height() - cyIcon + 1) / 2;

                // Draw the icon
                dc.DrawIcon(x, y, m_hIcon);
        }
        else
        {
                CDialog::OnPaint();
        }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLocaleExplorerDlg::OnQueryDragIcon()
{
        return (HCURSOR) m_hIcon;
}

void CLocaleExplorerDlg::OnCancel() 
{
}

void CLocaleExplorerDlg::OnOK() 
{
        
}

void CLocaleExplorerDlg::OnClose() 
   {
    CDialog::OnOK();
   }

/****************************************************************************
*                    CLocaleExplorerDlg::OnSelendokLocales
* Result: void
*       
* Effect: 
*       Handles change in the selected language
****************************************************************************/

void CLocaleExplorerDlg::OnSelendokLocales() 
   {
    InitDigitSubstitutionContext();
    SetUserFont();
    Refresh();
   }

void CLocaleExplorerDlg::OnLocaleNouseroverride() 
   {
    Refresh();
   }

void CLocaleExplorerDlg::OnLocaleUseCpAcp() 
   {
    Refresh();
   }

/****************************************************************************
*                        CLocaleExplorerDlg::OnLang...
* Result: void
*       
* Effect: 
*       Forces the language display to update
****************************************************************************/

void CLocaleExplorerDlg::OnLangC() 
   {
    LoadTemplates();
    Refresh();
   }

void CLocaleExplorerDlg::OnLangCpp() 
   {
    LoadTemplates();
    Refresh();
   }

void CLocaleExplorerDlg::OnLangMfc() 
   {
    LoadTemplates();
    Refresh();
   }

void CLocaleExplorerDlg::OnLangStl() 
   {
    LoadTemplates();
    Refresh();
   }

void CLocaleExplorerDlg::OnLangUser() 
   {
    LoadTemplates();
    Refresh();
   }
void CLocaleExplorerDlg::OnLangHelp() 
   {
    LoadTemplates();
    Refresh();
   }

void CLocaleExplorerDlg::OnDword() 
   {
    Refresh();
    RegistryInt dword(IDS_REGISTRY_DWORD);
    dword.value = c_DWORD.GetCheck() == BST_CHECKED;
    dword.store();
   }

/****************************************************************************
*                       CLocaleExplorerDlg::Refresh
* Result: void
*       
* Effect: 
*       Updates the code. If no code is selected, blanks the code display
****************************************************************************/

void CLocaleExplorerDlg::Refresh()
    {
     c_Lang_User.EnableWindow(!UserTemplateFile.IsEmpty());
     SendToActiveTab(UWM_REFRESH);
    } // CLocaleExplorerDlg::Refresh

/****************************************************************************
*                    CLocaleExplorerDlg::OnChangeVariable
* Result: void
*       
* Effect: 
*       Forces code to rewrite
****************************************************************************/

void CLocaleExplorerDlg::OnChangeVariable() 
   {
    Refresh();
   }


/****************************************************************************
*                      CLocaleExplorerDlg::OnBrowseUser
* Result: void
*       
* Effect: 
*       Browses for a file
* Notes:
*       For this to compile, it is necessary to set the windows version to
*       0x0500 (or higher) and MFC V6 won't work right (the file dialog
*       crashes in an ugly state). So we revert to the older GetOpenFileName
*       interface
****************************************************************************/

void CLocaleExplorerDlg::OnBrowseUser() 
   {

    RegistryString userfile(IDS_REGISTRY_USER_TEMPLATE);
    userfile.load();
    
    CString name;
    name = userfile.value;

#ifdef _UNICODE
    UINT width = 8;
#else
    UINT width = 0;
#endif
    if(!OpenFileEx(FALSE, name, _T(".txt"), width, IDS_USER_FILE_FILTER))
       return;

    userfile.value = name;
    VERIFY(userfile.store());
    UserTemplateFile = name;
    Refresh();
   }

/****************************************************************************
*                         CLocaleExplorerDlg::OnCopy
* Result: void
*       
* Effect: 
*       Copies the sample text to the clipboard
****************************************************************************/

void CLocaleExplorerDlg::OnCopy() 
   {
    c_SampleCode.SetRedraw(FALSE);
    int low;
    int high;
    c_SampleCode.GetSel(low, high);
    c_SampleCode.SetSel(0, -1);
    c_SampleCode.SendMessage(WM_COPY);
    c_SampleCode.SetSel(low, high);
    c_SampleCode.SetRedraw(TRUE);
   }

/****************************************************************************
*                    CLocaleExplorerDlg::LoadUserTemplate
* Result: void
*       
* Effect: 
*       Loads the user-defined template.
* Notes:
*       [FIXED]
*       template
*       [VARIABLE]
*       template
*       [DWORD]
*       template
****************************************************************************/

void CLocaleExplorerDlg::LoadUserTemplate()
    {
     Templates.ReadTemplates(UserTemplateFile);
    } // CLocaleExplorerDlg::LoadUserTemplate

/****************************************************************************
*                  CLocaleExplorerDlg::LoadStandardTemplate
* Inputs:
*       CString name: Language ID name, "C", "CPP", "MFC" or "STL"
* Result: void
*       
* Effect: 
*       Attempts to load a standard template
****************************************************************************/

void CLocaleExplorerDlg::LoadStandardTemplate(CString name)
    {
     CString filename = name + _T(".tpl");
     if(Templates.ReadTemplates(filename))
        return; // success

     if(::GetLastError() != ERROR_FILE_NOT_FOUND)
        return; // error, but not missing file

     // Try the base directory
     TCHAR module[MAX_PATH];
     ::GetModuleFileName(NULL, module, MAX_PATH);
     TCHAR drive[MAX_PATH];
     TCHAR path[MAX_PATH];
     _tsplitpath(module, drive, path, NULL, NULL);
     _tmakepath(module, drive,path, name, _T(".tpl"));
     if(Templates.ReadTemplates(CString(module)))
        return; // success, found in base directory

     if(::GetLastError() != ERROR_FILE_NOT_FOUND)
        return; // error, but not missing file

     // Load from resources
     HRSRC rsrc = ::FindResource(AfxGetInstanceHandle(), name, _T("TEMPLATE"));
     if(rsrc == NULL)
        return;

     HGLOBAL h = ::LoadResource(AfxGetInstanceHandle(), rsrc);
     if(h == NULL)
        return;

     LPBYTE p = (LPBYTE)::LockResource(h);
     if(p == NULL)
        return;

     int len = ::SizeofResource(AfxGetInstanceHandle(), rsrc);

     // Get the temporary path, create a temporary file, copy resource into it
     TCHAR TmpPath[MAX_PATH];
     DWORD env = ::GetEnvironmentVariable(_T("TMP"), TmpPath, MAX_PATH);
     if(env == 0)
        env = ::GetEnvironmentVariable(_T("TEMP"), TmpPath, MAX_PATH);
     if(env == NULL)
        lstrcpy(TmpPath, _T("."));
     TCHAR TmpFileName[MAX_PATH];
     ::GetTempFileName(TmpPath, name, 0, TmpFileName);
     CFile f;
     if(!f.Open(TmpFileName, CFile::modeWrite | CFile::modeCreate))
        return;
     f.Write(p, len);
     f.Close();


     DWORD err;
     BOOL result = FALSE;
     if(!Templates.ReadTemplates(TmpFileName))
        { /* failed */
         err = ::GetLastError();
         result = FALSE;
        } /* failed */
     else
        { /* success */
         err = ERROR_SUCCESS;
         result = TRUE;
        } /* success */
     ::DeleteFile(TmpFileName);
     ::SetLastError(err);
    } // CLocaleExplorerDlg::LoadStandardTemplate

/****************************************************************************
*                     CLocaleExplorerDlg::OnGetMinMaxInfo
* Inputs:
*       MINMAXINFO * lpMMI: MINMAXINFO structure
* Result: void
*       
* Effect: 
*       Limits the horizontal size to the original size, vertical size to
*       some smaller value
****************************************************************************/

void CLocaleExplorerDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
   {
    if(initialized)
       { /* has valid data */
        lpMMI->ptMaxTrackSize.x = original.Width();
        lpMMI->ptMaxTrackSize.y; // = original.Height();
        lpMMI->ptMinTrackSize.x = original.Width();
        lpMMI->ptMinTrackSize.y = 200; // get a better value someday
       } /* has valid data */
    
    CDialog::OnGetMinMaxInfo(lpMMI);
   }

/****************************************************************************
*                       CLocaleExplorerDlg::OnNcHitTest
* Inputs:
*       CPoint point: Point of hit test (ignored except to pass to superclass)
* Result: UINT
*       HT... value
* Effect: 
*       Since we do not allow horizontal resizing, forces any hit that would
*       indicate the possibility of horizontal sizing to either suppress
*       resizing or limit it to vertical sizing. Anything not listed here
*       is passed back unchanged.
****************************************************************************/

UINT CLocaleExplorerDlg::OnNcHitTest(CPoint point) 
   {
    UINT hit =  CDialog::OnNcHitTest(point);
    switch(hit)
       { /* hit */
        case HTBOTTOM:
           break;
        case HTBOTTOMLEFT:
        case HTBOTTOMRIGHT:
           hit = HTBOTTOM;
           break;
        case HTTOPLEFT:
        case HTTOPRIGHT:
           hit = HTTOP;
           break;
        case HTLEFT:
        case HTRIGHT:
           hit = HTBORDER;
           break;
       } /* hit */
    return hit;
   }

/****************************************************************************
*                       CLocaleExplorerDlg::ResizeTabs
* Inputs:
*       int cx: New width
*       int cy: New height
* Result: void
*       
* Effect: 
*       Resizes all the tabs to fit the new window size.
****************************************************************************/

void CLocaleExplorerDlg::ResizeTabs(int cx, int cy)
    {
    
        CRect client;
        GetClientRect(&client);

        CRect tabs;
        c_Tabs.GetWindowRect(&tabs);
        ScreenToClient(&tabs);

        // resize the tab control
        tabs.bottom = client.bottom - TabHeight;
        c_Tabs.SetWindowPos(NULL, 0, 0, tabs.Width(), tabs.Height(), SWP_NOMOVE | SWP_NOZORDER);

        // Now move the controls 
        CRect child;
        c_ChildControlFrame.GetWindowRect(&child);
        ScreenToClient(&child);

        // Compute the delta from the current window to the bottom of the client area

        int delta = client.bottom - child.bottom;

        for(ALL_CHILDREN(wnd))
           { /* scan windows */
            CRect w;
            wnd->GetWindowRect(&w);
            ScreenToClient(&w);
            CRect t;
            if(!t.IntersectRect(&w, &child))
               continue; // not a window we care about

            if(wnd == &c_Tabs)
               continue; // because of resize it might be overlapping
            w.top += delta;
            w.bottom += delta;
            wnd->MoveWindow(&w);
           } /* scan windows */

        { /* reupdate */
         CRect newchild;
         c_ChildControlFrame.GetWindowRect(&newchild);
         InvalidateRect(&newchild);

         for(ALL_CHILDREN(wnd))
            { /* update */
             wnd->Invalidate();
             wnd->UpdateWindow();
            } /* update */
        } /* reupdate */
    }

/****************************************************************************
*                         CLocaleExplorerDlg::OnSize
* Inputs:
*       UINT nType:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Adjust the scrolling information
****************************************************************************/

void CLocaleExplorerDlg::OnSize(UINT nType, int cx, int cy) 
   {
    CDialog::OnSize(nType, cx, cy);

    if(c_ChildControlFrame.GetSafeHwnd() != NULL)
       { /* can move them */
        // The situation here is that we have resize the tab control and then
        // move all the windows below the tab control up
       ResizeTabs(cx, cy);

       } /* can move them */

#if 0   
    CurrentHeight = cy;
    int ScrollMax;

    ScrollMax = originalClient.Height() - 1;
    int delta = 0;

    if(ScrollPos + cy > ScrollMax)
       { /* rescroll */
        delta = ScrollPos + cy - ScrollMax;
       } /* rescroll */

    SCROLLINFO si = {sizeof(SCROLLINFO)};
    si.fMask = SIF_PAGE | SIF_POS;
    si.nMin = 0;
    si.nMax = ScrollMax;
    si.nPage = cy + 1;
    si.nPos = ScrollPos;
    si.nPage = cy - delta + 1;
    SetScrollInfo(SB_VERT, &si, TRUE);
#endif
   }

/****************************************************************************
*                       CLocaleExplorerDlg::LoadLocales
* Result: void
*       
* Effect: 
*       Load the locale names, either "All" or "Supported"
****************************************************************************/

void CLocaleExplorerDlg::LoadLocales()
    {
     //-----------------------------------------------------------------------------
     // Supported locales
     //-----------------------------------------------------------------------------
     if(c_SupportedLocales.GetCheck() == BST_CHECKED)
        { /* system locales */
         c_Locales.ResetContent();
         EnumSystemLocales(localefunc, LCID_INSTALLED); 
         for(int i = 0; i < locales.GetSize(); i++)     
            { /* set */                                 
             int size = GetLocaleInfo(locales[i], LOCALE_SLANGUAGE, NULL, 0);
             LPTSTR name = new TCHAR[size];
             size = GetLocaleInfo(locales[i], LOCALE_SLANGUAGE, name, size);
             int n = c_Locales.AddString(name);
             c_Locales.SetItemData(n, locales[i]);

            } /* set */
                      // Load the predefined names
         CString def;
         def.LoadString(IDS_USER_DEFAULT);
         int n = c_Locales.InsertString(0, def);
         c_Locales.SetItemData(n, LOCALE_USER_DEFAULT);
         int select = n;

         def.LoadString(IDS_SYSTEM_DEFAULT);
         n = c_Locales.InsertString(0, def);
         c_Locales.SetItemData(n, LOCALE_SYSTEM_DEFAULT);

         c_Locales.SetCurSel(select);

         return;
        } /* system locales */

     //-----------------------------------------------------------------------------
     // All locales
     //-----------------------------------------------------------------------------
     if(c_AllLocales.GetCheck() == BST_CHECKED)
        { /* all locales */
         c_Locales.ResetContent();
         c_Locales.AddStrings(LCIDs);

         c_Locales.Select(0x0000); // select "language neutral"
         return;
        } /* all locales */
     //-----------------------------------------------------------------------------
     // Other options would go here. If we get to the line below, something is wrong
     //-----------------------------------------------------------------------------
     ASSERT(FALSE);
    } // CLocaleExplorerDlg::LoadLocales

/****************************************************************************
*                       CLocaleExplorerDlg::OnSupported
*                          CLocaleExplorerDlg::OnAll
* Result: void
*       
* Effect: 
*       Loads the appropriate suite of locales and forces a refrehs
****************************************************************************/

void CLocaleExplorerDlg::OnSupported() 
   {
    LoadLocales();
    Refresh();
   }

void CLocaleExplorerDlg::OnAll() 
   {
    LoadLocales();
    Refresh();
   }

/****************************************************************************
*                         CLocaleExplorerDlg::OnAbout
* Result: void
*       
* Effect: 
*       Pops up the About... box
****************************************************************************/

void CLocaleExplorerDlg::OnAbout() 
   {
    CAboutDlg dlgAbout;
    dlgAbout.DoModal();
   }

/****************************************************************************
*                         CLocaleExplorerDlg::OnExit
* Result: void
*       
* Effect: 
*       Exits the program (menu handler)
****************************************************************************/

void CLocaleExplorerDlg::OnExit() 
   {
    CDialog::OnOK();
   }

/****************************************************************************
*                        CLocaleExplorerDlg::OnFontMap
* Result: void
*       
* Effect: 
*       Pops up the font map
****************************************************************************/

void CLocaleExplorerDlg::OnFontmap() 
   {
    CFontMap dlg;
    dlg.DoModal();
   }

/****************************************************************************
*                         CLocaleExplorerDlg::OnHelp
* Result: void
*       
* Effect: 
*       Pops up the help
****************************************************************************/

void CLocaleExplorerDlg::OnHelp() 
   {
    CHelp dlg;
    dlg.m_HelpName = _T(""); // 0 means default help text
    dlg.DoModal();
   }

/****************************************************************************
*                       CLocaleExplorerDlg::SetUserFont
* Result: void
*       
* Effect: 
*       Sets the user font in all the controls that matter
* Notes:
*       The font will be set in every child page
****************************************************************************/

void CLocaleExplorerDlg::SetUserFont()
    {
#ifdef _UNICODE
     SendMessageToDescendants(UWM_SET_USER_FONT);
#endif
    } // CLocaleExplorerDlg::SetUserFont

/****************************************************************************
*                      CLocaleExplorerDlg::LoadTemplates
* Result: LangType
*       The selected language
* Effect: 
*       Loads the template based on the language selection
****************************************************************************/

LangType CLocaleExplorerDlg::LoadTemplates()
    {
     LangType lang;
     if(c_Lang_C.GetCheck() == BST_CHECKED)
        { /* use C templates */
         LoadStandardTemplate(_T("C"));
         lang = C;
        } /* use C templates */
     else
     if(c_Lang_CPP.GetCheck() == BST_CHECKED)
        { /* use C++ templates */
         LoadStandardTemplate(_T("CPP"));
         lang = CPP;
        } /* use C++ templates */
     else
     if(c_Lang_MFC.GetCheck() == BST_CHECKED)
        { /* use MFC templates */
         LoadStandardTemplate(_T("MFC"));
         lang = MFC;
        } /* use MFC templates */
     else
     if(c_Lang_STL.GetCheck() == BST_CHECKED)
        { /* Load STL templates */
         LoadStandardTemplate(_T("STL"));
         lang = STL;
        } /* Load STL templates */
     else
     if(c_Lang_Help.GetCheck() == BST_CHECKED)
        { /* Load help template */
         LoadStandardTemplate(_T("HELP"));
         lang = Help;
        } /* Load help template */
     else
     if(c_Lang_User.GetCheck() == BST_CHECKED)
        { /* user-defined */
         lang = User;
         // Note that the user template is loaded EACH TIME. This allows
         // the user to edit the template and keep retrying it!
         LoadUserTemplate();
        } /* user-defined */
     else
        { /* impossible */
         lang = C;  // should not happen!
        } /* impossible */
     return lang;
    } // CLocaleExplorerDlg::LoadTemplates

/****************************************************************************
*                         CLocaleExplorerDlg::OnQuery
* Inputs:
*       WPARAM: The designator for the query
*       LPARAM: Additional information (depends on the query type)
* Result: LRESULT
*       The type depends on the query type
****************************************************************************/

LRESULT CLocaleExplorerDlg::OnQuery(WPARAM wParam, LPARAM lParam)
    {
     QueryType query = (QueryType)wParam;
     switch(query)
        { /* Query Type */
         //----------------------------------------------------------------
         // QUERY_LOCALE    (LRESULT)(LCID)
         //     LPARAM: ignored
         //----------------------------------------------------------------
         case QUERY_LOCALE:
             { /* query locale */
            int n = c_Locales.GetCurSel();
            if(n == CB_ERR)
               return (LRESULT)MISSING_LCID;

            return (LRESULT)(LCID)c_Locales.GetItemData(n);
             } /* query locale */
         //----------------------------------------------------------------
         // QUERY_NOUSEROVERRIDE  (LRESULT)(DWORD)
         //     LPARAM: ignored
         //----------------------------------------------------------------
         case QUERY_NOUSEROVERRIDE:
             if(!c_LOCALE_NOUSEROVERRIDE.IsWindowEnabled())
                return (LRESULT)0;
             if(c_LOCALE_NOUSEROVERRIDE.GetCheck() == BST_CHECKED)
               return (LRESULT)LOCALE_NOUSEROVERRIDE;
            else
               return (LRESULT)0;
         //----------------------------------------------------------------
         // QUERY_USE_CP_ACP      (LRESULT)(DWORD)
         //     LPARAM: ignored
         //----------------------------------------------------------------
         case QUERY_USE_CP_ACP:
            if(!c_LOCALE_USE_CP_ACP.IsWindowEnabled())
               return (LRESULT)0;
            if(c_LOCALE_USE_CP_ACP.GetCheck() == BST_CHECKED)
               return (LRESULT)LOCALE_USE_CP_ACP;
            else
               return (LRESULT)0;
         //----------------------------------------------------------------
         // QUERY_LANGUAGE        (LRESULT)(LangType)
         //     LPARAM: ignored
         //----------------------------------------------------------------
         case QUERY_LANGUAGE:
            { /* QUERY_LANGUAGE */
             LangType lang = LoadTemplates();
             return (LRESULT)lang;
            } /* QUERY_LANGUAGE */
         //----------------------------------------------------------------
         // QUERY_DWORD                 (LRESULT)(BOOL)
         //     LPARAM: ignored
         //----------------------------------------------------------------
         case QUERY_DWORD:
            return (LRESULT)c_DWORD.GetCheck() == BST_CHECKED;
         //----------------------------------------------------------------
         // QUERY_TEMPLATE              (LRESULT)(LPCTSTR)
         //     LPARAM: (LPARAM)(LPCTSTR)name of template, e.g. [GetLocaleInfo::FIXED]
         //----------------------------------------------------------------
         case QUERY_TEMPLATE:
            { /* QUERY_TEMPLATE */
             CString name = (LPCTSTR)lParam;
             static CString templateCopy;
             // Note that we use a static CString here. This is so the destructor
             // on the CString type will not cause the CString contents to be
             // released when the context exits, thus leaving trash for the
             // recipient of the reply. But it does not involve making a copy
             // which the sender of the message must delete
             // BEWARE: this is not thread-safe for obvious reasons!
             // This is prompted by the problem that we cannot return a
             // tempoary C++ object unless the return type of the function
             // (which is, alas, LRESULT) is an appropriate type.  The effect
             // is to create a new object as part of the return mechamism.
             // But this is not possible when the return type is LRESULT.

             if(name.GetLength() == 0)
                { /* erase existing name and return nothing */
                 templateCopy = _T("");
                 c_TemplateName.SetWindowText(_T(""));
                } /* erase existing name and return nothing */
             else
                { /* has real request */
                 templateCopy = Templates.GetTemplate(name);
             
                 if(templateCopy.IsEmpty())
                    { /* failed to load */
                     CString fmt;
                     fmt.LoadString(IDS_NO_PATTERN);
                     templateCopy.Format(fmt, name);
                     c_TemplateName.SetWindowText(_T("")); // no template found
                    } /* failed to load */
                 else
                    { /* got it */
                     c_TemplateName.SetWindowText(name);
                    } /* got it */
                } /* has real request */

             return (LRESULT)(LPCTSTR)templateCopy;
            } /* QUERY_TEMPLATE */
         //----------------------------------------------------------------
         // QUERY_VARIABLE
         //     LPARAM: ignored
         //----------------------------------------------------------------
         case QUERY_VARIABLE:
            { /* QUERY_VARIABLE */
             c_Variable.GetWindowText(variable);
             return (LRESULT)(LPCTSTR)variable;
            } /* QUERY_VARIABLE */

         //----------------------------------------------------------------
         // QUERY_DIGITINFO
         //     LPARAM: ignored
         //----------------------------------------------------------------
         case QUERY_DIGITINFO:
            return (LRESULT)&digitinfo;

         //----------------------------------------------------------------
         // unknown query
         //     LPARAM: ignored
         //----------------------------------------------------------------
         default:
            ASSERT(FALSE);
            return 0;
        } /* Query Type */
    } // CLocaleExplorerDlg::OnQuery

/****************************************************************************
*                        CLocaleExplorerDlg::OnSetCode
* Inputs:
*       WPARAM wParam: (WPARAM)(LPCTSTR): The text to set
*       LPARAM: (LPARAM)(BOOL)TRUE to enable, FALSE to disable
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Sets the text
* Notes:
*       This is sent via SendMessage, and therefore the CString * will be
*       deleted by the caller. It must NOT be deleted here!
****************************************************************************/

LRESULT CLocaleExplorerDlg::OnSetCode(WPARAM wParam, LPARAM lParam)
    {
     LPCTSTR text = (LPCTSTR)wParam;
     c_SampleCode.SetWindowText(text);
     c_SampleCode.EnableWindow((BOOL)lParam);
     updateControls();
     return 0;
    } // CLocaleExplorerDlg::OnSetCode

/****************************************************************************
*                      CLocaleExplorerDlg::OnSetVariable
* Inputs:
*       WPARAM: (WPARAM)(LPCTSTR) String to set as variable, NULL will clear it
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Sets the variable edit control text
* Notes:
*       This uses the NoNotify mechanism to avoid circular dependency loops
****************************************************************************/

LRESULT CLocaleExplorerDlg::OnSetVariable(WPARAM wParam, LPARAM)
    {
     LPCTSTR text = (LPCTSTR)wParam;
     if(text == NULL)
        text = _T("");
     c_Variable.SetWindowTextNoNotify(text);
     return 0;
    } // CLocaleExplorerDlg::OnSetVariable

/****************************************************************************
*                     CLocaleExplorerDlg::SendToActiveTab
* Inputs:
*       UINT msg: Message to send
*       WPARAM wParam: (= 0)
*       LPARAM lParam: (= 0)
* Result: LRESULT
*       Result of message
* Effect: 
*       Sends the message to the active tab
****************************************************************************/

LRESULT CLocaleExplorerDlg::SendToActiveTab(UINT msg, WPARAM wParam, LPARAM lParam)
    {
     if(!initialized)
         return 0;
     int n = c_Tabs.GetActivePage();
     CWnd * wnd = c_Tabs.GetPage(n);
     ASSERT(wnd != NULL);
     return wnd->SendMessage(msg, wParam, lParam);
    } // CLocaleExplorerDlg::SendToActiveTab

/****************************************************************************
*                     CLocaleExplorerDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CLocaleExplorerDlg::updateControls()
    {
     BOOL enable = c_SampleCode.IsWindowEnabled();
     c_Copy.EnableWindow(enable);
    } // CLocaleExplorerDlg::updateControls

/****************************************************************************
*                     CLocaleExplorerDlg::OnShowPatterns
* Result: void
*       
* Effect: 
*       Displays the patterns
****************************************************************************/

void CLocaleExplorerDlg::OnShowPatterns() 
   {
#ifdef _DEBUG //----------------------------------------------------------------+
    QueryLanguage();                                                         // |
    CString s = Templates.GetTemplates();                                    // |
    AfxMessageBox(s, MB_ICONINFORMATION | MB_OK);                            // |
#endif //-----------------------------------------------------------------------+
   }

/****************************************************************************
*                       CLocaleExplorerDlg::OnCodeFont
* Result: void
*       
* Effect: 
*       Selects the font used for the code display (some people like a
*       fixed-width font
****************************************************************************/

void CLocaleExplorerDlg::OnCodeFont() 
   {
    RegistryFont font(IDS_REGISTRY_CODE_FONT);
    font.load();

    CFontDialog dlg(&font.value, CF_SCREENFONTS);
    if(dlg.DoModal() != IDOK)
       return; // user cancelled

    memcpy(&font.value, dlg.m_cf.lpLogFont, sizeof(LOGFONT));
    if(CodeFont.GetSafeHandle() != NULL)
       CodeFont.DeleteObject();
    if(!CodeFont.CreateFontIndirect(&font.value))
       { /* failed */
        return;
       } /* failed */
    font.store();
    c_SampleCode.SetFont(&CodeFont);
   }

/****************************************************************************
*                      CLocaleExplorerDlg::OnEnableQuery
* Inputs:
*       WPARAM: (WPARAM)(QueryType)
*       LPARAM: (LPARAM)(BOOL)
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Enables/disables the query 
****************************************************************************/

LRESULT CLocaleExplorerDlg::OnEnableQuery(WPARAM wParam, LPARAM lParam)
    {
     switch((QueryType)wParam)
        { /* Query type */
         case QUERY_NOUSEROVERRIDE:
            c_LOCALE_NOUSEROVERRIDE.EnableWindow((BOOL)lParam);
            break;
         case QUERY_USE_CP_ACP:
            c_LOCALE_USE_CP_ACP.EnableWindow((BOOL)lParam);
            break;
         case QUERY_DWORD:
            c_DWORD.EnableWindow((BOOL)lParam);
            break;
        } /* Query type */
     return 0;
    } // CLocaleExplorerDlg::OnEnableQuery


/****************************************************************************
*                  CLocaleExplorerDlg::OnQueryGetMinMaxInfo
* Inputs:
*       WPARAM: (WPARAM)(LPGETMINMAXINFO) The WM_GETMINMAXINFO of the child
*       LPARAM: (LPARAM)(HWND): The window handle of the sending child
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Limits the expansion of the child tab view so it won't overlap the
*       critical controls
****************************************************************************/

LRESULT CLocaleExplorerDlg::OnQueryGetMinMaxInfo(WPARAM wParam, LPARAM lParam)
    {
     LPMINMAXINFO mmi = (LPMINMAXINFO) wParam;
     CWnd * child = CWnd::FromHandle((HWND)lParam);

     // It is worth pointing out that the ptMinTrackSize and ptMaxTrackSize are
     // not POINT values in the logical sense, but SIZE values! But back in
     // prehistory, Microsoft erroneously claimed these to be POINT values
     // (which would have required issues such as being in screen coordinates or
     // client coordinates) and like most blunders involving Hungarian Notation,
     // the 'pt' prefix constrains them to be POINT types. This is one of the
     // many, many illustrations of why Hungarian Notation is a bankrupt concept
     // that has no place in modern computing.

     if(c_ChildControlFrame.GetSafeHwnd() != NULL)
        { /* can ask */
         // We do not want ptMaxTrackSize.y to exceed client.Height() - TabHeight
         CRect client;
         GetClientRect(&client);
         mmi->ptMaxTrackSize.y = client.Height() - TabHeight;
        } /* can ask */
     return 0;
    } // CLocaleExplorerDlg::OnQueryGetMinMaxInfo

/****************************************************************************
*                       CLocaleExplorerDlg::OnReference
* Inputs:
*       WPARAM: (WPARAM)(Reference *) Reference to add
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Adds the reference to the index table
****************************************************************************/

LRESULT CLocaleExplorerDlg::OnReference(WPARAM wParam, LPARAM)
    {
     Reference * r = (Reference *)wParam;
     //TRACE3("Reference \"%s\", 0x%08x, 0x%08x\n", r->text, r->page, r->wnd);
     References.Add(r);
     return 0;
    } // CLocaleExplorerDlg::OnReference

/****************************************************************************
*                       CLocaleExplorerDlg::OnMapColor
* Result: void
*       
* Effect: 
*       Launches a dialog to establish the map color scheme for highlighting
*       the location found
****************************************************************************/

void CLocaleExplorerDlg::OnMapcolor() 
   {
    CSetMapColor dlg;
    dlg.DoModal();
   }

/****************************************************************************
*                         CLocaleExplorerDlg::OnBreak
* Result: void
*       
* Effect: 
*       Causes a breakpoint; convenient for forcing a recompilation in
*       edit-and-continue mode while debugging
* Notes:
*       This is not available in non-debug configurations
****************************************************************************/

void CLocaleExplorerDlg::OnBreak() 
   {
#ifdef _DEBUG //----------------------------------------------------------------+
    DebugBreak();                                                            // |
#endif //-----------------------------------------------------------------------+
   }

/****************************************************************************
*                       CLocaleExplorerDlg::OnFileSave
* Result: void
*       
* Effect: 
*       Asks the current page to save itself
****************************************************************************/

void CLocaleExplorerDlg::OnFileSave() 
   {
    SendToActiveTab(UWM_SAVE);
   }

/****************************************************************************
*                     CLocaleExplorerDlg::OnInitMenuPopup
* Inputs:
*       CMenu * pPopupMenu: Menu which is active
*       UINT nIndex: Index of menu
*       BOOL bSysMenu: TRUE if it is the system menu, FALSE otherwise
* Result: void
*       
* Effect: 
*       Enables various menu items
****************************************************************************/

void CLocaleExplorerDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
   {
    CDialog::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
        
    BOOL enable = SendToActiveTab(UWM_QUERY_SAVE);
    pPopupMenu->EnableMenuItem(IDM_FILE_SAVE, MF_BYCOMMAND | (enable ? MF_ENABLED : MF_GRAYED));

    enable = c_Lang_User.GetCheck() == BST_UNCHECKED;
    pPopupMenu->EnableMenuItem(IDC_WRITE_TEMPLATE, MF_BYCOMMAND | (enable ? MF_ENABLED : MF_GRAYED));
   }

/****************************************************************************
*                      CLocaleExplorerDlg::OnDefaultFont
* Result: void
*       
* Effect: 
*       Asks for the default font
****************************************************************************/

void CLocaleExplorerDlg::OnDefaultFont() 
   {
    RegistryFont defaultfont(IDS_REGISTRY_DEFAULT_FONT);
    defaultfont.load();
    
    CFontDialog dlg(&defaultfont.value, CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT);
    if(dlg.DoModal() != IDOK)
       return;  // cancelled
        
    defaultfont.store();
    SetUserFont();
    Refresh();
   }

/****************************************************************************
*               CLocaleExplorerDlg::InitDigitSubstitutionContext
* Result: void
*       
* Effect: 
*       Initializes the SCRIPT_DIGITSUBSTITUE structure
****************************************************************************/

void CLocaleExplorerDlg::InitDigitSubstitutionContext()
   {
    LCID lcid = QueryLocale();
    ScriptRecordDigitSubstitution(lcid, &digitinfo);
   } // CLocaleExplorerDlg::InitDigitSubstitutionContext

/****************************************************************************
*                     CLocaleExplorerDlg::OnSettingChange
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       0, always
* Effect: 
*       If necessary. recomputes the digit info
****************************************************************************/

LRESULT CLocaleExplorerDlg::OnSettingChange(WPARAM, LPARAM)
    {
     InitDigitSubstitutionContext();
     return 0;
    } // CLocaleExplorerDlg::OnSettingChange

/****************************************************************************
*                       CLocaleExplorerDlg::OnKickIdle
* Result: LRESULT
*       (LRESULT)(BOOL) TRUE to continue idle processing
*                       FALSE to stop idle processing and block
* Effect: 
*       Dispatches deferred messages
* Notes:
*       This uses the ON_MESSAGE_VOID macro from afxpriv.h
****************************************************************************/

LRESULT CLocaleExplorerDlg::OnKickIdle(WPARAM, LPARAM)
    {
     if(messagePort != NULL)
        { /* check for deferred messages */
         DWORD bytesRead; // ignored
         ULONG_PTR key;   // ignored
         LPOVERLAPPED ovl;   // deferred message structure
#define MAX_MESSAGE_QUANTUM 10
         for(int i = 0; i < MAX_MESSAGE_QUANTUM; i++)
            { /* scan messages */
             if(!GetQueuedCompletionStatus(messagePort,
                                           &bytesRead,
                                           &key,
                                           &ovl,
                                           0)) // polled
                { /* no more */
                 return FALSE;
                } /* no more */
             DeferredMessage * msg = (DeferredMessage *)ovl;
             msg->wnd->PostMessage(msg->msg, msg->wParam, msg->lParam);
             delete msg;
            } /* scan messages */
         return TRUE;  // keep processing more
        } /* check for deferred messages */
     return FALSE; // stop idle processing unless we dispatched
    } // CLocaleExplorerDlg::OnKickIdle

/****************************************************************************
*                     CLocaleExplorerDlg::EnqueueMessage
* Inputs:
*       CWnd * wnd: Window to notify
*       UINT msg: Message to send
*       WPARAM wParam
*       LPARAM lParam
* Result: void
*       
* Effect: 
*       Enqueues the message
****************************************************************************/

void CLocaleExplorerDlg::EnqueueMessage(CWnd * wnd, UINT msg, WPARAM wParam, LPARAM lParam)
    {
     DeferredMessage * dm = new DeferredMessage;
     dm->wnd = wnd;
     dm->msg = msg;
     dm->wParam = wParam;
     dm->lParam = lParam;
     VERIFY(PostQueuedCompletionStatus(messagePort, 0, 0, (LPOVERLAPPED)dm));
    } // CLocaleExplorerDlg::EnqueueMessage

/****************************************************************************
*                     CLocaleExplorerDlg::OnWriteTemplate
* Result: void
*       
* Effect: 
*       Writes out a copy of the currently-selected template
****************************************************************************/

void CLocaleExplorerDlg::OnWriteTemplate() 
   {
    CString name;
    if(c_Lang_MFC.GetCheck() == BST_CHECKED)
       name = _T("MFC");
    else
    if(c_Lang_C.GetCheck() == BST_CHECKED)
       name = _T("C");
    else
    if(c_Lang_CPP.GetCheck() == BST_CHECKED)
       name = _T("CPP");
    else
    if(c_Lang_STL.GetCheck() == BST_CHECKED)
       name = _T("STL");
    else
    if(c_Lang_Help.GetCheck() == BST_CHECKED)
       name = _T("Help");
    
    // Copy of %s.tpl
    CString fmt;
    fmt.LoadString(IDS_WRITE_TEMPLATE_NAME);
    CString filename;
    filename.Format(fmt, name);

    // Save %s templates
    fmt.LoadString(IDS_WRITE_TEMPLATE_CAPTION);
    CString caption;
    caption.Format(fmt, name);
        
    UINT mode = 8; // assume 8-bit mode
    
    if(!OpenFileEx(TRUE, filename, _T(".tpl"), mode, IDS_USER_FILE_FILTER, caption))
       return; // open failed

    // The name may or may not be the same as the one we supplied
    
    HRSRC rsrc = ::FindResource(AfxGetInstanceHandle(), name, _T("TEMPLATE"));
    if(rsrc == NULL)
       return;

    HGLOBAL h = ::LoadResource(AfxGetInstanceHandle(), rsrc);
    if(h == NULL)
       return;

    LPBYTE p = (LPBYTE)::LockResource(h);
    if(p == NULL)
       return;

    CBiFile f;
    if(!f.Open(filename, CFile::modeCreate | CFile::modeWrite, mode))
       { /* open failed */
        DWORD err = ::GetLastError();
        CString fmt;
        fmt.LoadString(IDS_TEMPLATE_CREATE_FAILED);
        CString msg;
        msg.Format(fmt, filename, ErrorString(err));
        AfxMessageBox(fmt, MB_ICONERROR | MB_OK);
        return;
       } /* open failed */

    CString TTemplate((LPCSTR)p);

    f.WriteBOM(); 
    f.WriteString(TTemplate);
    f.Close();
   }

/****************************************************************************
*                     CLocaleExplorerDlg::OnCacheLocation
* Result: void
*       
* Effect: 
*       Sets the location for the index cache
****************************************************************************/

void CLocaleExplorerDlg::OnCacheLocation() 
   {
    RegistryString path(IDS_REGISTRY_CACHE_PATH);
    path.load();

    BROWSEINFO info = {0};
    info.hwndOwner = m_hWnd;
    info.pidlRoot = NULL;
    info.pszDisplayName = path.value.GetBuffer(MAX_PATH);
    info.ulFlags = BIF_EDITBOX | BIF_NEWDIALOGSTYLE;

    LPITEMIDLIST list = SHBrowseForFolder(&info);

    if(list == NULL)
       return;
    
    path.value.ReleaseBuffer();
    SHGetPathFromIDList(list, path.value.GetBuffer(MAX_PATH));
    path.value.ReleaseBuffer();

    path.store();
   }
