// LocaleExplorerDlg.h : header file
//

#if !defined(AFX_LOCALEEXPLORERDLG_H__3297F808_A6FC_4C9E_8205_F1EC413DEDD6__INCLUDED_)
#define AFX_LOCALEEXPLORERDLG_H__3297F808_A6FC_4C9E_8205_F1EC413DEDD6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CLocaleExplorerDlg dialog
#include "ExpandingTreeCtrl.h"
#include "WhatIsThisEdit.h"
#include "SmartDropdown.h"
#include "IDCombo.h"
#include "CodeTemplate.h"
#include "TabView.h"
#include "LangType.h"
#include "WhatIsItButton.h"
#include "IndexInfo.h"

class CLocaleExplorerDlg : public CDialog
{
// Construction
public:
        CLocaleExplorerDlg(CWnd* pParent = NULL);       // standard constructor

// Dialog Data
        //{{AFX_DATA(CLocaleExplorerDlg)
        enum { IDD = IDD_LOCALEEXPLORER_DIALOG };
        CEdit   c_TemplateName;
        CWhatIsItButton c_Lang_Help;
        CStatic c_ChildControlFrame;
        CTabView        c_Tabs;
        CWhatIsItButton c_SupportedLocales;
        CWhatIsItButton c_AllLocales;
        CStatic c_MainFrame;
        CWhatIsItButton c_Copy;
        CWhatIsItButton c_Lang_User;
        CWhatIsItButton c_BrowseUser;
        CWhatIsThisEdit   c_Variable;
        CWhatIsThisEdit   c_SampleCode;
        CWhatIsItButton c_DWORD;
        CWhatIsItButton c_Lang_STL;
        CWhatIsItButton c_Lang_MFC;
        CWhatIsItButton c_Lang_CPP;
        CWhatIsItButton c_Lang_C;
        CWhatIsItButton c_LOCALE_NOUSEROVERRIDE;
        CWhatIsItButton c_LOCALE_USE_CP_ACP;
        CIDCombo       c_Locales;
        //}}AFX_DATA

        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CLocaleExplorerDlg)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support
        //}}AFX_VIRTUAL
public:
        void EnqueueMessage(CWnd *, UINT, WPARAM, LPARAM);
           
// Implementation
protected:
        HICON m_hIcon;
protected: // methods
        void ShowLocale();
        void LoadUserTemplate();
        void LoadStandardTemplate(CString name);
        void Refresh();
        void LoadLocales();
        void updateControls();
        void ResizeTabs(int cx, int cy);
#ifdef _UNICODE
        BOOL IsRTL(LCID lcid);
        void RTLMap(CString & text, LCID lcid);
        BOOL HasUnicode(const CString & text);
#endif
        void SetUserFont();
        LangType LoadTemplates();
        LRESULT SendToActiveTab(UINT msg, WPARAM wParam = 0, LPARAM lParam = 0);
        void InitDigitSubstitutionContext();

protected: // data
        
        CString UserTemplateFile;
        CodeTemplate Templates;
        BOOL noindex;
        CString variable; // the name of the variable
        CRect original;   // original window rectangle, to handle GetMinMaxInfo
        ReferenceTable References;
#ifdef _UNICODE
        CFont UnicodeFont;
#endif
        SCRIPT_DIGITSUBSTITUTE * GetDigitSubstituteContext() { return &digitinfo;}
        SCRIPT_DIGITSUBSTITUTE digitinfo;

        HANDLE messagePort;
        CFont CodeFont;
        int TabHeight; // height of bottom of tab control from bottom of client area
        
        BOOL initialized;
protected: // message handlers
        afx_msg LRESULT OnQuery(WPARAM, LPARAM);
        afx_msg LRESULT OnSetCode(WPARAM, LPARAM);
        afx_msg LRESULT OnSetVariable(WPARAM, LPARAM);
        afx_msg LRESULT OnEnableQuery(WPARAM, LPARAM);
        afx_msg LRESULT OnQueryGetMinMaxInfo(WPARAM, LPARAM);
        afx_msg LRESULT OnReference(WPARAM, LPARAM);
        afx_msg LRESULT OnSettingChange(WPARAM, LPARAM);
        afx_msg LRESULT OnKickIdle(WPARAM, LPARAM);
        // Generated message map functions
        //{{AFX_MSG(CLocaleExplorerDlg)
        virtual BOOL OnInitDialog();
        afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
        afx_msg void OnPaint();
        afx_msg HCURSOR OnQueryDragIcon();
        virtual void OnCancel();
        virtual void OnOK();
        afx_msg void OnClose();
        afx_msg void OnSelendokLocales();
        afx_msg void OnLocaleNouseroverride();
        afx_msg void OnLocaleUseCpAcp();
        afx_msg void OnLangC();
        afx_msg void OnLangCpp();
        afx_msg void OnLangMfc();
        afx_msg void OnLangStl();
        afx_msg void OnDword();
        afx_msg void OnChangeVariable();
        afx_msg void OnLangUser();
        afx_msg void OnBrowseUser();
        afx_msg void OnCopy();
        afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
        afx_msg UINT OnNcHitTest(CPoint point);
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnSupported();
        afx_msg void OnAll();
        afx_msg void OnAbout();
        afx_msg void OnExit();
        afx_msg void OnFontmap();
        afx_msg void OnHelp();
        afx_msg void OnShowPatterns();
        afx_msg void OnCodeFont();
        afx_msg void OnLangHelp();
        afx_msg void OnMapcolor();
        afx_msg void OnBreak();
        afx_msg void OnFileSave();
        afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
        afx_msg void OnDefaultFont();
	afx_msg void OnWriteTemplate();
	afx_msg void OnCacheLocation();
	//}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LOCALEEXPLORERDLG_H__3297F808_A6FC_4C9E_8205_F1EC413DEDD6__INCLUDED_)
