// MultiByte.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "MultiByte.h"
#include "Query.h"
#include "AddFlag.h"
#include "lcids.h"
#include "ErrorString.h"
#include "Escapes.h"
#include "mbtrace.h"
#include "vs6.h"
#include "WideHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CMultiByte, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CMultiByte dialog


CMultiByte::CMultiByte(CWnd* pParent /*=NULL*/)
        : CFunction(CMultiByte::IDD, pParent)
   {
    //{{AFX_DATA_INIT(CMultiByte)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
   }


void CMultiByte::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CMultiByte)
        DDX_Control(pDX, IDC_WIDTHS, c_FontData);
        DDX_Control(pDX, IDC_WIDE_HISTORY, c_WideHistory);
        DDX_Control(pDX, IDC_MULTIBYTE_HISTORY, c_MultiByteHistory);
        DDX_Control(pDX, IDC_ERROR, c_Error);
        DDX_Control(pDX, IDC_ZOOMWIDE, c_ZoomWide);
        DDX_Control(pDX, IDC_WIDE, c_Wide);
        DDX_Control(pDX, IDC_MULTIBYTE, c_MultiByte);
        DDX_Control(pDX, IDC_WIDEHEX, c_WideHex);
        DDX_Control(pDX, IDC_MULTIBYTE_HEX, c_MultiByteHex);
        DDX_Control(pDX, IDC_CP_SUPPORTED, c_CP_SUPPORTED);
        DDX_Control(pDX, IDC_CP_INSTALLED, c_CP_INSTALLED);
        DDX_Control(pDX, IDC_VS7, c_VS7);
        DDX_Control(pDX, IDC_VS6, c_VS6);
        DDX_Control(pDX, IDC_VERSION_CAPTION, x_Version);
        DDX_Control(pDX, IDC_DWFLAGS_CAPTION, x_dwFlags);
        DDX_Control(pDX, IDC_WIDECHARTOMULTIBYTE, c_WideCharToMultiByte);
        DDX_Control(pDX, IDC_WC_SEPCHARS, c_WC_SEPCHARS);
        DDX_Control(pDX, IDC_WC_NO_BEST_FIT_CHARS, c_WC_NO_BEST_FIT_CHARS);
        DDX_Control(pDX, IDC_WC_DISCARDNS, c_WC_DISCARDNS);
        DDX_Control(pDX, IDC_WC_DEFAULTCHAR, c_WC_DEFAULTCHAR);
        DDX_Control(pDX, IDC_WC_COMPOSITECHECK, c_WC_COMPOSITECHECK);
        DDX_Control(pDX, IDC_MULTIBYTETOWIDECHAR, c_MultiByteToWideChar);
        DDX_Control(pDX, IDC_USEDDEFAULTCHAR_NULL, c_UsedDefaultCharNULL);
        DDX_Control(pDX, IDC_USEDDEFAULTCHAR_CAPTION, x_UsedDefaultChar);
        DDX_Control(pDX, IDC_USED_NON_NULL, c_UsedDefaultCharNonNULL);
        DDX_Control(pDX, IDC_MB_USEGLYPHCHARS, c_MB_USEGLYPHCHARS);
        DDX_Control(pDX, IDC_MB_PRECOMPOSED, c_MB_PRECOMPOSED);
        DDX_Control(pDX, IDC_MB_ERR_INVALID_CHARS, c_MB_ERR_INVALID_CHARS);
        DDX_Control(pDX, IDC_MB_COMPOSITE, c_MB_COMPOSITE);
        DDX_Control(pDX, IDC_ISTEXTUNICODE, c_IsTextUnicode);
        DDX_Control(pDX, IDC_ISDBCSLEADBYTEEX, c_IsDBCSLeadByteEx);
        DDX_Control(pDX, IDC_ISDBCSLEADBYTE, c_IsDBCSLeadByte);
        DDX_Control(pDX, IDC_DEFAULTCHAR_THIS, c_DefaultCharUseThis);
        DDX_Control(pDX, IDC_DEFAULTCHAR_NULL, c_DefaultCharUseNULL);
        DDX_Control(pDX, IDC_DEFAULTCHAR_CAPTION, x_DefaultChar);
        DDX_Control(pDX, IDC_DEFAULT_GETCPINO, c_DefaultCharUseGetCPInfo);
        DDX_Control(pDX, IDC_DEFAULT_CHAR_VALUE, c_DefaultCharValue);
        DDX_Control(pDX, IDC_CODEPAGE, c_CodePage);
        DDX_Control(pDX, IDC_ARROW_BOX, c_Arrow);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMultiByte, CFunction)
        //{{AFX_MSG_MAP(CMultiByte)
        ON_EN_CHANGE(IDC_DEFAULT_CHAR_VALUE, OnChangeDefaultCharValue)
        ON_BN_CLICKED(IDC_DEFAULT_GETCPINO, OnDefaultGetcpino)
        ON_CBN_SELENDOK(IDC_CODEPAGE, OnSelendokCodepage)
        ON_BN_CLICKED(IDC_DEFAULTCHAR_CAPTION, OnDefaultcharCaption)
        ON_BN_CLICKED(IDC_DEFAULTCHAR_NULL, OnDefaultcharNull)
        ON_BN_CLICKED(IDC_DEFAULTCHAR_THIS, OnDefaultcharThis)
        ON_BN_CLICKED(IDC_ISDBCSLEADBYTE, OnIsdbcsleadbyte)
        ON_BN_CLICKED(IDC_ISDBCSLEADBYTEEX, OnIsdbcsleadbyteex)
        ON_BN_CLICKED(IDC_ISTEXTUNICODE, OnIstextunicode)
        ON_BN_CLICKED(IDC_MB_COMPOSITE, OnMbComposite)
        ON_BN_CLICKED(IDC_MB_ERR_INVALID_CHARS, OnMbErrInvalidChars)
        ON_BN_CLICKED(IDC_MB_PRECOMPOSED, OnMbPrecomposed)
        ON_BN_CLICKED(IDC_MB_USEGLYPHCHARS, OnMbUseglyphchars)
        ON_BN_CLICKED(IDC_USED_NON_NULL, OnUsedNonNull)
        ON_BN_CLICKED(IDC_USEDDEFAULTCHAR_NULL, OnUseddefaultcharNull)
        ON_BN_CLICKED(IDC_WC_COMPOSITECHECK, OnWcCompositecheck)
        ON_BN_CLICKED(IDC_WC_DEFAULTCHAR, OnWcDefaultchar)
        ON_BN_CLICKED(IDC_WC_DISCARDNS, OnWcDiscardns)
        ON_BN_CLICKED(IDC_WC_NO_BEST_FIT_CHARS, OnWcNoBestFitChars)
        ON_BN_CLICKED(IDC_WC_SEPCHARS, OnWcSepchars)
        ON_BN_CLICKED(IDC_WIDECHARTOMULTIBYTE, OnWidechartomultibyte)
        ON_BN_CLICKED(IDC_MULTIBYTETOWIDECHAR, OnMultibytetowidechar)
        ON_BN_CLICKED(IDC_VS6, OnVs6)
        ON_BN_CLICKED(IDC_VS7, OnVs7)
        ON_BN_CLICKED(IDC_CP_INSTALLED, OnCpInstalled)
        ON_BN_CLICKED(IDC_CP_SUPPORTED, OnCpSupported)
        ON_EN_CHANGE(IDC_WIDE, OnChangeWide)
        ON_EN_CHANGE(IDC_WIDEHEX, OnChangeWidehex)
        ON_NOTIFY(EN_SELCHANGE, IDC_WIDE, OnSelchangeWide)
        ON_WM_VSCROLL()
        ON_BN_CLICKED(IDC_ARROW_BOX, OnArrowBox)
        ON_NOTIFY(EN_SETFOCUS, IDC_MULTIBYTE, OnSetfocusMultibyte)
        ON_NOTIFY(EN_SETFOCUS, IDC_MULTIBYTE_HEX, OnSetfocusMultibyteHex)
        ON_NOTIFY(EN_SELCHANGE, IDC_MULTIBYTE_HEX, OnSelchangeMultibyteHex)
        ON_NOTIFY(EN_SELCHANGE, IDC_MULTIBYTE, OnSelchangeMultibyte)
        ON_CBN_SELENDOK(IDC_MULTIBYTE_HISTORY, OnSelendokMultibyteHistory)
        ON_CBN_SELENDOK(IDC_WIDE_HISTORY, OnSelendokWideHistory)
        ON_NOTIFY(EN_SELCHANGE, IDC_WIDEHEX, OnSelchangeWidehex)
        ON_EN_CHANGE(IDC_MULTIBYTE_HEX, OnChangeMultibyteHex)
        ON_EN_CHANGE(IDC_MULTIBYTE, OnChangeMultibyte)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiByte message handlers

void CMultiByte::OnChangeDefaultCharValue() 
   {
    updateControls();
    Refresh();
   }

void CMultiByte::OnDefaultGetcpino() 
   {
    updateControls();
    Refresh();
   }

void CMultiByte::OnSelendokCodepage() 
   {
    ShowDBCSLeadByte();
    updateControls();
    Refresh();
   }

void CMultiByte::OnDefaultcharCaption() 
   {
    updateControls();
    Refresh();
   }

void CMultiByte::OnDefaultcharNull() 
   {
    updateControls();
    Refresh();
   }

void CMultiByte::OnDefaultcharThis() 
   {
    updateControls();
    Refresh();
   }

void CMultiByte::OnIsdbcsleadbyte() 
   {
    c_Error.SetWindowText(_T(""));
    ShowDBCSLeadByte();
    updateControls();
    Refresh();
   }

void CMultiByte::OnIsdbcsleadbyteex() 
   {
    c_Error.SetWindowText(_T(""));
    ShowDBCSLeadByte();
    updateControls();
    Refresh();
   }

void CMultiByte::OnIstextunicode() 
   {
    c_Error.SetWindowText(_T(""));
    DoIsTextUnicode();
    updateControls();
    Refresh();
   }

void CMultiByte::OnMbComposite() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnMbErrInvalidChars() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnMbPrecomposed() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnMbUseglyphchars() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnUsedNonNull() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnUseddefaultcharNull() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnWcCompositecheck() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnWcDefaultchar() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnWcDiscardns() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnWcNoBestFitChars() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnWcSepchars() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnWidechartomultibyte() 
   {
    updateControls();
    Refresh();
   }

void CMultiByte::OnMultibytetowidechar() 
   {
    updateControls();
    Refresh();
   }

void CMultiByte::OnVs6() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

void CMultiByte::OnVs7() 
   {
    c_Error.SetWindowText(_T(""));
    updateControls();
    Refresh();
   }

/****************************************************************************
*                         CMultiByte::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CMultiByte::updateControls()
    {
     UINT mb = SW_HIDE;
     UINT wc = SW_HIDE;
     UINT flags = SW_HIDE;
     UINT ver = SW_HIDE;

     //-----------------------------------------------------------------------------
     // +--API-----------------------------------------------------------------+
     // | (*) WideCharToMultiByte   ( ) IsDBCSLeadByte    ( ) IsTextUnicode    |
     // | ( ) MultiByteToWideChar   ( ) IsDBCSLeadByteEx                       |
     // +----------------------------------------------------------------------+
     //-----------------------------------------------------------------------------
     if(c_WideCharToMultiByte.GetCheck() == BST_CHECKED)
        { /* down */
         c_Arrow.SetDirection(DrawArrow::ARROW_S);
         c_Arrow.ShowWindow(SW_SHOW);
         wc = SW_SHOW;
         flags = SW_SHOW;
         ver = SW_SHOW;
        } /* down */
     else
     if(c_MultiByteToWideChar.GetCheck() == BST_CHECKED)
        { /* up */
         c_Arrow.SetDirection(DrawArrow::ARROW_N);
         c_Arrow.ShowWindow(SW_SHOW);
         mb = SW_SHOW;
         flags = SW_SHOW;
         ver = SW_SHOW;
        } /* up */
     else
        { /* neither */
         c_Arrow.ShowWindow(SW_HIDE);
        } /* neither */

     //----------------
     // Wide enabled
     //----------------
     BOOL enable = TRUE;
     if(c_IsDBCSLeadByte.GetCheck() == BST_CHECKED ||
        c_IsDBCSLeadByteEx.GetCheck() == BST_CHECKED)
        enable = FALSE;

     c_Wide.EnableWindow(enable);
     c_WideHex.EnableWindow(enable);

     //----------------------------------------------------------------
     // +---dwFlags------------------------------------------+
     // | [x] MB_PRECOMPOSED        [x] WC_NO_BST_FIT_CHARS  |
     // | [x] MB_COMPOSITE          [x] WC_COMPOSITECHECK    |
     // | [x] MB_ERR_INVALID_CHARS  [x] WC_DISCARDNS         |
     // | [x] MB_USEGLYPHCHARS      [x] WC_SEPCHARS          |
     // |                           [x] WC_DEFAULTCHAR       |
     // +----------------------------------------------------+
     //----------------------------------------------------------------
     c_MB_PRECOMPOSED.ShowWindow(mb);
     c_MB_COMPOSITE.ShowWindow(mb);
     c_MB_ERR_INVALID_CHARS.ShowWindow(mb);
     c_MB_USEGLYPHCHARS.ShowWindow(mb);

     c_WC_NO_BEST_FIT_CHARS.ShowWindow(wc);
     c_WC_COMPOSITECHECK.ShowWindow(wc);
     c_WC_DISCARDNS.ShowWindow(wc);
     c_WC_SEPCHARS.ShowWindow(wc);
     c_WC_DEFAULTCHAR.ShowWindow(wc);
     
     x_dwFlags.ShowWindow(flags);

     //----------------------------------------------------------------
     // +--lpdDefault--------+
     // | (*) NULL           |
     // | ( ) Use This [x]   |
     // | ( ) GetCPInfo      |
     // +--------------------+
     //----------------------------------------------------------------
     x_DefaultChar.ShowWindow(wc);
     c_DefaultCharUseNULL.ShowWindow(wc);
     c_DefaultCharUseThis.ShowWindow(wc);
     c_DefaultCharValue.ShowWindow(wc);
     c_DefaultCharUseGetCPInfo.ShowWindow(wc);
     c_DefaultCharValue.EnableWindow(c_DefaultCharUseThis.GetCheck() == BST_CHECKED);

     //----------------------------------------------------------------
     // +--lpUsedDefault-----+
     // | (*) NULL           |
     // | ( ) Variable       |
     // +--------------------+
     //----------------------------------------------------------------
     x_UsedDefaultChar.ShowWindow(wc);
     c_UsedDefaultCharNULL.ShowWindow(wc);
     c_UsedDefaultCharNonNULL.ShowWindow(wc);

     //----------------------------------------------------------------
     // +--Version-----+
     // | (*) VS6      |
     // | ( ) VS .NET  |
     // +--------------+
     //----------------------------------------------------------------
     x_Version.ShowWindow(ver);
     c_VS6.ShowWindow(ver);
     c_VS7.ShowWindow(ver);

     CString msg;
     c_Error.GetWindowText(msg);
     c_Error.ShowWindow(msg.IsEmpty() ? SW_HIDE : SW_SHOW);
     
    } // CMultiByte::updateControls

/****************************************************************************
*                            CMultiByte::GetFlags
* Inputs:
*       CString & options: Options to fill in
*       DWORD & flags: BInary flags to set
*       const CString & or: OR operator
* Result: void
*       
* Effect: 
*       Sets the flags
****************************************************************************/

void CMultiByte::GetFlags(CString & options, DWORD & flags, const CString & or)
    {
     if(c_WideCharToMultiByte.GetCheck() == BST_CHECKED)
        { /* WideCharToMultiByte */
         ADDFLAG(WC_NO_BEST_FIT_CHARS);
         ADDFLAG(WC_COMPOSITECHECK);
         ADDFLAG(WC_DISCARDNS);
         ADDFLAG(WC_SEPCHARS);
         ADDFLAG(WC_DEFAULTCHAR);
        } /* WideCharToMultiByte */
     else
     if(c_MultiByteToWideChar.GetCheck() == BST_CHECKED)
        { /* MultiByteToWideChar */
         ADDFLAG(MB_PRECOMPOSED);
         ADDFLAG(MB_COMPOSITE);
         ADDFLAG(MB_ERR_INVALID_CHARS);
         ADDFLAG(MB_USEGLYPHCHARS);
        } /* MultiByteToWideChar */

     if(options.IsEmpty())
        options = _T("0");
    } // CMultiByte::GetFlags

/****************************************************************************
*                             CMultiByte::GetLCID
* Inputs:
*       CString & localeName:
*       LCID & lcid
* Result: void
*       
* Effect: 
*       Retries the locale name and the LCID
****************************************************************************/

void CMultiByte::GetLCID(CString & localeName, LCID & lcid)
    {
     lcid = QueryLocale();

     localeName = GetLCIDString(lcid);
    } // CMultiByte::GetLCID

/****************************************************************************
*                         CMultiByte::GetCodePageInfo
* Inputs:
*       UINT & cp: Codepage number is stored here
*       CString & CodePage: Codepage name is stored here
* Result: void
*       
* Effect: 
*       Extracts the code page and name from the combo box info
****************************************************************************/

void CMultiByte::GetCodePageInfo(UINT & cp, CString & CodePage, CString & CodePageComment)
    {
     int sel = c_CodePage.GetCurSel();

     cp = c_CodePage.GetCodePage(sel);

     CodePage = c_CodePage.GetCodePageName(sel);

     // The name is of the form
     // A. 00000 (name)
     // B. 00000 CP_name
     // C. 00000
     if(CodePage.Find(_T("(")) >= 0)
        { /* A. */
         CodePageComment = CodePage;
         CodePage.Format(_T("%u"), cp);
        } /* A. */
     else
        if(CodePage.Find(_T("CP_")) >= 0)
           { /* B */
            int n = CodePage.Find(_T("CP_"));
            CodePageComment = CodePage;
            CodePage = CodePage.Mid(n);
           } /* B */
        else
           { /* C */
            CodePageComment = CodePage;
            CodePage.Format(_T("%u"), cp);
           } /* C */
     
    } // CMultiByte::GetCodePageInfo

/****************************************************************************
*                             CMultiByte::Refresh
* Result: void
*       
* Effect: 
*       Updates the generated code display and the contents
****************************************************************************/

void CMultiByte::Refresh()
    {
     if(!initialized)
        return;
     
     EnableQuery(QUERY_USE_CP_ACP, FALSE);
     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_DWORD, FALSE);

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;
     CString ver;
     if(c_VS6.GetCheck() == BST_CHECKED)
        ver = _T("6");

     if(c_VS7.GetCheck() == BST_CHECKED)
        ver = _T("7");


     if(c_MultiByteToWideChar.GetCheck() == BST_CHECKED)
        { /* MultiByteToWideChar */
         CString name = CString(_T("[MultiByteToWideChar:")) + ver + CString(_T("]"));
         fmt = QueryTemplate(name);
        } /* MultiByteToWideChar */
     else
     if(c_WideCharToMultiByte.GetCheck() == BST_CHECKED)
        { /* MultiByteToWideChar */
         // Variants:
         // UsedDefault         Default         variant
         //---------------------------------------------
         //   NULL              NULL            NN
         //   NULL              specific        NS
         //   NULL              GetCPInfo       NG
         //   ~NULL             NULL            UN
         //   ~NULL             specific        US
         //   ~NULL             GetCPInfo       UG
         if(c_UsedDefaultCharNULL.GetCheck() == BST_CHECKED)
            { /* ~/NS/NG */
             ver += _T("N");
            } /* ~/NS/NG */
         else
         if(c_UsedDefaultCharNonNULL.GetCheck() == BST_CHECKED)
            { /* U/US/UG */
             ver += _T("U");
            } /* U/US/UG */
         else
            { /* error */
             ASSERT(FALSE); 
             ver += _T("N");
            } /* error */

         if(c_DefaultCharUseNULL.GetCheck() == BST_CHECKED)
            { /* NN/UN */
             ver += _T("N");
            } /* NN/UN */
         else
         if(c_DefaultCharUseThis.GetCheck() == BST_CHECKED)
            { /* NS/US */
             ver += _T("S");
            } /* NS/US */
         else
         if(c_DefaultCharUseGetCPInfo.GetCheck() == BST_CHECKED)
            { /* NG/UG */
             ver += _T("G");
            } /* NG/UG */
         else
            { /* error */
             ver += _T("N");
             ASSERT(FALSE);
            } /* error */

         fmt = QueryTemplate(_T("[WideCharToMultiByte:") + ver + _T("]"));
        } /* MultiByteToWideChar */
     else
     if(c_IsDBCSLeadByte.GetCheck() == BST_CHECKED)
        { /* IsDBCSLeadByte */
         fmt = QueryTemplate(_T("[IsDBCSLeadByte]"));
        } /* IsDBCSLeadByte */
     else
     if(c_IsDBCSLeadByteEx.GetCheck() == BST_CHECKED)
        { /* IsDBCSLeadByteEx */
         fmt = QueryTemplate(_T("[IsDBCSLeadByteEx]"));
        } /* IsDBCSLeadByteEx */
     else
     if(c_IsTextUnicode.GetCheck() == BST_CHECKED)
        { /* IsTextUnicode */
         fmt = QueryTemplate(_T("[IsTextUnicode]"));
        } /* IsTextUnicode */
     else
        ASSERT(FALSE);

     //----------------------------------------------------------------
     // %1: LCID
     //----------------------------------------------------------------
     CString localeName;
     LCID lcid;
     GetLCID(localeName, lcid);

     //----------------------------------------------------------------
     // %2: The CodePage as a comment string
     //----------------------------------------------------------------
     // Computed with %9, below

     //----------------------------------------------------------------
     // %3: dwFlags
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;
     GetFlags(options, flags, or);
     
     //----------------------------------------------------------------
     // %4: 
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %5: variable name
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %6: Decimal flags
     //----------------------------------------------------------------
     CString flagsDecimal;
     flagsDecimal.Format(_T("%u"), flags);

     //----------------------------------------------------------------
     // %7: OR
     //----------------------------------------------------------------
     // Already set up, above

     //----------------------------------------------------------------
     // %8: Decimal locale
     //----------------------------------------------------------------
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);
     
     //----------------------------------------------------------------
     // %9: CodePage name
     //----------------------------------------------------------------
     int sel = c_CodePage.GetCurSel();
     if(sel == CB_ERR)
        sel = 0;

     UINT cp;
     CString CodePage;
     CString CodePageComment;

     GetCodePageInfo(cp, CodePage, CodePageComment);

     //----------------------------------------------------------------
     // %10: CodePage decimal value
     //----------------------------------------------------------------
     CString codePageDecimal;
     codePageDecimal.Format(_T("%u"), cp);
     

     //----------------------------------------------------------------
     // %11: String to to convert
     //----------------------------------------------------------------
     CString text;
     c_Wide.GetWindowText(text);
     CString wc;
     
     wc = text;
     EnEscape(wc, TRUE);

     //----------------------------------------------------------------
     // %12: The default character to use
     //----------------------------------------------------------------
     CString defChar;
     c_DefaultCharValue.GetWindowText(defChar);
     if(defChar.IsEmpty())
        { /* set default */
         defChar = _T("?");
         c_DefaultCharValue.SetWindowText(defChar);
        } /* set default */

     //----------------------------------------------------------------
     // %13: Lead Byte
     //----------------------------------------------------------------
     CString selection;
     BYTE leadbyte;
     
     if(GetSelectedByte(selection))
        leadbyte = (BYTE)selection[0];
     else
        leadbyte = 0;

     CString LeadByte;
     LeadByte.Format(_T("%d"), leadbyte);
     
     //----------------------------------------------------------------
     // %14: Lead Byte Hex
     //----------------------------------------------------------------
     CString LeadByteHex;
     LeadByteHex.Format(_T("%02x"), leadbyte);
     //-----------------------------------------------------------------------------
     //                      %1               %2             %3       %4      %5         %6        %7        %8          %9           %10       %11    %12      %13
     text.FormatMessage(fmt, localeName, CodePageComment, options, _T(""), variable, flagsDecimal, or, localeDecimal, CodePage, codePageDecimal, wc, defChar, LeadByte);

     BOOL enable = TRUE;
     SetCode(text, enable);
    } // CMultiByte::Refresh

/****************************************************************************
*                        CMultiByte::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font
****************************************************************************/

void CMultiByte::SetFontToControls()
    {
#ifdef _UNICODE
     c_Wide.SetFont(&UnicodeFont);
     c_WideHistory.SetFont(&UnicodeFont);
     c_FontData.SetFont(&UnicodeFont);
#endif
     LOGFONT lf;
     UnicodeFont.GetLogFont(&lf);
     // See if we have a negative or positive sign
     int low;
     int high;
     c_ZoomWide.GetRange(low, high);

     if(lf.lfHeight < 0 && low > 0)  
        { /* swap to negative*/
         // low == 1, high == 150
         c_ZoomWide.SetRange32(-low, -high);
        } /* swap to negative*/
     else
     if(lf.lfHeight > 0 && low < 0)
        { /* swap to positive */
         // low == -1, high == -150
         c_ZoomWide.SetRange32(-low, -high);
        } /* swap to positive */
     c_ZoomWide.SetPos32(lf.lfHeight);
    } // CMultiByte::SetFontToControls


/****************************************************************************
*                          CMultiByte::OnInitDialog
* Result: void
*       
* Effect: 
*       Initializes controls
****************************************************************************/

BOOL CMultiByte::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    CheckRadioButton(IDC_WIDECHARTOMULTIBYTE, IDC_ISTEXTUNICODE, IDC_WIDECHARTOMULTIBYTE);
    CheckRadioButton(IDC_DEFAULTCHAR_NULL, IDC_DEFAULT_GETCPINO, IDC_DEFAULTCHAR_NULL);
    CheckRadioButton(IDC_USEDDEFAULTCHAR_NULL, IDC_USED_NON_NULL, IDC_USEDDEFAULTCHAR_NULL);
    CheckRadioButton(IDC_VS6, IDC_VS7, IDC_VS6);
    CheckRadioButton(IDC_CP_INSTALLED, IDC_CP_SUPPORTED, IDC_CP_INSTALLED);
    CheckRadioButton(IDC_USEDDEFAULTCHAR_NULL, IDC_USED_NON_NULL, IDC_USEDDEFAULTCHAR_NULL);

    c_DefaultCharValue.SetLimitText(1);
    
    c_Wide.SetEventMask(ENM_CHANGE | ENM_SELCHANGE | c_Wide.GetEventMask());
    c_WideHex.SetEventMask(ENM_CHANGE | ENM_SELCHANGE | ENM_PROTECTED | c_WideHex.GetEventMask());

    c_MultiByte.SetEventMask(ENM_CHANGE | ENM_SELCHANGE | c_MultiByte.GetEventMask());
    c_MultiByteHex.SetEventMask(ENM_CHANGE | ENM_SELCHANGE | ENM_PROTECTED | c_MultiByteHex.GetEventMask());
#ifdef RICHEDIT30
    c_ZoomWide.SetRange32(1, 64*64);
    c_ZoomWide.SetPos32(64);
#else
    c_ZoomWide.SetRange32(5, 150);
    c_ZoomWide.SetPos32(15);
#endif

    //----------------------------------------------------------------
    // Set the initial default character
    //----------------------------------------------------------------
    CPINFO info;
    if(!::GetCPInfo(CP_ACP, &info)) // CP_ACP
       { /* failed */
        DWORD err = ::GetLastError();
        info.DefaultChar[0] = _T('?');
       } /* failed */
    CString def((TCHAR)info.DefaultChar[0]);
    c_DefaultCharValue.SetWindowText(def);
    c_MultiByteHex.SetModeA();

    UpdateCodePageList();
    updateControls();
        
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                        CMultiByte::EnumCodePagesProc
* Inputs:
*       LPTSTR codepage:
* Result: BOOL
*       TRUE, always
* Effect: 
*       Adds a codepage to the list
* Notes:
*       THIS IS NOT THREAD-SAFE! Due to terminal brain-damage on the part
*       of Microsoft, it is impossible to pass an additional parameter
*       into this enumerator!
****************************************************************************/
/* static */ CMultiByte * CMultiByte::Self = NULL;

/* static */ BOOL CALLBACK CMultiByte::EnumCodePagesProc(LPTSTR codepage)
    {
     UINT cp = _ttoi(codepage);
     CPINFOEX info;
     CString s;

     if(GetCPInfoEx(cp, 0, &info))
        { /* got it */
         s.Format(_T("%s"), info.CodePageName);
        } /* got it */
     else
        { /* failed */
         s.Format(_T("%u"), cp);
        } /* failed */

     Self->c_CodePage.AddString(s, cp);
     return TRUE;
    } // CMultiByte::EnumCodePagesProc


/****************************************************************************
*                       CMultiByte::UpdateCodePageList
* Result: void
*       
* Effect: 
*       Updates the code page list
****************************************************************************/

void CMultiByte::UpdateCodePageList()
    {
     c_CodePage.ResetContent();
     
     DWORD flags = 0;
     Self = this;
     if(c_CP_INSTALLED.GetCheck() == BST_CHECKED)
        flags = CP_INSTALLED;
     else
     if(c_CP_SUPPORTED.GetCheck() == BST_CHECKED)
        flags = CP_SUPPORTED;
     else
        ASSERT(FALSE);

     int n = c_CodePage.GetCurSel();
     UINT cp = CP_ACP;
     if(n != CB_ERR)
        cp = c_CodePage.GetCodePage(n);
        
     if(!::EnumSystemCodePages(EnumCodePagesProc, flags))
        { /* failed */
         DWORD err = ::GetLastError();
        } /* failed */

#define ADDSTOCKPAGE(x) { \
                        CString s; \
                        s.Format(_T("%d %s"), (x), _T(#x)); \
                        int n = c_CodePage.SupersedeString(s, (x)); \
                       }
     
     ADDSTOCKPAGE(CP_ACP);
     ADDSTOCKPAGE(CP_MACCP);
     ADDSTOCKPAGE(CP_OEMCP);
     ADDSTOCKPAGE(CP_SYMBOL);
     ADDSTOCKPAGE(CP_THREAD_ACP);
     ADDSTOCKPAGE(CP_UTF7);
     ADDSTOCKPAGE(CP_UTF8);
     
     n = c_CodePage.Select(cp);  // try for selection
     if(n == CB_ERR)
        c_CodePage.Select(CP_ACP);

     c_Error.ShowWindow(c_Error.GetWindowTextLength() > 0 ? SW_SHOW : SW_HIDE);
        
    } // CMultiByte::UpdateCodePageList

void CMultiByte::OnCpInstalled() 
   {
    UpdateCodePageList();
    updateControls();
    Refresh();
   }

void CMultiByte::OnCpSupported() 
   {
    UpdateCodePageList();
    updateControls();
    Refresh();
   }

/****************************************************************************
*                          CMultiByte::OnChangeWide
* Result: void
*       
* Effect: 
*       A character has been changed in the input control. Reflect
*       it in the hex display
****************************************************************************/

void CMultiByte::OnChangeWide() 
   {
    WideHelper::OnChangeWide(c_Wide, c_WideHex);

    CString s;
    c_Wide.GetWindowText(s);

    c_FontData.Fill(s);

    Refresh();
   }

/****************************************************************************
*                         CMultiByte::OnChangeWideHex
* Result: void
*       
* Effect: 
*       A change was made in the hex window. Replace the characters in
*       the input window
****************************************************************************/

void CMultiByte::OnChangeWidehex() 
   {
    CString s;
    long low;
    long high;
    c_Wide.GetSel(low, high);
    MB_TRACE2("=>CMultiByte::OnChangeWidehex() sel=[%d, %d]\n", low, high);
        c_WideHex.GetWindowText(s);

        MB_TRACE1("=>CMultiByte::OnChangeWidehex!c_Wide.SetWindowTextNoNotify(\"%s\")\n", s);
        c_Wide.SetWindowTextNoNotify(s);
        MB_TRACE0("<=CMultiByte::OnChangeWidehex!c_Wide.SetWindowTextNoNotify\n");

        MB_TRACE2("=>CMultiByte::OnChangeWidehex!c_Wide.SetSelNoNotify(%d, %d)\n", low, high);
        c_Wide.SetSelNoNotify(low, high);
        MB_TRACE0("<=CMultiByte::OnChangeWidehex!c_Wide.SetSelNoNotify\n");

        c_FontData.Fill(s);
        Refresh();
    MB_TRACE0("<=CMultiByte::OnChangeWidehex\n");
   }

/****************************************************************************
*                         CMultiByte::OnSelchangeWide
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Causes concurrent selection to appear in hex control
****************************************************************************/

void CMultiByte::OnSelchangeWide(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    SELCHANGE *pSelChange = reinterpret_cast<SELCHANGE *>(pNMHDR);
    // TODO: The control will not send this notification unless you override the
    // CFunction::OnInitDialog() function to send the EM_SETEVENTMASK message
    // to the control with the ENM_SELCHANGE flag ORed into the lParam mask.
        
    WideHelper::OnSelChangeWide(c_Wide, c_WideHex);
    *pResult = 0;
   }

/****************************************************************************
*                            CMultiByte::OnVScroll
* Inputs:
*       UINT nSBCode:
*       UINT nPos:
*       CScrollBar * pScrollBar: NULL for built-in scrollbar, non-NULL for
*                       spin controls
* Result: void
*       
* Effect: 
*       If the zoom control, zooms the font size
****************************************************************************/

void CMultiByte::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
   {
    if(pScrollBar == NULL)
       { /* default SB_VERT */
        CFunction::OnVScroll(nSBCode, nPos, pScrollBar);
        return;
       } /* default SB_VERT */
    if(pScrollBar == (CScrollBar *)&c_ZoomWide)
       { /* zoom wide */
#ifdef RICHEDIT30
        // ratio is 1/64..64*64/64
        c_Wide.SetZoom(c_ZoomWide.GetPos32(), 64);
#else
        MB_TRACE0("=>CMultiByte::OnVScroll\n");
        CFont * f;
        f = c_Wide.GetFont();
#ifdef _UNICODE
        if(f == NULL)
            f = &UnicodeFont;
#else
        if(f == NULL)
            f = CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT));
#endif
        LOGFONT lf;
        f->GetLogFont(&lf);
        lf.lfHeight = c_ZoomWide.GetPos32();
        if(zoomFont.m_hObject != NULL)
           zoomFont.DeleteObject();
        zoomFont.CreateFontIndirect(&lf);
        long wlow;
        long whigh;
        c_Wide.GetSel(wlow, whigh);

        long hlow;
        long hhigh;
        c_WideHex.GetRawSel(hlow, hhigh);

        c_Wide.SetFont(&zoomFont);

        c_Wide.SetSelNoNotify(wlow, whigh);
        c_WideHex.SetRawSel(hlow, hhigh);
        MB_TRACE0("<=CMultiByte::OnVScroll\n");
#endif
       } /* zoom wide */
   }

/****************************************************************************
*                      CMultiByte::DoMultiByteToWideChar
* Result: void
*       
* Effect: 
*       Does MultiByteToWideChar
****************************************************************************/

void CMultiByte::DoMultiByteToWideChar()
    {
     //----------------------------------------------------------------
     // Retrieve the code page number
     //----------------------------------------------------------------
     int n = c_CodePage.GetCurSel();
     UINT cp = CP_ACP;
     if(n != CB_ERR)
        cp = c_CodePage.GetCodePage(n);

     CString wc;

     CString mbs;
     c_MultiByte.GetWindowText(mbs);

     CByteArray mb;

     for(int i = 0; i < mbs.GetLength(); i++)
        { /* reduce to 8-bit */
         mb.Add((BYTE)mbs[i]);
        } /* reduce to 8-bit */
     mb.Add((BYTE)0);

     DWORD flags = 0;
     CString ignored;
     GetFlags(ignored, flags, _T(""));

     int count = ::MultiByteToWideChar(cp, flags, (LPCSTR)mb.GetData(), -1, NULL, 0);
     if(count == 0)
        { /* failed */
         DWORD err = ::GetLastError();
         CString msg = ErrorString(err);
         c_Error.SetWindowText(msg);
         updateControls();
         return;
        } /* failed */

     LPWSTR pwc = wc.GetBuffer(count);
     count = ::MultiByteToWideChar(cp, flags, (LPCSTR)mb.GetData(), -1, pwc, count);
     if(count == 0)
        { /* failed again */
         DWORD err = ::GetLastError();
         CString msg = ErrorString(err);
         wc.ReleaseBuffer();
         c_Error.SetWindowText(msg);
         updateControls();
         return;
        } /* failed again */

     wc.ReleaseBuffer();
     
     c_MultiByteHistory.InsertConditionally(0, new History(mbs));

     CString fmt;
     fmt.LoadString(IDS_MULTIBYTETOWIDECHAR_COUNT);
     CString msg;
     msg.Format(fmt, count);
     c_Error.SetWindowText(msg);

     MB_TRACE1("=>CMultiByte::DoMultiByteToWideChar!c_Wide.SetWindowText(\"%s\")\n", wc);
     c_Wide.SetWindowText(wc);
     MB_TRACE0("<=CMultiByte::DoMultiByteToWideChar!c_Wide.SetWindowText\n");
     
     MB_TRACE1("=>CMultiByte::DoMultiByteToWideChar!c_WideHistory.SetWindowText(\"%s\")\n", wc);
     c_WideHex.SetWindowText(wc, 0, 0, FALSE);
     MB_TRACE0("<=CMultiByte::DoMultiByteToWideChar!c_WideHistory.SetWindowText\n");

     c_WideHistory.InsertConditionally(0, new History(wc));

     updateControls();
     
    } // CMultiByte::DoMultiByteToWideChar

/****************************************************************************
*                      CMultiByte::DoWideCharToMultiByte
* Result: void
*       
* Effect: 
*       Executes a WideCharToMultiByte
* Notes:
*       As of coding this, I am no longer making any attempt to allow a
*       non-Unicode version to be built.
****************************************************************************/

void CMultiByte::DoWideCharToMultiByte()
    {
     CString wc;
     c_Wide.GetWindowText(wc);
     LPSTR defaultChar = NULL;
     LPBOOL pUsedDefaultChar = NULL;
     BOOL UsedDefaultChar;
     DWORD flags = 0;
     CString ignored;
     GetFlags(ignored, flags, _T(""));
     char chars[2]; // 8-bit character
     CPINFO info;

     //----------------------------------------------------------------
     // Retrieve the code page number
     //----------------------------------------------------------------
     int n = c_CodePage.GetCurSel();
     UINT cp = CP_ACP;
     if(n != CB_ERR)
        cp = c_CodePage.GetCodePage(n);

     //----------------------------------------------------------------
     // +--lpUsedDefaultChar---+
     // | (*) NULL             |
     // | ( ) Variable         |
     // +----------------------+
     //----------------------------------------------------------------
     if(c_UsedDefaultCharNULL.GetCheck() == BST_CHECKED)
        { /* NULL */
         pUsedDefaultChar = NULL;
        } /* NULL */
     else
     if(c_UsedDefaultCharNonNULL.GetCheck() == BST_CHECKED)
        { /* Non-NULL */
         pUsedDefaultChar = &UsedDefaultChar;
        } /* Non-NULL */

     //----------------------------------------------------------------
     // +--lpDefaultChar-----+
     // | (*) NULL           |
     // | ( ) Use This  [?]  |
     // | ( ) Use GetCPInfo  |
     // +--------------------+
     //----------------------------------------------------------------
     if(c_DefaultCharUseNULL.GetCheck() == BST_CHECKED)
        defaultChar = NULL;
     else
     if(c_DefaultCharUseThis.GetCheck() == BST_CHECKED)
        { /* use this */
         CString defchar;
         c_DefaultCharValue.GetWindowText(defchar);
         int n = ::WideCharToMultiByte(cp, 0, (LPCWSTR)defchar, -1, defaultChar, 2, NULL, NULL);
         if(n == 0)
            chars[0] = '?'; // 8-bit character
         defaultChar = chars;
        } /* use this */
     else
     if(c_DefaultCharUseGetCPInfo.GetCheck() == BST_CHECKED)
        { /* GetCPInfo */
         if(!GetCPInfo(cp, &info))
            { /* failed */
             chars[0] = '?'; // 8-bit character
             defaultChar = chars;
            } /* failed */
         else
            { /* got it */
             defaultChar = (LPSTR)info.DefaultChar;
            } /* got it */
        } /* GetCPInfo */

     //----------------------------------------------------------------
     // Now do the converison
     //----------------------------------------------------------------

     int count = ::WideCharToMultiByte(cp, flags, (LPCWSTR)wc, -1, NULL, 0, defaultChar, pUsedDefaultChar);
     if(count == 0)
        { /* failed */
         DWORD err = ::GetLastError();
         CString msg = ErrorString(err);
         c_Error.SetWindowText(msg);
         c_MultiByte.SetWindowText(_T(""));
         c_MultiByteHex.SetWindowText(_T(""), 0, 0);
         updateControls();
         return;
        } /* failed */
     
     CByteArray b;
     b.SetSize(count);
     count = ::WideCharToMultiByte(cp, flags, (LPCWSTR)wc, -1, (LPSTR)b.GetData(), count, defaultChar, pUsedDefaultChar);
     if(count == 0)
        { /* failed for real */
         DWORD err = ::GetLastError();
         CString msg = ErrorString(err);
         c_Error.SetWindowText(msg);
         c_MultiByte.SetWindowText(_T(""));
         c_MultiByteHex.SetWindowText(_T(""), 0, 0);
         updateControls();
         return;
        } /* failed for real */

     c_WideHistory.InsertConditionally(0, new History(wc));

     if(pUsedDefaultChar != NULL)
        { /* record success */
         //----------------------------------------------------------------
         // count = %d
         // lpUsedDefaultChar = %s
         //----------------------------------------------------------------
         CString fmt;
         fmt.LoadString(IDS_WIDECHARTOMULTIBYTE_USED);
         CString msg;
         CString truth;
         truth.LoadString(UsedDefaultChar ? IDS_TRUE : IDS_FALSE);
         msg.Format(fmt, count, truth);
         c_Error.SetWindowText(msg);
        } /* record success */
     else
        { /* record simple success */
         CString fmt;
         fmt.LoadString(IDS_WIDECHARTOMULTIBYTE_NOTUSED);
         CString msg;
         msg.Format(fmt, count);
         c_Error.SetWindowText(msg);
        } /* record simple success */

     // This string constuctor is based on the default conversion
     // from single-byte characters using CP_ACP
     int count2 = ::MultiByteToWideChar(CP_ACP, 0, (LPCSTR)b.GetData(), b.GetSize(), NULL, 0);
     if(count2 == 0)
        { /* deep trouble */
         ASSERT(FALSE);
         //.. put error message here
         updateControls();
         return;
        } /* deep trouble */

     //----------------------------------------------------------------
     // In order to display it, we have to convert from 8-bit characters
     // to wide characters. To do this, we use CP_ACP as the default
     // code page
     //----------------------------------------------------------------
     CString wc2;
     LPWSTR pwc = wc2.GetBuffer(count);
     for(int i = 0; i < count; i++)
        pwc[i] = (TCHAR)b[i];
     wc2.ReleaseBuffer();

     MB_TRACE1("=>CMultiByte::DoWideCharToMultiByte!c_MultiByte.SetWindowText(\"%s\")\n", wc2);
     c_MultiByte.SetWindowText(wc2);
     MB_TRACE0("<=CMultiByte::DoWideCharToMultiByte!c_MultiByte.SetWindowText\n");

     MB_TRACE1("=>CMultiByte::DoWideCharToMultiByte!c_MultiByteHex.SetWindowText(\"%s\", 0, 0)\n", wc2);
     c_MultiByteHex.SetWindowText(wc2, 0, 0);
     MB_TRACE0("<=CMultiByte::DoWideCharToMultiByte!c_MultiByteHex.SetWindowText\n");
     
     Highlight(cp,  c_MultiByte, c_MultiByteHex);
     c_MultiByteHistory.InsertConditionally(0, new History(wc2));
     updateControls();
    } // CMultiByte::DoWideCharToMultiByte

/****************************************************************************
*                           CMultiByte::OnArrowBox
* Result: void
*       
* Effect: 
*       Does the conversion
****************************************************************************/

void CMultiByte::OnArrowBox() 
   {
    if(c_WideCharToMultiByte.GetCheck() == BST_CHECKED)
       DoWideCharToMultiByte();
    else
    if(c_MultiByteToWideChar.GetCheck() == BST_CHECKED)
       DoMultiByteToWideChar();
   } // CMultiByte::OnArrowBox

#define COLOR_SHIFT_IN     RGB(255, 0, 255)
#define COLOR_SHIFT_OUT    RGB(255, 0, 255)
#define COLOR_DIRECT       RGB(0, 0, 0)
#define COLOR_ENCODE_EVEN  RGB(0, 0, 192)
#define COLOR_ENCODE_ODD   RGB(0, 144, 0)
#define COLOR_ENCODE_ERROR RGB(255, 0, 0)

/****************************************************************************
*                          CMultiByte::HighlightUTF8
* Inputs:
*       CRichEditCtrlEx & ctl: Control to highlight
*       CHexEditCtrlEx & hex: Control that holds hex
*       const CString & text: Text to highlight
* Result: void
*       
* Effect: 
*       Highlights the UTF8 encoding
* Notes:
*       From The Unicode Standard 3.0, page 47:
*
*     +--------------------------+----------+----------+----------+----------+
*     | Value                    |   1st    |   2nd    |   3rd    |   4th    |
*     +--------------------------+----------+----------+----------+----------+
*   D |        00000000 0xxxxxxx | 0xxxxxxx |##########|##########|##########|
*     +--------------------------+----------+----------+----------+----------+
*   A |        00000yyy yyxxxxxx | 110yyyyy | 10xxxxxx |##########|##########|
*     +--------------------------+----------+----------+----------+----------+
*   B |        zzzzyyyy yyxxxxxx | 1110zzzz | 10yyyyyy | 10xxxxxx |##########|
*     +--------------------------+----------+----------+----------+----------+
*   C |uuuuuzz zzzyyyyy yyxxxxxx | 11110uuu | 10uuzzzz | 10yyyyyy | 10xxxxxx |
*     +--------------------------+----------+----------+----------+----------+
****************************************************************************/

void CMultiByte::HighlightUTF8(CRichEditCtrlEx & ctl, CHexEditCtrl & hex, const CString & text)
    {
#ifndef _DEBUG // optimize flicker only in release version
     ctl.SetRedraw(FALSE);
#endif

     enum { ENCODE_DIRECT,
            ENCODE_A2,
            ENCODE_B2, ENCODE_B3,
            ENCODE_C2, ENCODE_C3, ENCODE_C4 } state;

     state = ENCODE_DIRECT;
     BOOL even = TRUE;
     
     for(int i = 0; i < text.GetLength(); i++)
        { /* scan string */
         BYTE b = (BYTE)text[i];
         switch(state)
            { /* state */
             //----------------
             // ENCODE_DIRECT
             //----------------             
             case ENCODE_DIRECT:
                if( (b & 0x80) == 0x80 )
                   { /* extended */
                    // 110yyyyy
                    // 1110zzzz
                    // 11110uuu
                    
                    if( (b & 0xF8) == 0xF0)
                       { /* 11110uuu:C */
                        state = ENCODE_C2;
                        SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                        hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                        hex.SetUnderline(i, TRUE);
                        continue;
                       } /* 11110uuu:C */

                    if( (b & 0xF0) == 0xE0) // 111?zzzz == 1110zzzz
                       { /* 1110zzzz:B */
                        state = ENCODE_B2;
                        SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                        hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                        hex.SetUnderline(i, TRUE);
                        continue;
                       } /* 1110zzzz:B */
                    if( (b & 0xE0) == 0xC0) // 11?yyyyy == 110yyyyy
                       { /* 110yyyy:A */
                        state = ENCODE_A2;
                        SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                        hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                        hex.SetUnderline(i, TRUE);
                        hex.UpdateWindow();
                        continue;
                       } /* 110yyyy:A */

                    //----------------
                    // errneous
                    //----------------
                    state = ENCODE_DIRECT;
                    SetTextColor(i, COLOR_ENCODE_ERROR, ctl);
                    hex.SetTextColor(i, COLOR_ENCODE_ERROR);
                    hex.SetUnderline(i, FALSE);
                   } /* extended */
                else
                   { /* direct */
                    SetTextColor(i, COLOR_DIRECT, ctl);
                    hex.SetTextColor(i, COLOR_DIRECT);
                    continue;
                   } /* direct */
             case ENCODE_A2:
#if 1
                if((b & 0xC0) == 0x80)
                   { /*  valid A2 */
                    state = ENCODE_DIRECT; // assume next byte will be direct until proven otherwise
                    SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                    hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                    hex.SetUnderline(i, FALSE);
                   } /*  valid A2 */
                else
                   { /* erroneous A2 */
                    state = ENCODE_DIRECT;
                    SetTextColor(i, COLOR_ENCODE_ERROR, ctl);
                    hex.SetTextColor(i, COLOR_ENCODE_ERROR);
                    hex.SetUnderline(i, FALSE);
                   } /* erroneous A2 */
#else
                state = ENCODE_DIRECT; // assume next byte will be direct until proven otherwise
                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, FALSE);
#endif
                even = !even;
                continue;
             case ENCODE_B2:
#if 1
                if((b & 0xC0) == 0x80)
                   { /*  valid B2 */
                    state = ENCODE_B3; 
                    SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                    hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                    hex.SetUnderline(i, TRUE);
                   } /*  valid B2 */
                else
                   { /* erroneous B2 */
                    state = ENCODE_DIRECT;
                    SetTextColor(i, COLOR_ENCODE_ERROR, ctl);
                    hex.SetTextColor(i, COLOR_ENCODE_ERROR);
                    hex.SetUnderline(i, FALSE);
                   } /* erroneous B2 */
#else
                state = ENCODE_B3; 
                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, TRUE);
#endif
                continue;
             case ENCODE_B3:
#if 1
                if((b & 0xC0) == 0x80)
                   { /*  valid B3 */
                    state = ENCODE_DIRECT; // assume next byte will be direct until proven otherwise
                    SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                    hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                    hex.SetUnderline(i, FALSE);
                   } /*  valid B3 */
                else
                   { /* erroneous B3 */
                    state = ENCODE_DIRECT;
                    SetTextColor(i, COLOR_ENCODE_ERROR, ctl);
                    hex.SetTextColor(i, COLOR_ENCODE_ERROR);
                    hex.SetUnderline(i, FALSE);
                   } /* erroneous B3 */
#else
                state = ENCODE_DIRECT; // assume next byte will be direct until proven otherwise
                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, FALSE);
#endif
                even = !even;
                continue;
             case ENCODE_C2:
#if 1
                if((b & 0xC0) == 0x80)
                   { /*  valid C2 */
                    state = ENCODE_C3; 
                    SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                    hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                    hex.SetUnderline(i, TRUE);
                   } /*  valid C2 */
                else
                   { /* erroneous C2 */
                    state = ENCODE_DIRECT;
                    SetTextColor(i, COLOR_ENCODE_ERROR, ctl);
                    hex.SetTextColor(i, COLOR_ENCODE_ERROR);
                    hex.SetUnderline(i, FALSE);
                   } /* erroneous C2 */
#else
                state = ENCODE_C3; 
                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, TRUE);
#endif
                continue;

             case ENCODE_C3:
#if 1
                if((b & 0xC0) == 0x80)
                   { /*  valid C3 */
                    state = ENCODE_C4; 
                    SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                    hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                    hex.SetUnderline(i, TRUE);
                   } /*  valid C3 */
                else
                   { /* erroneous C3 */
                    state = ENCODE_DIRECT;
                    SetTextColor(i, COLOR_ENCODE_ERROR, ctl);
                    hex.SetTextColor(i, COLOR_ENCODE_ERROR);
                    hex.SetUnderline(i, FALSE);
                   } /* erroneous C3 */
#else
                state = ENCODE_C4; 
                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, TRUE);
#endif
                continue;
             case ENCODE_C4:
#if 1
                if((b & 0xC0) == 0x80)
                   { /*  valid C4 */
                    state = ENCODE_DIRECT; 
                    SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                    hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                    hex.SetUnderline(i, FALSE);
                   } /*  valid B2 */
                else
                   { /* erroneous C4 */
                    state = ENCODE_DIRECT;
                    SetTextColor(i, COLOR_ENCODE_ERROR, ctl);
                    hex.SetTextColor(i, COLOR_ENCODE_ERROR);
                    hex.SetUnderline(i, FALSE);
                   } /* erroneous C4 */
#else
                state = ENCODE_DIRECT; 
                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, FALSE);
#endif
                even = !even;
                continue;
            } /* state */
        } /* scan string */

#ifndef _DEBUG
     ctl.SetRedraw(TRUE);
     ctl.Invalidate();
#endif

    } // CMultiByte::HighlightUTF8

/****************************************************************************
*                            CMultiByte::HighlightUTF7
* Inputs:
*       CRichEditCtrlEx & ctl: Control to highlight
*       CHexEditCtrl & hex:
*       const CString & text:
* Result: void
*       
* Effect: 
*       Highlights the UTF7 escapes
* Notes:
*       Black: directly encoded characters (Set D) 
*       Blue: Shift-in, shift-out
*       Red/Green: Encoded characters
****************************************************************************/

void CMultiByte::HighlightUTF7(CRichEditCtrlEx & ctl, CHexEditCtrl & hex, const CString & text)
    {
#if 0
     static const CString SetD = _T("ABCDEFGHIJKLMNOPQRSTUVWXYZ")
                                 _T("abcdefghijklmnopqrstuvwxyz")
                                 _T("0123456789")
                                 _T("'(),-./:?");
     static const CString SetO = _T("!\"#$%&*;<=>@[]^_'{|}");
     static const CString Base64 = _T("ABCDEFGHIJKLMNOPQRSTUVWXYZ")
                                   _T("abcdefghijklmnopqrstuvwxyz")
                                   _T("0123456789")
                                   _T("+/");
     // SetB is the remainder
#endif
     static const CString SetB = _T("ABCDEFGHIJKLMNOPQRSTUVWXYZ")
                                 _T("abcdefghijklmnopqrstuvwxyz")
                                 _T("0123456789");

     enum { ENCODE_DIRECT, ENCODE_0d, ENCODE_0c, ENCODE_1, ENCODE_2} state;
     state = ENCODE_DIRECT;

     BOOL even = TRUE;


     for(int i = 0; i < text.GetLength(); i++)
        { /* scan string */
         switch(state)
            { /* state */
             //----------------
             // ENCODE_DIRECT
             //----------------
             case ENCODE_DIRECT:
                if(text[i] == _T('+')) // shift in
                   { /* shift in */
                    SetTextColor(i, COLOR_SHIFT_IN, ctl);
                    hex.SetTextColor(i, COLOR_SHIFT_IN);
                    state = ENCODE_0d;
                    even = TRUE;
                    continue;
                   } /* shift in */
                SetTextColor(i, COLOR_DIRECT, ctl);
                hex.SetTextColor(i, COLOR_DIRECT);
                continue;
             //--------------------------------
             // ENCODE_0d: Encode 0 from direct
             //--------------------------------
             case ENCODE_0d:
                //--------------------
                // Handle case of '+-'
                //--------------------
                if(SetB.Find(text[i]) < 0 || text[i] == _T('-'))
                   { /* shift out */
                    SetTextColor(i, COLOR_SHIFT_OUT, ctl);
                    hex.SetTextColor(i, COLOR_DIRECT);
                    hex.SetTextColor(i - 1, COLOR_DIRECT);
                    hex.SetUnderline(i - 1, TRUE);
                    hex.SetUnderline(i, FALSE);
                    state = ENCODE_DIRECT;
                    continue;
                   } /* shift out */

                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, TRUE); 
                state = ENCODE_1;
                continue;
             //---------------------------------
             // ENCODE_0c: Encode 0 continuation
             //---------------------------------
             case ENCODE_0c: 
                if(SetB.Find(text[i]) < 0 || text[i] == _T('-'))
                   { /* shift out */
                    COLORREF color = text[i] == _T('-') ? COLOR_SHIFT_OUT : COLOR_DIRECT;
                    SetTextColor(i, color, ctl);
                    hex.SetTextColor(i, color);
                    state = ENCODE_DIRECT;
                    continue;
                   } /* shift out */

                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, TRUE); 
                state = ENCODE_1;
                continue;
             //----------------
             // ENCODE_1
             //----------------
             case ENCODE_1:
                if(SetB.Find(text[i]) < 0 || text[i] == _T('-'))
                   { /* shift out */
                    hex.SetUnderline(i - 1, TRUE, FALSE); // turn off underline
                    hex.SetUnderline(i - 1, FALSE); // and back on, shorter
                    COLORREF color = text[i] == _T('-') ? COLOR_SHIFT_OUT : COLOR_DIRECT;
                    SetTextColor(i, color, ctl);
                    hex.SetTextColor(i, color);
                    state = ENCODE_DIRECT;
                    continue;
                   } /* shift out */

                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, TRUE); 
                state = ENCODE_2;
                continue;
             //----------------
             // ENCODE_2
             //----------------
             case ENCODE_2:
                if(SetB.Find(text[i]) < 0 || text[i] == _T('-'))
                   { /* shift out */
                    hex.SetUnderline(i - 1, TRUE, FALSE); // turn off underline
                    hex.SetUnderline(i - 1, FALSE); // and back on, shorter
                    COLORREF color = text[i] == _T('-') ? COLOR_SHIFT_OUT : COLOR_DIRECT;
                    SetTextColor(i, color, ctl);
                    hex.SetTextColor(i, color);
                    state = ENCODE_DIRECT;
                    continue;
                   } /* shift out */

                SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD, ctl);
                hex.SetTextColor(i, even ? COLOR_ENCODE_EVEN : COLOR_ENCODE_ODD);
                hex.SetUnderline(i, FALSE); 
                state = ENCODE_0c;
                even = !even;
                continue;
             default:
                ASSERT(FALSE);
            } /* state */
        } /* scan string */
    } // CMultiByte::HighlightUTF7

/****************************************************************************
*                          CMultiByte::SetTextColor
* Inputs:
*       int i: Index of character
*       COLORREF color: Color to set
* Result: void
*       
* Effect: 
*       Sets the text color
****************************************************************************/

void CMultiByte::SetTextColor(int i, COLORREF color, CRichEditCtrlEx & ctl)
    {
     DWORD mask = ctl.GetEventMask();
     ctl.SetEventMask(mask & ~(ENM_PROTECTED | ENM_CHANGE));
     MB_TRACE2("=>CMultiByte::SetTextColor(%d, 0x%08x)\n", i, color);
     CHARFORMAT fmt = { sizeof(CHARFORMAT) };
     fmt.dwMask = CFM_COLOR;
     fmt.crTextColor = color;
     long low;
     long high;
     ctl.GetSel(low, high);
     ctl.SetSelNoNotify(i, i + 1);
     BOOL ok = ctl.SetSelectionCharFormat(fmt);
     ASSERT(ok);
     ctl.SetSelNoNotify(low, high);
     MB_TRACE0("<=CMultiByte::SetTextColor\n");
     ctl.SetEventMask(mask);
    } // CMultiByte::SetTextColor

/****************************************************************************
*                         CMultiByte::GetSelectedByte
* Inputs:
*       CString & s: String to retrieve
* Result: BOOL
*       TRUE if there was a selection (s is the character)
*       FALSE if there was no selection (s is empty)
* Effect: 
*       
****************************************************************************/

BOOL CMultiByte::GetSelectedByte(CString & s)
    {
     long olow;
     long ohigh;

     c_MultiByte.GetSel(olow, ohigh);
     if(olow == ohigh)
        { /* 0 selection */
         c_MultiByte.SetSelNoNotify(olow, olow + 1);
        } /* 0 selection */

     s = c_MultiByte.GetSelText();
     c_MultiByte.SetSelNoNotify(olow, ohigh);

     return !s.IsEmpty();
    } // CMultiByte::GetSelectedByte

/****************************************************************************
*                        CMultiByte::DoIsDBCSLeadByte
* Result: void
*       
* Effect: 
*       Executes IsDBCSLeadByte on current selection
****************************************************************************/

void CMultiByte::DoIsDBCSLeadByte()
    {
     CString s;
     GetSelectedByte(s);
     if(s.GetLength() > 0)
         { /* has byte */
          BOOL dbcs = ::IsDBCSLeadByte((BYTE)s[0]);
          CString fmt;
          fmt.LoadString(IDS_ISDBCLEADBYTE);
          CString result;
          result.LoadString(dbcs ? IDS_TRUE : IDS_FALSE);
          CString msg;
          msg.Format(fmt, (BYTE)s[0], result);
          c_Error.SetWindowText(msg);
         } /* has byte */
     else
         { /* string empty */
          CString msg;
          msg.LoadString(IDS_STRING_EMPTY);
          c_Error.SetWindowText(msg);
         } /* string empty */
     updateControls();
    } // CMultiByte::DoIsDBCSLeadByte

/****************************************************************************
*                        CMultiByte::DoIsDBCSLeadByteEx
* Result: void
*       
* Effect: 
*       Executes IsDBCSLeadByte on current selection
****************************************************************************/

void CMultiByte::DoIsDBCSLeadByteEx()
    {
     UINT cp = CP_ACP;
     CString CodePage;
     CString CodePageComment;

     GetCodePageInfo(cp, CodePage, CodePageComment);

     CString s;
     GetSelectedByte(s);

     if(s.GetLength() > 0)
        { /* has byte */
         BOOL dbcs = ::IsDBCSLeadByteEx(cp, (BYTE)s[0]);
         CString fmt;
         fmt.LoadString(IDS_ISDBCLEADBYTEEX);
         CString result;
         result.LoadString(dbcs ? IDS_TRUE : IDS_FALSE);
         CString msg;
         msg.Format(fmt, CodePage, (BYTE)s[0], result);
         c_Error.SetWindowText(msg);
        } /* has byte */
     else
         { /* string empty */
          CString msg;
          msg.LoadString(IDS_STRING_EMPTY);
          c_Error.SetWindowText(msg);
         }  /* string empty */
     updateControls();
    } // CMultiByte::DoIsDBCSLeadByteEx

/****************************************************************************
*                           CMultiByte::Highlight
* Inputs:
*       UINT cp: Code page info
*       CRichEditCtrlEx & ctl:
* Result: void
*       
* Effect: 
*       Highlights based on code page
****************************************************************************/

void CMultiByte::Highlight(UINT cp, CRichEditCtrlEx & ctl, CHexEditCtrl & hex)
    {
     CString s;
     ctl.GetWindowText(s);
     switch(cp)
        { /* cp */
         case CP_UTF7:
            HighlightUTF7(ctl, hex, s);
            break;
         case CP_UTF8:
            HighlightUTF8(ctl, hex, s);
            break;
        } /* cp */
    } // CMultiByte::Highlight

/****************************************************************************
*                         CMultiByte::ShowDBCSLeadByte
* Result: void
*       
* Effect: 
*       If any IsDBCSLeadByte mode is set, execute the code
****************************************************************************/

void CMultiByte::ShowDBCSLeadByte()
    {
     if(c_IsDBCSLeadByte.GetCheck() == BST_CHECKED)
        { /* IsDBCSLeadByte */
         DoIsDBCSLeadByte();
        } /* IsDBCSLeadByte */
     else
     if(c_IsDBCSLeadByteEx.GetCheck() == BST_CHECKED)
        { /* IsDBCSLeadByteEx */
         DoIsDBCSLeadByteEx();
        } /* IsDBCSLeadByteEx.*/
    } // CMultiByte::ShowDBCSLeadByte

/****************************************************************************
*                       CMultiByte::OnSetfocusMultibyte
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       If we are in IsDBCSLeadByte(Ex), do the appropriate function
****************************************************************************/

void CMultiByte::OnSetfocusMultibyte(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    ShowDBCSLeadByte();
    *pResult;
   }

/****************************************************************************
*                     CMultiByte::OnSetFocusMultiByteHex
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Reflects the selection back to MultiByte and handles ISDBCSLeadByte modes
****************************************************************************/

void CMultiByte::OnSetfocusMultibyteHex(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    long low;
    long high;
    c_MultiByteHex.GetSel(low, high);
    c_MultiByte.SetSelNoNotify(low, high);

    ShowDBCSLeadByte();
        
    *pResult = 0;
   }

/****************************************************************************
*                     CMultiByte::OnSelchangeMultibyteHex
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       If we are in IsDBCSLeadByte(Ex) mode, execute the appropriate function
****************************************************************************/

void CMultiByte::OnSelchangeMultibyteHex(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    SELCHANGE *pSelChange = reinterpret_cast<SELCHANGE *>(pNMHDR);
    // TODO: The control will not send this notification unless you override the
    // CFunction::OnInitDialog() function to send the EM_SETEVENTMASK message
    // to the control with the ENM_SELCHANGE flag ORed into the lParam mask.
    long low;
    long high;

    MB_TRACE0("=>CMultiByte::OnSelchangeMultibyteHex()\n");
    c_MultiByteHex.GetSel(low, high);
    c_MultiByte.SetSelNoNotify(low, high);

    ShowDBCSLeadByte();

    MB_TRACE0("<=CMultiByte::OnSelchangeMultibyteHex\n");

    *pResult = 0;
   }

/****************************************************************************
*                       CMultiByte::OnSelchangeWidehex
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Refelcts the change to the c_Wide control
****************************************************************************/

void CMultiByte::OnSelchangeWidehex(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    SELCHANGE *pSelChange = reinterpret_cast<SELCHANGE *>(pNMHDR);
    // TODO: The control will not send this notification unless you override the
    // CFunction::OnInitDialog() function to send the EM_SETEVENTMASK message
    // to the control with the ENM_SELCHANGE flag ORed into the lParam mask.
    WideHelper::OnSelChangeWideHex(c_Wide, c_WideHex);
    *pResult = 0;
   }

/****************************************************************************
*                      CMultiByte::OnSelchangeMultibyte
* Inputs:
*       NMHDR * pNMHDR:
*       LRESULT * pResult:
* Result: void
*       
* Effect: 
*       Replicates the selection in the MultiByteHex and handles
*       ISDBCSLeadByte modes
****************************************************************************/

void CMultiByte::OnSelchangeMultibyte(NMHDR* pNMHDR, LRESULT* pResult) 
   {
    SELCHANGE *pSelChange = reinterpret_cast<SELCHANGE *>(pNMHDR);
    // TODO: The control will not send this notification unless you override the
    // CFunction::OnInitDialog() function to send the EM_SETEVENTMASK message
    // to the control with the ENM_SELCHANGE flag ORed into the lParam mask.
        
    MB_TRACE0("=>CMultiByte::OnSelchangeMultibyte()\n");
    long low;
    long high;
    c_MultiByte.GetSel(low, high);
    c_MultiByteHex.SetSel(low, high);

    ShowDBCSLeadByte();
    *pResult = 0;
    MB_TRACE0("<=CMultiByte::OnSelchangeMultibyte\n");
   }

/****************************************************************************
*                   CMultiByte::OnSelendokMultibyteHistory
* Result: void
*       
* Effect: 
*       Restores the selected state to the multibyte windows
****************************************************************************/

void CMultiByte::OnSelendokMultibyteHistory() 
   {
    int sel = c_MultiByteHistory.GetCurSel();
    if(sel == CB_ERR)
       return;
    History * h = c_MultiByteHistory.GetItemData(sel);
    ASSERT(h != NULL);
    if(h == NULL)
       return;

    CString s;
    s = h->GetText();

    c_MultiByte.SetWindowText(s);
    c_MultiByteHex.SetWindowText(s, 0, 0, FALSE);
   }

/****************************************************************************
*                      CMultiByte::OnSelendokWideHistory
* Result: void
*       
* Effect: 
*       Makes the current selection be the contents of the wide box
****************************************************************************/

void CMultiByte::OnSelendokWideHistory() 
   {
    int sel = c_WideHistory.GetCurSel();
    if(sel == CB_ERR)
       return;
    History * h = c_WideHistory.GetItemData(sel);
    ASSERT(h != NULL);
    if(h == NULL)
       return;
    
    CString s;
    s = h->GetText();

    MB_TRACE1("=>CMultiByte::OnSelendOKWideHistory!c_Wide.SetWindowText(\"%s\")\n", s);
    c_Wide.SetWindowText(s);
    MB_TRACE0("<=CMultiByte::OnSelendOKWideHistory!c_Wide.SetWindowText\n");

    c_WideHex.SetWindowText(s, 0, 0, FALSE);
   }


/****************************************************************************
*                         CMultiByte::DoIsTextUnicode
* Result: void
*       
* Effect: 
*       Handles IsTextUnicode
****************************************************************************/

void CMultiByte::DoIsTextUnicode()
    {
     // Not implemented. Moved to a page of its own
    } // CMultiByte::DoIsTextUnicode

/****************************************************************************
*                      CMultiByte::OnChangeMultibyteHex
* Result: void
*       
* Effect: 
*       A change was made in the hex window. Replace the characters in the
*       input window
****************************************************************************/

void CMultiByte::OnChangeMultibyteHex() 
   {
    // TODO: If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CFunction::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.

    CString s;
    long low;
    long high;
    c_MultiByte.GetSel(low, high);
    MB_TRACE2("=>CMultiByte::OnChangeMultibyteHex() sel=[%d, %d]\n", low, high);

       c_MultiByteHex.GetWindowText(s);

       MB_TRACE1("=>CMultiByte::OnChangeMultibyteHex!c_MultiByte.SetWindowTextNoNotify(\"%s\")\n", s);
       c_MultiByte.SetWindowTextNoNotify(s);
       MB_TRACE0("<=CMultiByte::OnChangeMultibyteHex!c_MultiByte.SetWindowTextNoNotify\n");

       MB_TRACE2("=>CMultiByte::OnChangeMultibyteHex!c_Wide.SetSelNoNotify(%d, %d)\n", low, high);
       c_Wide.SetSelNoNotify(low, high);
       MB_TRACE0("<=CMultiByte::OnChangeMultibyteHex!c_Wide.SetSelNoNotify\n");

    MB_TRACE0("<=CMultiByte::OnChangeMultibyteHex\n");
   }

/****************************************************************************
*                        CMultiByte::OnChangeMultibyte
* Result: void
*       
* Effect: 
*       Handles changes in the multibyte text
****************************************************************************/

void CMultiByte::OnChangeMultibyte() 
   {
    CString s;
    c_MultiByte.GetWindowText(s);
    long low;
    long high;
    c_MultiByte.GetSel(low, high);


    MB_TRACE2("=>CMultiByte::OnChangeMultibyte() sel=[%d, %d]\n", low, high);
        MB_TRACE3("=>CMultiByte::OnChangeMultibyte!c_MultiByteHex.SetWindowTextNoNotify(\"%s\", %d, %d, FALSE)\n", s, low, high);
        c_MultiByteHex.SetWindowTextNoNotify(s, low, high);
        Refresh();
        MB_TRACE0("<=CMultiByte::OnChangeMultibyte!c_MultiByteHex.SetWindowTextNoNotify\n");
    MB_TRACE0("<=CMultiByte::OnChangeMultibyte\n");
   }
