#if !defined(AFX_MULTIBYTE_H__B2D566AB_5504_4243_A214_7BA36EDEA076__INCLUDED_)
#define AFX_MULTIBYTE_H__B2D566AB_5504_4243_A214_7BA36EDEA076__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MultiByte.h : header file
//
#include "WhatIsItButton.h"
#include "WhatIsThisEdit.h"
#include "CodePageCombo.h"
#include "ArrowButton.h"
#include "Function.h"
#include "HexEditCtrl.h"
#include "RichEditCtrlEx.h"
#include "WhatIsItSpinButtonCtrl.h"
#include "History.h"
#include "FontData.h"

/////////////////////////////////////////////////////////////////////////////
// CMultiByte dialog

class CMultiByte : public CFunction
{
    DECLARE_DYNCREATE(CMultiByte)
// Construction
public:
        CMultiByte(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CMultiByte)
        enum { IDD = IDD_MULTIBYTE };
        CFontData       c_FontData;
        CHistory        c_WideHistory;
        CHistory        c_MultiByteHistory;
        CStatic c_Error;
        CWhatIsItSpinButtonCtrl        c_ZoomWide;
        CRichEditCtrlEx c_Wide;
        CRichEditCtrlEx c_MultiByte;
        CHexEditCtrl c_WideHex;
        CHexEditCtrl c_MultiByteHex;
        CWhatIsItButton c_CP_SUPPORTED;
        CWhatIsItButton c_CP_INSTALLED;
        CWhatIsItButton c_VS7;
        CWhatIsItButton c_VS6;
        CButton x_Version;
        CButton x_dwFlags;
        CWhatIsItButton c_WideCharToMultiByte;
        CWhatIsItButton c_WC_SEPCHARS;
        CWhatIsItButton c_WC_NO_BEST_FIT_CHARS;
        CWhatIsItButton c_WC_DISCARDNS;
        CWhatIsItButton c_WC_DEFAULTCHAR;
        CWhatIsItButton c_WC_COMPOSITECHECK;
        CWhatIsItButton c_MultiByteToWideChar;
        CWhatIsItButton c_UsedDefaultCharNULL;
        CButton x_UsedDefaultChar;
        CWhatIsItButton c_UsedDefaultCharNonNULL;
        CWhatIsItButton c_MB_USEGLYPHCHARS;
        CWhatIsItButton c_MB_PRECOMPOSED;
        CWhatIsItButton c_MB_ERR_INVALID_CHARS;
        CWhatIsItButton c_MB_COMPOSITE;
        CWhatIsItButton c_IsTextUnicode;
        CWhatIsItButton c_IsDBCSLeadByteEx;
        CWhatIsItButton c_IsDBCSLeadByte;
        CWhatIsItButton c_DefaultCharUseThis;
        CWhatIsItButton c_DefaultCharUseNULL;
        CButton x_DefaultChar;
        CWhatIsItButton c_DefaultCharUseGetCPInfo;
        CWhatIsThisEdit   c_DefaultCharValue;
        CCodePageCombo  c_CodePage;
        CArrowButton  c_Arrow;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CMultiByte)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls();
protected: // methods
        void updateControls();
        void GetFlags(CString & options, DWORD & flags, const CString & or);
        void GetLCID(CString & localeName, LCID & lcid);
        void UpdateCodePageList();
        static BOOL CALLBACK EnumCodePagesProc(LPTSTR codepage);
        void DoMultiByteToWideChar();
        void DoWideCharToMultiByte();
        void Highlight(UINT cp, CRichEditCtrlEx & ctl, CHexEditCtrl & hex); 
        void HighlightUTF7(CRichEditCtrlEx & ctl, CHexEditCtrl & hex, const CString & text);
        void HighlightUTF8(CRichEditCtrlEx & ctl, CHexEditCtrl & hex, const CString & text);
        void SetTextColor(int i, COLORREF color, CRichEditCtrlEx & ctl);
        void DoIsDBCSLeadByte();
        void DoIsDBCSLeadByteEx();
        BOOL GetSelectedByte(CString & s);
        void GetCodePageInfo(UINT & cp, CString & CodePage, CString & CodePageComment);
        void ShowDBCSLeadByte();
        void DoIsTextUnicode();

protected: // data
        static CMultiByte * Self;  // entirely due to Microsoft brain damage
        CFont zoomFont;

protected: // Message handlers

        // Generated message map functions
        //{{AFX_MSG(CMultiByte)
        afx_msg void OnChangeDefaultCharValue();
        afx_msg void OnDefaultGetcpino();
        afx_msg void OnSelendokCodepage();
        afx_msg void OnDefaultcharCaption();
        afx_msg void OnDefaultcharNull();
        afx_msg void OnDefaultcharThis();
        afx_msg void OnIsdbcsleadbyte();
        afx_msg void OnIsdbcsleadbyteex();
        afx_msg void OnIstextunicode();
        afx_msg void OnMbComposite();
        afx_msg void OnMbErrInvalidChars();
        afx_msg void OnMbPrecomposed();
        afx_msg void OnMbUseglyphchars();
        afx_msg void OnUsedNonNull();
        afx_msg void OnUseddefaultcharNull();
        afx_msg void OnWcCompositecheck();
        afx_msg void OnWcDefaultchar();
        afx_msg void OnWcDiscardns();
        afx_msg void OnWcNoBestFitChars();
        afx_msg void OnWcSepchars();
        afx_msg void OnWidechartomultibyte();
        afx_msg void OnMultibytetowidechar();
        virtual BOOL OnInitDialog();
        afx_msg void OnVs6();
        afx_msg void OnVs7();
        afx_msg void OnCpInstalled();
        afx_msg void OnCpSupported();
        afx_msg void OnChangeWide();
        afx_msg void OnChangeWidehex();
        afx_msg void OnSelchangeWide(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        afx_msg void OnArrowBox();
        afx_msg void OnSetfocusMultibyte(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnSetfocusMultibyteHex(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnSelchangeMultibyteHex(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnSelchangeMultibyte(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnSelendokMultibyteHistory();
        afx_msg void OnSelendokWideHistory();
        afx_msg void OnSelchangeWidehex(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnChangeMultibyteHex();
        afx_msg void OnChangeMultibyte();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MULTIBYTE_H__B2D566AB_5504_4243_A214_7BA36EDEA076__INCLUDED_)
