#pragma once

class RegFontInfo {
    public:
       class Direction {
           public:
              typedef enum { Unknown, LTR, RTL } dir;
              CString toString();
              static CString MaxString(CDC & dc);
              Direction & operator=(const Direction d) { value = d.value; return *this; }
              Direction(dir d) { value = d; }
              Direction() { value = Unknown; }
              operator int() { return *(int *)&value; }
           protected:
              dir value;
       };
    public:
       LCID lcid;
       CString LanguageName;
       CString fontname;
       Direction direction;
       int size;
       void SetModify(BOOL mode) { modified = mode; }
       BOOL GetModify() { return modified; }
    public:
       RegFontInfo() { lcid = 0; direction = Direction(Direction::Unknown); size = 0; modified = FALSE; }
       BOOL GetRegistryFontInfo(LCID id);
       BOOL GetRegistryFontInfo(const CString & key);
       BOOL SetRegistryFontInfo();
       static DeleteAllEntries();
    protected:
       BOOL modified;
};

