// ScriptGetProperties.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ScriptGetProperties.h"
#include "lcids.h"
#include "Charsets.h"
#include "Query.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CScriptGetProperties, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CScriptGetProperties dialog


CScriptGetProperties::CScriptGetProperties(CWnd* pParent /*=NULL*/)
        : CFunction(CScriptGetProperties::IDD, pParent)
{
        //{{AFX_DATA_INIT(CScriptGetProperties)
        //}}AFX_DATA_INIT
}


void CScriptGetProperties::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CScriptGetProperties)
        DDX_Control(pDX, IDC_OUTPUT, c_Output);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScriptGetProperties, CFunction)
        //{{AFX_MSG_MAP(CScriptGetProperties)
        ON_WM_SIZE()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScriptGetProperties message handlers

BOOL CScriptGetProperties::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    // TODO: Add extra initialization here
    c_Header.SubclassWindow(c_Output.GetHeaderCtrl()->m_hWnd);

#define COL_IX 0
    c_Output.InsertColumnEx(COL_IX, _T(""), DT_RIGHT, CString(_T("[00]")));
#define COL_LANGID 1
    c_Output.InsertColumnEx(COL_LANGID, _T("langid"), DT_LEFT);
    c_Header.SetTextAlign(COL_LANGID, DT_LEFT | DT_BOTTOM | DT_0);

#define COL_LANGIDSTR 2
    c_Output.InsertColumnEx(COL_LANGIDSTR, _T("MAKELANGID()"), DT_LEFT);
    c_Header.SetTextAlign(COL_LANGIDSTR, DT_LEFT | DT_BOTTOM | DT_0);

#define ADDCOL(field) {     \
                      c_Output.InsertColumnEx(COL_##field, _T(#field)); \
                      c_Header.SetTextAlign(COL_##field, DT_CENTER | DT_90); \
                      }

#define COL_fNumeric 3
    ADDCOL(fNumeric);

#define COL_fComplex 4
    ADDCOL(fComplex);

#define COL_fNeedsWordBreaking 5
    ADDCOL(fNeedsWordBreaking);

#define COL_fNeedsCaretInfo 6
    ADDCOL(fNeedsCaretInfo);

#define COL_bCharSet 7
    ADDCOL(bCharSet);
    c_Header.SetTextAlign(COL_LANGIDSTR, DT_LEFT | DT_BOTTOM | DT_0);

#define COL_fControl 8
    ADDCOL(fControl);

#define COL_fPrivateUseArea 9
    ADDCOL(fPrivateUseArea);

#define COL_fNeedsCharacterJustify 10
    ADDCOL(fNeedsCharacterJustify);

#define COL_fInvalidGlyph 11
    ADDCOL(fInvalidGlyph);

#define COL_fInvalidLogAttr 12
    ADDCOL(fInvalidLogAttr);

#define COL_fCDM 13
    ADDCOL(fCDM);
    
#define COL_fAmbiguousCharSet 14
    ADDCOL(fAmbiguousCharSet);
    
#define COL_fClusterSizeVaries 15
    ADDCOL(fClusterSizeVaries);
    
#define COL_fRejectInvalid 16
    ADDCOL(fRejectInvalid);
        
#ifdef _DEBUG //----------------------------------------------------------------+
#define COL_DEBUG 17                                                         // |
    ADDCOL(DEBUG);                                                           // |
#endif //-----------------------------------------------------------------------+

    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                        CScriptGetProperties::OnSize
* Inputs:
*       UINT nType:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Handles resizing
****************************************************************************/

void CScriptGetProperties::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);
        
    ExpandBottom(c_Output);
   }

/****************************************************************************
*                        CScriptGetProperties::Refresh
* Result: void
*       
* Effect: 
*       Refreshes the structure
****************************************************************************/

void CScriptGetProperties::Refresh()
    {
     if(!initialized)
        return;
     
     const SCRIPT_PROPERTIES ** properties;
     int numproperties;

     HRESULT result = ::ScriptGetProperties(&properties, &numproperties);

     QueryTemplate(_T(""));
     c_Output.DeleteAllItems();

     for(int i = 0; i < numproperties; i++)
         { /* scan properties */
          const SCRIPT_PROPERTIES * p = properties[i];
          /*----------------------------------------------------------------
          typedef struct {
             DWORD   langid                 :16; // Primary and sublanguage associated with script
             DWORD   fNumeric               :1;
             DWORD   fComplex               :1;  // Script requires special shaping or layout
             DWORD   fNeedsWordBreaking     :1;  // Requires ScriptBreak for word breaking information
             DWORD   fNeedsCaretInfo        :1;  // Requires caret restriction to cluster boundaries
             DWORD   bCharSet               :8;  // Charset to use when creating font
             DWORD   fControl               :1;  // Contains only control characters
             DWORD   fPrivateUseArea        :1;  // This item is from the Unicode range U+E000 through U+F8FF
             DWORD   fNeedsCharacterJustify :1;  // Requires inter-character justification
             DWORD   fInvalidGlyph          :1;  // Invalid combinations generate glyph wgInvalid in the glyph buffer
             DWORD   fInvalidLogAttr        :1;  // Invalid combinations are marked by fInvalid in the logical attributes
             DWORD   fCDM                   :1;  // Contains Combining Diacritical Marks
             DWORD   fAmbiguousCharSet      :1;  // Script does not correspond 1:1 with a charset
             DWORD   fClusterSizeVaries     :1;  // Measured cluster width depends on adjacent clusters
             DWORD   fRejectInvalid         :1;  // Invalid combinations should be rejected
          } SCRIPT_PROPERTIES;
          
          ----------------------------------------------------------------*/
          CClientDC dc(&c_Output);

          TRACE1("---------------------[%d]-------------------------\n", i);
          CString lang = GetLANGIDString(p->langid);

          CString ix;
          ix.Format(_T("[%02d]"), i);
          int n = c_Output.InsertItem(i + 1, ix);
          CSize sz = dc.GetTextExtent(_T(" ") + ix + _T(" "));
          c_Output.SetPeakColumnWidth(COL_IX, sz.cx);

          //int w = c_Output.GetColumnWidth(COL_IX);
          //if(sz.cx > w)
          //   c_Output.SetColumnWidth(COL_IX, sz.cx);

          LVITEM subitem = {0};
          subitem.mask = LVIF_TEXT;
          subitem.iItem = n;

          CString hex;
          hex.Format(_T("0x%04X"), p->langid);

          sz = dc.GetTextExtent(_T(" ") + hex + _T(" "));
          c_Output.SetPeakColumnWidth(COL_LANGID, sz.cx);

//          w = c_Output.GetColumnWidth(COL_LANGID);
//          if(sz.cx > w)
//             c_Output.SetColumnWidth(COL_LANGID, sz.cx);

          VERIFY(subitem.iSubItem = COL_LANGID);
          subitem.pszText = (LPTSTR)(LPCTSTR)hex;
          c_Output.SetItem(&subitem);

          sz = dc.GetTextExtent(_T(" ") + lang + _T(" "));
          c_Output.SetPeakColumnWidth(COL_LANGIDSTR, sz.cx);

//          w = c_Output.GetColumnWidth(COL_LANGIDSTR);
//          if(sz.cx > w)
//             c_Output.SetColumnWidth(COL_LANGIDSTR, sz.cx);

          subitem.iSubItem = COL_LANGIDSTR;
          subitem.pszText = (LPTSTR)(LPCTSTR)lang;
          VERIFY(c_Output.SetItem(&subitem));

          //----------------------------------------------------------------
          // Now insert the subitems for the values
          //----------------------------------------------------------------

          CString t;

          DWORD debug = 0;
          CString debugs;
          
#define AddBitField(name) {                                    \
          subitem.iSubItem = COL_##name;                       \
               debug |= 1 << COL_##name;                                                   /* DEBUG OUTPUT */ \
          t.Format(_T("%d"), p->name);                         \
               debugs += _T(" ") + t;                                                      /* DEBUG OUTPUT */ \
          CSize sz = dc.GetTextExtent(_T(" ") + t + _T(" "));  \
          c_Output.SetPeakColumnWidth(COL_##name, sz.cx);      \
          /*int w = c_Output.GetColumnWidth(COL_##name);    */ \
          /*if(w < sz.cx)                                   */ \
          /*    c_Output.SetColumnWidth(COL_##name, sz.cx); */ \
          subitem.pszText = (LPTSTR)(LPCTSTR)t;                \
          VERIFY(c_Output.SetItem(&subitem));                  \
               CString trace;                                                              /* DEBUG OUTPUT */ \
               trace.Format(_T("%s ") _T(#name) _T("[%d]=\"%s\"\n"), lang, COL_##name, t); /* DEBUG OUTPUT */ \
               TRACE1("%s", trace);                                                        /* DEBUG OUTPUT */ \
         }

          AddBitField(fNumeric);
          AddBitField(fComplex);
          AddBitField(fNeedsWordBreaking);
          AddBitField(fNeedsCaretInfo);
          
          // AddBitField(bCharSet); // fix this up later
          { /* bCharSet */
           subitem.iSubItem = COL_bCharSet;

           t = GetCharsetName(p->bCharSet);

           debugs += _T(" ") + t;                                                      /* DEBUG OUTPUT */ 
           CSize sz = dc.GetTextExtent(_T(" ") + t + _T(" "));  
           c_Output.SetPeakColumnWidth(COL_bCharSet, sz.cx);
           //int w = c_Output.GetColumnWidth(COL_bCharSet);         
           //if(w < sz.cx)                                        
           //   c_Output.SetColumnWidth(COL_bCharSet, sz.cx);      
           subitem.pszText = (LPTSTR)(LPCTSTR)t;                
           VERIFY(c_Output.SetItem(&subitem));                  
           CString trace;                                                              /* DEBUG OUTPUT */ 
           trace.Format(_T("%s ") _T("bCharSet") _T("[%d]=\"%s\"\n"), lang, COL_bCharSet, t); /* DEBUG OUTPUT */ 
           TRACE1("%s", trace);                                                        /* DEBUG OUTPUT */ 
          }

          AddBitField(fControl);
          AddBitField(fPrivateUseArea);
          AddBitField(fNeedsCharacterJustify);
          AddBitField(fInvalidGlyph);
          AddBitField(fInvalidLogAttr);
          AddBitField(fCDM);
          AddBitField(fAmbiguousCharSet);
          AddBitField(fClusterSizeVaries);
          AddBitField(fRejectInvalid);
#ifdef _DEBUG //----------------------------------------------------------------+
          subitem.iSubItem = COL_DEBUG;                                      // |
          subitem.pszText = (LPTSTR)(LPCTSTR)debugs;                         // |
          c_Output.SetItem(&subitem);                                        // |
#endif //-----------------------------------------------------------------------+
         } /* scan properties */
     
     c_Header.Invalidate(); // force redraw after adjustment
    } // CScriptGetProperties::Refresh

/****************************************************************************
*                   CScriptGetProperties::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets font to controls
****************************************************************************/

void CScriptGetProperties::SetFontToControls()
    {
     
    } // CScriptGetProperties::SetFontToControls
