// ScriptStringAnalysisPanel.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ScriptStringAnalysisPanel.h"
#include "ParameterChange.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DECLARE_MESSAGE(UWM_PARAMETER_CHANGE)

IMPLEMENT_DYNCREATE(CScriptStringAnalysisPanel, CDialog)
/////////////////////////////////////////////////////////////////////////////
// CScriptStringAnalysisPanel dialog


CScriptStringAnalysisPanel::CScriptStringAnalysisPanel(CWnd* pParent /*=NULL*/)
        : CDialog(CScriptStringAnalysisPanel::IDD, pParent)
{
        //{{AFX_DATA_INIT(CScriptStringAnalysisPanel)
        //}}AFX_DATA_INIT
}


void CScriptStringAnalysisPanel::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CScriptStringAnalysisPanel)
        DDX_Control(pDX, IDC_USE_SPECIFIC_WIDTH, c_UseSpecificWidth);
        DDX_Control(pDX, IDC_GETCLIENTRECT, c_GetClientRect);
        DDX_Control(pDX, IDC_WIDTH_GROUP, x_Width);
        DDX_Control(pDX, IDC_WIDTH, c_Width);
        DDX_Control(pDX, IDC_SPINWIDTH, c_SpinWidth);
        DDX_Control(pDX, IDC_SSA_PASSWORD, c_SSA_PASSWORD);
        DDX_Control(pDX, IDC_SSA_TAB, c_SSA_TAB);
        DDX_Control(pDX, IDC_SSA_RTL, c_SSA_RTL);
        DDX_Control(pDX, IDC_SSA_METAFILE, c_SSA_METAFILE);
        DDX_Control(pDX, IDC_SSA_LINK, c_SSA_LINK);
        DDX_Control(pDX, IDC_SSA_HOTKEYONLY, c_SSA_HOTKEYONLY);
        DDX_Control(pDX, IDC_SSA_HOTKEY, c_SSA_HOTKEY);
        DDX_Control(pDX, IDC_SSA_HIDEHOTKEY, c_SSA_HIDEHOTKEY);
        DDX_Control(pDX, IDC_SSA_GLYPHS, c_SSA_GLYPHS);
        DDX_Control(pDX, IDC_SSA_GCP, c_SSA_GCP);
        DDX_Control(pDX, IDC_SSA_FIT, c_SSA_FIT);
        DDX_Control(pDX, IDC_SSA_FALLBACK, c_SSA_FALLBACK);
        DDX_Control(pDX, IDC_SSA_DZWG, c_SSA_DZWG);
        DDX_Control(pDX, IDC_SSA_CLIP, c_SSA_CLIP);
        DDX_Control(pDX, IDC_SSA_BREAK, c_SSA_BREAK);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScriptStringAnalysisPanel, CDialog)
        //{{AFX_MSG_MAP(CScriptStringAnalysisPanel)
        ON_BN_CLICKED(IDC_SSA_BREAK, OnSsaBreak)
        ON_BN_CLICKED(IDC_SSA_CLIP, OnSsaClip)
        ON_BN_CLICKED(IDC_SSA_DZWG, OnSsaDzwg)
        ON_BN_CLICKED(IDC_SSA_FALLBACK, OnSsaFallback)
        ON_BN_CLICKED(IDC_SSA_FIT, OnSsaFit)
        ON_BN_CLICKED(IDC_SSA_GCP, OnSsaGcp)
        ON_BN_CLICKED(IDC_SSA_GLYPHS, OnSsaGlyphs)
        ON_BN_CLICKED(IDC_SSA_HIDEHOTKEY, OnSsaHidehotkey)
        ON_BN_CLICKED(IDC_SSA_HOTKEY, OnSsaHotkey)
        ON_BN_CLICKED(IDC_SSA_HOTKEYONLY, OnSsaHotkeyonly)
        ON_BN_CLICKED(IDC_SSA_LINK, OnSsaLink)
        ON_BN_CLICKED(IDC_SSA_METAFILE, OnSsaMetafile)
        ON_BN_CLICKED(IDC_SSA_PASSWORD, OnSsaPassword)
        ON_BN_CLICKED(IDC_SSA_RTL, OnSsaRtl)
        ON_BN_CLICKED(IDC_SSA_TAB, OnSsaTab)
        ON_EN_CHANGE(IDC_WIDTH, OnChangeWidth)
        ON_BN_CLICKED(IDC_GETCLIENTRECT, OnGetclientrect)
        ON_BN_CLICKED(IDC_USE_SPECIFIC_WIDTH, OnUseSpecificWidth)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScriptStringAnalysisPanel message handlers

BOOL CScriptStringAnalysisPanel::OnInitDialog() 
   {
    CDialog::OnInitDialog();
        
    c_SpinWidth.SetRange(0, 1024); // 1024 seems to be a reasonable upper bound...
    c_SpinWidth.SetPos(100); // randomly-chosen value, maybe figure out something more sensible later
    CheckRadioButton(IDC_GETCLIENTRECT, IDC_USE_SPECIFIC_WIDTH, IDC_GETCLIENTRECT);
        
    updateControls();
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                    CScriptStringAnalysisPanel::GetFlags
* Result: DWORD
*       The dwFlags value based on the bits found
****************************************************************************/

DWORD CScriptStringAnalysisPanel::GetFlags()
    {
     DWORD flags = 0;
#define GetFlag(f) if(c_##f.GetCheck() == BST_CHECKED) flags |= f;
     GetFlag(SSA_BREAK);
     GetFlag(SSA_CLIP);
     GetFlag(SSA_DZWG);
     GetFlag(SSA_FALLBACK);
     GetFlag(SSA_FIT);
     GetFlag(SSA_GLYPHS);
     GetFlag(SSA_GCP);
     GetFlag(SSA_HIDEHOTKEY);
     GetFlag(SSA_HOTKEY);
     GetFlag(SSA_HOTKEYONLY);
     GetFlag(SSA_LINK);
     GetFlag(SSA_METAFILE);
     GetFlag(SSA_PASSWORD);
     GetFlag(SSA_RTL);
     GetFlag(SSA_TAB);
     return flags;
    } // CScriptStringAnalysisPanel::GetFlags

/****************************************************************************
*                  CScriptStringAnalysisPanel::GetFlagString
* Inputs:
*       DWORD flags:
*       const CString & or: OR operator
* Result: CString
*       
* Effect: 
*       The flags string
****************************************************************************/

CString CScriptStringAnalysisPanel::GetFlagString(DWORD flags, const CString & or)
    {
     CString sep = _T("");
     CString result;
#define AddFlag(s) if((flags & s) != 0) { result += sep + _T(#s); sep = _T(" ") + or + _T(" "); }
     AddFlag(SSA_BREAK);
     AddFlag(SSA_CLIP);
     AddFlag(SSA_DZWG);
     AddFlag(SSA_FALLBACK);
     AddFlag(SSA_FIT);
     AddFlag(SSA_GLYPHS);
     AddFlag(SSA_GCP);
     AddFlag(SSA_HIDEHOTKEY);
     AddFlag(SSA_HOTKEYONLY);
     AddFlag(SSA_LINK);
     AddFlag(SSA_METAFILE);
     AddFlag(SSA_PASSWORD);
     AddFlag(SSA_RTL);
     AddFlag(SSA_TAB);

     if(result.IsEmpty())
        result = _T("0");

     return result;
    } // CScriptStringAnalysisPanel::GetFlagString

/****************************************************************************
*                  CScriptStringAnalysisPanel::ReportChange
* Result: void
*       
* Effect: 
*       Notifies the parent that a change is required
****************************************************************************/

void CScriptStringAnalysisPanel::ReportChange()
    {
     GetParent()->SendMessage(UWM_PARAMETER_CHANGE);
    } // CScriptStringAnalysisPanel::ReportChange


void CScriptStringAnalysisPanel::OnSsaBreak() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaClip() 
   {
    c_SSA_FIT.SetCheck(BST_UNCHECKED);
    ReportChange();
    updateControls();
   }

void CScriptStringAnalysisPanel::OnSsaDzwg() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaFallback() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaFit() 
   {
    c_SSA_CLIP.SetCheck(BST_UNCHECKED);
    ReportChange();
    updateControls();
   }

void CScriptStringAnalysisPanel::OnSsaGcp() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaGlyphs() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaHidehotkey() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaHotkey() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaHotkeyonly() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaLink() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaMetafile() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaPassword() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaRtl() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnSsaTab() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnChangeWidth() 
   {
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnGetclientrect() 
   {
    updateControls();
    ReportChange();
   }

void CScriptStringAnalysisPanel::OnUseSpecificWidth() 
   {
    updateControls();
    ReportChange();
   }

/****************************************************************************
*                 CScriptStringAnalysisPanel::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CScriptStringAnalysisPanel::updateControls()
    {
     BOOL enable = c_SSA_FIT.GetCheck() == BST_CHECKED || c_SSA_CLIP.GetCheck() == BST_CHECKED;
     x_Width.EnableWindow(enable);
     c_UseSpecificWidth.EnableWindow(enable);
     c_GetClientRect.EnableWindow(enable);
     c_Width.EnableWindow(enable);
     c_SpinWidth.EnableWindow(enable);
    } // CScriptStringAnalysisPanel::updateControls

/****************************************************************************
*                 CScriptStringAnalysisPanel::GetWidthString
* Result: CString
*       Parameter value to use for iReqWidth
****************************************************************************/

CString CScriptStringAnalysisPanel::GetWidthString()
    {
     if(c_SSA_FIT.GetCheck() == BST_CHECKED || c_SSA_CLIP.GetCheck() == BST_CHECKED)
        { /* use width */
         if(c_UseSpecificWidth.GetCheck() == BST_CHECKED)
            { /* use specific width */
             UINT w = LOWORD(c_SpinWidth.GetPos());
             CString s;
             s.Format(_T("%d"), w);
             return s;
            } /* use specific width */
         if(c_GetClientRect.GetCheck() == BST_CHECKED)
            { /* use client width */
             return _T("r.Width()");
            } /* use client width */

         return _T("0");  // in case nothing matches
        } /* use width */
     else
        { /* no width needed */
         return _T("0");
        } /* no width needed */
    } // CScriptStringAnalysisPanel::GetWidthString
