// SetMapColor.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "SetMapColor.h"
#include "RegVars.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetMapColor dialog


CSetMapColor::CSetMapColor(CWnd* pParent /*=NULL*/)
        : CDialog(CSetMapColor::IDD, pParent)
{
        //{{AFX_DATA_INIT(CSetMapColor)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CSetMapColor::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CSetMapColor)
        DDX_Control(pDX, IDC_XOR, c_XOR);
        DDX_Control(pDX, IDC_NOTXOR, c_NOTXOR);
        DDX_Control(pDX, IDC_COPY, c_Copy);
        DDX_Control(pDX, IDC_SAMPLE, c_Sample);
        DDX_Control(pDX, IDC_RGB, c_RGB);
        DDX_Control(pDX, IDC_MAP, c_Map);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetMapColor, CDialog)
        //{{AFX_MSG_MAP(CSetMapColor)
        ON_BN_CLICKED(IDC_COLOR, OnColor)
        ON_BN_CLICKED(IDC_NOTXOR, OnNotxor)
        ON_BN_CLICKED(IDC_XOR, OnXor)
        ON_BN_CLICKED(IDC_COPY, OnCopy)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetMapColor message handlers
/****************************************************************************
*                         CSetMapColor::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes controls
****************************************************************************/

BOOL CSetMapColor::OnInitDialog() 
   {
    CDialog::OnInitDialog();
        
    RegistryInt op(IDS_REGISTRY_MAPOP);
    op.load(R2_COPYPEN);

    UINT opval;
    switch(op.value)
       { /* op */
        default:
        case R2_COPYPEN:
           opval = IDC_COPY;
           break;
        case R2_XORPEN:
           opval = IDC_XOR;
           break;
        case R2_NOTXORPEN:
           opval = IDC_NOTXOR;
           break;
       } /* op */

    CheckRadioButton(IDC_COPY, IDC_NOTXOR, opval);
    
    RegistryInt color(IDS_REGISTRY_MAPCOLOR);
    color.load(RGB(255,255,0));
    c_Sample.SetColor(color.value);
        
    c_Map.SetCoordinates(0.0, 0.0);
    CRect r;
    c_Map.GetClientRect(&r);
    c_Map.SetMapRect(r);
    
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
   }

/****************************************************************************
*                            CSetMapColor::OnColor
* Result: void
*       
* Effect: 
*       The [Color...] button was pushed
****************************************************************************/

void CSetMapColor::OnColor() 
   {
    COLORREF color = c_Sample.GetColor();
    CColorDialog dlg(color, CC_ANYCOLOR | CC_RGBINIT);
    if(dlg.DoModal() != IDOK)
       return;
          
    c_Sample.SetColor(dlg.GetColor());
        c_Map.SetColor(dlg.GetColor());
    updateControls();
   }

/****************************************************************************
*                           CSetMapColor::OnNotxor
*                             CSetMapColro::OnXor
*                             CSetMapColor::OnCopy
* Result: void
*       
* Effect: 
*       Selects the ROP mode for the control
****************************************************************************/

void CSetMapColor::OnNotxor() 
   {
    c_Map.SetROP2(R2_NOTXORPEN);
   }

void CSetMapColor::OnXor() 
   {
    c_Map.SetROP2(R2_XORPEN);
   }

void CSetMapColor::OnCopy() 
   {
    c_Map.SetROP2(R2_COPYPEN);
   }

/****************************************************************************
*                             CSetMapColor::OnOK
* Result: void
*       
* Effect: 
*       Stores the values in the Registry and returns
****************************************************************************/

void CSetMapColor::OnOK() 
   {
    RegistryInt clr(IDS_REGISTRY_MAPCOLOR);
    clr.value = c_Sample.GetColor();
    clr.store();

    RegistryInt op(IDS_REGISTRY_MAPOP);
    if(c_Copy.GetCheck() == BST_CHECKED)
       op.value = R2_COPYPEN;
    else
    if(c_XOR.GetCheck() == BST_CHECKED)
       op.value = R2_XORPEN;
    else
    if(c_NOTXOR.GetCheck() == BST_CHECKED)
       op.value = R2_NOTXORPEN;
    op.store();
        
    CDialog::OnOK();
   }

/****************************************************************************
*                        CSetMapColor::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CSetMapColor::updateControls()
    {
     COLORREF c = c_Sample.GetColor();
     CString s;
     s.Format(_T("RGB(%d, %d, %d)"), GetRValue(c), GetGValue(c), GetBValue(c));
     CString old;
     c_RGB.GetWindowText(old);
     if(s != old)
        c_RGB.SetWindowText(s);
    } // CSetMapColor::updateControls
