// TimeFormats.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "TimeFormats.h"
#include "Query.h"
#include "msg.h"
#include "RTLMap.h"
#include "GetCaption.h"
#include "LogWnd.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CTimeFormats, CFunction)
/////////////////////////////////////////////////////////////////////////////
// CTimeFormats dialog


CTimeFormats::CTimeFormats(CWnd* pParent /*=NULL*/)
        : CFunction(CTimeFormats::IDD, pParent)
{
        //{{AFX_DATA_INIT(CTimeFormats)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CTimeFormats::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CTimeFormats)
        DDX_Control(pDX, IDC_CALLBACK_NAME_CAPTION, c_IgnoreCaption);
        DDX_Control(pDX, IDC_RADIO3, c_SpareRadio);
        DDX_Control(pDX, IDC_CALLBACK_NAME, c_CallbackName);
        DDX_Control(pDX, IDC_OUTPUT, c_Output);
        //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTimeFormats, CFunction)
        //{{AFX_MSG_MAP(CTimeFormats)
        ON_EN_CHANGE(IDC_CALLBACK_NAME, OnChangeCallbackName)
        ON_WM_SIZE()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimeFormats message handlers

BOOL CTimeFormats::OnInitDialog() 
{
        CFunction::OnInitDialog();
        
        // TODO: Add extra initialization here
        
        c_Output.InsertColumnEx(0, _T("lpTimeFormatString"), LVCFMT_LEFT);
        c_Output.InsertColumnEx(1, _T(""), LVCFMT_LEFT, -1);
        return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

/****************************************************************************
*                       CTimeFormats::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font in the relevant controls
****************************************************************************/

void CTimeFormats::SetFontToControls()
    {
#ifdef _UNICODE
     c_Output.SetFont(&UnicodeFont);
#endif
    } // CTimeFormats::SetFontToControls

/****************************************************************************
*                          CTimeFormats::Refresh
* Result: void
*       
* Effect: 
*       Shows the data for the selected locale
****************************************************************************/

void CTimeFormats::Refresh()
    {
     UpdateCode();
    } // CTimeFormats::Refresh

/****************************************************************************
*                       CTimeFormats::EnumTimeFormatsProc
* Inputs:
*       LPTSTR info: Calendar info
* Result: BOOL
*       TRUE, always
* Effect: 
*       Displays the text
****************************************************************************/
CTimeFormats * CTimeFormats::LogWnd = NULL;

/* static */ BOOL CALLBACK CTimeFormats::EnumTimeFormatsProc(LPTSTR info)
    {
     if(LogWnd == NULL)
        return TRUE;
     CString s = info;
     LCID lcid = (LCID)LogWnd->TabParent->SendMessage(UWM_QUERY, (WPARAM)QUERY_LOCALE);
     CALID calid = 0; // not applicable
     RTLMap(s, lcid);
     //LogWnd->SendMessage(UWM_LOG_DATA, (WPARAM)(LPCTSTR)new InfoListData(lcid, calid, s, _T(""), FALSE));
     int n = LogWnd->c_Output.GetItemCount();
     LogWnd->c_Output.InsertItem(n, s);
     return TRUE;
    } // 

/****************************************************************************
*                          CTimeFormats::UpdateCode
* Result: void
*       
* Effect: 
*       Updates the code example
****************************************************************************/

void CTimeFormats::UpdateCode()
    {
     if(!initialized)
        return;

     EnableQuery(QUERY_NOUSEROVERRIDE, FALSE);
     EnableQuery(QUERY_USE_CP_ACP, TRUE);
     EnableQuery(QUERY_DWORD, FALSE);

     CString defaultCallback;

     CString or = QueryTemplate(_T("[OR]"));

     CString fmt;
     fmt = QueryTemplate(_T("[EnumTimeFormats:VARIABLE]"));
     defaultCallback = _T("EnumTimeFormatsProc");

     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2: The DWORD as a string
     //----------------------------------------------------------------
     CString dwordparameter = _T(""); // todo

     //----------------------------------------------------------------
     // %3: The option flags
     //----------------------------------------------------------------
     CString options;
     DWORD flags = 0;
     GetOptionFlags(options, flags, or);
     if(options.IsEmpty())
        options = _T("0");

     //----------------------------------------------------------------
     // %4: Length: not used
     //----------------------------------------------------------------
     CString length;

     //----------------------------------------------------------------
     // %5: The variable name
     //----------------------------------------------------------------
     CString variable;
     //     variable = QueryVariable();
     //     variable.TrimLeft();
     //     variable.TrimRight();
     //     if(variable.IsEmpty())
     //        variable = _T("?");
     variable = GetVariable();

     //----------------------------------------------------------------
     // %6: dwFlags as a decimal number
     //----------------------------------------------------------------
     CString dwFlagsDecimal;
     dwFlagsDecimal.Format(_T("%d"), flags);
     
     //----------------------------------------------------------------
     // %7: The OR operator for bitwise operations
     //----------------------------------------------------------------
     // This was set when the language choice was made

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal integer
     //----------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);
     
     //----------------------------------------------------------------
     // %9: Not used
     //----------------------------------------------------------------


     //----------------------------------------------------------------
     // %10: Not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %11: The callback function name
     //----------------------------------------------------------------
     CString callbackname;
     c_CallbackName.GetWindowText(callbackname);
     callbackname.TrimLeft();
     callbackname.TrimRight();
     if(callbackname.IsEmpty())
        callbackname = defaultCallback;
     
     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1           %2               %3       %4       %5           %6        %7     %8      %9     %10       %11
     text.FormatMessage(fmt, localeName,  dwordparameter, options, length, variable, dwFlagsDecimal,  or, _T(""), _T(""), _T(""), callbackname);

     //-----------------------------------------------------------------------------------------------
     SetCode(text, !variable.IsEmpty());

     c_Output.DeleteAllItems();
     LogWnd = this;

     if(!EnumTimeFormats(EnumTimeFormatsProc, lcid, flags))
        { /* failed */
         DWORD err = ::GetLastError();
         //c_Output.AddString(ErrorString(err));
         c_Output.InsertItem(c_Output.GetItemCount(), ErrorString(err));
        } /* failed */
     else
        { /* success */
        } /* success */
     
    } // CTimeFormats::UpdateCode

/****************************************************************************
*                     CTimeFormats::OnChangeCallbackName
* Result: void
*       
* Effect: 
*       Updates the code display
****************************************************************************/

void CTimeFormats::OnChangeCallbackName() 
   {
    Refresh();
   }

/****************************************************************************
*                            CTimeFormats::OnSize
* Inputs:
*       UINT nType:
*       int cx: New client width
*       int cy: New client height
* Result: void
*       
* Effect: 
*       Resizes the output window
****************************************************************************/

void CTimeFormats::OnSize(UINT nType, int cx, int cy) 
   {
    CFunction::OnSize(nType, cx, cy);
        
    ExpandBottom(c_Output);
    ExtendColumn(c_Output);
   }

/****************************************************************************
*                            CTimeFormats::IndexOK
* Inputs:
*       CWnd * wnd: Window to check
* Result: BOOL
*       TRUE to allow the window to be indexed
*       FALSE to skip it
****************************************************************************/

BOOL CTimeFormats::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_SpareRadio)
        return FALSE;
     if(wnd == &c_IgnoreCaption)
        return FALSE;
     return TRUE;
    } // CTimeFormats::IndexOK
