#pragma once

class TimeStamp : public FILETIME{
    public:
       TimeStamp() { dwLowDateTime = dwHighDateTime = 0; }
       TimeStamp(HANDLE h) { GetFileTime(h); }
       TimeStamp(CFile & f) { GetFileTime(f); }
       TimeStamp(FILETIME t) { GetFileTime(t); }
       TimeStamp(LPCTSTR s) { WIN32_FIND_DATA fd;
       HANDLE h = ::FindFirstFile(s, &fd);
       if(h == INVALID_HANDLE_VALUE)
          {  dwLowDateTime = dwHighDateTime = 0; }
       else
          {
           *this = fd.ftCreationTime;;
           ::FindClose(h);
          }
       }
       BOOL operator ==(TimeStamp & t) { return GetTime() == t.GetTime(); }
       BOOL operator !=(TimeStamp & t) { return GetTime() != t.GetTime(); }
       BOOL operator < (TimeStamp & t) { return GetTime() <  t.GetTime(); }
       BOOL operator <=(TimeStamp & t) { return GetTime() <= t.GetTime(); }
       BOOL operator >=(TimeStamp & t) { return GetTime() >= t.GetTime(); }
       BOOL operator > (TimeStamp & t) { return GetTime() >  t.GetTime(); }
    public:
       LONGLONG GetTime() { LARGE_INTEGER t; t.LowPart = dwLowDateTime; t.HighPart = dwHighDateTime; return t.QuadPart; }
    public:
       BOOL GetFileTime(CFile & f) { return ::GetFileTime((HANDLE)(HFILE)f.m_hFile, this, NULL, NULL); }
       BOOL GetFileTime(HANDLE h)  { return ::GetFileTime(h, this, NULL, NULL); }
       void GetFileTime(FILETIME t) { *(FILETIME *)this = t; }
    public:
       CString Format() {
          SYSTEMTIME timevalue;
          if(!::FileTimeToSystemTime(this, &timevalue))
             return _T("");
          CString datestring;
          LCID lcid = LOCALE_SYSTEM_DEFAULT;
          int length = ::GetDateFormat(lcid, DATE_LONGDATE, &timevalue, NULL, NULL, 0);
          if(length == 0)
             { /* error */
              DWORD err = ::GetLastError();
              return _T("");
              } /* error */
           else
              { /* got length */
               LPTSTR p = datestring.GetBuffer(length);
               if(!::GetDateFormat(lcid, DATE_LONGDATE, &timevalue, NULL, p, length))
                  { /* failed */
                   DWORD err = ::GetLastError();
                   datestring.ReleaseBuffer();
                   return _T("");
                  } /* failed */
               else
                  { /* got data */
                   datestring.ReleaseBuffer();
                  } /* got data */
              } /* got length */
          CString timestring;
          length = ::GetTimeFormat(lcid, TIME_NOTIMEMARKER | TIME_FORCE24HOURFORMAT, &timevalue, NULL, NULL, 0);
          if(length == 0)
             { /* error */
              DWORD err = ::GetLastError();
              return _T("");
              } /* error */
           else
              { /* got length */
               LPTSTR p = timestring.GetBuffer(length);
               if(!::GetTimeFormat(lcid, TIME_NOTIMEMARKER | TIME_FORCE24HOURFORMAT, &timevalue, NULL, p, length))
                  { /* failed */
                   DWORD err = GetLastError();
                   timestring.ReleaseBuffer();
                   return _T("");
                  } /* failed */
               else
                  { /* success */
                   timestring.ReleaseBuffer();
                  } /* success */
              } /* got length */
          return datestring + _T(" ") + timestring;
       }

};
