#if !defined(AFX_UNICODE_H__AA6475DB_1EA6_43E9_9E89_EF8F7D21D868__INCLUDED_)
#define AFX_UNICODE_H__AA6475DB_1EA6_43E9_9E89_EF8F7D21D868__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Unicode.h : header file
//
#include "Function.h"
#include "ListCtrlEx.h"
#include "VerticalHeader.h"
#include "UnicodeData.h"
#include "UnicodeDisplay.h"

/////////////////////////////////////////////////////////////////////////////
// CUnicode dialog

class CUnicode : public CFunction
{
    DECLARE_DYNCREATE(CUnicode)
// Construction
public:
        CUnicode(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CUnicode)
	enum { IDD = IDD_UNICODE };
	CProgressCtrl	c_Progress;
        CButton c_FullWidth;
        CButton c_Custom;
        CButton c_ChooseCustom;
        CButton c_BestFit;
        CUnicodeDisplay     c_UnicodeInfo;
        CListCtrlEx     c_CodePoints;
	//}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CUnicode)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void Initialize();
        virtual BOOL IndexOK(CWnd * wnd);
        virtual void SetFontToControls();
protected: // methods
        void LoadCodepoints();
        void LoadInfo();
        int SearchUnicodeInfo(UINT cp);
        void updateControls();

protected: // data
        CVerticalHeader c_Header;
        UnicodeData unicode;
        POSITION CurrentPos;
        CArray<int, int> fullwidths;
        CArray<int, int> bestwidths;
        CArray<int, int> custom;
        void AdjustWidths(int);
        int SumWidths();
        
        afx_msg LRESULT OnAddElements(WPARAM, LPARAM);
        // Generated message map functions
        //{{AFX_MSG(CUnicode)
        virtual BOOL OnInitDialog();
        afx_msg void OnDblclkCodepoints(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnCustom();
        afx_msg void OnBestfit();
        afx_msg void OnFullwidth();
        afx_msg void OnChooseCustom();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnItemclickUnicodeInfo(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_UNICODE_H__AA6475DB_1EA6_43E9_9E89_EF8F7D21D868__INCLUDED_)
