// WhatIsItButton.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "WhatIsItButton.h"
#include "GetCaption.h"
#include "Help.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CWhatIsItButton, CButton)
/////////////////////////////////////////////////////////////////////////////
// CWhatIsItButton

CWhatIsItButton::CWhatIsItButton()
   {
    UserData = 0;
    HelpCursor = ::LoadCursor(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDC_HELP_POINTER));
   }

CWhatIsItButton::~CWhatIsItButton()
{
}


BEGIN_MESSAGE_MAP(CWhatIsItButton, CButton)
        //{{AFX_MSG_MAP(CWhatIsItButton)
        ON_WM_CONTEXTMENU()
        ON_COMMAND(IDM_WHAT_IS_THIS, OnWhatIsThis)
        ON_WM_SETCURSOR()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWhatIsItButton message handlers

/****************************************************************************
*                       CWhatIsItButton::OnContextMenu
* Inputs:
*       CWnd * pWnd:
*       CPoint point:
* Result: void
*       
* Effect: 
*       Pops up the "What's this?" menu item
****************************************************************************/

void CWhatIsItButton::OnContextMenu(CWnd* pWnd, CPoint point) 
   {
    CMenu menu;

    CString caption;
    GetWindowText(caption);

    BOOL what = (CHelp::FindHelpResource(caption) != NULL);

    menu.LoadMenu(IDR_WHATS_THIS);
    menu.EnableMenuItem(IDM_WHAT_IS_THIS, MF_BYCOMMAND | (what ? MF_ENABLED : (MF_DISABLED | MF_GRAYED)));
    CMenu * popup = menu.GetSubMenu(0);

    popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this); 
   }

/****************************************************************************
*                        CWhatIsItButton::OnWhatIsThis
* Result: void
*       
* Effect: 
*       Pops up help message
****************************************************************************/

void CWhatIsItButton::OnWhatIsThis() 
   {
    CString s;
    GetWindowText(s);
    CHelp dlg;
    dlg.m_HelpName = s;
    dlg.DoModal();
   }

/****************************************************************************
*                         WhatIsItButton::OnSetCursor
* Inputs:
*       CWnd * pWnd: ignroed
*       UINT nHitTest: ignored
*       UINT message: ignored
* Result: BOOL
*       TRUE, always
* Effect: 
*       Indicates there is help (potentially) available for this item
****************************************************************************/

BOOL CWhatIsItButton::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
   {
    ::SetCursor(HelpCursor);
    return TRUE;
        
    //return CButton::OnSetCursor(pWnd, nHitTest, message);
   }
