// WhatIsItSpinButtonCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "WhatIsItSpinButtonCtrl.h"
#include "GetCaption.h"
#include "Help.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CWhatIsItSpinButtonCtrl, CSpinButtonCtrl7)
/////////////////////////////////////////////////////////////////////////////
// CWhatIsItSpinButtonCtrl

CWhatIsItSpinButtonCtrl::CWhatIsItSpinButtonCtrl()
   {
    UserData = 0;
    HelpCursor = ::LoadCursor(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDC_HELP_POINTER));
   }

CWhatIsItSpinButtonCtrl::~CWhatIsItSpinButtonCtrl()
{
}


BEGIN_MESSAGE_MAP(CWhatIsItSpinButtonCtrl, CSpinButtonCtrl7)
        //{{AFX_MSG_MAP(CWhatIsItSpinButtonCtrl)
        ON_COMMAND(IDM_WHAT_IS_THIS, OnWhatIsThis)
        ON_WM_CONTEXTMENU()
        ON_WM_SETCURSOR()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWhatIsItSpinButtonCtrl message handlers

/****************************************************************************
*                       CWhatIsItSpinButtonCtrl::OnContextMenu
* Inputs:
*       CWnd * pWnd:
*       CPoint point:
* Result: void
*       
* Effect: 
*       Pops up the "What's this?" menu item, based on the control ID of the
*       control
****************************************************************************/

void CWhatIsItSpinButtonCtrl::OnContextMenu(CWnd* pWnd, CPoint point) 
   {
    CMenu menu;
    
    UINT id = GetDlgCtrlID(); // get current ID
    BOOL what = (::FindResource(AfxGetInstanceHandle(), MAKEINTRESOURCE(id), _T("RTF")) != NULL);

    menu.LoadMenu(IDR_WHATS_THIS);
    menu.EnableMenuItem(IDM_WHAT_IS_THIS, MF_BYCOMMAND | (what ? MF_ENABLED : (MF_DISABLED | MF_GRAYED)));
    CMenu * popup = menu.GetSubMenu(0);
    popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
   }

/****************************************************************************
*                    CWhatIsItSpinButtonCtrl::OnWhatIsThis
* Result: void
*       
* Effect: 
*       Pops up the help message
****************************************************************************/

void CWhatIsItSpinButtonCtrl::OnWhatIsThis() 
   {
    UINT id = GetDlgCtrlID();

    CString s;
    s.Format(_T("#%d"), id);
    
    CHelp dlg;
    dlg.m_HelpName = s;
    dlg.DoModal();
   }


/****************************************************************************
*                    CWhatIsItSpinButtonCtrl::OnSectCursor
* Inputs:
*       CWnd * pWnd: ignored
*       UINT nHitTest: ignored
*       UINT message: ignored
* Result: BOOL
*       TRUE, always
* Effect: 
*       Indicates there is help (potentially) available for this item
****************************************************************************/

BOOL CWhatIsItSpinButtonCtrl::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
   {
    ::SetCursor(HelpCursor);
    return TRUE;
   }
