// WhatIsThisEditNotify.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "WhatIsThisEditNotify.h"
#include "lctypemsg.h"
#include "GetCaption.h"
#include "msg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DECLARE_MESSAGE(UWM_SELECT_LCTYPE)
DECLARE_MESSAGE(UWM_DESELECT_ALL)


/////////////////////////////////////////////////////////////////////////////
// CWhatIsThisEditNotify

CWhatIsThisEditNotify::CWhatIsThisEditNotify()
{
 HelpBrush.CreateSolidBrush(::GetSysColor(COLOR_INFOBK));
 selected = FALSE;
}

CWhatIsThisEditNotify::~CWhatIsThisEditNotify()
{
}


BEGIN_MESSAGE_MAP(CWhatIsThisEditNotify, CWhatIsThisEdit)
        ON_REGISTERED_MESSAGE(UWM_DESELECT_ALL, OnDeselectAll)
        ON_WM_CTLCOLOR_REFLECT()
        //{{AFX_MSG_MAP(CWhatIsThisEditNotify)
        ON_WM_SETFOCUS()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWhatIsThisEditNotify message handlers

/****************************************************************************
*                          CWhatIsThisEditNotify::CtlColor
* Inputs:
*       CDC * pDC: DC
*       UINT nCtlColor: CTLCOLOR_STATIC because the controls are disabled
* Result: HBRUSH
*       NULL if the default color is to be used
*       otherwise a handle to the help brush if the control has the focus
****************************************************************************/

HBRUSH CWhatIsThisEditNotify::CtlColor(CDC* pDC, UINT nCtlColor) 
   {
    if(!IsWindowEnabled())
       return NULL;
    
    LOGBRUSH br;
    HelpBrush.GetLogBrush(&br);
    pDC->SetBkColor(br.lbColor);
    if(selected)
       return (HBRUSH)HelpBrush;
        
    return NULL;
   } // CWhatIsThisEditNotify::CtlColor

/****************************************************************************
*                       CWhatIsThisEditNotify::OnSetFocus
* Inputs:
*       CWnd * pOldWnd: ignored
* Result: void
*       
* Effect: 
*       Sends message to parent
****************************************************************************/

void CWhatIsThisEditNotify::OnSetFocus(CWnd* pOldWnd) 
   {
    GetParent()->SendMessage(UWM_DESELECT_ALL);
    CEdit::OnSetFocus(pOldWnd);
    selected = TRUE;
    GetParent()->SendMessage(UWM_SELECT_LCTYPE, 0, (LPARAM)GetDlgCtrlID());
    Invalidate();
   } // CWhatIsThisEditNotify::OnSetFocus

/****************************************************************************
*                       CWhatIsThisEdit::OnDeselectAll
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       If the window was selected, deselect and invalidate
****************************************************************************/

LRESULT CWhatIsThisEditNotify::OnDeselectAll(WPARAM, LPARAM)
    {
     if(!selected)
        return 0;
     selected = FALSE;
     Invalidate();
     return 0;
    } // CWhatIsThisEditNotify::OnDeselectAll
