#include "stdafx.h"
#include "WideHelper.h"
#include "mbtrace.h"


/****************************************************************************
*                        WideHelper::SelChangeWide
* Inputs:
*       CRichEditCtrlEx & c_Wide
*       CHexEditCtrl & c_WideHex
* Result: void
*       
* Effect: 
*       Reflects changes in the wide-character edit control to the
*       wide-hex control
****************************************************************************/

/* static */ void WideHelper::OnSelChangeWide(CRichEditCtrlEx & c_Wide, CHexEditCtrl & c_WideHex)
    {
     long low;
     long high;
     c_Wide.GetSel(low, high);
     MB_TRACE2("=>WideHelper::OnSelChangeWide() sel=[%d, %d]\n", low, high);

     c_WideHex.SetSel(low, high);

     MB_TRACE0("<=WideHelper::OnSelChangeWide\n");
    } // WideHelper::OnSelChangeWide

/****************************************************************************
*                    CWideHelper::OnSelChangeWideHex
* Inputs:
*       CRichEditCtrlEx & c_Wide
^       CHexEditCtrl & c_WideHex
* Result: void
*       
* Effect: 
*       Handleschanges in the wide-hex control, reflecting them to the wide
*       contro
****************************************************************************/

/* static */ void WideHelper::OnSelChangeWideHex(CRichEditCtrlEx & c_Wide, CHexEditCtrl & c_WideHex)
    {
     MB_TRACE0("=>WideHelper::OnSelchangeWidehex()\n");

     long low;
     long high;

     c_WideHex.GetSel(low, high);
     c_Wide.SetSelNoNotify(low, high);

     MB_TRACE0("<=WideHelper::OnSelchangeWidehex\n");
    } // WideHelper::OnSelChangeWideHex

/****************************************************************************
*                            WideHelper::ChangeWide
* Inputs:
*       CRichEditCtrlEx & c_Wide
*       CHexEditCtrl & c_WideHex
* Result: void
*       
* Effect: 
*       A character has been changed in the wide-character input control.
*       Reflect it in the hex display
****************************************************************************/

/* static */ void WideHelper::OnChangeWide(CRichEditCtrlEx & c_Wide, CHexEditCtrl & c_WideHex)
    {
     CString s;
     c_Wide.GetWindowText(s);
     long low;
     long high;
     c_Wide.GetSel(low, high);
     MB_TRACE2("=>WideHelper::OnChangeWide() sel=[%d, %d]\n", low, high);
     MB_TRACE3("=>WideHelper::OnChangeWide!c_WideHex.SetWindowText(\"%s\", %d, %d, FALSE)\n", s, low, high);
     c_WideHex.SetWindowText(s, low, high, FALSE);
     MB_TRACE0("<=WideHelper::OnChangeWide!c_WideHex.SetWindowText\n");

     MB_TRACE0("<=WideHelper::OnChangeWide\n");
    } // WideHelper::OnChangeWide

/****************************************************************************
*                       WideHelper::OnChangeWideHex
* Inputs:
*       CRichEditCtrlEx & c_Wide:
*       CHexEditCtrl & c_WideHex:
* Result: void
*       
* Effect: 
*       A change was made in the hex window. Replace the characters in
*       the input window
****************************************************************************/

/* static */ void WideHelper::OnChangeWideHex(CRichEditCtrlEx & c_Wide, CHexEditCtrl & c_WideHex)
    {
     CString s;
     long low;
     long high;
     c_Wide.GetSel(low, high);
     MB_TRACE2("=>CIsTextUnicode::OnChangeWidehex() sel=[%d, %d]\n", low, high);
     c_WideHex.GetWindowText(s);

     MB_TRACE1("=>WideHelper::OnChangeWidehex!c_Wide.SetWindowTextNoNotify(\"%s\")\n", s);
     c_Wide.SetWindowTextNoNotify(s);
     MB_TRACE0("<=WideHelper::OnChangeWidehex!c_Wide.SetWindowTextNoNotify\n");

     MB_TRACE2("=>WideHelper::OnChangeWidehex!c_Wide.SetSelNoNotify(%d, %d)\n", low, high);
     c_Wide.SetSelNoNotify(low, high);
     MB_TRACE0("<=WideHelper::OnChangeWidehex!c_Wide.SetSelNoNotify\n");
     MB_TRACE0("<=WideHelper::OnChangeWidehex\n");
    } // WideHelper::ChangeWideHex
