/*****************************************************************************
* This compensates for a VS6 defect where _tstof was not defined because the
* C library did not have a wtof function
*****************************************************************************/
#include "stdafx.h"
#ifndef _tstof

#ifdef _UNICODE
#include "atlconv.h"
#endif // _UNICODE
#include "_tstof.h"

/****************************************************************************
*                                    _tstof
* Inputs:
*       LPCTSTR v: String to convert
* Result: double
*       Double-precision result
* Notes: 
*       This is done because Microsoft omitted the _ttof definition from
*       tchar.h
*       This error has been propagated through VS .NET 2003, at least!
****************************************************************************/

#ifdef _UNICODE
double _tstof(LPCTSTR v)
    {
    USES_CONVERSION;

     LPCSTR p = W2A(v);

     double d = atof(p);
     return d;
    } // _ttof
#endif // _UNICODE
    
#endif // _tstof
    
