#include "stdafx.h"
#include "tabview.h"
#include "function.h"
#include "pageref.h"

/****************************************************************************
*                           CFunction::GetPageName
* Inputs:
*       CWnd * page: Page to capture
* Result: CString
*       The page name of the page
****************************************************************************/

CString GetPageName(CFunction * page)
   {
    CString linkname;
    CTabView * parent = (CTabView *)page->GetParent();
    parent->GetPageTitle(GetPageIndex(page), linkname);
    return linkname;
   } // GetPageName

/****************************************************************************
*                           CFunction::GetPageIndex
* Inputs:
*       CFunction * page: Desired page
* Result: int
*       Index of page in tabbed dialog
****************************************************************************/

int GetPageIndex(CFunction * page)
   {
    CTabView * parent = (CTabView *)page->GetParent();

    return parent->GetIndex(page);
   } // GetPageIndex
