*****************************************************************************
** GetLocaleInfo
*****************************************************************************   
[GetLocaleInfo:Fixed]
// %2
TCHAR %5[%4];
LCID lcid = %1;
if(!GetLocaleInfo(lcid, %2%3, %5, sizeof(%5)/sizeof(TCHAR)))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */
// ... use %5 here
**---------------------------------------------------------------------------
[GetLocaleInfo:Variable]
// %2
LCID lcid = %1;
LPTSTR %5 = NULL;
{ /* get %2 */
 int length = GetLocaleInfo(lcid, %2%3, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* valid length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 != NULL)
        { /* got space */
         if(!GetLocaleInfo(lcid, %2%3, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             // .. handle error here
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got space */
    } /* valid length */
} /* get %2 */

if(%5 != NULL)
   { /* have value */
    // ... use %5 here
    free(%5);
   } /* have value */
**---------------------------------------------------------------------------
[GetLocaleInfo:DWORD]
// %2
DWORD %5;
LCID lcid = %1;
if(!GetLocaleInfo(lcid, %2%3 %7 LOCALE_RETURN_NUMBER, (LPTSTR)&%5, sizeof(DWORD)))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */
// ... use %5 here
*****************************************************************************
** OR
*****************************************************************************   
[OR]
|
*****************************************************************************
** EnumCalendarInfo
*****************************************************************************   
[EnumCalendarInfo]
static BOOL CALLBACK %11(LPTSTR info)
  {
   // use info, which is a string for %2, here
   return TRUE; // continue enumeration
  } // %11 

LCID lcid = %1;
if(!EnumCalendarInfo(%11, lcid, %9, %3))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */

*****************************************************************************
** EnumCalendarInfoEx
*****************************************************************************   
[EnumCalendarInfoEx]
static BOOL CALLBACK %11(LPTSTR info, CALID calid)
  {
   // use info, which is a string for %2, here
   return TRUE; // continue enumeration
  } // %11

LCID lcid = %1;
if(!EnumCalendarInfoEx(%11, lcid, %9, %3))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */

*****************************************************************************
** GetCalendarInfo
*****************************************************************************   
[GetCalendarInfo:VARIABLE]
// %2
LPTSTR %5;
LCID lcid = %1;
{ /* %2 */
 int length = GetCalendarInfo(lcid, %9, %3, NULL, 0, NULL);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* success */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 != NULL)
        { /* got space */
         if(!GetCalendarInfo(lcid, %9, %3, %5, length, NULL))
            { /* error */
             DWORD err = GetLastError();
             // .. handle error here
            } /* error */
        } /* got space */
    } /* success */
} /* %2 */
if(%5 != NULL)
   { /* got %2 */
    // use %5 here ...
    free(%5);
   } /* got %2 */
**---------------------------------------------------------------------------
[GetCalendarInfo:DWORD]
// %2
DWORD %5;
LCID lcid = %1;
if(!GetCalendarInfo(lcid, %9, %3, NULL, 0, &%5))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */
*****************************************************************************
** EnumDateFormats
*****************************************************************************   
[EnumDateFormats:VARIABLE]

static BOOL CALLBACK %11(LPTSTR fmt)
   {
    // Use fmt string here
    return TRUE; // continue enumeration
   } // %11

LCID lcid = %1;
if(!EnumDateFormats(%11, lcid, %3))
   { /* error */
    DWORD err = GetLastError();
    // .. handle the error here
   } /* error */

*****************************************************************************
** EnumDateFormatsEx
*****************************************************************************   
[EnumDateFormatsEx:VARIABLE]
static BOOL CALLBACK %11(LPTSTR fmt, CALID CalendarID)
   {
    // Use fmt string and CalendarID here
    return TRUE;  // continue enumeration
   } // %11

LCID lcid = %1;
if(!EnumDateFormatsEx(%11, lcid, %3))
   { /* error */
    DWORD err = GetLastError();
    // .. handle the error here
   } /* error */
*****************************************************************************
** EnumSystemCodePages
*****************************************************************************   
[EnumSystemCodePages:VARIABLE]
static BOOL CALLBACK %11(LPTSTR codepage)
   {
    int %5 = _ttoi(codepage);
    // use either 'codepage' or '%5' here
    return TRUE; // continue enumeration
   } // %11

if(!EnumSystemCodePages(%11, %3))
   { /* error */
    DWORD err = GetLastError();
    // .. handle the error here
   } /* error */
*****************************************************************************
** EnumSystemGeoID
*****************************************************************************   
[EnumSystemGeoID:VARIABLE]
static BOOL CALLBACK %11(GEOID id)
   {
    // use GeoID here
   return TRUE;  // continue enumeration
   } // %11

if(!EnumSystemGeoID(%3, 0, %11))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */

*****************************************************************************
** EnumLanguageGroupLocales
*****************************************************************************   
[EnumLanguageGroupLocales:VARIABLE]
static BOOL CALLBACK %11(LPGRPID group, LCID locale, LPTSTR localestring, LONG_PTR lParam)
   {
    %5 * p = (%5 *)lParam;
    // .. use parameters here
    return TRUE;  // continue enumeration
   } // %11

%5 p;
if(!EnumLanguageGroupLocales(%11, %2, 0, (LONG_PTR)&p))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */

*****************************************************************************
** EnumSystemLocales
*****************************************************************************
[EnumSystemLocales:VARIABLE]
static BOOL CALLBACK %11(LPTSTR locale)
   {
    LCID lcid = (LCID)_tcstoul(locale, NULL, 16);
    // .. use locale string or lcid here
    return TRUE; // continue enumeration
   } // %11

if(!EnumSystemLocales(%11, %3))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */

*****************************************************************************
** GetGeoInfo
*****************************************************************************   
[GetGeoInfo:VARIABLE]
// %2
LPTSTR %5 = NULL;
GEOID geoid = (GEOID)%3; // %11
{ /* get %2 */
 int length = GetGeoInfo(geoid, %2, NULL, 0, %9);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* valid length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 != NULL)
        { /* got space */
         if(!GetGeoInfo(geoid, %2, %5, length, %9))
            { /* failed */
             DWORD err = GetLastError();
             // .. handle error here
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got space */
    } /* valid length */
} /* get %2 */

if(%5 != NULL)
   { /* got %2 */
    // ... use %5 here
    free(%5);
   } /* got %2 */
**-----------------------------------------------------------------------------   
[GetGeoInfo:DOUBLE]
// %2
LPTSTR %5 = NULL;
GEOID geoid = (GEOID)%3; // %11
{ /* get %2 */
 int length = GetGeoInfo(geoid, %2, NULL, 0, %9);
 if(length == 0)
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */
else
   { /* valid length */
    %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
    if(%5 != NULL)
       { /* got space */
        if(!GetGeoInfo(geoid, %2, %5, length, %9))
           { /* failed */
            DWORD err = GetLastError();
            // .. handle error here
            free(%5);
            %5 = NULL;
           } /* failed */
       } /* got space */
   } /* valid length */
} /* get %2 */

if(%5 != NULL)
  { /* have value */
   double n%5 = _tstof(%5);
   // ... use %5 or n%5 here
   free(%5);
  } /* have value */

*****************************************************************************
** EnumTimeFormats
*****************************************************************************   
[EnumTimeFormats:VARIABLE]
static BOOL CALLBACK %11(LPTSTR locale)
   {
    // .. use parameter here
    return TRUE; // continue enumeration
   }

LCID lcid = %1;
if(!EnumTimeFormats(%11, lcid, %3))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */

*****************************************************************************
** GetCPInfo
*****************************************************************************
[GetCPInfo:VARIABLE]
CPINFO %5;
if(!GetCPInfo(%2, &%5)) // %10
   { /* failed */
    DWORD err = GetLastError();
    // .. handle error here
   } /* failed */
// .. use CPINFO %5 here
*****************************************************************************
** GetCPInfoEx
*****************************************************************************
[GetCPInfoEx:VARIABLE]
CPINFOEX %5;
if(!GetCPInfoEx(%2, 0, &%5))  // %10
   { /* failed */
    DWORD err = GetLastError();
    // .. handle error here
   } /* failed */
// .. use CPINFOEX %5 here

*****************************************************************************
** GetCurrencyFormat
*****************************************************************************
[GetCurrencyFormat:VARIABLE]
CURRENCYFMT %11;
%11.NumDigits = %12;
%11.LeadingZero = %13;
%11.Grouping = %14;
%11.lpDecimalSep = _T("%15");
%11.lpThousandSep = _T("%16");
%11.NegativeOrder = %17;
%11.PositiveOrder = %18;
%11.lpCurrencySymbol = _T("%19");
LPTSTR %5 = NULL;
LCID lcid = %1;
{ /* GetCurrencyFormat */
 int length = GetCurrencyFormat(lcid, %3, %9, &%11, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
    // .. handle error here
    } /* error */
 else
    { /* valid length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 != NULL)
        { /* got space */
         if(GetCurrencyFormat(lcid, %3, %9, &%11, %5, length) == 0)
            { /* failed */
             DWORD err = GetLastError();
             // .. handle error here
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got space */
    } /* valid length */
} /* GetCurrencyFormat */

if(%5 != NULL)
   { /* have value */
   // ... use %5 here
    free(%5);
   } /* have value */
**---------------------------------------------------------------------------
[GetCurrencyFormat:DEFAULT]
LPTSTR %5 = NULL;
LCID lcid = %1;
{ /* GetCurrencyFormat */
 int length = GetCurrencyFormat(lcid, %3, %9, NULL, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
    // .. handle error here
    } /* error */
 else
    { /* valid length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 != NULL)
        { /* got space */
         if(GetCurrencyFormat(lcid, %3, %9, NULL, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             // .. handle error here
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got space */
    } /* valid length */
} /* GetCurrencyFormat */

if(%5 != NULL)
   { /* have value */
   // ... use %5 here
    free(%5);
   } /* have value */
*****************************************************************************
** TranslateDigits
*****************************************************************************
[TranslateDigits]
BOOL TranslateDigits(LCID lcid, LPTSTR digits)
    {
     BOOL ok = TRUE;
     DWORD err = GetLastError();
     LPTSTR snativedigits_data;
     { /* get LOCALE_SNATIVEDIGITS */
      int length = GetLocaleInfo(lcid, LOCALE_SNATIVEDIGITS, NULL, 0);
      snativedigits_data = (LPTSTR)malloc(length * sizeof(TCHAR));
      if(snativedigits_data != NULL)
         { /* got buffer */
          if(!GetLocaleInfo(lcid, LOCALE_SNATIVEDIGITS, p, length))
             { /* failed */
              err = GetLastError();
              snativedigits_data = _T("0123456789");
              ok = FALSE;
             } /* failed */
          else
             { /* success */
              snativedigits_data.ReleaseBuffer();
              err = ERROR_SUCCESS;
             } /* success */
         } /* got buffer */
      else
         { /* allocation failed */
          // .. deal with allocation failure here
          snativedigits_data = _T("0123456789");
          ok = FALSE;
          err = ERROR_OUTOFMEMORY;
         } /* allocation failed */
     } /* get LOCALE_SNATIVEDIGITS */

     // Replace the digits
     BOOL change = FALSE;
     for(int i = 0; i < digits.GetLength(); i++)
        { /* replace digits */
         TCHAR ch = digits[i];
         static const LPTSTR digitcharacters = _T("0123456789");
         int p = digitcharacters.Find(ch);
         if(p >= 0)
            { /* replace */
             if(ch != snativedigits_data[p])
                { /* different */
                 digits.Replace(ch, snativedigits_data[p]);
                 change = TRUE;
                } /* different */
            } /* replace */
        } /* replace digits */

     ok &= change;

     if(snativedigits_data != NULL && err != ERROR_OUTOFMEMORY)
        free(snativedigits_data);

     SetLastError(err);
     return ok;
    } // TranslateDigits
*****************************************************************************
** ConvertDefaultLocale
*****************************************************************************
[ConvertDefaultLocale]
LCID lcid = %1;
LCID %5 = ConvertDefaultLocale(lcid);

*****************************************************************************
** GetSystemDefaultLangID
*****************************************************************************
[GetSystemDefaultLangID]
LANGID %5 = GetSystemDefaultLangID();

*****************************************************************************
** GetUserDefaultLangID
*****************************************************************************
[GetUserDefaultLangID]
LANGID %5 = GetUserDefaultLangID();

*****************************************************************************
** GetUserDefaultLCID
*****************************************************************************
[GetUserDefaultLCID]
LCID %5 = GetUserDefaultLCID();

*****************************************************************************
** GetUserDefaultUILanguage
*****************************************************************************
[GetUserDefaultUILanguage]
LANGID %5 = GetUserDefaultUILanguage();

*****************************************************************************
** GetUserGeoID
*****************************************************************************
[GetUserGeoID]
GEOID %5 = GetUserGeoID(GEOCLASS_NATION);

*****************************************************************************
** GetNLSVersion
*****************************************************************************
[GetNLSVersion:2003]
NLSVERSIONINFO %5 = {sizeof(NLSVERSIONINFO) };
LCID lcid = %1;
if(!GetNLSVersion(%2, lcid, &%5))
   { /* failed */
    DWORD err = GetLastError();
    // .. handle error here
   } /* failed */

// Use %5 values here
**---------------------------------------------------------------------------
[GetNLSVersion:Compatible]
NLSVERSIONINFO %5 = {sizeof(NLSVERSIONINFO) };
LCID lcid = %1;
{ /* GetNLSVersion */
 typedef BOOL (WINAPI * GetNLSVersionProc)(NLS_FUNCTION function, LCID locale, LPNLSVERSIONINFO info);
 GetNLSVersionProc GetNLSVersion;

 HMODULE kernel32 = GetModuleHandle(_T("KERNEL32"));
 GetNLSVersion = (GetNLSVersionProc)GetProcAddress(kernel32, "GetNLSVersion"); // note 8-bit name, not _T()!
 if(GetNLSVersion == NULL || !GetNLSVersion(%2, lcid, &%5))
    { /* failed */
     DWORD err = GetLastError();
     // .. deal with error here
    } /* failed */
} /* GetNLSVersion */
*****************************************************************************
** IsNLSDefinedString
*****************************************************************************
[IsNLSDefinedString:2003:VARIABLE]
NLSVERSIONINFO %5 = {sizeof(NLSVERSIONINFO) };
if(!IsNLSDefinedString(%3, 0, &%5, sample, %4))
   { /* failed */
    DWORD err = GetLastError();
    // .. handle error here
    if(err == ERROR_SUCCESS)
       { /* invalid characters */
        // .. handle invalid characters here
       } /* invalid characters */
    else
       { /* other error */
        DWORD err = GetLastError();
        // .. deal with other errors here
       } /* other error */
   } /* failed */
**---------------------------------------------------------------------------
[IsNLSDefinedString:Compatible:VARIABLE]
LCID lcid = %1;
{ /* IsNLSDefinedString */
 NLSVERSIONINFO %5 = {sizeof(NLSVERSIONINFO) };

 // First, get the function pointer from kernel32.dll
 typedef BOOL (WINAPI * GetNLSVersionProc)(NLS_FUNCTION function, LCID locale, LPNLSVERSIONINFO info);
 GetNLSVersionProc GetNLSVersion;

 HMODULE kernel32 = GetModuleHandle(_T("KERNEL32"));
 GetNLSVersion = (GetNLSVersionProc)GetProcAddress(kernel32, "GetNLSVersion"); // note 8-bit name, not _T()!
 if(GetNLSVersion == NULL || !GetNLSVersion(%2, lcid, &%5))
    { /* failed */
     DWORD err = GetLastError();
     // .. deal with error here
    } /* failed */
 else
    { /* got NLSVersion */
     // .. change NLSVersion information if needed
     LPWSTR sample = L"%9";
     typedef BOOL (WINAPI * IsNLSDefinedStringProc)(NLS_FUNCTION, DWORD, LPNLSVERSIONINFO, LPCWSTR, int);
     IsNLSDefinedStringProc pIsNLSDefinedString = (INLSDefinedStringProc)GetProcAddress(kernel32, "IsNLSDefinedString"); // 8-bit string name!
     if(pIsNLSDefinedString == NULL || !pIsNLSDefinedString(%3, 0, &%5, sample, %4))
        { /* failed */
         DWORD err = GetLastError();
         if(err == ERROR_SUCCESS)
            { /* invalid characters */
             // .. deal with invalid characters response here
            } /* invalid characters */
         else
            { /* other error */
             // .. deal with other error here
            } /* other error */
        } /* failed */
     else
        { /* IsNLSDefinedString succeeded */
         // .. deal with success here
        } /* IsNLSDefinedString succeeded */
    } /* got NLSVersion */
} /* IsNLSDefinedString */
**---------------------------------------------------------------------------
[IsNLSDefinedString:2003:FIXED]
LPWSTR %5;
%5 = L"%9";
if(!IsNLSDefinedString(%2, 0, NULL, %5, %4))
   { /* failed */
    DWORD err = GetLastError();
    if(err == ERROR_SUCCESS)
       { /* Contains invalid characters */
        // .. handle invalid characters here
       } /* Contains invalid characters */
    else
       { /* other error */
        // .. handle error here
       } /* other error */
   } /* failed */

// Use %5 values here
**---------------------------------------------------------------------------
[IsNLSDefinedString:Compatible:FIXED]
LCID lcid = %1;
{ /* IsNLSDefinedString */
 NLSVERSIONINFO %5 = {sizeof(NLSVERSIONINFO) };
 typedef BOOL (WINAPI * GetNLSVersionProc)(NLS_FUNCTION function, LCID locale, LPNLSVERSIONINFO info);
 GetNLSVersionProc GetNLSVersion;
 
 HMODULE kernel32 = GetModuleHandle(_T("KERNEL32"));
 GetNLSVersion = (GetNLSVersionProc)GetProcAddress(kernel32, "GetNLSVersion"); // note 8-bit name, not _T()!
 if(GetNLSVersion == NULL || !GetNLSVersion(%2, lcid, &%5))
    { /* failed */
     DWORD err = GetLastError();
     // .. deal with error here
    } /* failed */
} /* IsNLSDefinedString */
*****************************************************************************
** GetNumberFormat
*****************************************************************************
[GetNumberFormat:VARIABLE]
NUMBERFMT %11;
%11.NumDigits = %12;
%11.LeadingZero = %13;
%11.Grouping = %14;
%11.lpDecimalSep = _T("%15");
%11.lpThousandSep = _T("%16");
%11.NegativeOrder = %17;
LPTSTR %5 = NULL;
LCID lcid = %1;
{ /* GetNumberFormat */
 int length = GetNumberFormat(lcid, %3, %9, &%11, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
    // .. handle error here
    } /* error */
 else
    { /* valid length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 != NULL)
        { /* got space */
         if(GetNumberFormat(lcid, %3, %9, &%11, %5, length) == 0)
            { /* failed */
             DWORD err = GetLastError();
             // .. handle error here
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got space */
    } /* valid length */
} /* GetNumberFormat */

if(%5 != NULL)
   { /* have value */
   // ... use %5 here
    free(%5);
   } /* have value */
**---------------------------------------------------------------------------
[GetNumberFormat:DEFAULT]
LPTSTR %5 = NULL;
LCID lcid = %1;
{ /* GetNumberFormat */
 int length = GetNumberFormat(lcid, %3, %9, NULL, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
    // .. handle error here
    } /* error */
 else
    { /* valid length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 != NULL)
        { /* got space */
         if(GetNumberFormat(lcid, %3, %9, NULL, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             // .. handle error here
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got space */
    } /* valid length */
} /* GetNumberFormat */

if(%5 != NULL)
   { /* have value */
   // ... use %5 here
    free(%5);
   } /* have value */
*****************************************************************************
** GetDateFormat
*****************************************************************************
[GetDateFormat:NOW]

LPTSTR %5;
LCID lcid = %1;
LPCTSTR fmt = _T("%2");
{ /* GetDateFormat */
 int length = GetDateFormat(lcid, %3, NULL, fmt, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* got length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 == NULL)
        { /* allocation failed */
         // .. handle allocation error here
        } /* allocation failed */
     else
        { /* got buffer */
         if(!GetDateFormat(lcid, %3, NULL, fmt, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got buffer */
    } /* got length */
} /* GetDateFormat */
if(%5 != NULL)
   { /* got date */
    // .. process date here
   } /* got date */
**-----------------------------------------------------------------------------
[GetDateFormat:NOW:DEFAULT]

LPTSTR %5;
LCID lcid = %1;
{ /* GetDateFormat */
 int length = GetDateFormat(lcid, %3, NULL, NULL, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* got length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 == NULL)
        { /* allocation failed */
         // .. handle allocation error here
        } /* allocation failed */
     else
        { /* got buffer */
         if(!GetDateFormat(lcid, %3, NULL, NULL, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got buffer */
    } /* got length */
} /* GetDateFormat */
if(%5 != NULL)
   { /* got date */
    // .. process date here
   } /* got date */
**-----------------------------------------------------------------------------
[GetDateFormat:SPECIFICTIME]
SYSTEMTIME %9;
LCID lcid = %1;
LPCTSTR fmt = _T("%2");
// .. Set the time value here
{ /* GetDateFormat */
 int length = GetDateFormat(lcid, %3, &%9, fmt, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* got length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 == NULL)
        { /* allocation failed */
         // .. handle allocation error here
        } /* allocation failed */
     else
        { /* got buffer */
         if(!GetDateFormat(lcid, %3, &%9, fmt, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got buffer */
    } /* got length */
} /* GetDateFormat */
if(%5 != NULL)
   { /* got date */
    // .. process date here
   } /* got date */
**-----------------------------------------------------------------------------
[GetDateFormat:SPECIFICTIME:DEFAULT]
SYSTEMTIME %9;
LCID lcid = %1;
// .. Set the time value here
{ /* GetDateFormat */
 int length = GetDateFormat(lcid, %3, &%9, NULL, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* got length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 == NULL)
        { /* allocation failed */
         // .. handle allocation error here
        } /* allocation failed */
     else
        { /* got buffer */
         if(!GetDateFormat(lcid, %3, &%9, NULL, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got buffer */
    } /* got length */
} /* GetDateFormat */
if(%5 != NULL)
   { /* got date */
    // .. process date here
   } /* got date */

*****************************************************************************
** GetTimeFormat
*****************************************************************************
[GetTimeFormat:NOW]

LPTSTR %5;
LCID = %1;
LPCTSTR fmt = _T("%2");
{ /* GetTimeFormat */
 int length = GetTimeFormat(lcid, %3, NULL, fmt, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* got length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 == NULL)
        { /* allocation failed */
         // .. handle allocation error here
        } /* allocation failed */
     else
        { /* got buffer */
         if(!GetTimeFormat(lcid, %3, NULL, fmt, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got buffer */
    } /* got length */
} /* GetTimeFormat */
if(%5 != NULL)
   { /* got Time */
    // .. process Time here
   } /* got Time */
**-----------------------------------------------------------------------------
[GetTimeFormat:NOW:DEFAULT]

LPTSTR %5;
LCID = %1;
{ /* GetTimeFormat */
 int length = GetTimeFormat(lcid, %3, NULL, NULL, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* got length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 == NULL)
        { /* allocation failed */
         // .. handle allocation error here
        } /* allocation failed */
     else
        { /* got buffer */
         if(!GetTimeFormat(lcid, %3, NULL, NULL, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got buffer */
    } /* got length */
} /* GetTimeFormat */
if(%5 != NULL)
   { /* got Time */
    // .. process Time here
   } /* got Time */
**-----------------------------------------------------------------------------
[GetTimeFormat:SPECIFICTIME]
SYSTEMTIME %9;
LCID lcid = %1;
LPCTSTR fmt = _T("%2");
// .. Set the time value here
{ /* GetTimeFormat */
 int length = GetTimeFormat(lcid, %3, &%9, fmt, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* got length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 == NULL)
        { /* allocation failed */
         // .. handle allocation error here
        } /* allocation failed */
     else
        { /* got buffer */
         if(!GetTimeFormat(lcid, %3, &%9, fmt, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got buffer */
    } /* got length */
} /* GetTimeFormat */
if(%5 != NULL)
   { /* got Time */
    // .. process Time here
   } /* got Time */
**-----------------------------------------------------------------------------
[GetTimeFormat:SPECIFICTIME:DEFAULT]
SYSTEMTIME %9;
LCID lcid = %1;
// .. Set the time value here
{ /* GetTimeFormat */
 int length = GetTimeFormat(lcid, %3, &%9, NULL, NULL, 0);
 if(length == 0)
    { /* error */
     DWORD err = GetLastError();
     // .. handle error here
    } /* error */
 else
    { /* got length */
     %5 = (LPTSTR)malloc(length * sizeof(TCHAR));
     if(%5 == NULL)
        { /* allocation failed */
         // .. handle allocation error here
        } /* allocation failed */
     else
        { /* got buffer */
         if(!GetTimeFormat(lcid, %3, &%9, NULL, %5, length))
            { /* failed */
             DWORD err = GetLastError();
             free(%5);
             %5 = NULL;
            } /* failed */
        } /* got buffer */
    } /* got length */
} /* GetTimeFormat */
if(%5 != NULL)
   { /* got Time */
    // .. process Time here
   } /* got Time */

*****************************************************************************
** EnumUILanguages
*****************************************************************************
[EnumUILanguages]
static BOOL CALLBACK %11(LPTSTR UILanguage, LONG_PTR lParam)
   {
    LCID lcid = (LCID)_tcstoul(UILanguage, NULL, 16);
    // .. use locale string or lcid here
    return TRUE; // continue enumeration
   } // %11

if(!EnumUILanguages(%11, %3))
   { /* error */
    DWORD err = GetLastError();
    // .. handle error here
   } /* error */

*****************************************************************************
* CompareString
*****************************************************************************
[CompareString]
LCID lcid = %1;
switch(CompareString(lcid, %3, %5_1, -1, %5_2, -1))
   { /* compare */
    case CSTR_LESS_THAN:
       // handle less-than here
       break;
    case CSTR_EQUAL:
       // handle equal here
       break;
    case CSTR_GREATER_THAN:
       // handle greater-than here
       break;
    default:
       { /* failed */
        DWORD err = GetLastError();
        // handle error here
        break;
       } /* failed */
   } /* compare */
   
*****************************************************************************
** IsValidCodePage
*****************************************************************************
[IsValidCodePage]
BOOL %5 = IsValidCodePage(%2);

*****************************************************************************
** GetStringTypeEx
*****************************************************************************
[GetStringTypeEx]
LCID lcid = %1;
{ /* GetStringTypeEx(...) */
 LPWORD %5;
 LPTSTR s;
 // Assign a value to the string here:
 s = _T("%9"); // your string here, either constant or a variable
 %5 = (LPWORD)malloc(sizeof(WORD) * (_tcslen(s) + 1));
 if(!GetStringTypeEx(lcid, %2, s, -1, %5))
    { /* failed */ 
     DWORD err = GetLastError();
     free(%5);
     %5 = NULL;
     // .. deal with error here
    } /* failed */
 else
    { /* success */
     // .. use information here
     free(%5);
    } /* success */
} /* GetStringTypeEx(...) */
*****************************************************************************
** LCMapString
*****************************************************************************
[LCMapString]
LPTSTR %5 = _T(""); // your string here
int n = LCMapString(%1, %3, %5, _tcslen(%5) + 1, NULL, 0);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. handle error here
   } /* failed */
else
   { /* success */
    LPBYTE skey;
    int count = n;
    if((%3) & LCMAP_SORTKEY) == 0)
       count *= sizeof(TCHAR); // make large enough for characters
    skey = (LPBYTE)malloc(count);
    int c = LCMapString(%1, %3, %5, %5.GetLength() + 1, (LPTSTR)skey, count);
    if(c == 0)
       { /* error */
        DWORD err = GetLastError();
        // .. handle error here
        free(skey);
       } /* error */
    else
       { /* have map */
        if((%3) & LCMAP_SORTKEY) == 0)
           { /* mapped string */
            // .. use skey here
            free(skey);
           } /* mapped string */
        else
           { /* sortkey */
            // .. use skey value here
            free(skey);
           } /* sortkey */
       } /* have map */
   } /* success */
*****************************************************************************
** ScriptItemize
*****************************************************************************
[ScriptItemize]
LPTSTR %5 = _T("%9");
SCRIPT_ITEM * items = NULL;
{
 int actualitems;
 int maxitems = 2;
 HRESULT hr;
 while(TRUE)
    { /* scan until successful */
     items = (SCRIPT_ITEM *)malloc(sizeof(SCRIPT_ITEM) * maxitems);
     hr = ScriptItemize(%5, _tcslen(%5), maxitems,
                        &scriptControl, &scriptState,
                        items, &actualitems);
     if(hr == S_OK)
        { /* success */
         break; // successful completion
        } /* success */
     if(hr == E_OUTOFMEMORY)
        { /* buffer too small */
         maxitems *= 2;
         free(items);
         items = NULL;
         continue; // try with larger buffer
        } /* buffer too small */
    } /* scan until successful */

 if(hr != S_OK)
    { /* failed */
     // .. deal with error here
     free(items);
    } /* failed */
 else
    { /* successful */
     // ... handle script item layout here
     free(items);
    } /* successful */
*****************************************************************************
** ScriptApplyDigitSubstitution
*****************************************************************************
[ScriptApplyDigitSubstitution]
HRESULT hr;
SCRIPT_CONTROL scriptControl;
SCRIPT_STATE scriptState;

hr = ScriptApplyDigitSubstitution(&scriptDigitSubstitute, &scriptControl, &scriptState);
if(hr != S_OK)
   { /* failed */
     // ... deal with error here
   } /* failed */
else
   { /* success */
    // ... handle scriptControl and scriptState
   } /* success */
****************************************************************************************
** ScriptRecordDigitSubsitution
*****************************************************************************
[ScriptRecordDigitSubstitution]
SCRIPT_DIGITSUBSTITUTE scriptDigitSubstitute;

HRESULT hr = ScriptRecordDigitSubstitution(%1, &scriptDigitSubstitute);
if(hr != S_OK)
   { /* failed */
    // ... deal with error here
   } /* failed */
else
   { /* success */
    // ... deal with success here
   } /* success */
*****************************************************************************
** ScriptStringAnalyse
*****************************************************************************
[ScriptStringAnalyse]
LPTSTR %5 = _T("%9");
CClientDC dc(this);
int width = %4;  // Desired width...only if SSA_CLIP is specified
LPINT DX = (LPINT)malloc(sizeof(int) * ???);
%10
SCRIPT_STRING_ANALYSIS scriptStringAnalysis;
int glyphcounts = ((_tcslen(%5) * 3) / 2) + 1;

// dc.SelectObject(&font); // you may need to select a font object
HRESULT hr = ScriptStringAnalyse((HDC)dc, 
                                 %5,                // string
                                 _tcslen(%5),       // number of characters
                                 glyphsCount,       // # of glyphs
#ifdef _UNICODE
                                 -1,                // Character set is Unicode
#else
                                 ANSI_CHARSET,      // character set descriptor
#endif
                                 %3,
                                 width,             // width for SSA_CLIP
                                 &scriptControl,    // SCRIPT_CONTROL object
                                 &scriptState,      // SCRIPT_STATE object
                                 DX,                // Logical DX array
                                 %11,               // only if SSA_TAB is used
                                 %13,               // only if SSA_GCP is used
                                 &scriptStringAnalysis);
if(hr != S_OK)
   { /* failed */
    // .. handle error here
   } /* failed */
else
   { /* success */
    // .. deal with success here
    ScriptStringFree(scriptStringAnalysis);
   } /* success */
*****************************************************************************
** MultiByteToWideChar
*****************************************************************************
[MultiByteToWideChar:6]
UINT CodePage = %9; // %2

LPCSTR mb = "%11"; // note 8-bit characters
LPWSTR wc;
int n = MultiByteToWideChar(CodePage, %3, mb, -1, NULL, 0);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
   } /* failed */
else
   { /* success */
    wc = (LPWSTR)malloc(sizeof(WCHAR) * n);
    n = MultiByteToWideChar(CodePage, %3, mb, -1, wc, n);
    // .. use wc here
    free(wc);
   } /* success */

**---------------------------------------------------------------------------
[MultiByteToWideChar:7]
UINT CodePage = %9; // %2
LPCSTR mb = "%11"; // 8-bit characters, no _T()
LPWSTR wc;
int n = MultiByteToWideChar(CodePage, %3, mb, -1, NULL, 0);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
   } /* failed */
else
   { /* success */
    wc = (LPWSTR)malloc(sizeof(WCHAR) * n);
    n = MultiByteToWideChar(CodePage, %3, mb, -1, wcp, n);
    //... use wc here
    free(wc);
   } /* success */

*****************************************************************************
** WideCharToMultiByte
*****************************************************************************
**---------------------------------------------------------------------------
** UsedDefault = NULL, DefaultChar = NULL   (NN)
**---------------------------------------------------------------------------
[WideCharToMultiByte:6NN]
UINT CodePage = %9; // %2
LPCWSTR wc = L"%11";
LPSTR mb;
int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, NULL, NULL);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    mb = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mb, n, NULL, NULL);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mb);
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = NULL, DefaultChar = 'c' (NS)
**---------------------------------------------------------------------------
[WideCharToMultiByte:6NS]
UINT CodePage = %9; // %2
char DefaultChar = '%12';
LPCWSTR wc = L"%11";
LPSTR mb;
int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, &DefaultChar, NULL);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    mb = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mb, n, &DefaultChar, NULL);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mb);
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = NULL, DefaultChar = GetCpInfo (NG) VS6
**---------------------------------------------------------------------------
[WideCharToMultiByte:6NG]
UINT CodePage = %9; // %2
//-------------------------------
// Get default char for code page
//-------------------------------
CPINFO info;
if(!GetCPInfo(CodePage, &info))
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
    info.DefaultChar[0] = '?';
   } /* failed */
//-------------------------------
LPCWSTR wc = L"%11";
LPSTR mb;
int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, info.DefaultChar, NULL);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    mb = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mb, n, info.DefaultChar, NULL);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mb);
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = ~NULL, DefaultChar = NULL   (UN)
**---------------------------------------------------------------------------
[WideCharToMultiByte:6UN]
UINT CodePage = %9; // %2
LPCWSTR wc = L"%11";
BOOL UsedDefaultChar;
LPSTR mb;
int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, NULL, &UsedDefaultChar);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    mb = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mb, n, NULL, &UsedDefaultChar);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mb);
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = ~NULL, DefaultChar = 'c' (US)
**---------------------------------------------------------------------------
[WideCharToMultiByte:6US]
UINT CodePage = %9; // %2
char DefaultChar = '%12';
LPCWSTR wc = L"%11";
LPSTR mb;
BOOL UsedDefaultChar;

int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, &DefaultChar, &UsedDefaultChar);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    mb = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mb, n, &DefaultChar, &UsedDefaultChar);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mb);
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = ~NULL, DefaultChar = GetCpInfo (UG)
**---------------------------------------------------------------------------
[WideCharToMultiByte:6UG]
UINT CodePage = %9; // %2
//-------------------------------
// Get default char for code page
//-------------------------------
CPINFO info;
if(!GetCPInfo(CodePage, &info))
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
    info.DefaultChar[0] = '?';
   } /* failed */
//-------------------------------
LPCWSTR wc = L"%11";
LPSTR mb;
BOOL UsedDefaultChar;

int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, info.DefaultChar, &UsedDefaultChar);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    mb = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mb, n, info.DefaultChar, &UsedDefaultChar);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mb);
      } /* use multibyte string
   } /* success */

**---------------------------------------------------------------------------
** UsedDefault = NULL, DefaultChar = NULL   (NN)
**---------------------------------------------------------------------------
[WideCharToMultiByte:7NN]
UINT CodePage = %9; // %2
LPCWSTR wc = L"%11";
LPSTR mb;
int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, NULL, NULL);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    mb = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mb, n, NULL, NULL);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       free(mb);
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mb);
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = NULL, DefaultChar = 'c' (NS)
**---------------------------------------------------------------------------
[WideCharToMultiByte:7NS]
UINT CodePage = %9; // %2
char DefaultChar = '%12';
LPCWSTR wc = L"%11";
LPSTR mb;
int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, &DefaultChar, NULL);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    mb = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, pmb, n, &DefaultChar, NULL);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       free(mb);
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mb);
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = NULL, DefaultChar = GetCpInfo (NG) VS.NET
**---------------------------------------------------------------------------
[WideCharToMultiByte:7NG]
UINT CodePage = %9; // %2
//-------------------------------
// Get default char for code page
//-------------------------------
CPINFO info;
if(!GetCPInfo(CodePage, &info))
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
    info.DefaultChar[0] = '?';
   } /* failed */
//-------------------------------
LPWSTR wc = L"%11";
LPSTR mb;
int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, info.DefaultChar, NULL);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    LPSTR mbp = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mbp, n, info.DefaultChar, NULL);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       free(mbp);
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mbp);
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = ~NULL, DefaultChar = NULL   (UN) VS.NET
**---------------------------------------------------------------------------
[WideCharToMultiByte:7UN]
UINT CodePage = %9; // %2
LPWSTR wc = L"%11";
BOOL UsedDefaultChar;
LPSTR mb;
int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, NULL, &UsedDefaultChar);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    LPSTR mbp = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mbp, n, NULL, &UsedDefaultChar);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       mb.ReleaseBuffer();
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       mb.ReleaseBuffer();
       // ... use value here
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = ~NULL, DefaultChar = 'c' (US) VS.NET
**---------------------------------------------------------------------------
[WideCharToMultiByte:7US]
UINT CodePage = %9; // %2
char DefaultChar = '%12';
LPWSTR wc = L"%11";
LPSTR mb;
BOOL UsedDefaultChar;

int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, &DefaultChar, &UsedDefaultChar);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    LPSTR mbp = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mbp, n, &DefaultChar, &UsedDefaultChar);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       mb.ReleaseBuffer();
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       mb.ReleaseBuffer();
       // ... use value here
      } /* use multibyte string
   } /* success */
**---------------------------------------------------------------------------
** UsedDefault = ~NULL, DefaultChar = GetCpInfo (UG) VS.NET
**---------------------------------------------------------------------------
[WideCharToMultiByte:7UG]
UINT CodePage = %9; // %2
//-------------------------------
// Get default char for code page
//-------------------------------
CPINFO info;
if(!GetCPInfo(CodePage, &info))
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
    info.DefaultChar[0] = '?';
   } /* failed */
//-------------------------------
LPCWSTR wc = L"%11";
LPSTR mb;
BOOL UsedDefaultChar;

int n = WideCharToMultiByte(CodePage, %3, wc, -1, NULL, 0, info.DefaultChar, &UsedDefaultChar);
if(n == 0)
   { /* failed */
    DWORD err = GetLastError();
    // .. deal with error here
   } /* failed */
else
   { /* success */
    mb = (LPSTR)malloc(n);
    n = WideCharToMultiByte(CodePage, %3, wc, -1, mb, n, info.DefaultChar, &UsedDefaultChar);
    if(n == 0)
      { /* conversion failed */
       DWORD err = GetLastError();
       free(mb);
       // .. deal with error here
      } /* conversion failed */
    else
      { /* use multibyte string */
       // ... use value here
       free(mb);
      } /* use multibyte string
   } /* success */
*****************************************************************************
** IsDBCSLeadByte
*****************************************************************************
[IsDBCSLeadByte]
BYTE %5 = %13;  // 0x%14
BOOL result = IsDBCSLeadByte(%5);

*****************************************************************************
** IsDBCSLeadByteEx
*****************************************************************************
[IsDBCSLeadByteEx]
BYTE %5 = %13;  // 0x%14
UINT CodePage = %9; // %2
BOOL result = IsDBCSLeadByteEx(CodePage, %5);

*****************************************************************************
** ScriptGetProperties
*****************************************************************************
[ScriptGetProperties]
const SCRIPT_PROPERTIES ** %5;
int num_%5;

HRESULT result = ::ScriptGetProperties(&%5, &num_%5);
*****************************************************************************
** IsTextUnicode
*****************************************************************************
[IsTextUnicode:6]
LPCWSTR %5 = L"%9";
INT pi = %3;
if(IsTextUnicode(%5, wcslen(%5) * sizeof(WCHAR), &pi)
  { /* passed */
   ... deal with Unicode text here
  } /* passed */
else
  { /* failed */
   ... deal with non-Unicode text here
  } /* failed */

[IsTextUnicode:7]
CStringW %5(L"%9");
INT pi = %3;
if(IsTextUnicode(%5, wcslen(%5) * sizeof(WCHAR), &pi)
  { /* passed */
   ... deal with Unicode text here
  } /* passed */
else
  { /* failed */
   ... deal with non-Unicode text here
  } /* failed */
